{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUPDATE'
and f.rdb$field_name = 'NAZIV_FAJLA'
}

ALTER TABLE TBLUPDATE
ADD NAZIV_FAJLA VARCHAR(255);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENTI'
and f.rdb$field_name = 'JAVNA_USTANOVA'
}

ALTER TABLE TBLKOMITENTI
ADD JAVNA_USTANOVA SMALLINT;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_ZKOP_PACIJENTI_ID'}

SET TERM ^ ;
create or alter procedure SP_GEN_ZKOP_PACIJENTI_ID
returns (
    ID integer)
as
begin
  id = gen_id(GEN_ZKOP_PACIJENTI_ID, 1);
  suspend;
end^
SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from TBLPROVERA_GENERATORA f
where f.NAZIV_GENERATORA = 'GEN_ICONS_SHORTCUTS_ID'}

INSERT INTO TBLPROVERA_GENERATORA (TABELA, POLJE, NAZIV_GENERATORA) VALUES ('ICONS_SHORTCUTS', 'ID', 'GEN_ICONS_SHORTCUTS_ID');

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI'
and f.rdb$field_name = 'NEISPRAVAN'
}

ALTER TABLE AP_RECEPTI
ADD NEISPRAVAN SMALLINT;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'STAMPA'
and f.rdb$field_name = 'DEC16'
}

ALTER TABLE STAMPA
ADD DEC16 DOUBLE PRECISION;

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PUMPE'
and f.rdb$field_name = 'FABRICKI_BROJ'
}

ALTER TABLE HP_PUMPE
ADD FABRICKI_BROJ VARCHAR(20);

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_TANKOVI_INPUT'

}


CREATE TABLE HP_TANKOVI_INPUT (
    ID INTEGER NOT NULL,
    IDNOVCANO INTEGER NOT NULL,
    INPUT_DATE DATE,
    ID_PUMPE INTEGER NOT NULL,
    INPUT_VALUE DECIMAL(18,4),
    INPUT_TIME TIME,
    DOC_NUMBER VARCHAR(20));

COMMIT WORK;


ALTER TABLE HP_TANKOVI_INPUT ADD CONSTRAINT PK_HP_TANKOVI_INPUT PRIMARY KEY (ID);

COMMIT WORK;

ALTER TABLE HP_TANKOVI_INPUT ADD CONSTRAINT FK_HP_TANKOVI_INPUT_1 FOREIGN KEY (ID_PUMPE) REFERENCES HP_PUMPE(ID);

COMMIT WORK;

CREATE GENERATOR GEN_HP_TANKOVI_INPUT_ID;

COMMIT WORK;


SET TERM ^ ;

create or alter procedure SP_GEN_HP_TANKOVI_INPUT_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_hp_tankovi_input_id, 1);
  suspend;
end^

SET TERM ; ^

INSERT INTO SIN_TBL (ZAKLJUCAJ, ID, BROJ_ID, DATE_FIELD, TABELA, IDTABELE, SORTIRAJ, IDTABELE1, IZMENI, SQL, URADI, SIFRA_MAGACINA, ID_READ, ID_WRITE, IDKEY1, IDKEY2, GEN1, NAZIV_FAJLA, USLOV, TABELA2, IDTABELE2, DATE_FIELD2, SORTIRAJ2, USLOV2, DATUM_SINHRONIZACIJE, DATUM_IZMENE, USLOV_LOKAL, SQL_LOKAL, RADNIK_CHANGE, DATE_CHANGE, POMERI_SINHRONIZACIJU, OBRISI_TABELU, BROJ_TABELA, OPIS, PIB, SIFRA_MAG_SIN, SINHRONIZUJ_FINANSIJE)
             VALUES (0, 800, 12, 'N', 'HP_TANKOVI_INPUT', 'ID', 'N', NULL, 0, 'SELECT * FROM HP_TANKOVI_INPUT', 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 'N', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N', 'SELECT * FROM HP_TANKOVI_INPUT', NULL, NULL, NULL, 1, 1, 'Fakture rezervoara', '101270452', 0, NULL);

COMMIT WORK;


{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI'
and f.rdb$field_name = 'RAD_SA_PDA'
}

ALTER TABLE TBLDOKUMENTI
ADD RAD_SA_PDA SMALLINT;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKARI_SFILIJALA_NAZIV'
}

CREATE TABLE AP_LEKARI_SFILIJALA_NAZIV (
    ID_FILIJALA      INTEGER,
    ADRESA_C         VARCHAR(128),
    OKRUG_C          VARCHAR(128),
    OKRUG_NAZIV_C    VARCHAR(128),
    NAZIVFILIJALE_C  VARCHAR(128),
    SIFRAFILIJALE    VARCHAR(16)
);

CREATE INDEX AP_LEKARI_SFILIJALA_NAZIV_IDX1 ON AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA);
CREATE INDEX AP_LEKARI_SFILIJALA_NAZIV_IDX2 ON AP_LEKARI_SFILIJALA_NAZIV (SIFRAFILIJALE);

COMMIT WORK;

INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (1, 'Subotica,Trg Slobode 3-5', 'Severno-backi', 'Filijala za Severno-backi okrug Subotica', 'Filijala Subotica', '01');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (2, 'Zrenjanin, Kralja Aleksandra I Karadordevica 2/A', 'Srednje-banatski', 'Filijala za Srednje-banatski okrug Zrenjanin', 'Filijala Zrenjanin', '02');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (3, 'Kikinda, Dositejeva 33', 'Severno-banatski', 'Filijala za Severno-banatski okrug', 'Filijala Kikinda', '03');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (4, 'Pancevo, JNA 6', 'JuÃƒâ€¦Ã‚Â¾no-banatski', 'Filijala za JuÃƒâ€¦Ã‚Â¾no-banatski okrug', 'Filijala Pancevo', '04');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (5, 'Sombor, Venac Vojvode Stepe Stepanovica 18', 'Zapadno-backi', 'Filijala za Zapadno-backi okrug', 'Filijala Sombor', '05');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (6, 'Novi Sad, Ãƒâ€¦Ã‚Â½itni trg 1', 'JuÃƒâ€¦Ã‚Â¾no-backi', 'Filijala za JuÃƒâ€¦Ã‚Â¾no-backi okrug', 'Filijala Novi Sad', '06');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (7, 'Sremska Mitrovica, Trg Svetog Dimitrija 4', 'Sremski', 'Filijala  za Sremski okrug', 'Filijala Sremska Mitrovica', '07');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (8, 'Ãƒâ€¦Ã‚Â abac, Vojvode MiÃƒâ€¦Ã‚Â¡ica 9', 'Macvanski', 'Filijala za Macvanski okrug', 'Filijala ÃƒÆ’Ã¢â‚¬Â¦Ãƒâ€šÃ‚Â abac', '08');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (9, 'Valjevo, Karadordeva 71', 'Kolubarski', 'Filijala za Kolubarski okrug', 'Filijala Valjevo', '09');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (10, 'Smederevo, Trg Republike 4', 'Podunavski', 'Filijala za Podunavski okrug', 'Filijala Smederevo', '10');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (11, 'PoÃƒâ€¦Ã‚Â¾arevac Radomira VujoviÃƒÆ’Ã¢â‚¬Å¾ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¡a 1', 'Branicevski', 'Filijala za Branicevski okrug', 'Filijala PoÃƒâ€¦Ã‚Â¾arevac', '11');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (12, 'Kragujevac, Kralja Petra prvog 1', 'Ãƒâ€¦Ã‚Â umadijski', 'Filijala za Ãƒâ€¦Ã‚Â umadijski okrug', 'Filijala Kragujevac', '12');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (13, 'Jagodina, Karadordeva bb', 'Pomoravski', 'Filijala za Pomoravski okrug', 'Filijala Jagodina', '13');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (14, 'Bor, Trg Oslobodenja 2/2', 'Borski', 'Filijala za Borski okrug', 'Filijala Bor', '14');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (15, 'Zajecar, Nikole PaÃƒâ€¦Ã‚Â¡ica 32', 'Zajecarski', 'Filijala za Zajecarski okrug', 'Filijala Zajecar', '15');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (16, 'UÃƒâ€¦Ã‚Â¾ice, Kursulina 1', 'Zlatiborski', 'Filijala za Zlatiborski okrug', 'Filijala UÃƒâ€¦Ã‚Â¾ice', '16');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (17, 'Cacak, Ãƒâ€¦Ã‚Â½eleznicka 7', 'Moravicki', 'Filijala za Moravicki okrug', 'Filijala Cacak', '17');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (18, 'Kraljevo,Vojvode Putnika 5', 'RaÃƒâ€¦Ã‚Â¡ki', 'Filijala za RaÃƒÆ’Ã¢â‚¬Â¦Ãƒâ€šÃ‚Â¡ki okrug', 'Filijala Kraljevo', '18');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (19, 'KruÃƒâ€¦Ã‚Â¡evac, Trg okt.revolucije 2', 'Rasinski', 'Filijala za Rasinski okrug', 'Filijala KruÃƒâ€¦Ã‚Â¡evac', '19');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (20, 'NiÃƒâ€¦Ã‚Â¡, Prijezdina 1', 'NiÃƒâ€¦Ã‚Â¡avski', 'Filijala za NiÃƒâ€¦Ã‚Â¡avski okrug', 'Filijala NiÃƒâ€¦Ã‚Â¡', '20');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (21, 'Prokuplje, 21 srpske divizije 49', 'Toplicki', 'Filijala za Toplicki okrug', 'Filijala Prokuplje', '21');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (22, 'Pirot,Srpskih vladara bb', 'Pirotski', 'Filijala za Pirotski okrug', 'Filijala Pirot', '22');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (23, 'Leskovac, 11. oktobra 25', 'Jablanicki', 'Filijala za Jablanicki okrug', 'Filijala Leskovac', '23');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (24, 'Vranje, Cara DuÃƒâ€¦Ã‚Â¡ana 12', 'Pcinjski', 'Filijala za Pcinjski okrug', 'Filijala Vranje', '24');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (25, 'Gracanica', 'Kosovski-PriÃƒâ€¦Ã‚Â¡tina', 'Filijala za Kosovski okrug-PrÃƒâ€¦Ã‚Â¡Ãƒâ€šÃ‚Â¡tina', 'Filijala PriÃƒâ€¦Ã‚Â¡tina', '25');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (26, NULL, NULL, NULL, 'Filijala PeÃƒÆ’Ã¢â‚¬Å¾ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¡', '26');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (27, NULL, NULL, NULL, 'Filijala Prizren', '27');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (28, 'Kosovska Mitrovica', 'Kosovsko-Mitrovacki', 'Filijala za Kosovsko-Mitrovacki okrug', 'Filijala Kosovska Mitrovica', '28');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (29, 'Ranilug', 'Kosovsko-pomoravski', 'Filijala za Kosovsko-pomoravski okrug', 'Filijala Gnjilane', '29');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (30, 'Beograd, Nemanjina 30', 'Grad Beograd', 'Filijala za Grad Beograd', 'Filijala Beograd', '30');
INSERT INTO AP_LEKARI_SFILIJALA_NAZIV (ID_FILIJALA, ADRESA_C, OKRUG_C, OKRUG_NAZIV_C, NAZIVFILIJALE_C, SIFRAFILIJALE)
                               VALUES (31, '28. Novembra 120, 36300 Novi Pazar', 'Novi Pazar', 'Filijala za Novi Pazar sa sediÃƒâ€¦Ã‚Â¡tem u Novom Pazaru', 'Filijala Novi Pazar', '31');



COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'PRIORITET_ZA_TREBOVANJA'
}

ALTER TABLE TBLMAGACIN
ADD PRIORITET_ZA_TREBOVANJA SMALLINT;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLIZVODRASPOD'
and f.rdb$field_name = 'DATUMVALUTE'
}


ALTER TABLE TBLIZVODRASPOD
ADD DATUMVALUTE DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PUMPE'
and f.rdb$field_name = 'ODSTUPANJE'
}


ALTER TABLE HP_PUMPE
ADD ODSTUPANJE DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_TOTALI_PUMPA'
}

CREATE TABLE HP_TOTALI_PUMPA (
    ID INTEGER NOT NULL,
    ID_PUMPE INTEGER,
    VALUE_TOTAL INTEGER,
    TIME_TOTAL TIMESTAMP);

    COMMIT WORK;

  ALTER TABLE HP_TOTALI_PUMPA
  ADD CONSTRAINT PK_HP_TOTALI_PUMPA
  PRIMARY KEY (ID);

  COMMIT WORK;

  CREATE SEQUENCE GEN_HP_TOTALI_PUMPA_ID;

  COMMIT WORK;

  create trigger hp_totali_pumpa_bi for hp_totali_pumpa
  active before insert position 0
  as
  begin
    if (new.id is null) then
      new.id = gen_id(gen_hp_totali_pumpa_id,1);
  end;

  COMMIT WORK;

  create procedure sp_gen_hp_totali_pumpa_id
  returns (id integer)
  as
  begin
    id = gen_id(gen_hp_totali_pumpa_id, 1);
    suspend;
  end;

  COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLIZVODRASPOD'
and f.rdb$field_name = 'DATUMVALUTE'
}

ALTER TABLE TBLIZVODRASPOD
ADD DATUMVALUTE DATE;

ALTER TRIGGER TBLIZVODI_BI INACTIVE;
COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'STARI_PROGRAM'
}

ALTER TABLE SYSTEM
ADD STARI_PROGRAM INTEGER;

{$ENDIF}


{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLBLAGAJNA' and f.rdb$field_name = 'ID_POPDV'}
ALTER TABLE TBLBLAGAJNA
ADD ID_POPDV INTEGER;
{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLDOKUMENTI' and f.rdb$field_name = 'ID_POPDV'}
ALTER TABLE TBLDOKUMENTI
ADD ID_POPDV INTEGER;
{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLNOVCANO' and f.rdb$field_name = 'ID_POPDV'}
ALTER TABLE TBLNOVCANO
ADD ID_POPDV INTEGER;
{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLPROMENE' and f.rdb$field_name = 'ID_POPDV'}
ALTER TABLE TBLPROMENE
ADD ID_POPDV INTEGER;
{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLUSLUGEPROMENE' and f.rdb$field_name = 'ID_POPDV'}
ALTER TABLE TBLUSLUGEPROMENE
ADD ID_POPDV INTEGER;
{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'TBLBLAGAJNA_ID_POPDV'}
CREATE INDEX TBLBLAGAJNA_ID_POPDV
ON TBLBLAGAJNA (ID_POPDV);
{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'TBLDOKUMENTI_ID_POPDV'}
CREATE INDEX TBLDOKUMENTI_ID_POPDV
ON TBLDOKUMENTI (ID_POPDV);
{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'TBLPROMENE_ID_POPDV'}
CREATE INDEX TBLPROMENE_ID_POPDV
ON TBLPROMENE (ID_POPDV);
{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'TBLUSLUGEPROMENE_ID_POPDV'}
CREATE INDEX TBLUSLUGEPROMENE_ID_POPDV
ON TBLUSLUGEPROMENE (ID_POPDV);
{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI'
and f.rdb$field_name = 'SIFRA_ERECEPTA'
}

ALTER TABLE AP_RECEPTI
ADD SIFRA_ERECEPTA VARCHAR(20);

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'ID_POPDV'
}

ALTER TABLE MP_FISK_Z
ADD ID_POPDV INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN'
and f.rdb$field_name = 'ID_POPDV'
}

ALTER TABLE HP_OBRACUN
ADD ID_POPDV INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI_AKCIJA'
}

CREATE TABLE TBLARTIKLI_AKCIJA (
    ID              INTEGER NOT NULL,
    SIFRA_ROBE      INTEGER,
    SIFRA_MAGACINA  INTEGER,
    AKCIJSKA_SIFRA  INTEGER,
    POPUST          DECIMAL(15,2),
    CENA            DECIMAL(18,2),
    ODNOS           DECIMAL(18,4)
);

ALTER TABLE TBLARTIKLI_AKCIJA ADD CONSTRAINT PK_TBLARTIKLI_AKCIJA PRIMARY KEY (ID);

ALTER TABLE TBLARTIKLI_AKCIJA ADD CONSTRAINT FK_TBLARTIKLI_AKCIJA_AKCIJA FOREIGN KEY (AKCIJSKA_SIFRA) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE TBLARTIKLI_AKCIJA ADD CONSTRAINT FK_TBLARTIKLI_AKCIJA_ART FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);

{$ENDIF}


{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_FISKALNA_DNEVNI_SMENA_ID'}

CREATE SEQUENCE GEN_FISKALNA_DNEVNI_SMENA_ID;

{$ENDIF}

{$IFNOTEXISTS select * 
from TBLPROVERA_GENERATORA 
where TABELA = 'FISKALNA_DNEVNI_SMENA'
and POLJE = 'ID'}

INSERT INTO TBLPROVERA_GENERATORA (TABELA, POLJE, NAZIV_GENERATORA)
                           VALUES ('FISKALNA_DNEVNI_SMENA', 'ID', 'GEN_FISKALNA_DNEVNI_SMENA_ID');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_FISKALNA_SMENA_ID'}

SET TERM ^ ;

create or alter procedure SP_GEN_FISKALNA_SMENA_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_fiskalna_dnevni_smena_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
}

CREATE TABLE FISKALNA_DNEVNI_SMENA (
    ID             INTEGER NOT NULL,
    ID_DNEVNI      INTEGER,
    SIFRA_RADNIKA  INTEGER,
    KES          DECIMAL(18,2),
    DATUM_UNOSA    TIMESTAMP
);

ALTER TABLE FISKALNA_DNEVNI_SMENA ADD CONSTRAINT PK_FISKALNA_DNEVNI_SMENA PRIMARY KEY (ID);

ALTER TABLE FISKALNA_DNEVNI_SMENA ADD CONSTRAINT FK_FISKALNA_DNEVNI_SMENA_DNEVNI FOREIGN KEY (ID_DNEVNI) REFERENCES FISKALNA_DNEVIN_IZVESTAJ (ID);
ALTER TABLE FISKALNA_DNEVNI_SMENA ADD CONSTRAINT FK_FISKALNA_DNEVNI_SMENA_RADNIK FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
}

CREATE TABLE SYSTEM_MP (
    ID                    INTEGER NOT NULL,
    AUTO_OTVORI_NOVI_DAN  SMALLINT
);

ALTER TABLE SYSTEM_MP ADD CONSTRAINT PK_SYSTEM_MP PRIMARY KEY (ID);

INSERT INTO SYSTEM_MP (ID, AUTO_OTVORI_NOVI_DAN)
               VALUES (1, 0);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'ID_DNEVNOG_IZVESTAJA'
}

ALTER TABLE MP_FISK_Z
ADD ID_DNEVNOG_IZVESTAJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'BROJ_NALOGA'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD BROJ_NALOGA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'SIFRA_KASE'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD SIFRA_KASE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'DATE_CHANGE'
}


ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD DATE_CHANGE TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'RADNIK_CHANGE'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD RADNIK_CHANGE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'DATUM'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD DATUM DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'POSLATO'
}


ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD POSLATO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'KES'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD KES DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'CEK'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD CEK DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'KARTICA'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD KARTICA DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'VIRMAN'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD VIRMAN DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI'
and f.rdb$field_name = 'VREME_PRAVLJENA_FAKT'
}
ALTER TABLE AP_RECEPTI_VOJNI
ADD VREME_PRAVLJENA_FAKT TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI'
and f.rdb$field_name = 'TIP_RECEPTA'
}

ALTER TABLE AP_RECEPTI_VOJNI
ADD TIP_RECEPTA VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI'
and f.rdb$field_name = 'ID_LISTE'
}

ALTER TABLE AP_RECEPTI_VOJNI
ADD ID_LISTE VARCHAR(16);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI'
and f.rdb$field_name = 'JKL'
}

ALTER TABLE AP_RECEPTI_VOJNI
ADD JKL VARCHAR(30);

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI_OBRISANI'
and f.rdb$field_name = 'VREME_PRAVLJENA_FAKT'
}
ALTER TABLE AP_RECEPTI_VOJNI_OBRISANI
ADD VREME_PRAVLJENA_FAKT TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI_OBRISANI'
and f.rdb$field_name = 'TIP_RECEPTA'
}

ALTER TABLE AP_RECEPTI_VOJNI_OBRISANI
ADD TIP_RECEPTA VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI_OBRISANI'
and f.rdb$field_name = 'ID_LISTE'
}

ALTER TABLE AP_RECEPTI_VOJNI_OBRISANI
ADD ID_LISTE VARCHAR(16);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_RECEPTI_VOJNI_OBRISANI'
and f.rdb$field_name = 'JKL'
}

ALTER TABLE AP_RECEPTI_VOJNI_OBRISANI
ADD JKL VARCHAR(30);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ZKOP_PACIJENTI'
}


CREATE TABLE ZKOP_PACIJENTI (
    ID_PACIJENTA                 INTEGER NOT NULL,
    JMBG                         CHAR(13) NOT NULL,
    DATUM_RODJENJA               DATE,
    IME                          VARCHAR(20) CHARACTER SET WIN1250,
    PREZIME                      VARCHAR(50) CHARACTER SET WIN1250,
    IME_OCA                      VARCHAR(20) CHARACTER SET WIN1250,
    MESTO_PREBIVALISTA           INTEGER,
    ULICA                        VARCHAR(50) CHARACTER SET WIN1250,
    KRVNA_GRUPA                  CHAR(2),
    ODABRANI_LEKAR               VARCHAR(15),
    BRACNO_STANJE                INTEGER,
    POL                          INTEGER,
    ALERGIJA_NA_LEK              VARCHAR(50),
    NALAZI_KOMISIJE              VARCHAR(250),
    RADNICKO_AKT_PRVO            DATE,
    RADNICKO_AKT_PROMENA         DATE,
    OSTALA_OSG_LICA_PRVO         DATE,
    OSTALA_OSG_LICA_PROMENA      DATE,
    OSNOVNO_OSG_PRVO             DATE,
    OSNOVNO_OSG_PROMENA          DATE,
    PROSIRENO_OSG_PRVO           DATE,
    PROSIRENO_OSG_PROMENA        DATE,
    NEOSIGURANA_PRVO             DATE,
    NEOSIGURANA_PROMENA          DATE,
    NOSIOC_OSG                   CHAR(1),
    REG_BROJ                     INTEGER,
    SIFRA_DELATNOSTI             INTEGER,
    MESTO_SEDISTA_OSG            INTEGER,
    FOND_ZDR_OSG                 INTEGER,
    POSAO_KOJI_VRSI              INTEGER,
    ID_KOMITENTA                 INTEGER,
    DRZAVLJANSTVO                VARCHAR(3),
    NA_TOM_POSLU_OD              DATE,
    NOSILAC_FIZICKO              VARCHAR(50),
    PIMENOS                      VARCHAR(100),
    REGBROD                      VARCHAR(30),
    FILIJALA                     VARCHAR(50) CHARACTER SET WIN1251,
    ISPOSTAVA                    VARCHAR(50) CHARACTER SET WIN1251,
    NAZIV_RO                     VARCHAR(100) CHARACTER SET WIN1251,
    LBONOS                       VARCHAR(20),
    BZK                          VARCHAR(20),
    LBO                          VARCHAR(20),
    OSNOVKP                      VARCHAR(20),
    PUNO_IME                     VARCHAR(50),
    VID                          VARCHAR(10),
    RADNA_ORGANIZACIJA           VARCHAR(50),
    NAPOMENA                     VARCHAR(300),
    PIB                          VARCHAR(20),
    DAT_OREDJ_KG                 DATE,
    MESTO_ODREDJ_KG              VARCHAR(20),
    UPDATED                      DATE,
    PINCODE                      VARCHAR(20),
    POL_RODJ                     INTEGER,
    KONTAKT                      VARCHAR(100),
    JMBG_STARAT                  VARCHAR(13),
    IME_STARAT                   VARCHAR(100),
    PREZIME_STARAT               VARCHAR(100),
    VREME_RODJ                   TIME,
    DATUM_SMRTI                  TIMESTAMP,
    RH_FAKT                      VARCHAR(10),
    APGAR                        DOUBLE PRECISION,
    OBIM_GLAVE                   DOUBLE PRECISION,
    IME_MAJKE                    VARCHAR(100),
    POL_NA_RODJENJU              INTEGER,
    PIN                          VARCHAR(5),
    MESTO_RODJENJA               INTEGER,
    ZEMLJA_STANOVANJA            VARCHAR(3),
    BROJ_DECE                    INTEGER,
    IDSTRUCNE_SPREME             INTEGER,
    IDZANIMANJE                  INTEGER,
    IDTIP_ZAPOSLENOSTI           INTEGER,
    KORISCENJE_SOCIJALNE_POMOCI  INTEGER,
    IDPORODICNI_STATUS           INTEGER,
    IDMATERIJALNI_STATUS         INTEGER,
    BZK_VAZI_DO                  DATE,
    PODGRUPA                     VARCHAR(256),
    DATUM_UNOSA                  DATE
);


ALTER TABLE ZKOP_PACIJENTI ADD CONSTRAINT PK_ZKOP_PACIJENTI PRIMARY KEY (ID_PACIJENTA);

CREATE INDEX ZKOP_PACIJENTI_IDX1 ON ZKOP_PACIJENTI (LBO);

SET TERM ^ ;

/* Trigger: ZKOP_PACIJENTI_BI */
CREATE OR ALTER TRIGGER ZKOP_PACIJENTI_BI FOR ZKOP_PACIJENTI
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN

    NEW.ID_PACIJENTA = GEN_ID(GEN_ZKOP_PACIJENTI_ID,1);
END
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ZKOP_PACIJENTI'
and f.rdb$field_name = 'UPDATED'
}

ALTER TABLE ZKOP_PACIJENTI
ADD UPDATED DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_FISKAL'
and f.rdb$field_name = 'PROVERAVAJ_CEK_KOMITENTA'
}

ALTER TABLE HP_FISKAL
ADD PROVERAVAJ_CEK_KOMITENTA smallint;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'TREBOVANJE_BEZ_CENOVNIKA'
}

ALTER TABLE HP_FISKAL
ADD TREBOVANJE_BEZ_CENOVNIKA smallint;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'VAGA'
}

ALTER TABLE TBLARTIKLI
ADD VAGA smallint;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'ID_KLIJENTA_OTKLJUCAN'
}

ALTER TABLE TBLNOVCANO
ADD ID_KLIJENTA_OTKLJUCAN INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'IMA_KNJIGOVODSTVO'}

ALTER TABLE SYSTEM ADD IMA_KNJIGOVODSTVO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'PDV_NADOKNADA_DELIMICNO'}

ALTER TABLE SYSTEM ADD PDV_NADOKNADA_DELIMICNO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'RAD_MG_SA_PDA'}

ALTER TABLE SYSTEM ADD RAD_MG_SA_PDA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from ICONS_SHORTCUTS f
where f.CAPTION = 'Komitenti'
}

select * from provera_generatora('GEN_ICONS_SHORTCUTS_ID');
COMMIT WORK;

INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION)
                     VALUES (21, NULL, 1, 'Komitenti');
           
{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLAKCIJE'
}

CREATE TABLE TBLAKCIJE (
    ID           INTEGER NOT NULL,
    TIP_AKCIJE   VARCHAR(100),
    SQL          VARCHAR(1024),
    IDZ          INTEGER,
    IDNOVCANO    INTEGER,
    DATUMOD      DATE,
    DATUMDO      DATE,
    REZULTAT     DECIMAL(18,4),
    ID_CENOVNIK  INTEGER
);

ALTER TABLE TBLAKCIJE ADD CONSTRAINT PK_TBLAKCIJE PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DATUM_ZA_SLANJE_PREDRACUNA'}

ALTER TABLE SYSTEM_MP
ADD DATUM_ZA_SLANJE_PREDRACUNA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ZABRANA_IZMENE_ULAZNE_CENE_OTP'}

ALTER TABLE SYSTEM_MP
ADD ZABRANA_IZMENE_ULAZNE_CENE_OTP SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'IZVORNI_DOKUMENT'}

ALTER TABLE TBLNOVCANO
ADD IZVORNI_DOKUMENT VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'RAD_SA_PDA'}

ALTER TABLE TBLMAGACIN
ADD RAD_SA_PDA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DEF_DOK_REFAKCIJE'}

ALTER TABLE SYSTEM_MP
ADD DEF_DOK_REFAKCIJE INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'CENA_POVRATNICE_NOCF'}

ALTER TABLE TBLMAGACIN
ADD CENA_POVRATNICE_NOCF SMALLINT;

COMMIT WORK;

COMMENT ON COLUMN TBLMAGACIN.CENA_POVRATNICE_NOCF IS
'Cena na povratinici (poslednja ulazna cena) na osnovu cele firme.';

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'PRODAJA_CEO_BROJ'}

ALTER TABLE TBLARTIKLI
ADD PRODAJA_CEO_BROJ INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI_SKALA'}

CREATE GENERATOR GEN_TBLRABATI_SKALA_ID;

CREATE TABLE TBLRABATI_SKALA (
    ID      INTEGER NOT NULL,
    PROMET  DECIMAL(18,2),
    RABAT   DECIMAL(15,2)
);

ALTER TABLE TBLRABATI_SKALA ADD CONSTRAINT PK_TBLRABATI_SKALA PRIMARY KEY (ID);

CREATE INDEX TBLRABATI_SKALA_IDX1 ON TBLRABATI_SKALA (PROMET);

SET TERM ^ ;

/* Trigger: TBLRABATI_SKALA_BI */
CREATE OR ALTER TRIGGER TBLRABATI_SKALA_BI FOR TBLRABATI_SKALA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tblrabati_skala_id,1);
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'EKO_TAKSA'}

ALTER TABLE SYSTEM
ADD EKO_TAKSA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI_PRO'
}

CREATE TABLE TBLRABATI_PRO (
    ID               INTEGER NOT NULL,
    ID_KOMITENTA     INTEGER NOT NULL,
    ID_PROIZVODJACA  INTEGER NOT NULL,
    RABAT            DECIMAL(15,2) DEFAULT 0
);

ALTER TABLE TBLRABATI_PRO ADD CONSTRAINT UNQ1_TBLRABATI_PRO UNIQUE (ID_KOMITENTA, ID_PROIZVODJACA);
ALTER TABLE TBLRABATI_PRO ADD CONSTRAINT PK_TBLRABATI_PRO PRIMARY KEY (ID);
ALTER TABLE TBLRABATI_PRO ADD CONSTRAINT FK_TBLRABATI_PRO_SK FOREIGN KEY (ID_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);
ALTER TABLE TBLRABATI_PRO ADD CONSTRAINT FK_TBLRABATI_PRO_SP FOREIGN KEY (ID_PROIZVODJACA) REFERENCES TBLPROIZVODJAC (SIFRA_PROIZVODJACA);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'POPISSTAVKE'
and f.rdb$field_name = 'SIFRA_RADNIKA'}

ALTER TABLE POPISSTAVKE
ADD SIFRA_RADNIKA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'POPIS'
and f.rdb$field_name = 'NASLOV'}

ALTER TABLE POPIS
ADD NASLOV VARCHAR(250);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI'
and f.rdb$field_name = 'SIFRA_ROBE'}

ALTER TABLE TBLRABATI
ADD SIFRA_ROBE INTEGER NOT NULL;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI'
and f.rdb$field_name = 'VAZI_OD'}

ALTER TABLE TBLRABATI
ADD VAZI_OD DATE;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI'
and f.rdb$field_name = 'VAZI_DO'}

ALTER TABLE TBLRABATI
ADD VAZI_DO DATE;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLRABATI'
and f.rdb$field_name = 'RABAT_PERIODA'}

ALTER TABLE TBLRABATI
ADD RABAT_PERIODA DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'PERIOD_DOZVOLJENOG_STORNIRANJA'}

ALTER TABLE SYSTEM
ADD PERIOD_DOZVOLJENOG_STORNIRANJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI'
and f.rdb$field_name = 'DEF_STORNO_DOK'}

ALTER TABLE TBLDOKUMENTI
ADD DEF_STORNO_DOK INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'PROMENA_DATUMA_PRIJEMA'}

ALTER TABLE SYSTEM
ADD PROMENA_DATUMA_PRIJEMA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'FTP_USER'}

ALTER TABLE TBLKOMITMESTO
ADD FTP_USER VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'FTP_PASS'}

ALTER TABLE TBLKOMITMESTO
ADD FTP_PASS VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'FTP_ADRESA'}

ALTER TABLE TBLKOMITMESTO
ADD FTP_ADRESA VARCHAR(30);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'FTP_FOLDER'}

ALTER TABLE TBLKOMITMESTO
ADD FTP_FOLDER VARCHAR(250);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'FTP_PORT'}

ALTER TABLE TBLKOMITMESTO
ADD FTP_PORT VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLAKCIJE'
and f.rdb$field_name = 'SIFRA_DOKUMENTA'}

ALTER TABLE TBLAKCIJE
ADD SIFRA_DOKUMENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SRV_STARTED_WORKORDER'
}

CREATE TABLE SRV_STARTED_WORKORDER (
    BROJ_NALOGA INTEGER,
    GODINA_NALOGA INTEGER,
    SIFRA_RADNIKA INTEGER,
    VRSTA_NALOGA CHAR(1),
    DISABLE_MULTI_WORKORDER SMALLINT);

COMMIT WORK;

COMMENT ON COLUMN SRV_STARTED_WORKORDER.DISABLE_MULTI_WORKORDER IS
'1-nalog je teren i ne moze da ima vise od jednog
0-nalog je u lokalu i moguce je da postoji vise od jednog naloga';

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'PDT_LOKACIJE'
}

CREATE TABLE PDT_LOKACIJE (
   SIFRA_MAGACINA  INTEGER NOT NULL,
   LOKACIJA        VARCHAR(255) NOT NULL
);

ALTER TABLE PDT_LOKACIJE ADD CONSTRAINT PDT_LOKACIJE_PK PRIMARY KEY (LOKACIJA, SIFRA_MAGACINA);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'RACUN_POVRAT_UDALJENI_SERVER'}

ALTER TABLE SYSTEM_MP
ADD RACUN_POVRAT_UDALJENI_SERVER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_ORDER'
}
-- ovo je preuzeto iz monolita

CREATE TABLE SYSTEM_ORDER (
    ID INTEGER NOT NULL,
    VSB_PREDKALKULACIJA SMALLINT);

ALTER TABLE SYSTEM_ORDER ADD CONSTRAINT PK_SYSTEM_ORDER PRIMARY KEY (ID);

{$ENDIF}


{$IFNOTEXISTS SELECT * 
FROM RDB$RELATION_FIELDS F 
WHERE F.RDB$RELATION_NAME = 'TBLPRIJEM_DOKUMENATA'}

-- ovo je preuzeto iz monolita

CREATE TABLE TBLPRIJEM_DOKUMENATA (
    ID INTEGER NOT NULL,
    SIFRA_DOKUMENTA INTEGER NOT NULL,
    SIFRA_KOMITENTA INTEGER NOT NULL,
    SIFRA_MAGACINA INTEGER NOT NULL,
    SIFRA_MAGACINA_IZ INTEGER,
    SIFRA_RADNIKA INTEGER NOT NULL,
    ID_STATUSA INTEGER,
    DATUMDPO DATE NOT NULL,
    DATUMVALUTE DATE,
    BUD VARCHAR(20),
    BID INTEGER,
    KOMITENT VARCHAR(250),
    NAPOMENA VARCHAR(250),
    DATUMPRIJEMA DATE,
    VREDNOST DECIMAL(18,4),
    DATUM_CHANGE TIMESTAMP,
    RADNIK_CHANGE INTEGER,
    DATUM_RADA TIMESTAMP,
    IDNOVCANO INTEGER,
    ZAKLJUCANO SMALLINT);

ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT PK_TBLPRIJEM_DOKUMENATA PRIMARY KEY (ID);

CREATE SEQUENCE GEN_PRIJEM_DOKUM_ID;

create procedure sp_gen_prijem_dokum_id
returns (id integer)
as
begin
  id = gen_id(gen_prijem_dokum_id, 1);
  suspend;
end;

CREATE trigger tblprijem_dokumenata_bi0 for tblprijem_dokumenata
active before insert position 0
as
declare variable bid integer;
begin
  select max(bid) from tblprijem_dokumenata
  where extract(year from datumprijema) = extract(year from new.datumprijema) into bid;

  if (bid is null) then new.bid=1;
  else new.bid = :bid+1;
end;

ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_SD FOREIGN KEY (SIFRA_DOKUMENTA) REFERENCES TBLDOKUMENTI(SIFRA_DOKUMENTA);
ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_MG1 FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN(SIFRA_MAGACINA);
ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_MG2 FOREIGN KEY (SIFRA_MAGACINA_IZ) REFERENCES TBLMAGACIN(SIFRA_MAGACINA);
ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_SR FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI(SIFRA_RADNIKA);
ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_RC FOREIGN KEY (RADNIK_CHANGE) REFERENCES TBLRADNICI(SIFRA_RADNIKA);
ALTER TABLE TBLPRIJEM_DOKUMENATA ADD CONSTRAINT FK_TBLPRIJEM_DOKUMENATA_NV FOREIGN KEY (IDNOVCANO) REFERENCES TBLNOVCANO(IDNOVCANO);


ALTER TABLE SYSTEM_ORDER ADD OBAVEZAN_PRIJEM_DOK SMALLINT;

COMMENT ON COLUMN SYSTEM_ORDER.OBAVEZAN_PRIJEM_DOK IS
'Prilikom unosa kalkulacije obavezno uneti prijemni broj (zegin) iz tabele tblprijem_dokumenata.';

ALTER TABLE TBLNOVCANO ADD BROJ_PRIJEMA_DOK VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPRIJEM_DOKUMENATA'
and f.rdb$field_name = 'ID_KLIJENTA'}


ALTER TABLE TBLPRIJEM_DOKUMENATA
ADD ID_KLIJENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'REST_ONE_STOP_MARKETING'
}

CREATE TABLE REST_ONE_STOP_MARKETING (
    ID INTEGER,
    ADDRESS VARCHAR(250),
    PORT VARCHAR(250),
    REQUEST_ARTICAL VARCHAR(250),
    REQUEST_STATE VARCHAR(250),
    REQUEST_TRANSACTION VARCHAR(250));

COMMIT WORK;

CREATE SEQUENCE GEN_REST_ONE_STOP_MARKETING_ID;

COMMIT WORK;

create trigger rest_one_stop_marketing_bi for rest_one_stop_marketing
active before insert position 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_rest_one_stop_marketing_id,1);
end;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPROMENE'
and f.rdb$field_name = 'RABAT4'}


ALTER TABLE TBLPROMENE
ADD RABAT4 DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYS_BROJ_DOC'
and f.rdb$field_name = 'GODINA'}

ALTER TABLE SYS_BROJ_DOC
ADD GODINA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'RACUN_POVRAT_MPF1'}

ALTER TABLE SYSTEM_MP
ADD RACUN_POVRAT_MPF1 SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'POVRAT_CELO_PAKOVANJE_DOB'}


ALTER TABLE SYSTEM_MP
ADD POVRAT_CELO_PAKOVANJE_DOB SMALLINT;

update SYSTEM_MP set POVRAT_CELO_PAKOVANJE_DOB = 1;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_TBLVAUCER_ID'}

CREATE SEQUENCE GEN_TBLVAUCER_ID;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_TBLVAUCERSTAVKE_ID'}

CREATE SEQUENCE GEN_TBLVAUCERSTAVKE_ID;

{$ENDIF}


{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_TBLVAUCERSTAVKE_ID'}

SET TERM ^ ;

create or alter procedure SP_GEN_TBLVAUCERSTAVKE_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblvaucerstavke_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_TBLVAUCER_ID'}

SET TERM ^ ;

create or alter procedure SP_GEN_TBLVAUCER_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblvaucer_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVAUCER'
}

CREATE TABLE TBLVAUCER (
    ID               INTEGER NOT NULL,
    SIFRA_KOMITENTA  INTEGER,
    RADNIK_CHANGE    INTEGER,
    DATE_CHANGE      TIMESTAMP,
    DATUM_OD         DATE,
    DATUM_DO         DATE
);

ALTER TABLE TBLVAUCER ADD CONSTRAINT PK_TBLVAUCER PRIMARY KEY (ID);
ALTER TABLE TBLVAUCER ADD CONSTRAINT FK_TBLVAUCER_KOMITENT FOREIGN KEY (SIFRA_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);
ALTER TABLE TBLVAUCER ADD CONSTRAINT FK_TBLVAUCER_RADNIK FOREIGN KEY (RADNIK_CHANGE) REFERENCES TBLRADNICI (SIFRA_RADNIKA);


{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVAUCERSTAVKE'
}


CREATE TABLE TBLVAUCERSTAVKE (
    ID             INTEGER NOT NULL,
    IDVAUCER       INTEGER,
    SERIJSKI       BIGINT,
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER,
    IZNOS          INTEGER,
    REALIZOVAN     INTEGER,
    IDZG           INTEGER,
    IDNOVCANO      INTEGER
);

ALTER TABLE TBLVAUCERSTAVKE ADD CONSTRAINT UNQ1_TBLVAUCERSTAVKE UNIQUE (SERIJSKI);
ALTER TABLE TBLVAUCERSTAVKE ADD CONSTRAINT PK_TBLVAUCERSTAVKE PRIMARY KEY (ID);
ALTER TABLE TBLVAUCERSTAVKE ADD CONSTRAINT FK_TBLVAUCERSTAVKE_1 FOREIGN KEY (RADNIK_CHANGE) REFERENCES TBLRADNICI (SIFRA_RADNIKA);
ALTER TABLE TBLVAUCERSTAVKE ADD CONSTRAINT FK_TBLVAUCERSTAVKE_MPFISKZ FOREIGN KEY (IDZG) REFERENCES MP_FISK_Z (IDZ);
ALTER TABLE TBLVAUCERSTAVKE ADD CONSTRAINT FK_TBLVAUCERSTAVKE_VAUCER FOREIGN KEY (IDVAUCER) REFERENCES TBLVAUCER (ID);


{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'PREDRACUN_CENA_BEZ_PDV_A'}


ALTER TABLE SYSTEM_MP
ADD PREDRACUN_CENA_BEZ_PDV_A SMALLINT;


{$ENDIF}




{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI'
and f.rdb$field_name = 'FAJL_STAMPE_SPEC_PDV'}


ALTER TABLE TBLDOKUMENTI
ADD FAJL_STAMPE_SPEC_PDV VARCHAR(255);


{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'RAZLIKA'}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD RAZLIKA DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'SERVER'}

ALTER TABLE TBLMAGACIN
ADD SERVER SMALLINT;

COMMENT ON COLUMN TBLMAGACIN.SERVER IS 'magacin radi u touchscreenu na serveru i ima privremenu prodaju preko hp_obracuna, pa treba da se racuna kolicina na lageru';

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKOMITENTI' 
and f.rdb$field_name = 'JBBK'
} 
ALTER TABLE TBLKOMITENTI
ADD JBBK VARCHAR(50);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKOMITENTI' 
and f.rdb$field_name = 'ADRESA_PTT'
} 
ALTER TABLE TBLKOMITENTI ADD ADRESA_PTT varchar(50) ; 
commit work; 
{$ENDIF}



{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKOMITENTI_TEL' 

} 
CREATE TABLE TBLKOMITENTI_TEL (
    ID               INTEGER NOT NULL,
    SIFRA_KOMITENTA  INTEGER,
    KONTAKT          VARCHAR(100),
    TELEFON          VARCHAR(50),
    MAIL             VARCHAR(50),
    SIFRA_RADNIKA    INTEGER,
    DATUM_VREME      TIMESTAMP,
    FUNKCIJA         VARCHAR(255),
    SMS              SMALLINT DEFAULT 0
);

CREATE SEQUENCE GEN_TBLKOMITENTI_TEL;
ALTER SEQUENCE GEN_TBLKOMITENTI_TEL RESTART WITH 1;

ALTER TABLE TBLKOMITENTI_TEL ADD CONSTRAINT PK_TBLKOMITENTI_TEL PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_TBLKOMITENTI_TEL
returns (
    ID integer)
as
begin
  ID = gen_id(gen_tblkomitenti_tel, 1);
  suspend;
end^

SET TERM ; ^


{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKOMITENTI_TEL' 
and f.rdb$field_name = 'SMS'
} 
ALTER TABLE TBLKOMITENTI_TEL ADD SMS SMALLINT DEFAULT 0; 
commit work; 
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'MP_FISK_Z' 
and f.rdb$field_name = 'FISKAL_PORUKA'
} 

ALTER TABLE MP_FISK_Z
ADD FISKAL_PORUKA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_KASA_ISECAK' 
and f.rdb$field_name = 'ODRADI_SAMO_DNEVNI'
} 

ALTER TABLE FISKALNA_KASA_ISECAK
ADD ODRADI_SAMO_DNEVNI SMALLINT;

update FISKALNA_KASA_ISECAK set odradi_samo_dnevni = 1;
commit work;
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM' 
and f.rdb$field_name = 'MAX_NESLAGANJE_KALKULACIJE'
} 

ALTER TABLE SYSTEM
ADD MAX_NESLAGANJE_KALKULACIJE DECIMAL(18,2);

update SYSTEM set MAX_NESLAGANJE_KALKULACIJE = 0.5;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'DOZVOLI_ROBU_IZ_USLUGA'
} 

ALTER TABLE SYSTEM_MP
ADD DOZVOLI_ROBU_IZ_USLUGA SMALLINT;

update system_mp set DOZVOLI_ROBU_IZ_USLUGA = 0;
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLTREBOVANJESTAVKE' 
and f.rdb$field_name = 'BARKOD'
} 

ALTER TABLE TBLTREBOVANJESTAVKE
ADD BARKOD VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLNOVCANO' 
and f.rdb$field_name = 'BROJ_FISKALNOG'
} 

ALTER TABLE TBLNOVCANO
ADD BROJ_FISKALNOG INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYS_BROJ' 
and f.rdb$field_name = 'VREME'
} 

ALTER TABLE SYS_BROJ
ADD VREME TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYS_BROJ' 
and f.rdb$field_name = 'SIFRA_RADNIKA'
} 

ALTER TABLE SYS_BROJ
ADD SIFRA_RADNIKA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'RABAT_PO_KATEGORIJI'
} 

ALTER TABLE SYSTEM_MP
ADD RABAT_PO_KATEGORIJI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'RABAT_PO_PROIZVODJACU'
} 

ALTER TABLE SYSTEM_MP
ADD RABAT_PO_PROIZVODJACU SMALLINT;

{$ENDIF}



{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'DATUM_UNOSA'
} 

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD DATUM_UNOSA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'DATUM_IZMENE'
} 

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD DATUM_IZMENE TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA'
and f.rdb$field_name = 'DOPUNE'
} 


ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD DOPUNE NUMERIC(18,2);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVNI_DOPUNE'
} 

CREATE TABLE FISKALNA_DNEVNI_DOPUNE (
    ID          INTEGER NOT NULL,
    ID_DNEVNI   INTEGER NOT NULL,
    SIFRA_KASE  INTEGER NOT NULL,
    SIFRA_ROBE  INTEGER NOT NULL,
    KOLICINA    DECIMAL(18,4),
    VREDNOST    DECIMAL(18,4)
);


ALTER TABLE FISKALNA_DNEVNI_DOPUNE ADD CONSTRAINT PK_FISKALNA_DNEVNI_DOPUNE PRIMARY KEY (ID, ID_DNEVNI, SIFRA_KASE, SIFRA_ROBE);
ALTER TABLE FISKALNA_DNEVNI_DOPUNE ADD CONSTRAINT FK_FISKALNA_DNEVNI_DOPUNE_1 FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVNI_DOPUNE'
and f.rdb$field_name = 'POSLATO'
} 


ALTER TABLE FISKALNA_DNEVNI_DOPUNE
ADD POSLATO INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'NEFISKLANI_SINDIKAT'
} 

ALTER TABLE SYSTEM_MP
ADD NEFISKLANI_SINDIKAT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'BR_RACUNA_U_PREGLEDU'
} 

ALTER TABLE SYSTEM_MP
ADD BR_RACUNA_U_PREGLEDU INTEGER;

update SYSTEM_MP set BR_RACUNA_U_PREGLEDU = 100000;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLMAGACIN' 
and f.rdb$field_name = 'SIFRA_ZA_FOND'
} 

ALTER TABLE TBLMAGACIN
ADD SIFRA_ZA_FOND VARCHAR(20);

update TBLMAGACIN M
set M.SIFRA_ZA_FOND = M.SKRACENICA;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'CITO'
} 


ALTER TABLE AP_RECEPTI
ADD CITO VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'ZABRANA_PARALELE'
} 


ALTER TABLE AP_RECEPTI
ADD ZABRANA_PARALELE INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'ATRIBUT'
} 

ALTER TABLE AP_RECEPTI
ADD ATRIBUT INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_LISTA'
} 
ALTER TABLE AP_RECEPTI
ADD E_LISTA VARCHAR(10);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPNA_MARZA'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPNA_MARZA DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPAN_POREZ'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPAN_POREZ DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPNA_CENA'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPNA_CENA DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPAN_IZNOS'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPAN_IZNOS DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPNA_NAB_VRED'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPNA_NAB_VRED DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'AP_RECEPTI' 
and f.rdb$field_name = 'E_UKUPNA_PARTICIPACIJA'
} 
ALTER TABLE AP_RECEPTI
ADD E_UKUPNA_PARTICIPACIJA DECIMAL(18,2);
{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVNI_SMENA' 
and f.rdb$field_name = 'DATUM_ZAVRSETKA'
}

ALTER TABLE FISKALNA_DNEVNI_SMENA
ADD DATUM_ZAVRSETKA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TIP_PLACANJA' 
and f.rdb$field_name = 'AKTIVAN'
}

ALTER TABLE TIP_PLACANJA
ADD AKTIVAN INTEGER;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'REINDEXIRAJ'}

SET TERM ^ ;

create or alter procedure REINDEXIRAJ
returns (
    ZAVRSENO integer)
as
declare variable INDEX_NAME varchar(31);
begin
FOR SELECT RDB$INDEX_NAME FROM RDB$INDICES INTO :INDEX_NAME DO 
  EXECUTE STATEMENT 'SET STATISTICS INDEX ' || :INDEX_NAME || ';';

  zavrseno = 1;
--  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLDIMENZIJE_ARTIKLI' 
}


CREATE TABLE TBLDIMENZIJE_ARTIKLI (
    ID             INTEGER NOT NULL,
    NAZIV          VARCHAR(255),
    SIFRA_RADNIKA  INTEGER,
    DATUM_UNOSA    TIMESTAMP
);

ALTER TABLE TBLDIMENZIJE_ARTIKLI ADD CONSTRAINT PK_TBLDIMENZIJE_ARTIKLI PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLARTIKLI' 
and f.rdb$field_name = 'ID_DIMENZIJE'
}

ALTER TABLE TBLARTIKLI
ADD ID_DIMENZIJE integer;

ALTER TABLE TBLARTIKLI ADD CONSTRAINT FK_TBLARTIKLI_DIM FOREIGN KEY (ID_DIMENZIJE) REFERENCES TBLDIMENZIJE_ARTIKLI (ID);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLAPOTEKE_SETUP' 
and f.rdb$field_name = 'HOST_REST'
}

ALTER TABLE TBLAPOTEKE_SETUP
ADD HOST_REST VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLAPOTEKE_SETUP' 
and f.rdb$field_name = 'PORT_REST'
}

ALTER TABLE TBLAPOTEKE_SETUP
ADD PORT_REST INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'COMPORT'
}

ALTER TABLE VAGA
ADD COMPORT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'BAUD'
}

ALTER TABLE VAGA
ADD BAUD INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'PARITY'
}

ALTER TABLE VAGA
ADD PARITY SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'STOPBITS'
}

ALTER TABLE VAGA
ADD STOPBITS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'DATABITS'
}

ALTER TABLE VAGA
ADD DATABITS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'AUTOMATSKA_VAGA'
}

ALTER TABLE VAGA
ADD AUTOMATSKA_VAGA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM' 
and f.rdb$field_name = 'KONTROLISI_PROMET_KASA'
}

ALTER TABLE SYSTEM
ADD KONTROLISI_PROMET_KASA SMALLINT default 1;

update system set KONTROLISI_PROMET_KASA = 1;

update system s
set s.kontrolisi_promet_kasa = 0
where (select first 1 pib from tblhost) = '106659216';

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKONTO' 
and f.rdb$field_name = 'KONTO_ZARADA'
}

ALTER TABLE TBLKONTO
ADD KONTO_ZARADA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLNOVCANO' 
and f.rdb$field_name = 'POZIV_BROJ'
}

ALTER TABLE TBLNOVCANO
ADD POZIV_BROJ VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKONTO' 
and f.rdb$field_name = 'PDV_PRIJAVA'
}

ALTER TABLE TBLKONTO
ADD PDV_PRIJAVA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKONTO' 
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE TBLKONTO
ADD DATE_CHANGE TIMESTAMP;

{$ENDIF}


{$IFNOTEXISTS select * 
from tblkonta 
where sifra_konta = 2040
}

INSERT INTO TBLKONTA (SIFRA_KONTA, KONTO, GRUPA, PODGRUPA, LOKACIJA, OPIS_KONTA)
              VALUES (2040, '2040', NULL, NULL, NULL, '2040-KUPAC');
COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select * 
from tblkonta 
where sifra_konta = 4350
}

INSERT INTO TBLKONTA (SIFRA_KONTA, KONTO, GRUPA, PODGRUPA, LOKACIJA, OPIS_KONTA)
              VALUES (4350, '4350', NULL, NULL, NULL, '4350-DOBAVLJAC');
COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select * 
from tblkonto 
where analitika = '2040'
}

INSERT INTO TBLKONTO (ID_KONTA, ANALITIKA, SUB_ANALITIKA, NAZIV_KONTA, KOD, DUGUJE, POTRAZUJE, AKTIVAN, DUGUJE_PR, POTRAZUJE_PR, DUGOVNI, POTRAZNI, PRELAZ_A_P, IZVESTAJ_PIR, BILANS, KONTO, AKTIVA_PASIVA, PR_DOC, DUGUJE_DEV, POTRAZUJE_DEV, VRSTA_ANALITIKE, ID_ANALITIKE, DUGUJE_POTRAZUJE, TIP, ID_NAMENE, PROTIVKONTO, STRANI_NAZIV, DATE_CHANGE, RADNIK_CHANGE, KONTO_ZARADA, PDV_PRIJAVA)
              VALUES (1447, '2040', '0', 'POTRAZIVANJA OD KUPACA U ZEMLJI', 'A', 0, 0, 1, 0, 0, 0, 0, 0, NULL, 'Stanja', NULL, NULL, NULL, 0, 0, 'KOMITENT', 1, NULL, NULL, NULL, NULL, NULL, '2015-12-26 11:10:16', 73, NULL, NULL);
COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select * 
from tblkonto 
where analitika = '4350'
}

INSERT INTO TBLKONTO (ID_KONTA, ANALITIKA, SUB_ANALITIKA, NAZIV_KONTA, KOD, DUGUJE, POTRAZUJE, AKTIVAN, DUGUJE_PR, POTRAZUJE_PR, DUGOVNI, POTRAZNI, PRELAZ_A_P, IZVESTAJ_PIR, BILANS, KONTO, AKTIVA_PASIVA, PR_DOC, DUGUJE_DEV, POTRAZUJE_DEV, VRSTA_ANALITIKE, ID_ANALITIKE, DUGUJE_POTRAZUJE, TIP, ID_NAMENE, PROTIVKONTO, STRANI_NAZIV, DATE_CHANGE, RADNIK_CHANGE, KONTO_ZARADA, PDV_PRIJAVA)
              VALUES (1457, '4350', '0', 'Dobavljaci u zemlji', 'A', 0, 0, 1, 0, 0, 0, 0, 0, NULL, 'Stanja', NULL, NULL, NULL, 0, 0, 'KOMITENT', 1, NULL, NULL, NULL, NULL, NULL, '2014-09-30 11:23:32', 82, NULL, NULL);

COMMIT WORK;

{$ENDIF}



{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 0
}
INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (0, 'Komitent MP', 'D', NULL, '2040', '4350', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 1
}

INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (1, 'Komitent VP', 'D', NULL, '2040', '4350', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 2
}
INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (2, 'Inokomitent', 'I', NULL, '2030', '4340', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 10
}

INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (10, 'Dobavljac', 'D', NULL, '2040', '4350', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 11
}

INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (11, 'Zaposleni', 'D', NULL, '2040', '4350', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select * from TBLSTATUS where sifra_statusa = 100
}

INSERT INTO TBLSTATUS (SIFRA_STATUSA, STATUS, TIP, CENA, KUPAC, DOBAVLJAC, CENA_B, KUPAC_AV, DOBAVLJAC_AV, DATE_CHANGE, RADNIK_CHANGE)
               VALUES (100, 'Ostali', 'D', NULL, '2040', '4350', NULL, NULL, NULL, '2016-01-16 13:06:50', NULL);

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLIZVODRASPOD' 
and f.rdb$field_name = 'DUGUJE_INO'
}

ALTER TABLE TBLIZVODRASPOD
ADD DUGUJE_INO DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLIZVODRASPOD' 
and f.rdb$field_name = 'POTRAZUJE_INO'
}

ALTER TABLE TBLIZVODRASPOD
ADD POTRAZUJE_INO DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLNOVCANO' 
and f.rdb$field_name = 'PL_IZNOS_INO'
}

ALTER TABLE TBLNOVCANO
ADD PL_IZNOS_INO DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLIZVODI' 
and f.rdb$field_name = 'PL_IZNOS_INO'
}

ALTER TABLE TBLIZVODI
ADD PL_IZNOS_INO DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'PRVI_PUT_POKRENUT_PROGRAM'
}

ALTER TABLE SYSTEM_MP
ADD PRVI_PUT_POKRENUT_PROGRAM INTEGER;

{$ENDIF}


{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'AP_LEKOVI_PROIZVODJAC_IDPRO'}

CREATE INDEX AP_LEKOVI_PROIZVODJAC_IDPRO
ON AP_LEKOVI_PROIZVODJAC (ID_PROIZVODJAC);

{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'AP_LEKOVI_ATC_IDATC'}

CREATE INDEX AP_LEKOVI_ATC_IDATC
ON AP_LEKOVI_ATC (ID_ATC);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLARTIKLI' 
and f.rdb$field_name = 'POVRATNA_AMBALAZA'
}

ALTER TABLE TBLARTIKLI
ADD POVRATNA_AMBALAZA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_OBRACUN' 
and f.rdb$field_name = 'POVRATNA_AMBALAZA'
}

ALTER TABLE HP_OBRACUN
ADD POVRATNA_AMBALAZA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'USE_SAVED_DISCOUNT'
}

ALTER TABLE SYSTEM_MP
ADD USE_SAVED_DISCOUNT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'DISCOUNT_CUSTOMER_ARTICAL' 
}

CREATE TABLE DISCOUNT_CUSTOMER_ARTICAL (
    CUSTOMER_ID  INTEGER NOT NULL,
    ARTICAL_ID   INTEGER NOT NULL,
    DISCOUNT     DECIMAL(18,4),
    DATA_CHANGE  TIMESTAMP
);

ALTER TABLE DISCOUNT_CUSTOMER_ARTICAL ADD CONSTRAINT PK_DISCOUNT_CUSTOMER_ARTICAL PRIMARY KEY (CUSTOMER_ID, ARTICAL_ID);

ALTER TABLE DISCOUNT_CUSTOMER_ARTICAL ADD CONSTRAINT FK_DISCOUNT_ARTICAL FOREIGN KEY (ARTICAL_ID) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE DISCOUNT_CUSTOMER_ARTICAL ADD CONSTRAINT FK_DISCOUNT_CUSTOMER FOREIGN KEY (CUSTOMER_ID) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLBARKOD' 
and f.rdb$field_name = 'KOLICINA'
}

ALTER TABLE TBLBARKOD
ADD KOLICINA DECIMAL(18,4);

update tblbarkod b set b.kolicina =1 where b.kolicina is null or (b.kolicina = 0);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLARTIKLI' 
and f.rdb$field_name = 'TBLASORTIMAN_ID'
}

ALTER TABLE TBLARTIKLI
ADD TBLASORTIMAN_ID VARCHAR(16);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLARTIKLI' 
and f.rdb$field_name = 'ID_POPDV'
}

ALTER TABLE TBLARTIKLI
ADD ID_POPDV INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'MP_FISK_Z' 
and f.rdb$field_name = 'MAT_BROJ_K2'
}

ALTER TABLE MP_FISK_Z
ADD MAT_BROJ_K2 VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBL_CENOVNIK_AKCIJE' 
}


CREATE TABLE TBL_CENOVNIK_AKCIJE (
    ID                   INTEGER NOT NULL,
    ID_CENOVNIKA         INTEGER NOT NULL,
    ID_CENOVNIKA_STAVKA  INTEGER,
    SIFRA_ROBE           INTEGER NOT NULL,
    CENA                 DECIMAL(18,4) NOT NULL,
    RABAT                DECIMAL(18,4),
    NETO_CENA            DECIMAL(18,4),
    AKCIJA_OD            DATE,
    AKCIJA_DO            DATE,
    VREME_OD             TIME,
    VREME_DO             TIME,
    AKTIVAN              SMALLINT,
    SIFRA_RADNIKA        INTEGER,
    DATUM_UNOSA          TIMESTAMP,
    CENOVNIK             CHAR(1),
    STARA_CENA           DECIMAL(18,2)
);

ALTER TABLE TBL_CENOVNIK_AKCIJE ADD CONSTRAINT PK_TBL_CENOVNIK_AKCIJE PRIMARY KEY (ID);


ALTER TABLE TBL_CENOVNIK_AKCIJE ADD CONSTRAINT FK_TBL_CENE_AKCIJE_IDC FOREIGN KEY (ID_CENOVNIKA) REFERENCES TIP_CENOVNIKA (ID);
--ALTER TABLE TBL_CENOVNIK_AKCIJE ADD CONSTRAINT FK_TBL_CENE_AKCIJE_IDCS FOREIGN KEY (ID_CENOVNIKA_STAVKA) REFERENCES TBL_CENOVNIK (ID);
ALTER TABLE TBL_CENOVNIK_AKCIJE ADD CONSTRAINT FK_TBL_CENE_AKCIJE_SR FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE TBL_CENOVNIK_AKCIJE ADD CONSTRAINT FK_TBL_CENOVNIK_AKCIJE_RD FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);



CREATE INDEX TBL_CENOVNIK_AKCIJE_ADO ON TBL_CENOVNIK_AKCIJE (AKCIJA_DO);
CREATE INDEX TBL_CENOVNIK_AKCIJE_AOD ON TBL_CENOVNIK_AKCIJE (AKCIJA_OD);
CREATE INDEX TBL_CENOVNIK_AKCIJE_VDO ON TBL_CENOVNIK_AKCIJE (VREME_DO);
CREATE INDEX TBL_CENOVNIK_AKCIJE_VOD ON TBL_CENOVNIK_AKCIJE (VREME_OD);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBL_CENOVNIK_KOL' 
}


CREATE TABLE TBL_CENOVNIK_KOL (
    ID                   INTEGER NOT NULL,
    ID_CENOVNIKA         INTEGER NOT NULL,
    ID_CENOVNIKA_STAVKA  INTEGER,
    SIFRA_ROBE           INTEGER NOT NULL,
    CENA                 DECIMAL(18,4) NOT NULL,
    RABAT                DECIMAL(18,4),
    NETO_CENA            DECIMAL(18,4),
    KOLICINA_OD          DECIMAL(18,4),
    KOLICINA_DO          DECIMAL(18,4),
    AKTIVAN              SMALLINT,
    SIFRA_RADNIKA        INTEGER,
    DATUM_UNOSA          TIMESTAMP
);

ALTER TABLE TBL_CENOVNIK_KOL ADD CONSTRAINT PK_TBL_CENOVNIK_KOL PRIMARY KEY (ID);

ALTER TABLE TBL_CENOVNIK_KOL ADD CONSTRAINT FK_TBL_CENOVNIK_KOL_IDC FOREIGN KEY (ID_CENOVNIKA) REFERENCES TIP_CENOVNIKA (ID);
ALTER TABLE TBL_CENOVNIK_KOL ADD CONSTRAINT FK_TBL_CENOVNIK_KOL_RD FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);
ALTER TABLE TBL_CENOVNIK_KOL ADD CONSTRAINT FK_TBL_CENOVNIK_KOL_SR FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);



{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBL_CENOVNIK_AKCIJE' 
and f.rdb$field_name = 'CENOVNIK'
}

ALTER TABLE TBL_CENOVNIK_AKCIJE
ADD CENOVNIK CHAR(1);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBL_CENOVNIK_AKCIJE' 
and f.rdb$field_name = 'STARA_CENA'
}

ALTER TABLE TBL_CENOVNIK_AKCIJE
ADD STARA_CENA DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLASORTIMAN' 
}

CREATE TABLE TBLASORTIMAN (
    ID               VARCHAR(16) NOT NULL,
    TBLASORTIMAN_ID  VARCHAR(16),
    NAZIV            VARCHAR(100),
    KOD              VARCHAR(36)
);

ALTER TABLE TBLASORTIMAN ADD CONSTRAINT PK_TBLASORTIMAN PRIMARY KEY (ID);

CREATE INDEX TBLASORTIMAN_IDX1 ON TBLASORTIMAN (ID);
CREATE INDEX TBLASORTIMAN_IDX2 ON TBLASORTIMAN (TBLASORTIMAN_ID);
CREATE INDEX TBLASORTIMAN_IDX3 ON TBLASORTIMAN COMPUTED BY (uuid_to_char(tblasortiman_id));

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TEMP_TBLKOMITENTI' 
}

CREATE TABLE TEMP_TBLKOMITENTI (
    SIFRA_KOMITENTA        INTEGER,
    KOMITENT               VARCHAR(255),
    ADRESA                 VARCHAR(50),
    TEL1                   VARCHAR(25),
    TEL2                   VARCHAR(25),
    MOBIL_TEL              VARCHAR(25),
    HOME_TEL               VARCHAR(25),
    ZIRO_RACUN             VARCHAR(30),
    SIFRA_KATEGORIJE       INTEGER,
    SIFRA_STATUSA          INTEGER,
    SIFRA_MESTA            INTEGER,
    PIB                    VARCHAR(15),
    E_MAIL                 VARCHAR(50),
    WEB                    VARCHAR(50),
    FAX                    VARCHAR(25),
    POST_BROJ              VARCHAR(10),
    KONTAKT_OSOBA          VARCHAR(50),
    KOMENTAR               BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    RABAT                  DECIMAL(15,2) DEFAULT 0,
    PLACANJE               INTEGER default 0,
    DOZVOLJENO_ZADUZENJE   DECIMAL(15,2) default 0,
    DATUM_KUP              DATE default 'NOW',
    USER_NAME              VARCHAR(20),
    LOZINKA                VARCHAR(20),
    STANJE                 DECIMAL(15,2) default 0,
    ID_ZEMLJE              INTEGER default 1,
    PDV                    SMALLINT default 1,
    PDV_BROJ               VARCHAR(10),
    ID_RADNIK              SMALLINT,
    POSETA                 INTEGER DEFAULT 0,
    ZABRANA_IZD            CHAR(1) DEFAULT '0',
    WEB_VIDLJIV_PRODAVAC   SMALLINT,
    ID_CENOVNIKA           SMALLINT DEFAULT 1,
    ID_KOMERC              SMALLINT,
    ID_LINIJA              INTEGER,
    BROJ_LK                VARCHAR(10),
    BROJ_GAZDINSTVA        VARCHAR(12),
    JMBG                   VARCHAR(13),
    BROJ_UGOVORA           VARCHAR(15),
    FAKT_KOL               DOUBLE PRECISION DEFAULT 0,
    BROJ_KUCE              VARCHAR(6),
    ID_ULICE               INTEGER,
    EURO                   DECIMAL(18,4) DEFAULT 0,
    POL                    CHAR(1) DEFAULT 'M',
    DATUM_RODJENJA         DATE,
    MESTO_RODJENJA         VARCHAR(70),
    BROJ_PASOSA            VARCHAR(50),
    LK_IZATA_U_SUP         VARCHAR(150),
    SIGURNOST              VARCHAR(30),
    ID_GRUPE               VARCHAR(10),
    ID_GRUPE_1             VARCHAR(10),
    VALUTA                 VARCHAR(10),
    ZABRANA_IZD_VV         VARCHAR(10),
    SIFRA_KOMITENTA1       SMALLINT,
    ZAKLJUCANO             SMALLINT,
    TOLERANCIJA_KASNJENJA  INTEGER,
    ID_PRODAVCA            INTEGER,
    STARI_RABATI           DECIMAL(18,4),
    DATUM_OPOMENA          DATE,
    DATUM_SMS              TIMESTAMP,
    MAT_BROJ               VARCHAR(20),
    RADNIK_CHANGE          INTEGER,
    DATE_CHANGE            TIMESTAMP,
    ID_KOD_KOMITENTA       VARCHAR(30),
    PLACANJE_DOB           INTEGER,
    IDRABATKAT             INTEGER,
    BR_POR_RES             VARCHAR(20),
    DATUM_OTV              DATE,
    PROVERA_ZADUZENJA      SMALLINT,
    BENEFIT_KARTICA        VARCHAR(30),
    JAVNA_USTANOVA         SMALLINT,
    JBBK                   VARCHAR(50),
    PAK                    VARCHAR(20),
    AKTIVAN                SMALLINT DEFAULT 1,
    ID_CASSA_GRUPE_KOM     INTEGER,
    BENEFIT_PROGRAM        INTEGER DEFAULT 0,
    RABATMP                DECIMAL(15,2),
    PROVERA_BLOKADE_NBS    INTEGER,
    ID_NAMENE_KUP          INTEGER,
    ID_NAMENE_DOB          INTEGER,
    GLN                    VARCHAR(20),
    ADRESA_PTT             VARCHAR(50),
    DATUM_PTT              DATE,
    CENA_LAGEROVANJA       DECIMAL(18,4),
    ID_NAMENE              INTEGER,
    PROVERA_USLOVA_DOB     INTEGER,
    SLANJE_MAIL            SMALLINT,
    TOLERANCIJA_VV         DECIMAL(18,2),
    MINIMALNI_RUC          DECIMAL(18,4),
    SIFRA_DOB              VARCHAR(30),
    ID_TIP_KJS_TREZOR      INTEGER,
    ID                     INTEGER,
    STATUS                 VARCHAR(20),
    KATEGORIJA             VARCHAR(50),
    MESTO                  VARCHAR(50),
    JBKJS                  VARCHAR(50),
    URADJENO               SMALLINT DEFAULT 0,
    UPDATE_MESTO           SMALLINT,
    UPDATE_STATUS          SMALLINT,
    UPDATE_KATEGORIJA      SMALLINT
);

{$ENDIF}



{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_TEMP_TBLKOMITENTI_ID'}

CREATE SEQUENCE GEN_TEMP_TBLKOMITENTI_ID;

SET TERM ^ ;

create procedure sp_gen_temp_tblkomitenti_id
returns (id integer)
as
begin
  id = gen_id(gen_temp_tblkomitenti_id, 1);
  suspend;
end^

SET TERM ; ^



CREATE SEQUENCE GEN_TBLKATEGORIJA_ID;

SET TERM ^ ;

create procedure sp_gen_tblkategorija_id
returns (id integer)
as
begin
  id = gen_id(gen_tblkategorija_id, 1);
  suspend;
end^

SET TERM ; ^



CREATE SEQUENCE GEN_TBLSTATUS_ID;

SET TERM ^ ;

create procedure sp_gen_tblstatus_id
returns (id integer)
as
begin
  id = gen_id(gen_tblstatus_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TIP_CENOVNIKA' 
and f.rdb$field_name = 'DEFAULT_MP_VP'
}


ALTER TABLE TIP_CENOVNIKA
ADD DEFAULT_MP_VP VARCHAR(2);

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'SEARCH_ONLY_BARCODE'
}

INSERT INTO TROLE_AKCIJE_SOFTVERA (ID, NAZIV_AKCIJE, ID_SOFTVERA)
                           VALUES (11, 'Storniranje', 2);

    COMMIT WORK;      

ALTER TABLE SYSTEM_MP
ADD SEARCH_ONLY_BARCODE SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_FISKAL' 
and f.rdb$field_name = 'GRUPISI_ARTIKLE_NA_FISK'
}

ALTER TABLE HP_FISKAL
ADD GRUPISI_ARTIKLE_NA_FISK INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_TIP' 
and f.rdb$field_name = 'BR_STAVKI_NA_FISK'
}

ALTER TABLE FISKALNA_TIP
ADD BR_STAVKI_NA_FISK INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_KASA_ISECAK' 
and f.rdb$field_name = 'BR_STAVKI_NA_FISK'
}

ALTER TABLE FISKALNA_KASA_ISECAK
ADD BR_STAVKI_NA_FISK INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_OBRACUN' 
and f.rdb$field_name = 'AMBALAZA'
}

ALTER TABLE HP_OBRACUN
ADD AMBALAZA DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'STAMPA' 
and f.rdb$field_name = 'INT4'
}

ALTER TABLE STAMPA
ADD INT4 INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'STAMPA' 
and f.rdb$field_name = 'INT5'
}

ALTER TABLE STAMPA
ADD INT5 INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'STAMPA' 
and f.rdb$field_name = 'TEXT16'
}

ALTER TABLE STAMPA
ADD TEXT16 VARCHAR(200);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TIP_PLACANJA' 
and f.rdb$field_name = 'DEFAULT'
}

ALTER TABLE TIP_PLACANJA
ADD "DEFAULT" SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'KES'
}

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD KES DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'CEK'
}

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD CEK DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'KARTICA'
}

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD KARTICA DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ' 
and f.rdb$field_name = 'VIRMAN'
}

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD VIRMAN DECIMAL(18,2);

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'SOPSTVENA_POTROSNJA'
}

ALTER TABLE SYSTEM_MP
ADD SOPSTVENA_POTROSNJA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'MP_FISK_Z_ID_DNEVNOG'}

CREATE INDEX MP_FISK_Z_ID_DNEVNOG
ON MP_FISK_Z (ID_DNEVNOG_IZVESTAJA);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPREDRACUN' 
and f.rdb$field_name = 'SIFRA_KOMITENTA_2'
}

ALTER TABLE TBLPREDRACUN
ADD SIFRA_KOMITENTA_2 INTEGER;

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPROMENE' 
and f.rdb$field_name = 'POVRATNA_AMBALAZA'
}

ALTER TABLE TBLPROMENE
ADD POVRATNA_AMBALAZA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPROMENE' 
and f.rdb$field_name = 'AMBALAZA'
}

ALTER TABLE TBLPROMENE
ADD AMBALAZA DECIMAL(18,4);

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLARTIKLI_VAGA' 
}

CREATE TABLE TBLARTIKLI_VAGA (
    SIFRA_ROBE  INTEGER NOT NULL,
    ID_VAGE     INTEGER NOT NULL,
    KOD         VARCHAR(20),
    PLU         VARCHAR(22)
);

ALTER TABLE TBLARTIKLI_VAGA ADD CONSTRAINT PK_TBLARTIKLI_VAGA PRIMARY KEY (SIFRA_ROBE, ID_VAGE);

ALTER TABLE TBLARTIKLI_VAGA ADD CONSTRAINT FK_TBLARTIKLI_VAGA_1 FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE TBLARTIKLI_VAGA ADD CONSTRAINT FK_TBLARTIKLI_VAGA_2 FOREIGN KEY (ID_VAGE) REFERENCES VAGA (ID);


{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'AUTO_UBACI_ART_CENOVNI'
}

ALTER TABLE SYSTEM_MP
ADD AUTO_UBACI_ART_CENOVNI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_FISKAL' 
and f.rdb$field_name = 'MNOZI_ODNOS_PJM'
}

ALTER TABLE HP_FISKAL
ADD MNOZI_ODNOS_PJM SMALLINT;

update hp_fiskal set mnozi_odnos_pjm = 1;

{$ENDIF}

{$IFNOTEXISTS select * from RDB$INDICES r where r.rdb$index_name = 'TBLARTIKLI_VAGA_PLU'}

CREATE INDEX TBLARTIKLI_VAGA_PLU
ON TBLARTIKLI_VAGA (PLU);

{$ENDIF}


{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'DISCOUNT_CUSTOMER_ARTICAL' 
and f.rdb$field_name = 'ACCOUNTING_DISCOUNT'
}

ALTER TABLE DISCOUNT_CUSTOMER_ARTICAL
ADD ACCOUNTING_DISCOUNT DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'USE_SAVED_ACCOUNTING_DISCOUNT'
}

ALTER TABLE SYSTEM_MP
ADD USE_SAVED_ACCOUNTING_DISCOUNT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_ORDER' 
}

CREATE TABLE SYSTEM_ORDER (
    ID                   INTEGER NOT NULL,
    VSB_PREDKALKULACIJA  SMALLINT,
    PROVERA_CASSA        SMALLINT,
    OBAVEZAN_PRIJEM_DOK  SMALLINT,
    OBAVEZNA_LOKACIJA    SMALLINT
);


ALTER TABLE SYSTEM_ORDER ADD CONSTRAINT PK_SYSTEM_ORDER PRIMARY KEY (ID);

COMMENT ON COLUMN SYSTEM_ORDER.OBAVEZAN_PRIJEM_DOK IS 
'Prilikom unosa kalkulacije obavezno uneti prijemni broj (zegin) iz tabele tblprijem_dokumenata.';

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_ORDER' 
and f.rdb$field_name = 'OBAVEZAN_PRIJEM_DOK'
}

ALTER TABLE SYSTEM_ORDER
ADD OBAVEZAN_PRIJEM_DOK SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_ORDER' 
and f.rdb$field_name = 'PROVERA_CASSA'
}

ALTER TABLE SYSTEM_ORDER
ADD PROVERA_CASSA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_ORDER' 
and f.rdb$field_name = 'OBAVEZNA_LOKACIJA'
}

ALTER TABLE SYSTEM_ORDER
ADD OBAVEZNA_LOKACIJA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPRIJEM_DOKUMENATA' 
and f.rdb$field_name = 'UUID'
}

ALTER TABLE TBLPRIJEM_DOKUMENATA
ADD UUID VARCHAR(16);

SET TERM ^ ;

CREATE OR ALTER TRIGGER TBLPRIJEM_DOKUMENATA_BI_UUID FOR TBLPRIJEM_DOKUMENATA
ACTIVE BEFORE INSERT POSITION 0
AS
begin
    if (new.uuid is null) then
        new.uuid = GEN_UUID();
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_UUID'}

SET TERM ^ ;

create or alter procedure SP_GEN_UUID
returns (
    ID varchar(16))
as
begin
  id = gen_uuid();
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLKOMITENTI' 
and f.rdb$field_name = 'PO_NABAVNOJ'
}

ALTER TABLE TBLKOMITENTI
ADD PO_NABAVNOJ SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 1}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (1, 1, 'Digi');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 2}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (2, 2, 'Bezerba');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 3}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (3, 3, 'Bezerba BX');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 4}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (4, 4, 'Bezerba PLST');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 5}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (5, 5, 'Bizerba automatska');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 6}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (6, 6, 'ELabel');

{$ENDIF}

{$IFNOTEXISTS select *
from vaga_tip t
where t.tip = 7}

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (7, 7, 'Pegaz');

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'KOD_VAGE'
}

ALTER TABLE VAGA
ADD KOD_VAGE VARCHAR(5);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'VAGA' 
and f.rdb$field_name = 'PREFIX_VAGE'
}


ALTER TABLE VAGA
ADD PREFIX_VAGE VARCHAR(7);

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'REQUESTING_SEARCH_CUSTOMER'
}

ALTER TABLE SYSTEM_MP
ADD REQUESTING_SEARCH_CUSTOMER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'RETURN_RECIPIENT_NO_NEED_NUMBER'
}

ALTER TABLE SYSTEM_MP
ADD RETURN_RECIPIENT_NO_NEED_NUMBER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP' 
and f.rdb$field_name = 'SPOSTVENA_DEF_DOC'
}

ALTER TABLE SYSTEM_MP
ADD SPOSTVENA_DEF_DOC INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_REZERVACIJA' 
and f.rdb$field_name = 'SIFRA_RADNIKA'
}

ALTER TABLE HP_REZERVACIJA
ADD SIFRA_RADNIKA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_REZERVACIJA' 
and f.rdb$field_name = 'SIFRA_RADNIKA_RACUN'
}

ALTER TABLE HP_REZERVACIJA
ADD SIFRA_RADNIKA_RACUN INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLNOVCANO' 
and f.rdb$field_name = 'IDH'
}

ALTER TABLE TBLNOVCANO
ADD IDH INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLBLAGAJNA' 
and f.rdb$field_name = 'IDH'
}

ALTER TABLE TBLBLAGAJNA
ADD IDH INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLIZVODI' 
and f.rdb$field_name = 'IDH'
}

ALTER TABLE TBLIZVODI
ADD IDH INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from ICONS_SHORTCUTS f
where f.CAPTION = 'Stara Prodaja'
}

INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION)
                     VALUES (25, NULL, 1, 'Stara Prodaja');

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_TROLE_OTVORIO_FORMU'}

CREATE SEQUENCE GEN_TROLE_OTVORIO_FORMU;

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'TROLE_RADNIK_SOFTVER_FORMA' 
}

CREATE TABLE TROLE_RADNIK_SOFTVER_FORMA (
    ID             VARCHAR(16) NOT NULL,
    SIFRA_RADNIKA  INTEGER,
    ID_SOFTVERA    INTEGER,
    ID_FORME       VARCHAR(100),
    BROJ_PUTA      INTEGER
);


ALTER TABLE TROLE_RADNIK_SOFTVER_FORMA ADD CONSTRAINT PK_TROLE_RADNIK_SOFTVER_FORMA PRIMARY KEY (ID);

SET TERM ^ ;

CREATE OR ALTER TRIGGER TROLE_RADNIK_SOFTVER_FORMA_BI FOR TROLE_RADNIK_SOFTVER_FORMA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_uuid();
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * 
from rdb$relation_fields f 
where f.rdb$relation_name = 'WORKER_SHORTCUTS' 
and f.rdb$field_name = 'ID_TROLE'
}

ALTER TABLE WORKER_SHORTCUTS
ADD ID_TROLE INTEGER;

{$ENDIF}

 {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'MESTO_SLANJA'
 }
 
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
 ADD MESTO_SLANJA VARCHAR(100);
 
 {$ENDIF}
 
 
  {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'ID_RADNIK_POSLAO'
 }
 
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD ID_RADNIK_POSLAO INTEGER;
 
 {$ENDIF}
 
   {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'ID_RADNIK_PRIMIO'
 }
 
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD ID_RADNIK_PRIMIO INTEGER;
 
 {$ENDIF}
 
   {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'VREMEN_SLANJA'
 } 
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD VREMEN_SLANJA TIMESTAMP;
 
 {$ENDIF}
 
    {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'VREME_PREUZIMANJA'
 } 
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD VREME_PREUZIMANJA TIMESTAMP;
 
 {$ENDIF}
 
    {$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA' 
 and f.rdb$field_name = 'MESTO_PRIMANJA'
 }  
 ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD MESTO_PRIMANJA VARCHAR(100);

 {$ENDIF}

{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Prenos na server') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (1, NULL, 1, 'Prenos na server'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Prodaja') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (2, NULL, 1, 'Prodaja'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Azuriranje') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (3, NULL, 1, 'Azuriranje'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Kalkulacija') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (4, NULL, 1, 'Kalkulacija'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Stampanje Cena') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (5, NULL, 1, 'Stampanje Cena'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Trebovanje') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (6, NULL, 1, 'Trebovanje'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Porudzbenica') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (7, NULL, 1, 'Porudzbenica'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Nalog Prijema') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (8, NULL, 1, 'Nalog Prijema'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Nivelacija') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (9, NULL, 1, 'Nivelacija'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Pregled racuna') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (10, NULL, 1, 'Pregled racuna'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Fiskalne komande') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (11, NULL, 1, 'Fiskalne komande'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Promena operatera') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (12, NULL, 1, 'Promena operatera'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Popis') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (13, NULL, 1, 'Popis'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Lager') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (14, NULL, 1, 'Lager'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Dnevni izvestaj') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (15, NULL, 1, 'Dnevni izvestaj'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('KEP knjiga') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (16, NULL, 1, 'KEP knjiga'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Zatvori') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (17, NULL, 1, 'Zatvori'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Predracun') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (18, NULL, 1, 'Predracun'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Rezervacija') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (19, NULL, 1, 'Rezervacija'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Interna prijemnica') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (20, NULL, 1, 'Interna prijemnica'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Komitenti') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (21, NULL, 1, 'Komitenti'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Stara Prodaja') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (25, NULL, 1, 'Stara Prodaja'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Interna otpremnica') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (23, NULL, 1, 'Interna otpremnica'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Artikli') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (23, NULL, 1, 'Artikli'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Promena smene') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (23, NULL, 1, 'Promena smene'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Zaposleni') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (23, NULL, 1, 'Zaposleni'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Podesavanja') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (28, NULL, 1, 'Podesavanja'); {$ENDIF}
{$IFNOTEXISTS SELECT * FROM icons_shortcuts i where upper(i.caption) = upper('Avansni racuni') } INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION) VALUES (29, NULL, 1, 'Avansni racuni'); {$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'SYSTEM_MP' 
 and f.rdb$field_name = 'PRODAJA_CELO_PAKOVANJE'
}  
 
ALTER TABLE SYSTEM_MP
ADD PRODAJA_CELO_PAKOVANJE SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLJM' 
 and f.rdb$field_name = 'VAGA_KOMAD'
}  

ALTER TABLE TBLJM
ADD VAGA_KOMAD SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'VAGA' 
 and f.rdb$field_name = 'TIP_NALEPNICE'
}  

ALTER TABLE VAGA
ADD TIP_NALEPNICE VARCHAR(5);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'POL'
}  

ALTER TABLE HP_REZERVACIJA
ADD POL VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'DATUM_RODJENJA'
}  

ALTER TABLE HP_REZERVACIJA
ADD DATUM_RODJENJA DATE;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'DATUM_IZDAVANJA_PASOSA'
}  

ALTER TABLE HP_REZERVACIJA
ADD DATUM_IZDAVANJA_PASOSA DATE;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'MESTO_RODJENJA'
}  

ALTER TABLE HP_REZERVACIJA
ADD MESTO_RODJENJA VARCHAR(200);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'MESTO_STANOVANJA'
}  

ALTER TABLE HP_REZERVACIJA
ADD MESTO_STANOVANJA VARCHAR(200);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'DRZAVLJANSTVO'
}  

ALTER TABLE HP_REZERVACIJA
ADD DRZAVLJANSTVO VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'JMBG'
}  

ALTER TABLE HP_REZERVACIJA
ADD JMBG VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'MESTO_RODJENJA_STRANCI'
}  

ALTER TABLE HP_REZERVACIJA
ADD MESTO_RODJENJA_STRANCI VARCHAR(200);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'VIZA'
}  

ALTER TABLE HP_REZERVACIJA
ADD VIZA VARCHAR(100);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_REZERVACIJA' 
 and f.rdb$field_name = 'DATUM_ODOBRENJA_BORAVKA'
}  

ALTER TABLE HP_REZERVACIJA
ADD DATUM_ODOBRENJA_BORAVKA DATE;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_SOBE'
 and f.rdb$field_name = 'ADRESA'
}  

ALTER TABLE HP_SOBE
ADD ADRESA VARCHAR(100);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_SOBE'
 and f.rdb$field_name = 'STANODAVAC'
}  

ALTER TABLE HP_SOBE
ADD STANODAVAC VARCHAR(100);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLNOVCANO' 
 and f.rdb$field_name = 'DATUM_PL'
} 

ALTER TABLE TBLNOVCANO
ADD DATUM_PL DATE;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLKONTA' 
 and f.rdb$field_name = 'TBLKONTA'
} 

ALTER TABLE TBLKONTA
ADD TBLKONTA VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBL_KNJ_STAVKE' 
 and f.rdb$field_name = 'AKTIVAN'
} 

ALTER TABLE TBL_KNJ_STAVKE
ADD AKTIVAN INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'SYSTEM_MP' 
 and f.rdb$field_name = 'ACCEPTS_BARCODE_PART'
} 

ALTER TABLE SYSTEM_MP
ADD ACCEPTS_BARCODE_PART SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLPREDRACUNSASTAV' 
 and f.rdb$field_name = 'RED_BR'
} 

ALTER TABLE TBLPREDRACUNSASTAV
ADD RED_BR INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLMAGACIN' 
 and f.rdb$field_name = 'OBRISI_PREFIKS_VAGE'
} 

ALTER TABLE TBLMAGACIN
ADD OBRISI_PREFIKS_VAGE SMALLINT;

{$ENDIF}


{$IFNOTEXISTS select id 
 from FISKALNA_TIP f 
 where f.TIP = 30 
} 

INSERT INTO FISKALNA_TIP (ID, TIP, FISKALNA, BEZ_POREZA_BP, OSNOVNA_STOPA_OS, POSEBNA_STOPA_PS, BR_STAVKI_NA_FISK) VALUES (23, 30, 'Nefiskalna kasa', 1, 3, 4, NULL);

{$ENDIF}

{$IFNOTEXISTS select id 
 from FISKALNA_TIP f 
 where f.TIP = 24 
} 

INSERT INTO FISKALNA_TIP (ID, TIP, FISKALNA, BEZ_POREZA_BP, OSNOVNA_STOPA_OS, POSEBNA_STOPA_PS, BR_STAVKI_NA_FISK) VALUES (23, 24, 'Kolitbri1', 1, 3, 4, NULL);

{$ENDIF}



{$IFNOTEXISTS select id 
 from VAGA_TIP f 
 where f.TIP = 8
} 

INSERT INTO VAGA_TIP (ID, TIP, NAZIV) VALUES (8, 8, 'Elsi');

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLMAGACIN' 
 and f.rdb$field_name = 'OBRISI_PREFIKS_VAGE'
} 

ALTER TABLE SYSTEM
ADD DATE_CHANGE SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLKOMITENTI'
 and f.rdb$field_name = 'DRZAVA_IZDAVANJA_PASOSA '
}  

ALTER TABLE TBLKOMITENTI
ADD DRZAVA_IZDAVANJA_PASOSA VARCHAR(40);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLPREDRACUNSASTAV'
 and f.rdb$field_name = 'POSL_NAB_CENA'
}  

ALTER TABLE TBLPREDRACUNSASTAV
ADD POSL_NAB_CENA DECIMAL(18,4);

{$ENDIF}


{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLARTIKLI'
 and f.rdb$field_name = 'SIFRA_POREZ_IZLAZ'
}  

ALTER TABLE TBLARTIKLI
ADD SIFRA_POREZ_IZLAZ INTEGER;

ALTER TABLE TBLARTIKLI
ADD CONSTRAINT FK_TBLARTIKLI_POREZ_IZLAZ
FOREIGN KEY (SIFRA_POREZ_IZLAZ)
REFERENCES TBLPOREZ(SIFRA_POREZA);

{$ENDIF}

{$IFNOTEXISTS select r.* 
from RDB$INDICES r where r.RDB$INDEX_NAME = 'HP_OBRACUN_IDX_SR_RECEPT'
}

CREATE INDEX HP_OBRACUN_IDX_SR_RECEPT
ON HP_OBRACUN (SIFRA_ROBE_RECEPT);

{$ENDIF}

{$IFNOTEXISTS select r.* 
from RDB$INDICES r where r.RDB$INDEX_NAME = 'TBLNOVCANO_IDX_GODINA'
}

CREATE INDEX TBLNOVCANO_IDX_GODINA
ON TBLNOVCANO COMPUTED BY (EXTRACT(YEAR FROM DATUMDPO)) ;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_TBLKATEGORIJA_ID'}

CREATE SEQUENCE GEN_TBLKATEGORIJA_ID;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_TBLSTATUS_ID'}

CREATE SEQUENCE GEN_TBLSTATUS_ID;

{$ENDIF}

{$IFNOTEXISTS select r.* 
from RDB$INDICES r where r.RDB$INDEX_NAME = 'HP_OBRACUN_SRPKSM'
}

CREATE INDEX HP_OBRACUN_SRPKSM
ON HP_OBRACUN (SIFRA_ROBE,POSLATOUKNJIGOVODSTVO,SIFRA_MAGACINA);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TBLREZERVACIJA'
 and f.rdb$field_name = 'ID_PREDRACUNA'
}  

ALTER TABLE TBLREZERVACIJA
ADD ID_PREDRACUNA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'HP_OBRACUN'
 and f.rdb$field_name = 'GUID'
}  

ALTER TABLE HP_OBRACUN
ADD GUID VARCHAR(16);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'MP_FISK_Z'
 and f.rdb$field_name = 'GUID'
}  

ALTER TABLE MP_FISK_Z
ADD GUID VARCHAR(16);

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
 where f.rdb$relation_name = 'TIP_PLACANJA'
 and f.rdb$field_name = 'DEFAULT_PREDRACUN'
}  

ALTER TABLE TIP_PLACANJA
ADD DEFAULT_PREDRACUN SMALLINT;

COMMIT WORK;

update tip_placanja p set p.default_predracun = 1 where upper(p.naziv) = 'CEKOVI';

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ZABRANA_PRODAJE_PO_KAT'
}  

ALTER TABLE SYSTEM_MP
ADD ZABRANA_PRODAJE_PO_KAT integer;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'HP_FISKAL'
and f.rdb$field_name = 'SIFRA_PROIZV_UF_PRODAJA'
}  

ALTER TABLE HP_FISKAL
ADD SIFRA_PROIZV_UF_PRODAJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
} 

CREATE TABLE FISKALNA_DNEVNI_IZMENA (
    GUID     VARCHAR(16),
    KES      DECIMAL(18,2),
    CEK      DECIMAL(18,2),
    KARTICA  DECIMAL(18,2),
    VIRMAN   DECIMAL(18,2),
    ID       INTEGER NOT NULL,
    BI       INTEGER,
    BD       INTEGER,
    VREME    TIMESTAMP
);

{$ENDIF}


{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_FISKALNA_DNEVNI_IZMENA_ID'}

CREATE SEQUENCE GEN_FISKALNA_DNEVNI_IZMENA_ID;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPROMENE'
and f.rdb$field_name = 'VEZA_IDP'
}  

ALTER TABLE TBLPROMENE
ADD VEZA_IDP BIGINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'VALUE_ADDED_TAX'
}  

ALTER TABLE SYSTEM
ADD VALUE_ADDED_TAX SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * 
 from rdb$relation_fields f 
where f.rdb$relation_name = 'TBLPROMENE'
and f.rdb$field_name = 'ID_REZERVACIJASASTAV'
}  

ALTER TABLE TBLPROMENE
ADD ID_REZERVACIJASASTAV INTEGER;

{$ENDIF}

{$IFEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'STAMPA'
and f.rdb$field_name = 'TEXT11'
}  

ALTER TABLE STAMPA DROP TEXT11;

ALTER TABLE STAMPA
ADD TEXT11 VARCHAR(10000);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'STAMPA'
and f.rdb$field_name = 'TEXT11'
}  

ALTER TABLE STAMPA
ADD TEXT11 VARCHAR(10000);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'VISE_INTERNIH_U_TOKU_DANA'
}  

ALTER TABLE SYSTEM_MP
ADD VISE_INTERNIH_U_TOKU_DANA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'MANDATORY_ENTRY_PAYMENT'
}  

ALTER TABLE SYSTEM_MP
ADD MANDATORY_ENTRY_PAYMENT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI_AKCIJA'
and f.rdb$field_name = 'ID_AKCIJE'
}  

ALTER TABLE TBLARTIKLI_AKCIJA
ADD ID_AKCIJE INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLAKCIJE'
and f.rdb$field_name = 'AKTIVNA'
}  

ALTER TABLE TBLAKCIJE
ADD AKTIVNA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLAKCIJE'
and f.rdb$field_name = 'PORUKA'
} 

ALTER TABLE TBLAKCIJE
ADD PORUKA VARCHAR(1024);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_BRZINA_PRETRAGE'
} 

CREATE TABLE HP_BRZINA_PRETRAGE (
    GUID            VARCHAR(16),
    VREME_TRAJANJA  DOUBLE PRECISION,
    MAC_ADRESA      VARCHAR(20),
    SIFRA_RADNIKA   INTEGER,
    DATUM           TIMESTAMP,
    DEO_PROGRAMA    VARCHAR(20)
);


SET TERM ^ ;

/* Trigger: HP_BRZINA_PRETRAGE_BI0 */
CREATE OR ALTER TRIGGER HP_BRZINA_PRETRAGE_BI0 FOR HP_BRZINA_PRETRAGE
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if (new.guid is null) then
  new.guid = gen_uuid();
end
^

SET TERM ; ^

{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ENABLE_PACKING_AUTO_INT'
} 

ALTER TABLE SYSTEM_MP
ADD ENABLE_PACKING_AUTO_INT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUNSASTAV'
and f.rdb$field_name = 'SKOLICINA'
} 

ALTER TABLE TBLPREDRACUNSASTAV
    ADD SKOLICINA DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUNSASTAV'
and f.rdb$field_name = 'REZ_KOL'
} 

ALTER TABLE TBLPREDRACUNSASTAV
    ADD REZ_KOL DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'HP_KOL'
} 

ALTER TABLE TLOKACIJA
ADD HP_KOL DECIMAL(18,4);

update tlokacija l
set l.hp_kol = 0
where l.hp_kol is null;

ALTER TABLE TLOKACIJA ALTER COLUMN HP_KOL
SET DEFAULT 0;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$procedures f
where f.rdb$procedure_name = 'MON_NAB_DOB'
} 

SET TERM ^ ;

create or alter procedure MON_NAB_DOB (
    SK integer,
    TIP smallint,
    D1 date,
    D2 date,
    MG integer)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    KOLICINE_LAGER decimal(18,4),
    UK_KOLICINA decimal(18,4),
    UK_VREDNOST decimal(18,4),
    POREZ_ULAZ decimal(18,2),
    POTRAZUJE decimal(18,4),
    ULAZ_KOL decimal(18,4),
    ULAZ_CENA decimal(18,4),
    POSNOVU decimal(18,4),
    DATUM_NAB date,
    BROJ_DANA integer)
as
BEGIN
  FOR
    select p.sifra_robe,
           a.kod,
           a.artikal,
           j.naziv as jed_mere,
           (select l.kolicina from tlokacija l where l.sifra_magacina=n.sifra_magacina and l.sifra_robe=p.sifra_robe and l.godina=extract(year from :d1)) as kolicine_lager,
           sum(p.ulaz_kol)as uk_kolicina,
           sum(p.posnovu) as uk_vrednost,
           sum(p.porez_ulaz) as porez_ulaz,
           sum(p.potrazuje) as potrazuje
    
    from tblnovcano n    join tblpromene p   on (p.idnovcano = n.idnovcano)
                         join tblartikli a   on (p.sifra_robe = a.sifra_robe)
                         join tbljm      j   on (j.id = a.idjm)
                         join tbldokumenti d on (d.sifra_dokumenta =  n.sifra_dokumenta)
    where n.sifra_komitenta=:sk
    and   d.tip=:tip
    and   n.datumdpo between :d1 and :d2
    and   n.sifra_magacina=:mg
    group by p.sifra_robe,
           a.kod,
           a.artikal,
           j.naziv,
           n.sifra_magacina
    order by 4 desc
    INTO :SIFRA_ROBE,
         :KOD,
         :ARTIKAL,
         :JED_MERE,
         :KOLICINE_LAGER,
         :UK_KOLICINA,
         :UK_VREDNOST,
         :POREZ_ULAZ,
         :POTRAZUJE
  DO
  BEGIN

    ulaz_kol=0; ulaz_cena=0; posnovu=0; datum_nab=null;

    select first 1 ulaz_kol, ulaz_cena, posnovu, datumdpo
    from tblnovcano n1 join tblpromene p1 on n1.idnovcano=p1.idnovcano
                                         and p1.sifra_robe=:sifra_robe
                                         and n1.sifra_magacina=:mg
    where ulaz_kol>0
    order by n1.datumdpo desc
    into :ulaz_kol, :ulaz_cena, :posnovu, :datum_nab;

    broj_dana = d2-datum_nab;
    SUSPEND;
  END
END^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$procedures f
where f.rdb$procedure_name = 'MNG_PROM_DOBAV'
} 

SET TERM ^ ;

create or alter procedure MNG_PROM_DOBAV (
    OD_DATUMA date,
    DO_DATUMA date,
    TIP smallint,
    KONTO integer)
returns (
    SIFRA_KOMITENTA integer,
    KOMITENT varchar(255),
    KOLICINA decimal(18,3),
    NAB_VREDNOST decimal(18,3),
    MAGACIN varchar(50),
    PLACENO decimal(18,2),
    POREZ decimal(18,2),
    UKUPNO decimal(18,2))
as
begin
  for
    select k.sifra_komitenta,
           k.komitent,
           m.magacin,
           n.pl_iznos,
           cast(sum(p.ulaz_kol) as decimal(18,3)),
           cast(sum(p.posnovu) as decimal(18,2)),
           cast(sum(p.porez_ulaz) as decimal(18,2)),
           cast(sum(p.potrazuje) as decimal(18,3))
     from tblnovcano n join tblpromene p on n.idnovcano=p.idnovcano
                       join tbldokumenti d on n.sifra_dokumenta=d.sifra_dokumenta
                       join tblkomitenti k on n.sifra_komitenta=k.sifra_komitenta
                       join tblmagacin m on m.sifra_magacina = n.sifra_magacina
     where (n.datumdpo between :od_datuma and :do_datuma)
            and (d.tip=:tip)
            and (d.stanje=1)
            and (p.ulaz_kol<>0)
            and (n.sifra_konta starting with :konto)
     group by 1,2,3,4
     order by k.komitent
    into :sifra_komitenta,
         :komitent,
         :magacin,
         :placeno,
         :kolicina,
         :nab_vrednost,
         :porez,
         :ukupno
  do
  begin
    suspend;
  end

  nab_vrednost=0; kolicina =0; placeno=0; ukupno=0;

  for  select k.sifra_komitenta,
              k.komitent,
              m.magacin,
              n.pl_iznos,
              cast(sum(b.pot_din+b.drugi_iznosi) as decimal(18,3)),
              cast(sum(b.porez_ulaz) as decimal(18,2)),
              cast(sum(b.potrazuje) as decimal(18,3))

     from tblnovcano n join tblblagajna b on n.idnovcano=b.idnovcano
                       join tbldokumenti d on n.sifra_dokumenta=d.sifra_dokumenta
                       join tblkomitenti k on n.sifra_komitenta=k.sifra_komitenta
                       join tblmagacin m on m.sifra_magacina = n.sifra_magacina
     where (n.datumdpo between :od_datuma and :do_datuma)
            and (d.tip=:tip)
            and (d.stanje=1)
            and (n.sifra_konta starting with :konto)
     group by 1,2,3,4
     order by k.komitent
    into :sifra_komitenta,
         :komitent,
         :magacin,
         :placeno,
         :nab_vrednost,
         :porez,
         :ukupno

  do
  begin
    suspend;
  end
end^

SET TERM ; ^



{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'CEK1'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD CEK1 DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'KES1'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD KES1 DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'KARTICA1'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD KARTICA1 DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'VIRMAN1'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD VIRMAN1 DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'POSLATO'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD POSLATO TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'ZAVRSENO'
} 

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD ZAVRSENO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$GENERATORs WHERE rdb$GENERATOR_name = 'GEN_VAGA_ID'}

CREATE SEQUENCE GEN_VAGA_ID;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPROMENE'
and f.rdb$field_name = 'PONDER_CENA'
} 

ALTER TABLE TBLPROMENE ADD PONDER_CENA DOUBLE PRECISION;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'ULAZKOL'
} 

ALTER TABLE TLOKACIJA ADD  ULAZKOL DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'IZLAZKOL'
} 
ALTER TABLE TLOKACIJA ADD  IZLAZKOL DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'NVULAZ'
} 
ALTER TABLE TLOKACIJA ADD  NVULAZ DOUBLE PRECISION;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'NVIZLAZ'
} 
ALTER TABLE TLOKACIJA ADD  NVIZLAZ DOUBLE PRECISION;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TLOKACIJA'
and f.rdb$field_name = 'PONDER_CENA'
} 

ALTER TABLE TLOKACIJA ADD  PONDER_CENA DOUBLE PRECISION;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TEMP_TBLKOMITENTI'
and f.rdb$field_name = 'PK_TEMP_TBLKOMITENTI'
} 

delete from temp_tblkomitenti;
commit work;

ALTER TABLE TEMP_TBLKOMITENTI DROP ID;

ALTER TABLE TEMP_TBLKOMITENTI
ADD ID INTEGER
NOT NULL  PRIMARY KEY ;
    

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'DEF_DOKUMENT_CC'
} 


ALTER TABLE TBLMAGACIN
ADD DEF_DOKUMENT_CC INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI'
and f.rdb$field_name = 'UD_CENE'
} 

ALTER TABLE TBLDOKUMENTI
ADD UD_CENE SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN_OBRISAN'
and f.rdb$field_name = 'ID_RECEPTA_VOJNI'
} 

ALTER TABLE HP_OBRACUN_OBRISAN
ADD ID_RECEPTA_VOJNI INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN_OBRISAN'
and f.rdb$field_name = 'POSLATO_POSTGRE'
} 

ALTER TABLE HP_OBRACUN_OBRISAN
ADD POSLATO_POSTGRE INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN_OBRISAN'
and f.rdb$field_name = 'RABAT'
} 

ALTER TABLE HP_OBRACUN_OBRISAN
ADD RABAT DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z_OBRISAN'
} 

CREATE TABLE MP_FISK_Z_OBRISAN (
    ID                      integer NOT null,
    IDZ                    INTEGER NOT NULL,
    SIFRA_KOMITENTA        INTEGER,
    SIFRA_MAGACINA         INTEGER,
    DUGUJEPDV              DECIMAL(18,4),
    POTRAZUJEPDV           DECIMAL(18,4),
    DUGUJE                 DECIMAL(18,4),
    POTRAZUJE              DECIMAL(18,4),
    PDV_DUG                DECIMAL(18,4),
    PDV_POT                NUMERIC(18,4),
    BID                    INTEGER,
    BROJ_FISKALNOG         INTEGER,
    OPIS                   VARCHAR(255),
    BRD                    VARCHAR(20),
    SIFRA_KASE             INTEGER,
    DATUMDPO               DATE,
    DATUMVALUTE            DATE,
    DATUMPRAVLJENJA        TIMESTAMP,
    GODINA_RADA            INTEGER,
    ZAVRSENO               INTEGER,
    ZAKLJUCANO             INTEGER,
    BR_STOLA               INTEGER,
    BR_TURE                INTEGER,
    ROBNO                  CHAR(1),
    SIFRA_RADNIKA          INTEGER,
    KES                    DECIMAL(18,4),
    CEK                    DECIMAL(18,4),
    KARTICA                DECIMAL(18,4),
    VIRMAN                 DECIMAL(18,4),
    SIFRA_KONTA            INTEGER,
    DUGUJE8                NUMERIC(18,4),
    PDV8                   NUMERIC(18,4),
    DUGUJE18               NUMERIC(18,4),
    PDV18                  NUMERIC(18,4),
    NAPOMENA               VARCHAR(255),
    IDSEDISTE              INTEGER,
    FISKAL_PUSTEN          INTEGER,
    SIFRA_DOKUMENTA        INTEGER,
    SIFRA_KOMITENTA2       INTEGER,
    KOMITENT2              VARCHAR(255),
    PLACENO                CHAR(1),
    POSLATOUKNJIGOVODSTVO  CHAR(1),
    POSLATO                SMALLINT default 0,
    IDLOGOVANJE            INTEGER,
    IDSOBE                 INTEGER,
    POSLATO_IZV            INTEGER DEFAULT 0,
    ID_REZERVACIJE         INTEGER,
    ID_MESTO_ISP           INTEGER,
    BROJ_RATA              INTEGER,
    ADRESAK_K2             VARCHAR(255),
    PIB_K2                 VARCHAR(25),
    ID_KLIJENTA            BIGINT,
    BR_DNEVNOG_IZV         INTEGER,
    POSLAT_KESIRIC         SMALLINT,
    KESIRICI               DECIMAL(18,4),
    BENEFIT_KARTICA        VARCHAR(30),
    ID_POPDV               INTEGER,
    ID_DNEVNOG_IZVESTAJA   INTEGER,
    FISKAL_PORUKA          INTEGER,
    MAT_BROJ_K2            VARCHAR(50),
    GUID                   VARCHAR(16)
);


ALTER TABLE mp_fisk_z_obrisan ADD CONSTRAINT PK_MP_FISK_Z_OBR PRIMARY KEY (ID);

CREATE SEQUENCE GEN_MP_FISK_Z_OBRISAN_ID;

SET TERM ^ ;

create or alter procedure SP_GEN_MP_FISK_Z_OBRISAN_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_mp_fisk_z_obrisan_id, 1);
  suspend;
end^

SET TERM ; ^

/******************************************************************************/
/***      Following SET SQL DIALECT is just for the Database Comparer       ***/
/******************************************************************************/
SET SQL DIALECT 3;


SET TERM ^ ;



CREATE OR ALTER TRIGGER MP_FISK_Z_BD0 FOR MP_FISK_Z
ACTIVE BEFORE DELETE POSITION 0
as
begin
  insert into MP_FISK_Z_OBRISAN (ID, IDZ, SIFRA_KOMITENTA, SIFRA_MAGACINA, DUGUJEPDV, POTRAZUJEPDV, DUGUJE, POTRAZUJE,
                                 PDV_DUG, PDV_POT, BID, BROJ_FISKALNOG, OPIS, BRD, SIFRA_KASE, DATUMDPO, DATUMVALUTE,
                                 DATUMPRAVLJENJA, GODINA_RADA, ZAVRSENO, ZAKLJUCANO, BR_STOLA, BR_TURE, ROBNO,
                                 SIFRA_RADNIKA, KES, CEK, KARTICA, VIRMAN, SIFRA_KONTA, DUGUJE8, PDV8, DUGUJE18, PDV18,
                                 NAPOMENA, IDSEDISTE, FISKAL_PUSTEN, SIFRA_DOKUMENTA, SIFRA_KOMITENTA2, KOMITENT2,
                                 PLACENO, POSLATOUKNJIGOVODSTVO, POSLATO, IDLOGOVANJE, IDSOBE, POSLATO_IZV,
                                 ID_REZERVACIJE, ID_MESTO_ISP, BROJ_RATA, ADRESAK_K2, PIB_K2, ID_KLIJENTA,
                                 BR_DNEVNOG_IZV, POSLAT_KESIRIC, KESIRICI, BENEFIT_KARTICA, ID_POPDV,
                                 ID_DNEVNOG_IZVESTAJA, FISKAL_PORUKA, MAT_BROJ_K2, GUID)

  values (gen_id(gen_mp_fisk_z_obrisan_id, 1), OLD.IDZ, OLD.SIFRA_KOMITENTA, OLD.SIFRA_MAGACINA, OLD.DUGUJEPDV, OLD.POTRAZUJEPDV, OLD.DUGUJE, OLD.POTRAZUJE,
                                 OLD.PDV_DUG, OLD.PDV_POT, OLD.BID, OLD.BROJ_FISKALNOG, OLD.OPIS, OLD.BRD, OLD.SIFRA_KASE, OLD.DATUMDPO, OLD.DATUMVALUTE,
                                 OLD.DATUMPRAVLJENJA, OLD.GODINA_RADA, OLD.ZAVRSENO, OLD.ZAKLJUCANO, OLD.BR_STOLA, OLD.BR_TURE, OLD.ROBNO,
                                 OLD.SIFRA_RADNIKA, OLD.KES, OLD.CEK, OLD.KARTICA, OLD.VIRMAN, OLD.SIFRA_KONTA, OLD.DUGUJE8, OLD.PDV8, OLD.DUGUJE18, OLD.PDV18,
                                 OLD.NAPOMENA, OLD.IDSEDISTE, OLD.FISKAL_PUSTEN, OLD.SIFRA_DOKUMENTA, OLD.SIFRA_KOMITENTA2, OLD.KOMITENT2,
                                 OLD.PLACENO, OLD.POSLATOUKNJIGOVODSTVO, OLD.POSLATO, OLD.IDLOGOVANJE, OLD.IDSOBE, OLD.POSLATO_IZV,
                                 OLD.ID_REZERVACIJE, OLD.ID_MESTO_ISP, OLD.BROJ_RATA, OLD.ADRESAK_K2, OLD.PIB_K2, OLD.ID_KLIJENTA,
                                 OLD.BR_DNEVNOG_IZV, OLD.POSLAT_KESIRIC, OLD.KESIRICI, OLD.BENEFIT_KARTICA, OLD.ID_POPDV,
                                 OLD.ID_DNEVNOG_IZVESTAJA, OLD.FISKAL_PORUKA, OLD.MAT_BROJ_K2, OLD.GUID);
end
^


SET TERM ; ^


SET TERM ^ ;



CREATE OR ALTER TRIGGER HP_OBRACUN_BD_BRISI FOR HP_OBRACUN
ACTIVE BEFORE DELETE POSITION 0
as
begin
  insert into HP_OBRACUN_OBRISAN (ID, IDNOVCANO, IDSOBE, IDSTOLA, SIFRA_ROBE, KOD, CENA, KOLICINA, PROCENATPDVA, TURA,
                                  PLACENO, POSLATOUKNJIGOVODSTVO, DATUM, SIFRA_RADNIKA, ZDNJAPROMENA, IZNOS, PDV,
                                  SIFRA_KOMITENTA, PROCENAT, PROIZVEDENO, SIFRA_MAGACINA, GRESKA, ID_BOOKING, RB,
                                  KATEGORIJA, STAMPATI, NAPLATAIZVRSENA, ZADNJAPROMENA, SOBA, IDSEDISTE,
                                  SIFRA_DOKUMENTA, IDZG, VODI_SE_LAGER, SIFRA_POREZA, LAGER_KOL, POSLATO, MOBIL_SLIP,
                                  PROSECNA_CENA, ID_RECEPTA, RADNIK_CHANGE, DATE_CHANGE, STARA_SIFRA_ROBE, VRED_P,
                                  CENOVNIK, UCESCE, UCESCE_PDV, UCESCE_CENA, SIFRA_ROBE_RECEPT, KOLICINA_FISKAL,
                                  STARA_CENA, POSLATO_IZV, SPAKOVANO, BROJ_SERIJE, ROK_TRAJANJA, KOL_SARZE, IDHPO,
                                   ID_RECEPTA_VOJNI, RABAT, POSLATO_POSTGRE, datum_brisanja)

  values (OLD.ID, OLD.IDNOVCANO, OLD.IDSOBE, OLD.IDSTOLA, OLD.SIFRA_ROBE, OLD.KOD, OLD.CENA, OLD.KOLICINA, OLD.PROCENATPDVA, OLD.TURA,
                                  OLD.PLACENO, OLD.POSLATOUKNJIGOVODSTVO, OLD.DATUM, OLD.SIFRA_RADNIKA, OLD.ZDNJAPROMENA, OLD.IZNOS, OLD.PDV,
                                  OLD.SIFRA_KOMITENTA, OLD.PROCENAT, OLD.PROIZVEDENO, OLD.SIFRA_MAGACINA, OLD.GRESKA, OLD.ID_BOOKING, OLD.RB,
                                  OLD.KATEGORIJA, OLD.STAMPATI, OLD.NAPLATAIZVRSENA, OLD.ZADNJAPROMENA, OLD.SOBA, OLD.IDSEDISTE,
                                  OLD.SIFRA_DOKUMENTA, OLD.IDZG, OLD.VODI_SE_LAGER, OLD.SIFRA_POREZA, OLD.LAGER_KOL, OLD.POSLATO, OLD.MOBIL_SLIP,
                                  OLD.PROSECNA_CENA, OLD.ID_RECEPTA, OLD.RADNIK_CHANGE, OLD.DATE_CHANGE, OLD.STARA_SIFRA_ROBE, OLD.VRED_P,
                                  OLD.CENOVNIK, OLD.UCESCE, OLD.UCESCE_PDV, OLD.UCESCE_CENA, OLD.SIFRA_ROBE_RECEPT, OLD.KOLICINA_FISKAL,
                                  OLD.STARA_CENA, OLD.POSLATO_IZV, OLD.SPAKOVANO, OLD.BROJ_SERIJE, OLD.ROK_TRAJANJA, OLD.KOL_SARZE,
                                  gen_id(gen_hp_obracun_obrisan_id, 1),
                                    OLD.ID_RECEPTA_VOJNI, OLD.RABAT, 2, current_timestamp);
end
^


SET TERM ; ^

{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'AC_CREDIT_HISTORY_ID'
} 

ALTER TABLE MP_FISK_Z
ADD AC_CREDIT_HISTORY_ID INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK'
and f.rdb$field_name = 'VAZI_OD'
} 

ALTER TABLE TBL_CENOVNIK
ADD VAZI_OD DATE DEFAULT CURRENT_DATE;

update tbl_cenovnik c set c.vazi_od = c.akcija_od;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK'
and f.rdb$field_name = 'VAZI_DO'
} 

ALTER TABLE TBL_CENOVNIK
ADD VAZI_DO DATE;

update tbl_cenovnik c set c.vazi_do = c.akcija_do;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK_DANI'
} 

CREATE TABLE TBL_CENOVNIK_DANI (
    ID               INTEGER NOT NULL,
    ID_TBL_CENOVNIK  INTEGER,
    DAN              SMALLINT,
    CENA             DECIMAL(18,4),
    VREME_OD         SMALLINT DEFAULT 0,
    VREME_DO         SMALLINT DEFAULT 24
);

ALTER TABLE TBL_CENOVNIK_DANI ADD CONSTRAINT PK_TBL_CENOVNIK_DANI PRIMARY KEY (ID);
ALTER TABLE TBL_CENOVNIK_DANI ADD CONSTRAINT FK_TBL_CENOVNIK_DANI_1 FOREIGN KEY (ID_TBL_CENOVNIK) REFERENCES TBL_CENOVNIK (ID);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
} 
CREATE TABLE AC_CREDIT_HISTORY (
    ID            INTEGER NOT NULL,
    "VALUE"       DECIMAL(18,4),
    DATE_INSERT   TIMESTAMP,
    WORKER_ID     INTEGER,
    CARD_ID       VARCHAR(225),
    MP_FISK_Z_ID  INTEGER
);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
and f.rdb$field_name = 'SIFRA_MAGACINA'
} 

ALTER TABLE AC_CREDIT_HISTORY
ADD SIFRA_MAGACINA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'STAMPA_GRATIS_ARTIKALA'
} 

ALTER TABLE SYSTEM_MP
ADD STAMPA_GRATIS_ARTIKALA VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
and f.rdb$field_name = 'GUID_MPFISKZ'
} 

ALTER TABLE AC_CREDIT_HISTORY
ADD GUID_MPFISKZ VARCHAR(16);

CREATE INDEX AC_CREDIT_HISTORY_IDX_GUID ON AC_CREDIT_HISTORY (GUID_MPFISKZ);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
and f.rdb$field_name = 'GUID_MPFISKZ'
} 

SET TERM ^ ;

create or alter procedure SP_GEN_FISKALNA_DNEVNI_IZMENA
returns (
    ID integer)
as
begin
  id = gen_id(GEN_FISKALNA_DNEVNI_IZMENA_ID, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'STAMPAJ_ELEKTRONSKI_VAUCER'
} 


ALTER TABLE SYSTEM_MP
ADD STAMPAJ_ELEKTRONSKI_VAUCER VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BAZAZ'
and f.rdb$field_name = 'SP'
} 


ALTER TABLE BAZAZ
ADD SP CHAR(1);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLROBNAMARKA'
} 


SET SQL DIALECT 3;

CREATE TABLE TBLROBNAMARKA (
    ID           INTEGER NOT NULL,
    ROBNA_MARKA  VARCHAR(50)
);

ALTER TABLE TBLROBNAMARKA ADD CONSTRAINT PK_TBLROBNAMARKA PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI_AKCIJA'
and f.rdb$field_name = 'SAM_ARTIKAL_NA_RACUNU'
} 

ALTER TABLE TBLARTIKLI_AKCIJA
ADD SAM_ARTIKAL_NA_RACUNU SMALLINT;

{$ENDIF}

{$IFEXISTS select T.rdb$type_name
from rdb$relation_fields f 
join  RDB$FIELDS r on (UPPER(r.RDB$FIELD_NAME) = UPPER(f.rdb$field_source))
JOIN RDB$TYPES T ON  T.rdb$type = R.rdb$field_type AND T.rdb$field_name = 'RDB$FIELD_TYPE'
where f.rdb$relation_name = 'HP_OBRACUN_OBRISAN'
and F.rdb$field_name = 'SIFRA_ROBE'
and  T.rdb$type_name = 'SHORT'
}

ALTER TABLE HP_OBRACUN_OBRISAN DROP CONSTRAINT FK_HP_OBRACUN_OBRISAN_ROBA ;

ALTER TABLE HP_OBRACUN_OBRISAN ALTER COLUMN SIFRA_ROBE TYPE INTEGER;

ALTER TABLE HP_OBRACUN_OBRISAN
ADD CONSTRAINT FK_HP_OBRACUN_OBRISAN_ROBA
FOREIGN KEY (SIFRA_ROBE)
REFERENCES TBLARTIKLI(SIFRA_ROBE);

{$ENDIF}

{$IFEXISTS select T.rdb$type_name
from rdb$relation_fields f 
join  RDB$FIELDS r on (UPPER(r.RDB$FIELD_NAME) = UPPER(f.rdb$field_source))
JOIN RDB$TYPES T ON  T.rdb$type = R.rdb$field_type AND T.rdb$field_name = 'RDB$FIELD_TYPE'
where f.rdb$relation_name = 'HP_OBRACUN_OBRISAN'
and F.rdb$field_name = 'SIFRA_KOMITENTA'
and  T.rdb$type_name = 'SHORT'
}

ALTER TABLE HP_OBRACUN_OBRISAN DROP CONSTRAINT FK_HP_OBRACUN_OBRISAN_KOMITENT;

ALTER TABLE HP_OBRACUN_OBRISAN ALTER COLUMN SIFRA_KOMITENTA TYPE INTEGER;

ALTER TABLE HP_OBRACUN_OBRISAN
ADD CONSTRAINT FK_HP_OBRACUN_OBRISAN_KOMITENT
FOREIGN KEY (SIFRA_KOMITENTA)
REFERENCES TBLKOMITENTI(SIFRA_KOMITENTA);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'BENEFIT'
} 

ALTER TABLE TBLMAGACIN
ADD BENEFIT SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'BENEFIT'
} 

ALTER TABLE MP_FISK_Z
ADD BENEFIT DECIMAL(18,4) DEFAULT 0;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'AUTO_OTVORI_NOVI_DNEVNI'
}

ALTER TABLE SYSTEM_MP
ADD AUTO_OTVORI_NOVI_DNEVNI SMALLINT;

update SYSTEM_MP set AUTO_OTVORI_NOVI_DNEVNI = AUTO_OTVORI_NOVI_DAN;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'BENEFIT_VOUCHER'
} 

ALTER TABLE SYSTEM_MP
ADD BENEFIT_VOUCHER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ENTER_QUANTITY_AUTOMATICALY'
} 

ALTER TABLE SYSTEM_MP
ADD ENTER_QUANTITY_AUTOMATICALY SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOV_NAPOM'
and f.rdb$field_name = 'IDPRED'
} 

ALTER TABLE TBLNOV_NAPOM
ADD IDPRED INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'

}

CREATE TABLE BENEFIT_VOUCHER (
    ID INTEGER NOT NULL,
    UID VARCHAR(16) NOT NULL,
    DATE_CREATE TIMESTAMP,
    USED SMALLINT DEFAULT 0,
    DATE_USED TIMESTAMP,
    AMOUNT DECIMAL(18,4),
    USER_CREATED INTEGER,
    BILL_UID VARCHAR(16));

COMMIT WORK;

CREATE SEQUENCE GEN_BENEFIT_VOUCHER_ID;

COMMIT WORK;

create trigger benefit_voucher_bi for benefit_voucher
active before insert position 0
as
begin
  if (new.id is null) then
    new.id = gen_id(GEN_BENEFIT_VOUCHER_ID,1);
end;

COMMIT WORK;

SET TERM ^ ;



CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BI0 FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if(new.date_create is null) then
    new.date_create = 'now';
end
^


SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;



CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_UID FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if(new.uid is null) then
    new.uid = gen_uuid();
end
^


SET TERM ; ^


{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'NEW_UID'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD NEW_UID INTEGER NOT NULL;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'DATE_TO'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD DATE_TO DATE;

{$ENDIF}

{$IFNOTEXISTS select * 
from RDB$INDICES r 
where r.rdb$index_name = 'MP_FISK_Z_IDX_GUID'
}

CREATE INDEX MP_FISK_Z_IDX_GUID ON MP_FISK_Z (GUID);

{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'SYSTEM' and f.rdb$field_name = 'DLV_FTPPORT'} ALTER TABLE SYSTEM ADD DLV_FTPPORT integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'SYSTEM' and f.rdb$field_name = 'DLV_FTPUSER'} ALTER TABLE SYSTEM ADD DLV_FTPUSER varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'SYSTEM' and f.rdb$field_name = 'DLV_PASSWD'} ALTER TABLE SYSTEM ADD DLV_PASSWD varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'SYSTEM' and f.rdb$field_name = 'DLV_FTPFOLDER'} ALTER TABLE SYSTEM ADD DLV_FTPFOLDER varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'SYSTEM' and f.rdb$field_name = 'DVL_FTPADRESA'} ALTER TABLE SYSTEM ADD DVL_FTPADRESA varchar(150) ; commit work; {$ENDIF};

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TRANS_VOZAC'
and f.rdb$field_name = 'SIFRA_RADNIKA'
} 

ALTER TABLE TRANS_VOZAC
ADD SIFRA_RADNIKA INTEGER;

CREATE INDEX TRANS_VOZAC_IDX_RADNIK
ON TRANS_VOZAC (SIFRA_RADNIKA);

{$ENDIF}



{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE'
} 

CREATE GENERATOR GEN_TBL_XML_TEMPLATE_ID;

CREATE TABLE TBL_XML_TEMPLATE (
    ID               INTEGER NOT NULL,
    SIFRA_KOMITENTA  INTEGER,
    NAZIV            VARCHAR(100)
);

ALTER TABLE TBL_XML_TEMPLATE ADD CONSTRAINT PK_TBL_XML_TEMPLATE PRIMARY KEY (ID);

SET TERM ^ ;

/* Trigger: TBL_XML_TEMPLATE_BI */
CREATE OR ALTER TRIGGER TBL_XML_TEMPLATE_BI FOR TBL_XML_TEMPLATE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbl_xml_template_id,1);
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE_STAVKE'
} 


CREATE GENERATOR GEN_TBL_XML_TEMPLATE_STAVKE_ID;

CREATE TABLE TBL_XML_TEMPLATE_STAVKE (
    ID           INTEGER NOT NULL,
    ID_TEMPLATE  INTEGER,
    NIVO         INTEGER,
    NAZIV        VARCHAR(200),
    NASE_POLJE   VARCHAR(100)
);

ALTER TABLE TBL_XML_TEMPLATE_STAVKE ADD CONSTRAINT PK_TBL_XML_TEMPLATE_STAVKE PRIMARY KEY (ID);

ALTER TABLE TBL_XML_TEMPLATE_STAVKE ADD CONSTRAINT FK_TBL_XML_TEMPLATE_STAVKE_ZG FOREIGN KEY (ID_TEMPLATE) REFERENCES TBL_XML_TEMPLATE (ID);

SET TERM ^ ;

/* Trigger: TBL_XML_TEMPLATE_STAVKE_BI */
CREATE OR ALTER TRIGGER TBL_XML_TEMPLATE_STAVKE_BI FOR TBL_XML_TEMPLATE_STAVKE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbl_xml_template_stavke_id,1);
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_KASA'
and f.rdb$field_name = 'SIFRA_OPERATERA'
} 

ALTER TABLE FISKALNA_KASA
ADD SIFRA_OPERATERA VARCHAR(18);

update fiskalna_kasa set sifra_operatera = '1';

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE_STAVKE'
and f.rdb$field_name = 'PARRENT'
} 

ALTER TABLE TBL_XML_TEMPLATE_STAVKE
ADD PARRENT VARCHAR(100);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE_STAVKE_TMP'
} 

SET SQL DIALECT 3;

CREATE GENERATOR GEN_TBL_XML_TEMPL_STAV_TMP1;

CREATE TABLE TBL_XML_TEMPLATE_STAVKE_TMP (
    ID           INTEGER NOT NULL,
    ID_TEMPLATE  INTEGER,
    NIVO         INTEGER,
    NAZIV        VARCHAR(200),
    NASE_POLJE   VARCHAR(100),
    PARRENT      VARCHAR(100),
    VREDNOST     VARCHAR(255),
    TIP          VARCHAR(20)
);


ALTER TABLE TBL_XML_TEMPLATE_STAVKE_TMP ADD CONSTRAINT PK_TBL_XML_TEMPLATE_STAVKE_TMP PRIMARY KEY (ID);

SET TERM ^ ;


/* Trigger: TBL_XML_TEMPLATE_STAVKE_TMP_BI */
CREATE OR ALTER TRIGGER TBL_XML_TEMPLATE_STAVKE_TMP_BI FOR TBL_XML_TEMPLATE_STAVKE_TMP
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbl_xml_templ_stav_tmp1,1);
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE_STAVKE'
and f.rdb$field_name = 'TIP'
} 


ALTER TABLE TBL_XML_TEMPLATE_STAVKE
ADD TIP VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'AUTOMATSKO_SNIMANJE_XML_MP'
} 

ALTER TABLE SYSTEM_MP
ADD AUTOMATSKO_SNIMANJE_XML_MP SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_OPERACIJE'
} 

CREATE TABLE ALARM_OPERACIJE (
    ID             INTEGER NOT NULL,
    NAZIV          VARCHAR(50),
    KOD_OPERACIJE  VARCHAR(10),
    TIP_OPERACIJE  VARCHAR(10)
);


ALTER TABLE ALARM_OPERACIJE ADD CONSTRAINT PK_ALARM_OPERACIJE PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_TIME'
} 

CREATE TABLE ALARM_TIME (
    ID                  INTEGER NOT NULL,
    OPIS                VARCHAR(50),
    IDOPERACIJE         INTEGER,
    ALM_VREME           TIME,
    SIFRA_RADNIKA       INTEGER,
    DATUM               TIMESTAMP,
    OD_DATUMA_BR_DANA   INTEGER,
    DO_DATUMA_BR_DANA   INTEGER,
    SIFRA_KATEGORIJE    INTEGER,
    SIFRA_PROIZVODJACA  INTEGER,
    AKTIVNA             INTEGER
);





ALTER TABLE ALARM_TIME ADD CONSTRAINT PK_ALARM_TIME PRIMARY KEY (ID);


ALTER TABLE ALARM_TIME ADD CONSTRAINT FK_ALARM_TIME_OP FOREIGN KEY (IDOPERACIJE) REFERENCES ALARM_OPERACIJE (ID);
ALTER TABLE ALARM_TIME ADD CONSTRAINT FK_ALARM_TIME_SR FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);
{$ENDIF}



{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_MAGACINI'
} 


CREATE TABLE ALARM_MAGACINI (
    ID              INTEGER NOT NULL,
    ID_ALARM_TIME   INTEGER,
    SIFRA_MAGACINA  INTEGER,
    POSALJI_MAIL    SMALLINT,
    POSALJI_FTP     SMALLINT
);



ALTER TABLE ALARM_MAGACINI ADD CONSTRAINT PK_ALARM_MAGACINI PRIMARY KEY (ID);

ALTER TABLE ALARM_MAGACINI ADD CONSTRAINT FK_ALARM_MAGACINI_AT FOREIGN KEY (ID_ALARM_TIME) REFERENCES ALARM_TIME (ID);
ALTER TABLE ALARM_MAGACINI ADD CONSTRAINT FK_ALARM_MAGACINI_MG FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);




{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_DOBAVLJAC'
} 

CREATE GENERATOR GEN_ALARM_DOBAVLJAC_ID;

CREATE TABLE ALARM_DOBAVLJAC (
    ID                INTEGER NOT NULL,
    ID_ALARM_TIME     INTEGER,
    SIFRA_KOMITENTA   INTEGER,
    SIFRA_KATEGORIJE  INTEGER
);



ALTER TABLE ALARM_DOBAVLJAC ADD CONSTRAINT PK_ALARM_DOBAVLJAC PRIMARY KEY (ID);



SET TERM ^ ;



/* Trigger: ALARM_DOBAVLJAC_BI */
CREATE OR ALTER TRIGGER ALARM_DOBAVLJAC_BI FOR ALARM_DOBAVLJAC
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_alarm_dobavljac_id,1);
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_REZERVACIJA_GOST'
} 

CREATE SEQUENCE GEN_HP_REZERVACIJA_GOST_ID;

CREATE TABLE HP_REZERVACIJA_GOST (
    ID               INTEGER NOT NULL,
    ID_REZERVACIJE   INTEGER,
    SIFRA_KOMITENTA  INTEGER
);

ALTER TABLE HP_REZERVACIJA_GOST ADD CONSTRAINT PK_HP_REZERVACIJA_GOST PRIMARY KEY (ID);

ALTER TABLE HP_REZERVACIJA_GOST
ADD CONSTRAINT FK_HP_REZERVACIJA_GOST_KOMITENT
FOREIGN KEY (SIFRA_KOMITENTA)
REFERENCES TBLKOMITENTI(SIFRA_KOMITENTA);

SET TERM ^ ;

create or alter procedure SP_GEN_HP_REZERVACIJA_GOST_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_hp_rezervacija_gost_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'ID'} ALTER TABLE HP_REZERVACIJA_GOST ADD ID integer  not null ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'SPRATSMESTAJNEJEDINICE'} ALTER TABLE HP_REZERVACIJA_GOST ADD SPRATSMESTAJNEJEDINICE integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'ID_REZERVACIJE'} ALTER TABLE HP_REZERVACIJA_GOST ADD ID_REZERVACIJE integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'SIFRA_KOMITENTA'} ALTER TABLE HP_REZERVACIJA_GOST ADD SIFRA_KOMITENTA integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DALIJELICEDOMACE'} ALTER TABLE HP_REZERVACIJA_GOST ADD DALIJELICEDOMACE smallint  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DALIJELICERODJENOUINOSTRANSTVU'} ALTER TABLE HP_REZERVACIJA_GOST ADD DALIJELICERODJENOUINOSTRANSTVU smallint  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DATUMICASDOLASKA'} ALTER TABLE HP_REZERVACIJA_GOST ADD DATUMICASDOLASKA TIMESTAMP  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'RAZLOGBORAVKASIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD RAZLOGBORAVKASIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'VRSTAPUTNEISPRAVESIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD VRSTAPUTNEISPRAVESIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'UMANJENJE_BORAVISNE_TAKSE'} ALTER TABLE HP_REZERVACIJA_GOST ADD UMANJENJE_BORAVISNE_TAKSE varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'VRSTAVIZESIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD VRSTAVIZESIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'VRSTAPRUZENIHUSLUGASIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD VRSTAPRUZENIHUSLUGASIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'NACINDOLASKASIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD NACINDOLASKASIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'POLSIFRA'} ALTER TABLE HP_REZERVACIJA_GOST ADD POLSIFRA varchar(6) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVAPREBIVALISTAALFA2'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVAPREBIVALISTAALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVAPREBIVALISTAALFA3'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVAPREBIVALISTAALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVARODJENJAALFA2'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVARODJENJAALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTO_ULASKA_U_SRB'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTO_ULASKA_U_SRB varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'OPSTINAPREBIVALISTAMATICNIBROJ'} ALTER TABLE HP_REZERVACIJA_GOST ADD OPSTINAPREBIVALISTAMATICNIBROJ varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVARODJENJAALFA3'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVARODJENJAALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVLJANSTVOALFA2'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVLJANSTVOALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DRZAVLJANSTVOALFA3'} ALTER TABLE HP_REZERVACIJA_GOST ADD DRZAVLJANSTVOALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTOPREBIVALISTAMATICNIBROJ'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTOPREBIVALISTAMATICNIBROJ varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'BROJSMESTAJNEJEDINICE'} ALTER TABLE HP_REZERVACIJA_GOST ADD BROJSMESTAJNEJEDINICE varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'JMBG'} ALTER TABLE HP_REZERVACIJA_GOST ADD JMBG varchar(15) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'EXTERNALID'} ALTER TABLE HP_REZERVACIJA_GOST ADD EXTERNALID varchar(20) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'BROJPUTNEISPRAVE'} ALTER TABLE HP_REZERVACIJA_GOST ADD BROJPUTNEISPRAVE varchar(30) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'ID_OBJEKTA'} ALTER TABLE HP_REZERVACIJA_GOST ADD ID_OBJEKTA varchar(30) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'BROJVIZE'} ALTER TABLE HP_REZERVACIJA_GOST ADD BROJVIZE varchar(30) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTOPREBIVALISTANAZIV'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTOPREBIVALISTANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTOULASKAUREPUBLIKUSRBIJU'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTOULASKAUREPUBLIKUSRBIJU varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTORODJENJANAZIV'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTORODJENJANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'OPSTINAPREBIVALISTANAZIV'} ALTER TABLE HP_REZERVACIJA_GOST ADD OPSTINAPREBIVALISTANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'MESTOIZDAVANJAVIZE'} ALTER TABLE HP_REZERVACIJA_GOST ADD MESTOIZDAVANJAVIZE varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'NAZIVAGENCIJE'} ALTER TABLE HP_REZERVACIJA_GOST ADD NAZIVAGENCIJE varchar(100) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'IME'} ALTER TABLE HP_REZERVACIJA_GOST ADD IME varchar(150) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'PREZIME'} ALTER TABLE HP_REZERVACIJA_GOST ADD PREZIME varchar(150) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DATUMRODJENJA'} ALTER TABLE HP_REZERVACIJA_GOST ADD DATUMRODJENJA DATE  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DATUM_ODOBRENJA_BORAVAK'} ALTER TABLE HP_REZERVACIJA_GOST ADD DATUM_ODOBRENJA_BORAVAK DATE  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'PLANIRANIDATUMODLASKA'} ALTER TABLE HP_REZERVACIJA_GOST ADD PLANIRANIDATUMODLASKA TIMESTAMP  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DATUMIZDAVANJAPUTNEISPRAVE'} ALTER TABLE HP_REZERVACIJA_GOST ADD DATUMIZDAVANJAPUTNEISPRAVE DATE  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'HP_REZERVACIJA_GOST' and f.rdb$field_name = 'DATUMULASKAUREPUBLIKUSRBIJU'} ALTER TABLE HP_REZERVACIJA_GOST ADD DATUMULASKAUREPUBLIKUSRBIJU DATE  ; commit work; {$ENDIF};

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_GOST'
} 

CREATE SEQUENCE GEN_TBLKOMITENT_GOST_ID;

CREATE TABLE TBLKOMITENT_GOST (
    ID               INTEGER NOT NULL,
    SIFRA_KOMITENTA  INTEGER
);

ALTER TABLE TBLKOMITENT_GOST
ADD CONSTRAINT FK_TBLKOMITENT_GOST_KOMITENT
FOREIGN KEY (SIFRA_KOMITENTA)
REFERENCES TBLKOMITENTI(SIFRA_KOMITENTA);

SET TERM ^ ;

create or alter procedure SP_GEN_TBLKOMITENT_GOST_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblkomitent_gost_id, 1);
  suspend;
end^

SET TERM ; ^
{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DALIJELICEDOMACE'} ALTER TABLE TBLKOMITENT_GOST ADD DALIJELICEDOMACE smallint  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DALIJELICERODJENOUINOSTRANSTVU'} ALTER TABLE TBLKOMITENT_GOST ADD DALIJELICERODJENOUINOSTRANSTVU smallint  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'VRSTAPUTNEISPRAVESIFRA'} ALTER TABLE TBLKOMITENT_GOST ADD VRSTAPUTNEISPRAVESIFRA varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'UMANJENJE_BORAVISNE_TAKSE'} ALTER TABLE TBLKOMITENT_GOST ADD UMANJENJE_BORAVISNE_TAKSE varchar(5) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'POLSIFRA'} ALTER TABLE TBLKOMITENT_GOST ADD POLSIFRA varchar(6) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVAPREBIVALISTAALFA2'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVAPREBIVALISTAALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVAPREBIVALISTAALFA3'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVAPREBIVALISTAALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVARODJENJAALFA2'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVARODJENJAALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'OPSTINAPREBIVALISTAMATICNIBROJ'} ALTER TABLE TBLKOMITENT_GOST ADD OPSTINAPREBIVALISTAMATICNIBROJ varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVARODJENJAALFA3'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVARODJENJAALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVLJANSTVOALFA2'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVLJANSTVOALFA2 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DRZAVLJANSTVOALFA3'} ALTER TABLE TBLKOMITENT_GOST ADD DRZAVLJANSTVOALFA3 varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'MESTOPREBIVALISTAMATICNIBROJ'} ALTER TABLE TBLKOMITENT_GOST ADD MESTOPREBIVALISTAMATICNIBROJ varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'BROJPUTNEISPRAVE'} ALTER TABLE TBLKOMITENT_GOST ADD BROJPUTNEISPRAVE varchar(30) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'MESTOPREBIVALISTANAZIV'} ALTER TABLE TBLKOMITENT_GOST ADD MESTOPREBIVALISTANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'MESTOULASKAUREPUBLIKUSRBIJU'} ALTER TABLE TBLKOMITENT_GOST ADD MESTOULASKAUREPUBLIKUSRBIJU varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'MESTORODJENJANAZIV'} ALTER TABLE TBLKOMITENT_GOST ADD MESTORODJENJANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'OPSTINAPREBIVALISTANAZIV'} ALTER TABLE TBLKOMITENT_GOST ADD OPSTINAPREBIVALISTANAZIV varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'IME'} ALTER TABLE TBLKOMITENT_GOST ADD IME varchar(150) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'PREZIME'} ALTER TABLE TBLKOMITENT_GOST ADD PREZIME varchar(150) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DATUM_ODOBRENJA_BORAVAK'} ALTER TABLE TBLKOMITENT_GOST ADD DATUM_ODOBRENJA_BORAVAK DATE  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENT_GOST' and f.rdb$field_name = 'DATUMIZDAVANJAPUTNEISPRAVE'} ALTER TABLE TBLKOMITENT_GOST ADD DATUMIZDAVANJAPUTNEISPRAVE DATE  ; commit work; {$ENDIF};


{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_GRANICNI_PRELAZI'
} 

CREATE SEQUENCE GEN_H_GRANICNI_PRELAZI_ID;

CREATE TABLE H_GRANICNI_PRELAZI (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_GRANICNI_PRELAZI ADD CONSTRAINT PK_H_GRANICNI_PRELAZI PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_GRANICNI_PRELAZI_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_granicni_prelazi_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_NACIN_DOLASKA'
} 

CREATE SEQUENCE GEN_H_NACIN_DOLASKA_ID;

CREATE TABLE H_NACIN_DOLASKA (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_NACIN_DOLASKA ADD CONSTRAINT PK_H_NACIN_DOLASKA PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_NACIN_DOLASKA_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_nacin_dolaska_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_PUTNE_ISPRAVE'
} 

CREATE SEQUENCE GEN_H_PUTNE_ISPRAVE_ID;

CREATE TABLE H_PUTNE_ISPRAVE (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_PUTNE_ISPRAVE ADD CONSTRAINT PK_H_PUTNE_ISPRAVE PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_PUTNE_ISPRAVE_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_putne_isprave_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_RAZLOG_BORAVKA'
}

CREATE SEQUENCE GEN_H_RAZLOG_BORAVKA_ID; 

CREATE TABLE H_RAZLOG_BORAVKA (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_RAZLOG_BORAVKA ADD CONSTRAINT PK_H_RAZLOG_BORAVKA PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_RAZLOG_BORAVKA_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_razlog_boravka_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_UMANJENJE_BORAVISNE_TAKSE'
} 

CREATE SEQUENCE GEN_H_UMANJENJE_BOR_TAKSE; 

CREATE TABLE H_UMANJENJE_BORAVISNE_TAKSE (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_UMANJENJE_BORAVISNE_TAKSE ADD CONSTRAINT PK_H_UMANJENJE_BORAVISNE_TAKSE PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_UMANJENJE_BOR_TA
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_umanjenje_bor_takse, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_VRSTA_USLUGE'
}

CREATE SEQUENCE GEN_H_VRSTA_USLUGE_ID; 

CREATE TABLE H_VRSTA_USLUGE (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_VRSTA_USLUGE ADD CONSTRAINT PK_H_VRSTA_USLUGE PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_VRSTA_USLUGE_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_vrsta_usluge_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_VRSTA_VIZE'
} 

CREATE SEQUENCE GEN_H_VRSTA_VIZE_ID;

CREATE TABLE H_VRSTA_VIZE (
    ID             INTEGER NOT NULL,
    SIFRA          VARCHAR(10),
    OPIS           VARCHAR(200),
    DATE_CHANGE    TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);

ALTER TABLE H_VRSTA_VIZE ADD CONSTRAINT PK_H_VRSTA_VIZE PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_H_VRSTA_VIZE_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_h_vrsta_vize_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_DANI'
} 


CREATE TABLE ALARM_DANI (
    ID             INTEGER NOT NULL,
    PON            SMALLINT,
    UTO            SMALLINT,
    SRE            SMALLINT,
    CET            SMALLINT,
    PET            SMALLINT,
    SUB            SMALLINT,
    NED            SMALLINT,
    ID_ALARM_TIME  INTEGER
);



ALTER TABLE ALARM_DANI ADD CONSTRAINT PK_ALARM_DANI PRIMARY KEY (ID);


ALTER TABLE ALARM_DANI ADD CONSTRAINT FK_ALARM_DANI_AT FOREIGN KEY (ID_ALARM_TIME) REFERENCES ALARM_TIME (ID);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLZEMLJA'
and f.rdb$field_name = 'SKRACENICA_2'
}

ALTER TABLE TBLZEMLJA
ADD SKRACENICA_2 VARCHAR(10);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLZEMLJA'
and f.rdb$field_name = 'SKRACENICA_3'
}

ALTER TABLE TBLZEMLJA
ADD SKRACENICA_3 VARCHAR(10);

COMMIT WORK;

{$ENDIF}



{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_GRANICNI_PRELAZI'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_GRANICNI_PRELAZI              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_GRANICNI_PRELAZI              ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_NACIN_DOLASKA'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_NACIN_DOLASKA              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_NACIN_DOLASKA                 ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_PUTNE_ISPRAVE'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_PUTNE_ISPRAVE              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_PUTNE_ISPRAVE                 ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_RAZLOG_BORAVKA'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_RAZLOG_BORAVKA              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_RAZLOG_BORAVKA                ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_UMANJENJE_BORAVISNE_TAKSE'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_UMANJENJE_BORAVISNE_TAKSE              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_UMANJENJE_BORAVISNE_TAKSE     ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_VRSTA_USLUGE'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_VRSTA_USLUGE              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_VRSTA_USLUGE                  ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'H_VRSTA_VIZE'
and f.rdb$field_name = 'DATE_CHANGE'
}

ALTER TABLE H_VRSTA_VIZE              ADD DATE_CHANGE TIMESTAMP;
ALTER TABLE H_VRSTA_VIZE                    ADD RADNIK_CHANGE INTEGER;

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_REZERVACIJA_GOST'
and f.rdb$field_name = 'SIFRA_MESTA'
}

ALTER TABLE HP_REZERVACIJA_GOST
ADD SIFRA_MESTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_GOST'
and f.rdb$field_name = 'SIFRA_MESTA'
}

ALTER TABLE tblkomitent_gost
ADD SIFRA_MESTA INTEGER;

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
}

CREATE GENERATOR GEN_SIN_LOG_ID;

CREATE TABLE SIN_LOG (
    ID      BIGINT NOT NULL,
    SQL     BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    "USER"  VARCHAR(32) DEFAULT current_user,
    TS      TIMESTAMP DEFAULT current_timestamp,
    TID     INTEGER DEFAULT current_transaction,
    ADRESA  VARCHAR(255),
    PROCES  VARCHAR(255)
);



ALTER TABLE SIN_LOG ADD CONSTRAINT PK_SIN_LOG PRIMARY KEY (ID);



SET TERM ^ ;




/* Trigger: SIN_LOG_BI */
CREATE OR ALTER TRIGGER SIN_LOG_BI FOR SIN_LOG
ACTIVE BEFORE INSERT POSITION 0
as
declare variable adresa VARCHAR(255);
declare variable proces VARCHAR(255);
begin
  if (new.id is null) then
    new.id = gen_id(gen_SIN_log_id,1);

    SELECT
    FIRST 1
     A.mon$remote_address, A.mon$remote_process
    from mon$transactions T
    JOIN mon$attachments A ON T.mon$attachment_id = A.mon$attachment_id
    WHERE T.mon$transaction_id = NEW.tid
    INTO :ADRESA, :PROCES;

    NEW.adresa = :ADRESA;
    NEW.proces = :PROCES;
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
and f.rdb$field_name = 'TABELA'
}

ALTER TABLE SIN_LOG
ADD TABELA VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLZEMLJA'
and f.rdb$field_name = 'NUMERIC_COUNTRY_CODE'
}

ALTER TABLE TBLZEMLJA
ADD NUMERIC_COUNTRY_CODE CHAR(3);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE'
and f.rdb$field_name = 'FORMAT_DATUMA'
}

ALTER TABLE TBL_XML_TEMPLATE
ADD FORMAT_DATUMA VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE'
and f.rdb$field_name = 'FORMAT_DECIMALA'
}

ALTER TABLE TBL_XML_TEMPLATE
ADD FORMAT_DECIMALA VARCHAR(1);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISK_RAZMENA_ARTIKALA'
and f.rdb$field_name = 'GRUPA'
}

ALTER TABLE FISK_RAZMENA_ARTIKALA
ADD GRUPA VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISK_RAZMENA_ARTIKALA'
and f.rdb$field_name = 'PODGRUPA'
}

ALTER TABLE FISK_RAZMENA_ARTIKALA
ADD PODGRUPA VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISK_RAZMENA_ARTIKALA'
and f.rdb$field_name = 'PJEDMERE'
}

ALTER TABLE FISK_RAZMENA_ARTIKALA
ADD PJEDMERE VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISK_RAZMENA_ARTIKALA'
and f.rdb$field_name = 'ODNOSPJM'
}

ALTER TABLE FISK_RAZMENA_ARTIKALA
ADD ODNOSPJM DECIMAL(15,4);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISK_RAZMENA_ARTIKALA'
and f.rdb$field_name = 'KOD_PR'
}

ALTER TABLE FISK_RAZMENA_ARTIKALA
ADD KOD_PR VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
} 

CREATE TABLE HP_PARKING (
    ID               INTEGER NOT NULL,
    ID_KARTE         VARCHAR(50),
    SIFRA_KOMITENTA  INTEGER,
    TABLICE          VARCHAR(20),
    VREME_ULASKA     TIMESTAMP,
    PARKING_MESTO    VARCHAR(10),
    IDZG             INTEGER,
    PLACENO          SMALLINT,
    VREME_ODLASKA    TIMESTAMP
);

ALTER TABLE HP_PARKING ADD CONSTRAINT PK_HP_PARKING PRIMARY KEY (ID);

ALTER TABLE HP_PARKING ADD CONSTRAINT FK_HP_PARKING_1 FOREIGN KEY (IDZG) REFERENCES MP_FISK_Z (IDZ);
ALTER TABLE HP_PARKING ADD CONSTRAINT FK_HP_PARKING_2 FOREIGN KEY (SIFRA_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);

CREATE SEQUENCE GEN_HP_PARKING_ID;


SET TERM ^ ;

create procedure sp_gen_hp_parking_id
returns (id integer)
as
begin
  id = gen_id(gen_hp_parking_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VREME_IZLASKA'
}


ALTER TABLE HP_PARKING
ADD VREME_IZLASKA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VREME_PLACANJA'
}


ALTER TABLE HP_PARKING
ADD VREME_PLACANJA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_TABLICE'
} 

CREATE TABLE TBLKOMITENT_TABLICE (
    ID               INTEGER NOT NULL,
    SIFRA_KOMITENTA  INTEGER,
    NAZIV            VARCHAR(30),
    TIP_PLACANJA     VARCHAR(15)
);

ALTER TABLE TBLKOMITENT_TABLICE ADD CONSTRAINT PK_TBLKOMITENT_TABLICE PRIMARY KEY (ID);

ALTER TABLE TBLKOMITENT_TABLICE ADD CONSTRAINT FK_TBLKOMITENT_TABLICE_1 FOREIGN KEY (SIFRA_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);

CREATE SEQUENCE GEN_TBLKOMITENT_TABLICE_ID;

SET TERM ^ ;

create procedure sp_gen_tblkomitent_tablice_id
returns (id integer)
as
begin
  id = gen_id(gen_tblkomitent_tablice_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'ID_KARTE'
}

ALTER TABLE MP_FISK_Z
ADD ID_KARTE VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVOZILA_TIP'
and f.rdb$field_name = 'SIFRA_ROBE'
}

ALTER TABLE TBLVOZILA_TIP
ADD SIFRA_ROBE INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'ID_TIP_VOZILA'
}

ALTER TABLE HP_PARKING
ADD ID_TIP_VOZILA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_TABLICE'
and f.rdb$field_name = 'ID_TIP_VOZILA'
}

ALTER TABLE TBLKOMITENT_TABLICE
ADD ID_TIP_VOZILA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_TABLICE'
and f.rdb$field_name = 'ID_TIP_PLACANJA'
}

ALTER TABLE TBLKOMITENT_TABLICE
ADD ID_TIP_PLACANJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'TABLICE2'
}

ALTER TABLE HP_PARKING
ADD TABLICE2 VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVOZILA_TIP'
}

CREATE TABLE TBLVOZILA_TIP (
    ID          INTEGER NOT NULL,
    TIPVOZILA   VARCHAR(20),
    SIFRA_ROBE  INTEGER
);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVOZILA_TIP'
and f.rdb$field_name = 'SIFRA_ROBE'
}

ALTER TABLE TBLVOZILA_TIP
ADD SIFRA_ROBE INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DELETE_RESERVATION_RULS'}

ALTER TABLE SYSTEM_MP
ADD DELETE_RESERVATION_RULS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'IDBAZE'}

ALTER TABLE SYSTEM
ADD IDBAZE BIGINT;

update system set idbaze = 1;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
and f.rdb$field_name = 'IDBAZE'}

ALTER TABLE SIN_LOG
ADD IDBAZE BIGINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLAKCIJE'
and f.rdb$field_name = 'SIFRA_MAGACINA'}

ALTER TABLE TBLAKCIJE
ADD SIFRA_MAGACINA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'NOVA_VERZIJA'}

ALTER TABLE SYSTEM
ADD NOVA_VERZIJA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ZABRANJENO_VISE_RACUNA'}

ALTER TABLE SYSTEM_MP
ADD ZABRANJENO_VISE_RACUNA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'MIN_BR_KARAKTERA_PRETRAGA'}

ALTER TABLE SYSTEM_MP
ADD MIN_BR_KARAKTERA_PRETRAGA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'BROJ_DECIMALA_IZLAZ'}

ALTER TABLE TBLMAGACIN
ADD BROJ_DECIMALA_IZLAZ SMALLINT;

UPDATE TBLMAGACIN SET BROJ_DECIMALA_IZLAZ = 3;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'DATUM'}

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD DATUM DATE;

update fiskalna_dnevni_izmena i
set i.datum = cast(i.vreme as date);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DEF_DOK_AMBASADA'}


ALTER TABLE SYSTEM_MP
ADD DEF_DOK_AMBASADA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'AMBASADA'}

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD AMBASADA DECIMAL(18,2) default 0;

update FISKALNA_DNEVNI_IZMENA set ambasada = 0 where ambasada is null;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVNI_IZMENA'
and f.rdb$field_name = 'STORNO'}

ALTER TABLE FISKALNA_DNEVNI_IZMENA
ADD STORNO DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
and f.rdb$field_name = 'ID_KLIJENTA'}

ALTER TABLE SIN_LOG
ADD ID_KLIJENTA BIGINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYS_BROJ_DOC'
and f.rdb$field_name = 'HP_TABELE'}

ALTER TABLE SYS_BROJ_DOC
ADD HP_TABELE SMALLINT default 0;

update SYS_BROJ_DOC set hp_tabele = 0;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'ID_CENOVNIKA_OLD'
}

ALTER TABLE TIP_CENOVNIKA
ADD ID_CENOVNIKA_OLD integer;

COMMIT WORK;

update tip_cenovnika set ID_CENOVNIKA_OLD = id;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
and f.rdb$field_name = 'URADJENO'}

ALTER TABLE SIN_LOG
ADD URADJENO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_LOG'
and f.rdb$field_name = 'DATUM'}

ALTER TABLE SIN_LOG
ADD DATUM TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUPDATE'
and f.rdb$field_name = 'SQL2'}

ALTER TABLE TBLUPDATE
ADD SQL2 BLOB SUB_TYPE 1 SEGMENT SIZE 8192;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_TIME'
and f.rdb$field_name = 'OD_DATUMA_BR_DANA'}

ALTER TABLE ALARM_TIME
ADD OD_DATUMA_BR_DANA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'ALARM_TIME'
and f.rdb$field_name = 'DO_DATUMA_BR_DANA'}

ALTER TABLE ALARM_TIME
ADD DO_DATUMA_BR_DANA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'DO_DATUMA'}

ALTER TABLE TIP_CENOVNIKA
ADD DO_DATUMA DATE;

{$ENDIF}

{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'OD_DATUMA'}

ALTER TABLE TIP_CENOVNIKA
ADD OD_DATUMA DATE;

{$ENDIF}



{$IFNOTEXISTS select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_XML_TEMPLATE_POLJA'
}


CREATE GENERATOR GEN_TBL_XML_TEMPLATE_POLJA_ID;

CREATE TABLE TBL_XML_TEMPLATE_POLJA (
    ID          INTEGER NOT NULL,
    NASE_POLJE  VARCHAR(50),
    OPIS        VARCHAR(100)
);


ALTER TABLE TBL_XML_TEMPLATE_POLJA ADD CONSTRAINT PK_TBL_XML_TEMPLATE_POLJA PRIMARY KEY (ID);

CREATE INDEX TBL_XML_TEMPLATE_POLJA_IDX1 ON TBL_XML_TEMPLATE_POLJA (NASE_POLJE);

CREATE SEQUENCE GEN_TBL_XML_TEMPLATE_POLJA_ID;

SET TERM ^ ;

/* Trigger: TBL_XML_TEMPLATE_POLJA_BI */
CREATE OR ALTER TRIGGER TBL_XML_TEMPLATE_POLJA_BI FOR TBL_XML_TEMPLATE_POLJA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbl_xml_template_polja_id,1);
end
^

SET TERM ; ^

INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (1, 'DATUMDPO', 'Datum dpo');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (2, 'DATUMVALUTE', 'Datum valute');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (3, 'SIFRA_KOMITENTA', 'Sifra komitenta');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (4, 'SIFRA_MAGACINA', 'Sifra magacina');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (5, 'SIFRAPRM', 'Sifra PRM magacina');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (6, 'PIB', 'PIB');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (7, 'KODMAGACINA', 'Kod magacina');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (8, 'BUD', 'Broj ulaznog dokumenta');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (9, 'POTRAZUJE', 'Potrazuje');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (10, 'KOD', 'Kod artikla');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (11, 'BARKOD', 'Barkod artikla');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (12, 'ARTIKAL', 'Artikal');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (13, 'ULAZ_KOL', 'Ulazna kolicina');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (14, 'ULAZ_CENA', 'Ulazna cena');
INSERT INTO TBL_XML_TEMPLATE_POLJA (ID, NASE_POLJE, OPIS)
                            VALUES (15, 'POSNOVU', 'Poreska osnovica ulaz');                        

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'BROJ_LK'
}

ALTER TABLE TBLKOMITMESTO
ADD BROJ_LK VARCHAR(10);

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'TELEFON'
}

ALTER TABLE TBLKOMITMESTO
ADD TELEFON VARCHAR(25);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'MOBIL_TEL'
}

ALTER TABLE TBLKOMITMESTO
ADD MOBIL_TEL VARCHAR(25);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'OPSTINA'
}

ALTER TABLE TBLKOMITMESTO
ADD OPSTINA VARCHAR(25);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'JMBG'
}

ALTER TABLE TBLKOMITMESTO
ADD JMBG VARCHAR(13);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'BR_PREDMETA_CEK'
}

ALTER TABLE TBLKOMITMESTO
ADD BR_PREDMETA_CEK VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITMESTO'
and f.rdb$field_name = 'MUP'
}

ALTER TABLE TBLKOMITMESTO
ADD MUP VARCHAR(30);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'BROJ_SASIJE'
}

ALTER TABLE TBLPREDRACUN
ADD BROJ_SASIJE VARCHAR(30);

{$ENDIF}





{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVRSTAROBE'
and f.rdb$field_name = 'U_CENOVNIK'
}

ALTER TABLE TBLVRSTAROBE
ADD U_CENOVNIK SMALLINT;

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'ACCODE_2'
}

ALTER TABLE TBLPREDRACUN
ADD ACCODE_2 VARCHAR(10);

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'IP_2'
}

ALTER TABLE TBLPREDRACUN
ADD IP_2 VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'TRANSAKCIJA_2'
}

ALTER TABLE TBLPREDRACUN
ADD TRANSAKCIJA_2 VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'BROJ_SASIJE_2'
}

ALTER TABLE TBLPREDRACUN
ADD BROJ_SASIJE_2 VARCHAR(30);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VREME_PLACANJA'
}

ALTER TABLE HP_PARKING
ADD VREME_PLACANJA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'SIFRA_SPEDICIJE'
}

ALTER TABLE HP_PARKING
ADD SIFRA_SPEDICIJE INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'TEL_BR_VOZAC'
}

ALTER TABLE HP_PARKING
ADD TEL_BR_VOZAC VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VALIDNA'
}

ALTER TABLE HP_PARKING
ADD VALIDNA SMALLINT
DEFAULT 0;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VREME_IZLASKA'
}


ALTER TABLE HP_PARKING
ADD VREME_IZLASKA TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUPDATE'
and f.rdb$field_name = 'ID_SERVERA'
}

ALTER TABLE TBLUPDATE
ADD ID_SERVERA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUPDATE'
and f.rdb$field_name = 'TIP_POLJA'
}

ALTER TABLE TBLUPDATE
ADD TIP_POLJA VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUPDATE'
and f.rdb$field_name = 'DATUM_USLOV'
}

ALTER TABLE TBLUPDATE
ADD DATUM_USLOV VARCHAR(15);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'ID_KARTE_OLD'
}

ALTER TABLE HP_PARKING
ADD ID_KARTE_OLD VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'VREME_ODLASKA_OLD'
}

ALTER TABLE HP_PARKING
ADD VREME_ODLASKA_OLD TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI_PLACANJA'
}


CREATE TABLE TBLDOKUMENTI_PLACANJA (
    SIFRA_DOKUMENTA  INTEGER,
    ID               INTEGER NOT NULL,
    IDPLACANJA       INTEGER,
    DOZVOLJENO       INTEGER DEFAULT 1
);


ALTER TABLE TBLDOKUMENTI_PLACANJA ADD CONSTRAINT PK_TBLDOKUMENTI_PLACANJA PRIMARY KEY (ID);
ALTER TABLE TBLDOKUMENTI_PLACANJA ADD CONSTRAINT FK_TBLDOKUMENTI_PLACANJA_DOK FOREIGN KEY (SIFRA_DOKUMENTA) REFERENCES TBLDOKUMENTI (SIFRA_DOKUMENTA);
ALTER TABLE TBLDOKUMENTI_PLACANJA ADD CONSTRAINT FK_TBLDOKUMENTI_PLACANJA_PLAC FOREIGN KEY (IDPLACANJA) REFERENCES TIP_PLACANJA (IDPLACANJA);


CREATE GENERATOR GEN_TBLDOKUMENTI_PLACANJA_ID;

SET TERM ^ ;



CREATE OR ALTER TRIGGER TBLDOKUMENTI_PLACANJA_BI FOR TBLDOKUMENTI_PLACANJA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbldokumenti_placanja_id,1);
end
^


SET TERM ; ^


SET TERM ^ ;

create or alter procedure SP_GEN_TBLDOKUMENTI_PLACANJA_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tbldokumenti_placanja_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM'
and f.rdb$field_name = 'BENEFIT_PROCENAT'
}


ALTER TABLE SYSTEM
ADD BENEFIT_PROCENAT DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMIT_BENEFIT'
and f.rdb$field_name = 'IZNOS_ISPLATE'
}
ALTER TABLE TBLKOMIT_BENEFIT
ADD IZNOS_ISPLATE DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMIT_BENEFIT'
and f.rdb$field_name = 'PROCENAT_ISPLATE'
}
ALTER TABLE TBLKOMIT_BENEFIT
ADD PROCENAT_ISPLATE DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'HAPPY_OD'
}

ALTER TABLE TIP_CENOVNIKA
ADD HAPPY_OD TIME;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'HAPPY_DO'
}

ALTER TABLE TIP_CENOVNIKA
ADD HAPPY_DO TIME;

{$ENDIF}


{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'HOTEL_BUTTON_VISIBLE'
}

ALTER TABLE SYSTEM_MP
ADD HOTEL_BUTTON_VISIBLE SMALLINT;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'KORISTI_CENU_U_PRODAJI_REZ'
}

ALTER TABLE SYSTEM_MP
ADD KORISTI_CENU_U_PRODAJI_REZ SMALLINT;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_DEKLARACIJA'
}

CREATE TABLE TIP_DEKLARACIJA (
    ID           INTEGER NOT NULL,
    NAZIV        VARCHAR(255),
    AKTIVAN      SMALLINT,
    FAJL_STAMPA  VARCHAR(250)
);

ALTER TABLE TIP_DEKLARACIJA ADD CONSTRAINT PK_TIP_DEKLARACIJA PRIMARY KEY (ID);
{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'ID_TIP_DEKLARACIJE'
}

ALTER TABLE TBLARTIKLI
ADD ID_TIP_DEKLARACIJE INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'GTIN'
}

ALTER TABLE TBLARTIKLI
ADD GTIN VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'ROK_TRAJANJA'
}

ALTER TABLE TBLARTIKLI
ADD ROK_TRAJANJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENT_PARKING'
}

SET SQL DIALECT 3;

CREATE TABLE TBLKOMITENT_PARKING (
    SIFRA_KOMITENTA  INTEGER,
    SIFRA_DOKUMENTA  INTEGER
);



ALTER TABLE TBLKOMITENT_PARKING ADD CONSTRAINT UNQ1_TBLKOMITENT_PARKING UNIQUE (SIFRA_KOMITENTA);

ALTER TABLE TBLKOMITENT_PARKING ADD CONSTRAINT FK_TBLKOMITENT_PARKING_DOK FOREIGN KEY (SIFRA_DOKUMENTA) REFERENCES TBLDOKUMENTI (SIFRA_DOKUMENTA);
ALTER TABLE TBLKOMITENT_PARKING ADD CONSTRAINT FK_TBLKOMITENT_PARKING_KOMIT FOREIGN KEY (SIFRA_KOMITENTA) REFERENCES TBLKOMITENTI (SIFRA_KOMITENTA);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN_ATRIBUTI'
and f.rdb$field_name = 'NAPOMENA'
}

ALTER TABLE HP_OBRACUN_ATRIBUTI
ADD NAPOMENA VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ATRIBUTI_ZA_PRODAJU'
}


ALTER TABLE SYSTEM_MP
ADD ATRIBUTI_ZA_PRODAJU SMALLINT;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'KESIRICI_API'
}


ALTER TABLE SYSTEM_MP
ADD KESIRICI_API SMALLINT;

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_MAG'
}

CREATE TABLE SIN_MAG (
    SIFRA_MAGACINA  INTEGER NOT NULL,
    GRESKA          BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VREME_GRESKE    TIMESTAMP,
    MAX_SINHRO      BIGINT,
    VREME_SINHRO    TIMESTAMP,
    IMA_GRESKU      SMALLINT,
    ADRESA          VARCHAR(255),
    PROCES          VARCHAR(255),
    DATE_CHANGE     TIMESTAMP,
    TID             INTEGER DEFAULT current_transaction
);

ALTER TABLE SIN_MAG ADD CONSTRAINT PK_SIN_MAG PRIMARY KEY (SIFRA_MAGACINA);

SET TERM ^ ;

/* Trigger: SIN_MAG_BI0 */
CREATE OR ALTER TRIGGER SIN_MAG_BI0 FOR SIN_MAG
ACTIVE BEFORE INSERT OR UPDATE POSITION 10
as
declare variable adresa VARCHAR(255);
declare variable proces VARCHAR(255);
begin

    SELECT
    FIRST 1
     A.mon$remote_address, A.mon$remote_process
    from mon$transactions T
    JOIN mon$attachments A ON T.mon$attachment_id = A.mon$attachment_id
    WHERE T.mon$transaction_id = NEW.tid
    INTO :ADRESA, :PROCES;

    NEW.adresa = :ADRESA;
    NEW.proces = :PROCES;
    new.date_change = current_timestamp;
end
^


/* Trigger: SIN_MAG_BU0 */
CREATE OR ALTER TRIGGER SIN_MAG_BU0 FOR SIN_MAG
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  new.tid = current_transaction;
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA_VRSTA'
}


CREATE TABLE TIP_CENOVNIKA_VRSTA (
    ID        INTEGER NOT NULL,
    NAZIV     CHAR(250),
    REDOSLED  INTEGER
);

ALTER TABLE TIP_CENOVNIKA_VRSTA ADD CONSTRAINT PK_TIP_CENOVNIKA_VRSTA PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_KASA'
and f.rdb$field_name = 'NOVI_NACIN_FISKALNI'
}

ALTER TABLE FISKALNA_KASA
ADD NOVI_NACIN_FISKALNI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_DEKLARACIJA'
and f.rdb$field_name = 'ZAMRZNUTO'
}

ALTER TABLE TIP_DEKLARACIJA
ADD ZAMRZNUTO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_DEKLARACIJA'
and f.rdb$field_name = 'ZIG'
}

ALTER TABLE TIP_DEKLARACIJA
ADD ZIG VARCHAR(5);

{$ENDIF}

{$IFNOTEXISTS
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
}

CREATE GENERATOR GEN_INVOICE_ID;

CREATE TABLE INVOICE (
    ID                      INTEGER NOT NULL,
    VERIFICATIONURL         VARCHAR(1200),
    DATEADDED               TIMESTAMP DEFAULT current_timestamp,
    TOTALCOUNTER            INTEGER,
    TRANSACTIONTYPECOUNTER  INTEGER,
    TOTALAMOUNT             NUMERIC(18,2),
    INVOICENUMBER           VARCHAR(50),
    IDNOVCANO               INTEGER,
    IDZ                     INTEGER,
    SDCDATETIME             VARCHAR(40),
    INVOICETYPE             VARCHAR(40)
);

ALTER TABLE INVOICE ADD CONSTRAINT PK_INVOICE PRIMARY KEY (ID);

SET TERM ^ ;



CREATE OR ALTER TRIGGER INVOICE_BI FOR INVOICE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_invoice_id,1);
end
^


SET TERM ; ^



SET TERM ^ ;



CREATE OR ALTER TRIGGER INVOICE_AI0 FOR INVOICE
ACTIVE AFTER INSERT POSITION 0
AS
begin
  if (new.sdcdatetime is not null) then
  begin
      update invoice i set i.dateadded = cast( left( replace( new.sdcdatetime, 'T', ' '), 19) as timestamp )
      where i.id = new.id;
      if (new.idz is not null and new.invoicetype <> 'Copy') then
      begin
        update mp_fisk_z z set z.datumpravljenja = cast( left( replace( new.sdcdatetime, 'T', ' '), 19) as timestamp );
      end
  end
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'SDCDATETIME'
}

ALTER TABLE INVOICE
ADD SDCDATETIME VARCHAR(40);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'IDZ'
}

ALTER TABLE INVOICE
ADD IDZ INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'IDNOVCANO'
}

ALTER TABLE INVOICE
ADD IDNOVCANO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'TOTALCOUNTER'
}

ALTER TABLE INVOICE
ADD TOTALCOUNTER INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'TRANSACTIONTYPECOUNTER'
}

ALTER TABLE INVOICE
ADD TRANSACTIONTYPECOUNTER INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'TOTALAMOUNT'
}

ALTER TABLE INVOICE
ADD TOTALAMOUNT NUMERIC(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'INVOICENUMBER'
}

ALTER TABLE INVOICE
ADD INVOICENUMBER VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPOREZ'
and f.rdb$field_name = 'LABEL'
}

ALTER TABLE TBLPOREZ
ADD LABEL VARCHAR(10);

UPDATE TBLPOREZ SET 
    LABEL = 'G'
WHERE (STOPA1 = 0) AND
      (FISKAL = 1) AND
      (TIP = 'BP');

UPDATE TBLPOREZ SET 
    LABEL = 'D'
WHERE (STOPA1 = 20) AND
      (FISKAL = 3) AND
      (TIP = 'OS');

UPDATE TBLPOREZ SET 
    LABEL = 'E'
WHERE (STOPA1 = 10) AND
      (FISKAL = 4) AND
      (TIP = 'PS');

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'WEB_MAGACINI'
}

CREATE TABLE WEB_MAGACINI (
    ID              INTEGER NOT NULL,
    SIFRA_MAGACINA  INTEGER,
    AKTIVAN         INTEGER DEFAULT 1
);



ALTER TABLE WEB_MAGACINI ADD CONSTRAINT PK_WEB_MAGACINI PRIMARY KEY (ID);


ALTER TABLE WEB_MAGACINI ADD CONSTRAINT FK_WEB_MAGACINI_1 FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);


{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_ORDER'
}


CREATE TABLE SYSTEM_ORDER (
    ID                   INTEGER NOT NULL,
    VSB_PREDKALKULACIJA  SMALLINT,
    OBAVEZAN_PRIJEM_DOK  SMALLINT,
    PROVERA_CASSA        SMALLINT,
    OBAVEZNA_LOKACIJA    SMALLINT
);





ALTER TABLE SYSTEM_ORDER ADD CONSTRAINT PK_SYSTEM_ORDER PRIMARY KEY (ID);

COMMENT ON COLUMN SYSTEM_ORDER.OBAVEZAN_PRIJEM_DOK IS 
'Prilikom unosa kalkulacije obavezno uneti prijemni broj (zegin) iz tabele tblprijem_dokumenata.';


{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_ORDER'
and f.rdb$field_name = 'ID_WEB_CENOVNIK'
}


ALTER TABLE SYSTEM_ORDER
ADD ID_WEB_CENOVNIK INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI'
and f.rdb$field_name = 'KRATAK_OPIS'
}


ALTER TABLE TBLARTIKLI
ADD KRATAK_OPIS VARCHAR(3000);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'WEB_LAGER'
}

ALTER TABLE TBLMAGACIN
ADD WEB_LAGER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOV_NAPOM'
and f.rdb$field_name = 'ISPORUKA'
}

ALTER TABLE TBLNOV_NAPOM
ADD ISPORUKA VARCHAR(250);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOV_AMBAL'
and f.rdb$field_name = 'DIMENZIJE'
}

ALTER TABLE TBLNOV_AMBAL
ADD DIMENZIJE VARCHAR(250);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_INVOICETYPE'
}


CREATE TABLE SUF_INVOICETYPE (
    ID     INTEGER NOT NULL,
    NAZIV  VARCHAR(50)
);

ALTER TABLE SUF_INVOICETYPE ADD CONSTRAINT PK_SUF_INVOICETYPE PRIMARY KEY (ID);

INSERT INTO SUF_INVOICETYPE (ID, NAZIV)
                     VALUES (0, 'Normal');
INSERT INTO SUF_INVOICETYPE (ID, NAZIV)
                     VALUES (1, 'Proforma');
INSERT INTO SUF_INVOICETYPE (ID, NAZIV)
                     VALUES (2, 'Copy');
INSERT INTO SUF_INVOICETYPE (ID, NAZIV)
                     VALUES (3, 'Training');
INSERT INTO SUF_INVOICETYPE (ID, NAZIV)
                     VALUES (4, 'Advance');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_TRANSACTIONTYPE'
}


CREATE TABLE SUF_TRANSACTIONTYPE (
    ID     INTEGER NOT NULL,
    NAZIV  VARCHAR(50),
    TIP    VARCHAR(10)
);


ALTER TABLE SUF_TRANSACTIONTYPE ADD CONSTRAINT PK_SUF_TRANSACTIONTYPE PRIMARY KEY (ID);

INSERT INTO SUF_TRANSACTIONTYPE (ID, NAZIV, TIP)
                         VALUES (0, 'Sale', 'S');
INSERT INTO SUF_TRANSACTIONTYPE (ID, NAZIV, TIP)
                         VALUES (1, 'Refund', 'R');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_PAYMENTTYPE'
}

CREATE TABLE SUF_PAYMENTTYPE (
    ID     INTEGER NOT NULL,
    NAZIV  VARCHAR(50)
);

ALTER TABLE SUF_PAYMENTTYPE ADD CONSTRAINT PK_SUF_PAYMENTTYPE PRIMARY KEY (ID);

INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                     VALUES (0, 'Other');
INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                     VALUES (1, 'Cash');
INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                     VALUES (2, 'Card');
INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                     VALUES (3, 'Check');
INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                     VALUES (4, 'Wire');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_INVOICECOUNTEREXTENSION'
}


CREATE TABLE SUF_INVOICECOUNTEREXTENSION (
    ID     INTEGER NOT NULL,
    NAZIV  VARCHAR(50),
    TIP    VARCHAR(10) NOT NULL
);

ALTER TABLE SUF_INVOICECOUNTEREXTENSION ADD CONSTRAINT UNQ1_SUF_INVOICECOUNTEREXTENSIO UNIQUE (TIP);
ALTER TABLE SUF_INVOICECOUNTEREXTENSION ADD CONSTRAINT PK_SUF_INVOICECOUNTEREXTENSION PRIMARY KEY (ID);

INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (7, 'Advance Refund', 'AR');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (6, 'Advance Sale', 'AS');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (3, 'Copy Refund', 'CR');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (2, 'Copy Sale', 'CS');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (1, 'Normal Refund', 'NR');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (0, 'Normal Sale', 'NS');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (5, 'Proforma Refund', 'PR');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (4, 'Proforma Sale', 'PS');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (9, 'Training Refund', 'TR');
INSERT INTO SUF_INVOICECOUNTEREXTENSION (ID, NAZIV, TIP)
                                 VALUES (8, 'Training Sale', 'TS');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_INVOICECOUNTEREXTENSION'
}

CREATE TABLE SUF_CODES (
    CODE   VARCHAR(4) NOT NULL,
    NAZIV  VARCHAR(100),
    INFO   VARCHAR(50)
);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'INVOICETYPE'
}

ALTER TABLE INVOICE
ADD INVOICETYPE VARCHAR(40);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'TRANSACTIONTYPE'
}

ALTER TABLE INVOICE
ADD TRANSACTIONTYPE VARCHAR(40);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'IDPRED'
}


ALTER TABLE INVOICE
ADD IDPRED INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_PLACANJA'
and f.rdb$field_name = 'SUF_PAYMENT'
}

ALTER TABLE TIP_PLACANJA
ADD SUF_PAYMENT VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'POPISSTAVKE'
and f.rdb$field_name = 'SKLADISNI_PROSTOR'
}

ALTER TABLE POPISSTAVKE
ADD SKLADISNI_PROSTOR VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_TAXRATE'
}

CREATE GENERATOR GEN_SUF_TAXRATE_ID;

CREATE TABLE SUF_TAXRATE (
    TAXRATEGROUP  VARCHAR(25),
    VALIDFROM     VARCHAR(25),
    CATEGORYID    INTEGER,
    GROUPID       INTEGER,
    NAME          VARCHAR(50),
    CTYPE         INTEGER,
    ORDERID       INTEGER,
    LABEL         VARCHAR(10),
    RATE          DECIMAL(15,4),
    ID            INTEGER
    
);

SET TERM  ^ ;

CREATE OR ALTER TRIGGER SUF_TAXRATE_BI FOR SUF_TAXRATE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_suf_taxrate_id,1);
end
^

SET TERM ; ^

COMMENT ON COLUMN SUF_TAXRATE.cTYPE IS
'One of the following tax category types:
0 (tax-on-net) - all tax rates from this category are proportional, and shall be applied on the net price;
1 (tax-on-total) - all tax rates from this category are proportional, and shall be applied on the total amount;
2 (amount-per-quantity) - all tax rates from this category are fixed tax amounts, which shall be multiplied with item quantity.';

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_OBRACUN'
and f.rdb$field_name = 'BARKOD'
}

ALTER TABLE HP_OBRACUN
ADD BARKOD VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_BUYERID'
}

CREATE TABLE SUF_BUYERID (
    ID    INTEGER NOT NULL,
    OPIS  VARCHAR(50)
);

ALTER TABLE SUF_BUYERID ADD CONSTRAINT PK_SUF_BUYERID PRIMARY KEY (ID);

INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (10, 'Pib kupca');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (11, 'JMBG');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (20, 'Broj licne karte');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (21, 'Broj izbeglicke legitimacije');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (22, 'EBS');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (23, 'Broj pasosa domaci');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (30, 'Broj pasosa strani');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (31, 'Broj diplomatske legitimacije');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (32, 'Broj licne karte MKD');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (33, 'Broj licne karte MNE');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (34, 'Broj licne karte ALB');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (35, 'Broj licne karte BIH');
INSERT INTO SUF_BUYERID (ID, OPIS)
                 VALUES (40, 'PIB izdat u inostranstvu');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'AVANS'
}

ALTER TABLE MP_FISK_Z
ADD AVANS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_OBRACUN_AVANSA'
and f.rdb$field_name = 'IDZG'
}

ALTER TABLE TBL_OBRACUN_AVANSA
ADD IDZG INTEGER;

CREATE INDEX TBL_OBRACUN_AVANSA_IDX_NOVC ON TBL_OBRACUN_AVANSA (VEZA);

CREATE INDEX TBL_OBRACUN_AVANSA_IDX_FISKZ ON TBL_OBRACUN_AVANSA (IDZG);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'KESIRICI_API_KEY'
}

ALTER TABLE SYSTEM_MP
ADD KESIRICI_API_KEY VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'KESIRICI_API'
}

ALTER TABLE TBLMAGACIN
ADD KESIRICI_API VARCHAR(20);

UPDATE TBLMAGACIN  SET KESIRICI_API = API_ID_KESIRICI
WHERE API_ID_KESIRICI IS NOT NULL;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUSLUGEPROMENE'
and f.rdb$field_name = 'SIFRA_ROBE'
}

ALTER TABLE TBLUSLUGEPROMENE
ADD SIFRA_ROBE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'GNL'
}

ALTER TABLE TBLPREDRACUN
ADD GNL VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS
select * from RDB$GENERATORS g where
g.rdb$generator_name = 'GEN_INVOICE_ID'
}

CREATE GENERATOR GEN_INVOICE_ID;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'NACIN_RADA'
}

ALTER TABLE SYSTEM_MP
ADD NACIN_RADA SMALLINT;

update system_mp set nacin_rada = 0;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLREZERVACIJASASTAV'
and f.rdb$field_name = 'RUCNO_ZAVRSEN'
}

ALTER TABLE TBLREZERVACIJASASTAV
ADD RUCNO_ZAVRSEN INTEGER;


{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPOREZ'
and f.rdb$field_name = 'ZAKLJUCANO'
}

ALTER TABLE TBLPOREZ
ADD ZAKLJUCANO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_TAXRATE'
and f.rdb$field_name = 'LABEL1'
}

ALTER TABLE SUF_TAXRATE
ADD LABEL1 VARCHAR(10) CHARACTER SET UTF8 
COLLATE UNICODE;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_CODES'
}


SET SQL DIALECT 3;

CREATE TABLE SUF_CODES (
    CODE   VARCHAR(4) NOT NULL,
    NAZIV  VARCHAR(100),
    INFO   VARCHAR(50)
);


ALTER TABLE SUF_CODES ADD CONSTRAINT PK_SUF_CODES PRIMARY KEY (CODE);

INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('0000', 'Command is executed without warnings or errors', 'All OK');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('0100', 'This code indicates that the provided PIN code is correct', 'Pin OK');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('0210', NULL, 'Internet Available');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('0220', NULL, 'Internet Unavailable');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('1100', NULL, 'Storage 90% Full');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('1300', NULL, 'Smart Card is not present');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('1400', NULL, 'Audit Required');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('1500', NULL, 'Pin Code Required');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('1999', NULL, 'Undefined Warning');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2100', NULL, 'Pin Not OK');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2110', NULL, 'Card Locked');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2210', NULL, 'SE Locked');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2220', NULL, 'SE Communication Failed');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2230', NULL, 'SE Protocol Mismatch');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2310', NULL, 'Invalid tax labels');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2400', NULL, 'Not configured');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2800', NULL, 'Field Required');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2801', NULL, 'Field Value Too Long');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2802', NULL, 'Field Value Too Short');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2803', NULL, 'Invalid Field Length');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2804', NULL, 'Field Out Of Range');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2805', NULL, 'Invalid Field Value');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2806', NULL, 'Invalid Data Format');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2807', NULL, 'List Too Short');
INSERT INTO SUF_CODES (CODE, NAZIV, INFO)
               VALUES ('2808', NULL, 'List Too Long');

COMMIT WORK;

{$ENDIF} 


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_KONEKCIJE'
}

SET SQL DIALECT 3;

CREATE GENERATOR GEN_HP_KONEKCIJE_ID;

CREATE TABLE HP_KONEKCIJE (
    ID               INTEGER NOT NULL,
    TOKEN            VARCHAR(255),
    USERNAME         VARCHAR(50),
    PASSWD           VARCHAR(50),
    API              VARCHAR(255),
    NAZIV_KONEKCIJE  VARCHAR(50)
);



ALTER TABLE HP_KONEKCIJE ADD CONSTRAINT PK_HP_KONEKCIJE PRIMARY KEY (ID);


SET TERM ^ ;

/* Trigger: HP_KONEKCIJE_BI */
CREATE OR ALTER TRIGGER HP_KONEKCIJE_BI FOR HP_KONEKCIJE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_hp_konekcije_id,1);
end
^


SET TERM ; ^


{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_KONEKCIJE'
and f.rdb$field_name = 'SIFRA_ROBE_DOPUNE'
}

ALTER TABLE HP_KONEKCIJE
ADD SIFRA_ROBE_DOPUNE INTEGER;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'INVOICENUMBER'
}

ALTER TABLE MP_FISK_Z
ADD INVOICENUMBER VARCHAR(50);

ALTER TABLE MP_FISK_Z_OBRISAN
ADD INVOICENUMBER VARCHAR(50);

update mp_fisk_z z
set z.invoicenumber = ( select first 1 i.invoicenumber from invoice i where i.idz = z.idz );

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'POSLATO'
}

ALTER TABLE INVOICE
ADD POSLATO SMALLINT;

update invoice set poslato = 0;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE'
and f.rdb$field_name = 'ID_KLIJENTA'
}

ALTER TABLE INVOICE
ADD ID_KLIJENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'INVOICENUMBER'
} 

ALTER TABLE TBLNOVCANO
ADD INVOICENUMBER VARCHAR(50);

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_MAG'
and f.rdb$field_name = 'DATUM_NAJST_RACUNA'
} 

ALTER TABLE SIN_MAG
ADD DATUM_NAJST_RACUNA TIMESTAMP;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_MAG'
and f.rdb$field_name = 'BROJ_NEPOSLATIH_RACUNA'
} 

ALTER TABLE SIN_MAG
ADD BROJ_NEPOSLATIH_RACUNA INTEGER;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SIN_MAG'
and f.rdb$field_name = 'VREME_PRENOSA_RACUNA'
} 

ALTER TABLE SIN_MAG
ADD VREME_PRENOSA_RACUNA TIMESTAMP;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUSLUGEPROMENE'
and f.rdb$field_name = 'ZAKLJUCANO'
} 

ALTER TABLE TBLUSLUGEPROMENE
ADD ZAKLJUCANO INTEGER;

{$ENDIF} 

{$IFEXISTS select T.rdb$type_name
from rdb$relation_fields f 
join  RDB$FIELDS r on (UPPER(r.RDB$FIELD_NAME) = UPPER(f.rdb$field_source))
JOIN RDB$TYPES T ON  T.rdb$type = R.rdb$field_type AND T.rdb$field_name = 'RDB$FIELD_TYPE'
where f.rdb$relation_name = 'AP_RECEPTI'
and F.rdb$field_name = 'REDNI_BROJ'
and  T.rdb$type_name <> 'INT64'
}

ALTER TABLE AP_RECEPTI ALTER COLUMN REDNI_BROJ TYPE BIGINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'ZAKLJUCANO'
} 

ALTER TABLE TBLPREDRACUN
ADD ZAKLJUCANO SMALLINT;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOV_AMBAL'
and f.rdb$field_name = 'NETO'
} 

ALTER TABLE TBLNOV_AMBAL
ADD NETO DOUBLE PRECISION;

{$ENDIF} 


{$IFEXISTS select T.rdb$type_name
from rdb$relation_fields f 
join  RDB$FIELDS r on (UPPER(r.RDB$FIELD_NAME) = UPPER(f.rdb$field_source))
JOIN RDB$TYPES T ON  T.rdb$type = R.rdb$field_type AND T.rdb$field_name = 'RDB$FIELD_TYPE'
where f.rdb$relation_name = 'TBLNOV_AMBAL'
and F.rdb$field_name = 'KOLICINA'
and  T.rdb$type_name <> 'INT64'
}

ALTER TABLE TBLNOV_AMBAL ALTER COLUMN KOLICINA TYPE DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'REDNI_BROJ'
} 

ALTER TABLE MP_FISK_Z
ADD REDNI_BROJ INTEGER;

SET TERM ^ ;



CREATE OR ALTER TRIGGER MP_FISK_Z_BI_rbr FOR MP_FISK_Z
ACTIVE BEFORE INSERT POSITION 0
AS
    declare variable rbr integer;
begin
  if (new.redni_broj is null) then
  begin
    select coalesce(max( z.redni_broj ),0) from mp_fisk_z z where z.datumdpo = current_date
    and z.sifra_kase = new.sifra_kase
    into :rbr;
    new.redni_broj = :rbr + 1;
  end
end
^


SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA'
and f.rdb$field_name = 'ODLOZENO'
} 

ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD ODLOZENO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLCEKOVI_EVIDENCIJA'
and f.rdb$field_name = 'SIFRA_KOMITENTA'
} 

ALTER TABLE TBLCEKOVI_EVIDENCIJA
ADD SIFRA_KOMITENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
and f.rdb$field_name = 'POSLATO'
} 

ALTER TABLE AC_CREDIT_HISTORY
ADD POSLATO SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_INPUT_TYPE'
} 

CREATE GENERATOR GEN_AC_INPUT_TYPE_ID;

CREATE TABLE AC_INPUT_TYPE (
    ID    INTEGER NOT NULL,
    NAME  VARCHAR(50)
);

ALTER TABLE AC_INPUT_TYPE ADD CONSTRAINT PK_AC_INPUT_TYPE PRIMARY KEY (ID);


SET TERM ^ ;

/* Trigger: AC_INPUT_TYPE_BI */
CREATE OR ALTER TRIGGER AC_INPUT_TYPE_BI FOR AC_INPUT_TYPE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_ac_input_type_id,1);
end
^


SET TERM ; ^

INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (1, 'ulaz');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (0, 'izlaz');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (2, 'prolaz');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (3, 'spa ulaz');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (4, 'spa izlaz');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (6, 'info');
INSERT INTO AC_INPUT_TYPE (ID, NAME)
                   VALUES (7, 'time');

COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_LOCATIONS'
} 

CREATE GENERATOR GEN_AC_LOCATIONS_ID;

CREATE TABLE AC_LOCATIONS (
    ID    INTEGER NOT NULL,
    NAME  VARCHAR(50) COLLATE NONE
);

ALTER TABLE AC_LOCATIONS ADD CONSTRAINT PK_AC_LOCATIONS PRIMARY KEY (ID);


SET TERM ^ ;

/* Trigger: AC_LOCATIONS_BI */
CREATE OR ALTER TRIGGER AC_LOCATIONS_BI FOR AC_LOCATIONS
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_ac_locations_id,1);
end
^


SET TERM ; ^



{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_USERS'
} 


CREATE TABLE AC_USERS (
    CARD_NUMBER  VARCHAR(225) NOT NULL COLLATE NONE,
    "ACTIVE"     INTEGER DEFAULT 1,
    SUPER        SMALLINT DEFAULT 0,
    GYM          SMALLINT,
    INVALID      SMALLINT,
    MASER        SMALLINT
);

ALTER TABLE AC_USERS ADD CONSTRAINT PK_AC_USERS PRIMARY KEY (CARD_NUMBER);



{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_DEVICES'
} 


SET SQL DIALECT 3;


CREATE GENERATOR GEN_AC_DEVICES_ID;

CREATE TABLE AC_DEVICES (
    ID            INTEGER NOT NULL,
    LOCATION_ID   INTEGER NOT NULL,
    IP            VARCHAR(125) NOT NULL,
    PORT          INTEGER NOT NULL,
    NAME          VARCHAR(225),
    "ACTIVE"      INTEGER DEFAULT 1,
    CONNECTED     SMALLINT DEFAULT 0,
    MSG_ALLOW     VARCHAR(20),
    MSG_DENY      VARCHAR(20),
    "INPUT_TYPE"  SMALLINT
);




ALTER TABLE AC_DEVICES ADD CONSTRAINT PK_AC_DEVICES PRIMARY KEY (ID);



ALTER TABLE AC_DEVICES ADD CONSTRAINT FK_AC_DEVICES_1 FOREIGN KEY (LOCATION_ID) REFERENCES AC_LOCATIONS (ID);



SET TERM ^ ;




/* Trigger: AC_DEVICES_BI */
CREATE OR ALTER TRIGGER AC_DEVICES_BI FOR AC_DEVICES
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_ac_devices_id,1);
end
^


SET TERM ; ^



COMMENT ON COLUMN AC_DEVICES."INPUT_TYPE" IS 
'1 - ulaz
 0 - izlaz
 2 - prolaz';




{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_ACCESS'
} 

CREATE TABLE AC_ACCESS (
    DEVICE_ID  INTEGER NOT NULL,
    CARD_ID    VARCHAR(225) NOT NULL COLLATE NONE,
    PASS       INTEGER DEFAULT 0 NOT NULL
);

ALTER TABLE AC_ACCESS ADD CONSTRAINT PK_AC_ACCESS PRIMARY KEY (DEVICE_ID, CARD_ID);

ALTER TABLE AC_ACCESS ADD CONSTRAINT FK_AC_ACCESS_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);
ALTER TABLE AC_ACCESS ADD CONSTRAINT FK_AC_ACCESS_2 FOREIGN KEY (DEVICE_ID) REFERENCES AC_DEVICES (ID);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_ACCESS_HISTORY'
} 


CREATE TABLE AC_ACCESS_HISTORY (
    DATE_INSERT       DATE NOT NULL,
    CARD_ID           VARCHAR(225) NOT NULL COLLATE NONE,
    DEVICE_ID         INTEGER NOT NULL,
    DATE_TIME_INSERT  TIMESTAMP,
    "INPUT_TYPE"      SMALLINT NOT NULL
);

ALTER TABLE AC_ACCESS_HISTORY ADD CONSTRAINT PK_AC_ACCESS_HISTORY PRIMARY KEY (DATE_INSERT, CARD_ID, "INPUT_TYPE");
ALTER TABLE AC_ACCESS_HISTORY_SUPER ADD CONSTRAINT PK_AC_ACCESS_HISTORY_SUPER PRIMARY KEY (CARD_ID, DATE_TIME_INSERT);

ALTER TABLE AC_ACCESS_HISTORY ADD CONSTRAINT FK_AC_ACCESS_HISTORY_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);
ALTER TABLE AC_ACCESS_HISTORY ADD CONSTRAINT FK_AC_ACCESS_HISTORY_2 FOREIGN KEY (DEVICE_ID) REFERENCES AC_DEVICES (ID);


SET TERM ^ ;



/* Trigger: AC_ACCESS_HISTORY_AIU0 */
CREATE OR ALTER TRIGGER AC_ACCESS_HISTORY_AIU0 FOR AC_ACCESS_HISTORY
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
begin
  if(new."INPUT_TYPE" in ( 1, 6) ) then
    update ac_access acs set acs.pass = acs.pass -1 where acs.card_id = new.card_id and acs.pass > 0;

--  if(new."INPUT_TYPE" = 0 and (select first 1 s.pass from ac_access s where s.card_id = new.card_id) = 0) then
--    update ac_access acs set acs.pass = 1 where acs.card_id = new.card_id;
end
^


/* Trigger: AC_ACCESS_HISTORY_BI */
CREATE OR ALTER TRIGGER AC_ACCESS_HISTORY_BI FOR AC_ACCESS_HISTORY
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
as
begin
    if (new.DATE_TIME_INSERT is null) then
        new.DATE_TIME_INSERT = 'now';
    if (new.DATE_INSERT is null) then
        new.DATE_INSERT = 'now';

end
^


SET TERM ; ^



{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_ACCESS_HISTORY_SUPER'
} 


CREATE TABLE AC_ACCESS_HISTORY_SUPER (
    CARD_ID           VARCHAR(225) NOT NULL COLLATE NONE,
    DEVICE_ID         INTEGER NOT NULL,
    DATE_TIME_INSERT  TIMESTAMP NOT NULL
);

ALTER TABLE AC_ACCESS_HISTORY_SUPER ADD CONSTRAINT FK_AC_ACCESS_HISTORY_SUPER_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);
ALTER TABLE AC_ACCESS_HISTORY_SUPER ADD CONSTRAINT FK_AC_ACCESS_HISTORY_SUPER_2 FOREIGN KEY (DEVICE_ID) REFERENCES AC_DEVICES (ID);


SET TERM ^ ;


/* Trigger: AC_ACCESS_HISTORY_SUPER_BIU0 */
CREATE OR ALTER TRIGGER AC_ACCESS_HISTORY_SUPER_BIU0 FOR AC_ACCESS_HISTORY_SUPER
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
  if(new.date_time_insert is null) then
    new.date_time_insert = 'now';
end
^


SET TERM ; ^



{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_COMMANDS'
} 


CREATE TABLE AC_COMMANDS (
    DEVICE_ID             INTEGER NOT NULL,
    TURNIKETA_NOT_IN_USE  VARCHAR(2) COLLATE NONE,
    TURNIKETA_USED        VARCHAR(2) COLLATE NONE
);

ALTER TABLE AC_COMMANDS ADD CONSTRAINT PK_AC_COMMANDS PRIMARY KEY (DEVICE_ID);

ALTER TABLE AC_COMMANDS ADD CONSTRAINT FK_AC_COMMANDS_1 FOREIGN KEY (DEVICE_ID) REFERENCES AC_DEVICES (ID);

INSERT INTO AC_COMMANDS (DEVICE_ID, TURNIKETA_NOT_IN_USE, TURNIKETA_USED)
                 VALUES (1, '55', '00');

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT'
} 


CREATE TABLE AC_CREDIT (
    CARD_ID  VARCHAR(225) NOT NULL COLLATE NONE,
    AMOUNT   DECIMAL(18,4) DEFAULT 0
);

ALTER TABLE AC_CREDIT ADD CONSTRAINT PK_AC_CREDIT PRIMARY KEY (CARD_ID);

ALTER TABLE AC_CREDIT ADD CONSTRAINT FK_AC_CREDIT_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
} 

CREATE GENERATOR GEN_AC_CREDIT_HISTORY_ID;

CREATE TABLE AC_CREDIT_HISTORY (
    ID              INTEGER NOT NULL,
    "VALUE"         DECIMAL(18,4),
    DATE_INSERT     TIMESTAMP,
    WORKER_ID       INTEGER,
    CARD_ID         VARCHAR(225) NOT NULL COLLATE NONE,
    MP_FISK_Z_ID    INTEGER,
    SIFRA_MAGACINA  INTEGER,
    GUID_MPFISKZ    VARCHAR(16) COLLATE NONE
);

ALTER TABLE AC_CREDIT_HISTORY ADD CONSTRAINT PK_AC_CREDIT_HISTORY PRIMARY KEY (ID);

ALTER TABLE AC_CREDIT_HISTORY ADD CONSTRAINT CHK1_AC_CREDIT_HISTORY CHECK (card_id <> 0);

CREATE INDEX AC_CREDIT_HISTORY_IDX_GUID ON AC_CREDIT_HISTORY (GUID_MPFISKZ);

ALTER TABLE AC_CREDIT_HISTORY ADD CONSTRAINT FK_AC_CREDIT_HISTORY_1 FOREIGN KEY (WORKER_ID) REFERENCES TBLRADNICI (SIFRA_RADNIKA);
ALTER TABLE AC_CREDIT_HISTORY ADD CONSTRAINT FK_AC_CREDIT_HISTORY_2 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);


SET TERM ^ ;


/* Trigger: AC_CREDIT_HISTORY_AD0 */
CREATE OR ALTER TRIGGER AC_CREDIT_HISTORY_AD0 FOR AC_CREDIT_HISTORY
ACTIVE AFTER DELETE POSITION 0
AS
begin
  update or insert into AC_CREDIT (CARD_ID, AMOUNT)
    values (old.card_id, coalesce( (select sum(ch."VALUE")
    from ac_credit_history ch where ch.card_id = old.card_id)
    ,0))
    matching (old.card_id);
end
^


/* Trigger: AC_CREDIT_HISTORY_AIU0 */
CREATE OR ALTER TRIGGER AC_CREDIT_HISTORY_AIU0 FOR AC_CREDIT_HISTORY
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
begin
  update or insert into AC_CREDIT (CARD_ID, AMOUNT)
    values (new.card_id, coalesce( (select sum(ch."VALUE")
    from ac_credit_history ch where ch.card_id = new.card_id)
    ,0))
    matching (new.card_id);
end
^


/* Trigger: AC_CREDIT_HISTORY_BI */
CREATE OR ALTER TRIGGER AC_CREDIT_HISTORY_BI FOR AC_CREDIT_HISTORY
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_ac_credit_history_id,1);
end
^


/* Trigger: AC_CREDIT_HISTORY_BI0 */
CREATE OR ALTER TRIGGER AC_CREDIT_HISTORY_BI0 FOR AC_CREDIT_HISTORY
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if(new.date_insert is null) then
    new.date_insert = 'now';
end
^


SET TERM ; ^



{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_GYM_HISTORY'
} 


CREATE TABLE AC_GYM_HISTORY (
    CARD_ID         VARCHAR(225) COLLATE NONE,
    PAY_TIME        INTEGER,
    TIME_ENTER      TIMESTAMP,
    DEVIATION_TIME  INTEGER,
    TIME_EXIT       TIMESTAMP,
    BUY_TIME        DATE DEFAULT current_date
);

ALTER TABLE AC_GYM_HISTORY ADD CONSTRAINT FK_AC_GYM_HISTORY_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_SPA_HISTORY'
} 


CREATE TABLE AC_SPA_HISTORY (
    CARD_ID         VARCHAR(225) NOT NULL COLLATE NONE,
    PAY_TIME        INTEGER,
    TIME_ENTER      TIMESTAMP,
    DEVIATION_TIME  INTEGER,
    MP_FISK_Z_ID    INTEGER NOT NULL,
    BUY_TIME        DATE DEFAULT current_date,
    TIME_EXIT       TIMESTAMP
);

ALTER TABLE AC_SPA_HISTORY ADD CONSTRAINT PK_AC_SPA_HISTORY PRIMARY KEY (CARD_ID, MP_FISK_Z_ID);

ALTER TABLE AC_SPA_HISTORY ADD CONSTRAINT FK_AC_SPA_HISTORY_1 FOREIGN KEY (CARD_ID) REFERENCES AC_USERS (CARD_NUMBER);



SET TERM ^ ;

/* Trigger: AC_SPA_HISTORY_BIU0 */
CREATE OR ALTER TRIGGER AC_SPA_HISTORY_BIU0 FOR AC_SPA_HISTORY
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
  if(new.deviation_time is null) then
    new.deviation_time = 15;
end
^


--SET TERM ; ^




/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/

CREATE OR ALTER PROCEDURE SWIMMING_ADD_CARD (
    CARDNUMBER VARCHAR(50) COLLATE NONE,
    GYM INTEGER = -404)
AS
BEGIN
  EXIT;
END^





CREATE OR ALTER PROCEDURE SWIMMING_POOL_CREDIT_RESET (
    CARDID VARCHAR(225) COLLATE NONE)
RETURNS (
    CARD_NUMBER VARCHAR(225) COLLATE NONE,
    IZNOS DECIMAL(15,2))
AS
BEGIN
  SUSPEND;
END^





CREATE OR ALTER PROCEDURE SWIMMING_POOL_CREDIT_UPDATE (
    CARDID VARCHAR(225) COLLATE NONE)
AS
BEGIN
  EXIT;
END^





CREATE OR ALTER PROCEDURE SWIMMING_POOL_DAYLI_RESTART
AS
BEGIN
  EXIT;
END^






SET TERM ; ^



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/


SET TERM ^ ;

CREATE OR ALTER PROCEDURE SWIMMING_ADD_CARD (
    CARDNUMBER VARCHAR(50) COLLATE NONE,
    GYM INTEGER = -404)
AS
declare variable LOCALCARD varchar(50);
declare variable DEVICE_ID integer;
begin
   select coalesce(count(*),0) from ac_users where card_number = :CARDNUMBER
   into :LOCALCARD;
   if(LOCALCARD = 0) then
   begin
  insert into AC_USERS (CARD_NUMBER, "ACTIVE", SUPER)
    values (:CARDNUMBER, 1, 0);
    INSERT INTO AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
               VALUES (1, :CARDNUMBER, 1);
    INSERT INTO AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
               VALUES (2, :CARDNUMBER, 1);
    end
    else
    begin
    /*
      UPDATE OR INSERT INTO AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
                         VALUES (1, :CARDNUMBER, 1)
                          MATCHING (DEVICE_ID, CARD_ID);
      UPDATE OR INSERT INTO AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
                         VALUES (2, :CARDNUMBER, 1)
                         MATCHING (DEVICE_ID, CARD_ID);
    */
    for
    select d.id
    from ac_devices d
    where d."ACTIVE" = 1
    into :DEVICE_ID
    do
    begin
      UPDATE OR INSERT INTO AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
                         VALUES (:DEVICE_ID, :CARDNUMBER, 1)
                         MATCHING (DEVICE_ID, CARD_ID);
    end
      delete from ac_access_history where card_id = :CARDNUMBER;
    end 
end^


CREATE OR ALTER PROCEDURE SWIMMING_POOL_CREDIT_RESET (
    CARDID VARCHAR(225) COLLATE NONE)
RETURNS (
    CARD_NUMBER VARCHAR(225) COLLATE NONE,
    IZNOS DECIMAL(15,2))
AS
BEGIN
  FOR
    select
              U.CARD_NUMBER
          from
              AC_USERS U
          where
              U.CARD_NUMBER is not distinct from :CARDID
              or (:CARDID is null)
    INTO :CARD_NUMBER
  DO
  BEGIN
    select coalesce( sum(CH."VALUE"),0)
    from AC_CREDIT_HISTORY CH
    where CH.CARD_ID = :CARD_NUMBER
    and cast( ch.date_insert as date) <> current_date
    into :iznos;
    if (iznos <> 0) then
    begin

        INSERT INTO AC_CREDIT_HISTORY ( "VALUE", DATE_INSERT, WORKER_ID, CARD_ID, MP_FISK_Z_ID, SIFRA_MAGACINA, GUID_MPFISKZ)
        VALUES ((-1)* :iznos, current_timestamp, 10, :CARD_NUMBER, -1, NULL, NULL);
        SUSPEND;
    end

  END
END^


CREATE OR ALTER PROCEDURE SWIMMING_POOL_CREDIT_UPDATE (
    CARDID VARCHAR(225) COLLATE NONE)
AS
declare variable CARD_NUMBER varchar(225);
begin
  for select
          U.CARD_NUMBER
      from
          AC_USERS U
      where
          U.CARD_NUMBER = :CARDID
          or (:CARDID is null)
      into :CARD_NUMBER
  do
  begin
    update or insert into AC_CREDIT (CARD_ID, AMOUNT)
    values (:CARD_NUMBER, coalesce( (select
                                    sum(CH."VALUE")
                                from
                                    AC_CREDIT_HISTORY CH
                                where
                                    CH.CARD_ID = :CARD_NUMBER ),0))
    matching (CARD_ID);

  end
  suspend;
end^


CREATE OR ALTER PROCEDURE SWIMMING_POOL_DAYLI_RESTART
AS
declare variable INSER_VALUE integer;
declare variable VALUE_FROM_CARD integer;
declare variable ID integer;
declare variable CARD_NUMBER varchar(225);
begin
    delete from ac_access a where a.device_id not in (select
              D.ID
          from
              AC_DEVICES D
          where
              D."INPUT_TYPE" = 1);
  for select
          U.CARD_NUMBER
      from
          AC_USERS U
      into :CARD_NUMBER
  do
  begin
    begin
      for select
              D.ID
          from
              AC_DEVICES D
          where
              D."INPUT_TYPE" = 1
          into :ID
      do
      begin
        INSER_VALUE = 1;
        select first 1 pass from ac_access where CARD_ID = :CARD_NUMBER into :VALUE_FROM_CARD;
        if(:VALUE_FROM_CARD > 1) then
            INSER_VALUE = :VALUE_FROM_CARD;
        update or insert into AC_ACCESS (DEVICE_ID, CARD_ID, PASS)
        values (:ID, :CARD_NUMBER, :INSER_VALUE)
        matching (DEVICE_ID, CARD_ID);
        --SUSPEND;
      end
    end
  end
  suspend;
end^



SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AC_CREDIT_HISTORY'
and f.rdb$field_name = 'POSLATO'
} 

ALTER TABLE AC_CREDIT_HISTORY
ADD POSLATO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'DATEADDED'
} 

ALTER TABLE TBLNOVCANO
ADD DATEADDED TIMESTAMP;

update tblnovcano n
set n.dateadded = (select first 1 i.dateadded from invoice i where i.idnovcano = n.idnovcano and i.invoicetype <> 'Copy')
where n.idnovcano in (select distinct idnovcano from invoice where idnovcano is not null);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLSTATUS'
and f.rdb$field_name = 'SIFRA_DEF_IFK_MP'
} 

ALTER TABLE TBLSTATUS
ADD SIFRA_DEF_IFK_MP INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DEF_POREZ_AMBASADA'
} 

ALTER TABLE SYSTEM_MP
ADD DEF_POREZ_AMBASADA INTEGER;

update system_mp m set m.def_porez_ambasada = (select first 1 p.sifra_poreza from tblporez p where p.tip = 'BP' and p.vazi_do is null);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'TIP_PIB_K2'
} 

ALTER TABLE MP_FISK_Z
ADD TIP_PIB_K2 VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLUSLUGEPROMENE'
and f.rdb$field_name = 'IDNOVCANO_VEZA'
} 

ALTER TABLE TBLUSLUGEPROMENE
ADD IDNOVCANO_VEZA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'TIP_IDENTIFIKACIJE'
} 

ALTER TABLE TBLPREDRACUN
ADD TIP_IDENTIFIKACIJE VARCHAR(10);

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPREDRACUN'
and f.rdb$field_name = 'IDENTIFIKACIJA'
} 

ALTER TABLE TBLPREDRACUN
ADD IDENTIFIKACIJA VARCHAR(50);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'SIFRA_KOMITENTA3'
} 

ALTER TABLE TBLNOVCANO
ADD SIFRA_KOMITENTA3 INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_FISKAL'
and f.rdb$field_name = 'TRAZI_BENEFIT_KOMITENTA'
} 

ALTER TABLE HP_FISKAL
ADD TRAZI_BENEFIT_KOMITENTA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_FISKAL'
and f.rdb$field_name = 'WEB_UPUTSTVO'
} 

ALTER TABLE HP_FISKAL
ADD WEB_UPUTSTVO VARCHAR(255);

update hp_fiskal f set f.web_uputstvo = 'http://46.174.100.32/cashit/uputstva/';

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'VERIFIKOVANO'
} 

ALTER TABLE TBLNOVCANO
ADD VERIFIKOVANO INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOV_VERIFIKACIJA'
} 

CREATE TABLE TBLNOV_VERIFIKACIJA (
    ID             INTEGER NOT NULL,
    IDNOVCANO      INTEGER,
    VERIFIKACIJA   VARCHAR(255),
    SIFRA_RADNIKA  INTEGER,
    VREME_IZMENE   TIMESTAMP
);

ALTER TABLE TBLNOV_VERIFIKACIJA ADD CONSTRAINT PK_TBLNOV_VERIFIKACIJA PRIMARY KEY (ID);
ALTER TABLE TBLNOV_VERIFIKACIJA ADD CONSTRAINT FK_TBLNOV_VERIFIKACIJA_1 FOREIGN KEY (IDNOVCANO) REFERENCES TBLNOVCANO (IDNOVCANO);
ALTER TABLE TBLNOV_VERIFIKACIJA ADD CONSTRAINT FK_TBLNOV_VERIFIKACIJA_2 FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);

create generator GEN_TBLNOV_VERIFIKACIJA_ID;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TBLNOV_VERIFIKACIJA_BI FOR TBLNOV_VERIFIKACIJA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tblnov_verifikacija_id,1);
end
^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure SP_GEN_TBLNOV_VERIFIKACIJA_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblnov_verifikacija_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'CRF_PL_IZNOS'
} 

ALTER TABLE TBLNOVCANO
ADD CRF_PL_IZNOS DECIMAL(18,2);
               
{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'EOZNAKA'
} 
                    
ALTER TABLE TBLNOVCANO
ADD EOZNAKA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'EOZNAKA'
} 
                    
ALTER TABLE TBLNOVCANO
ADD EOZNAKA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'ID_DOSTAVE'
} 
                                       
    
ALTER TABLE TBLNOVCANO
ADD ID_DOSTAVE VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'ID_PACKING'
} 
                        
    
ALTER TABLE TBLNOVCANO
ADD ID_PACKING INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'ID_PROJEKTA'
}                                   
    
ALTER TABLE TBLNOVCANO
ADD ID_PROJEKTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'IDOTPREMNICE'
}                                   
                   
ALTER TABLE TBLNOVCANO
ADD IDOTPREMNICE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'IDOTPREMNICE'
}                                   
                   
           
ALTER TABLE TBLNOVCANO
ADD IDREZERVACIJE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'ODOBRIO_MG'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD ODOBRIO_MG SMALLINT;

{$ENDIF}
             
{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'POSLAT_NIELSEN'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD POSLAT_NIELSEN TIMESTAMP;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'POSLAT_NIELSEN'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD POSLAT_NIELSEN TIMESTAMP;

{$ENDIF}
                 
{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'PREFERENCIJAL'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD PREFERENCIJAL SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'RADNIK_ODOBRIO_MG'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD RADNIK_ODOBRIO_MG INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'STORNO_CRF'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD STORNO_CRF SMALLINT DEFAULT 0;

{$ENDIF}          
                 
{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'STORNO_CRF'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD STORNO_CRF SMALLINT DEFAULT 0;

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'VREME_ODOBRAVANJA'
}                                   
                       
ALTER TABLE TBLNOVCANO
ADD VREME_ODOBRAVANJA TIME;

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO'
and f.rdb$field_name = 'VREME_ODOBRAVANJA'
}                                   
                       
ALTER TABLE TBLMAGACIN
ADD MINUS_LAGER SMALLINT;

update tblmagacin set minus_lager = 1 where robno_daljinski = 0;

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKARI_SFILIJALA'
and f.rdb$field_name = 'PRIMAMTPFAKTURE'
}   

ALTER TABLE AP_LEKARI_SFILIJALA
ADD PRIMAMTPFAKTURE VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKARI_SFILIJALA'
and f.rdb$field_name = 'PRIMARECEPTFAKTURE'
}   

ALTER TABLE AP_LEKARI_SFILIJALA
ADD PRIMARECEPTFAKTURE VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKARI_SFILIJALA'
and f.rdb$field_name = 'VAZI_OD'
}   

ALTER TABLE AP_LEKARI_SFILIJALA
ADD VAZI_OD VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEK'
and f.rdb$field_name = 'ID_LEKPERIOD'
}   

ALTER TABLE AP_LEKOVI_SLEK
ADD ID_LEKPERIOD VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEK'
and f.rdb$field_name = 'KPP'
}   

ALTER TABLE AP_LEKOVI_SLEK
ADD KPP VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEKUCESCEDIJAGNOZA'
and f.rdb$field_name = 'OSLOBODJENJEPROCENTUALNEPARTICI'
}   

ALTER TABLE AP_LEKOVI_SLEKUCESCEDIJAGNOZA
ADD OSLOBODJENJEPROCENTUALNEPARTICI VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEKUCESCEDIJAGNOZA'
and f.rdb$field_name = 'ID_LEKATRIBUT'
}   

ALTER TABLE AP_LEKOVI_SLEKUCESCEDIJAGNOZA
ADD ID_LEKATRIBUT VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEKUCESCEDIJAGNOZA'
and f.rdb$field_name = 'ID_LEKPERIOD'
}   

ALTER TABLE AP_LEKOVI_SLEKUCESCEDIJAGNOZA
ADD ID_LEKPERIOD VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_NR_PROVERARECEPTA'
}   

CREATE TABLE AP_LEKOVI_NR_PROVERARECEPTA (
    ID_PROVERE      VARCHAR(30),
    NAZIVPROVERE    VARCHAR(128),
    MASKA           VARCHAR(30),
    KRITERIJUM      VARCHAR(1024),
    KRITERIJUM2     VARCHAR(1024),
    UKLJUCENO       VARCHAR(16),
    ISPISPROVERESC  VARCHAR(128),
    ISPISPROVERESL  VARCHAR(128)
);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_NR_PROVERARECEPTA'
and f.rdb$field_name = 'SIFRA'
}   

ALTER TABLE AP_LEKOVI_NR_PROVERARECEPTA
ADD SIFRA VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_NR_PROVERARECEPTA'
and f.rdb$field_name = 'RUCNOOSPORENJE'
}   

ALTER TABLE AP_LEKOVI_NR_PROVERARECEPTA
ADD RUCNOOSPORENJE VARCHAR(16);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_P_SMTP'
and f.rdb$field_name = 'KPP'
}   

ALTER TABLE AP_P_SMTP
ADD KPP VARCHAR(30);

 {$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_P_SMTPPONUDJAC'
and f.rdb$field_name = 'NAPOMENA'
}   

ALTER TABLE AP_P_SMTPPONUDJAC
ADD NAPOMENA VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_SLEKUCESCEDIJAGNOZA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_LEKOVI_SLEKUCESCEDIJAGNOZA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_DRZAVA_SDRZAVA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_DRZAVA_SDRZAVA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_DRZAVA_SDRZAVA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_DRZAVA_TDRZAVA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_OOP_SOOP'
and f.rdb$field_name = 'EXPORTDATE'
}   



ALTER TABLE AP_OOP_SOOP
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_OOP_SOOP'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_OOP_TOOP
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_P_PROVERANALOGA'
}   

CREATE TABLE AP_P_PROVERANALOGA (
    "ID_Provere"       VARCHAR(20),
    "NazivProvere"     VARCHAR(128),
    "Maska"            VARCHAR(30),
    "Ukljuceno"        VARCHAR(20),
    "RucnoOsporenje"   VARCHAR(20),
    "IspisProvereCyr"  VARCHAR(128),
    "IspisProvereLat"  VARCHAR(128)
);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_P_PROVERANALOGA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_P_PROVERANALOGA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_P_SMTP'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_P_SMTP
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_PARTICIPACIJA_SPARTICIPACIJA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_PARTICIPACIJA_SPARTICIPACIJA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'AP_LEKOVI_NR_PROVERARECEPTA'
and f.rdb$field_name = 'EXPORTDATE'
}   

ALTER TABLE AP_LEKOVI_NR_PROVERARECEPTA
ADD EXPORTDATE VARCHAR(255);

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TIP_CENOVNIKA'
and f.rdb$field_name = 'ID_TIP_CENOVNIKA'
}   

ALTER TABLE TIP_CENOVNIKA
ADD ID_TIP_CENOVNIKA INTEGER;

{$ENDIF}  

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_FISKAL'
and f.rdb$field_name = 'STAMPAJ_ULAZNICE'
}   

ALTER TABLE HP_FISKAL
ADD STAMPAJ_ULAZNICE SMALLINT;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_KONEKCIJE'
and f.rdb$field_name = 'PROVIDER_ID'
}   


ALTER TABLE HP_KONEKCIJE
ADD PROVIDER_ID INTEGER;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
}   


CREATE GENERATOR GEN_TBLULAZNICE_ID;

CREATE TABLE TBLULAZNICE (
    ULAZNICA           BIGINT NOT NULL,
    BROJ_PROLAZA       INTEGER,
    RADNIK_CHANGE      INTEGER,
    DATE_CHANGE        TIMESTAMP,
    AKTIVNA            SMALLINT,
    KONTROLNI_BROJ     VARCHAR(2),
    ULAZNICA_KONTROLA  VARCHAR(32),
    UKUPNO_PROLAZA     INTEGER,
    SIFRA_KOMITENTA    INTEGER
);


ALTER TABLE TBLULAZNICE ADD CONSTRAINT PK_TBLULAZNICE PRIMARY KEY (ULAZNICA);


CREATE INDEX TBLULAZNICE_IDX1 ON TBLULAZNICE (ULAZNICA_KONTROLA);
CREATE INDEX TBLULAZNICE_IDX2 ON TBLULAZNICE (SIFRA_KOMITENTA);


SET TERM ^ ;



CREATE OR ALTER TRIGGER TBLULAZNICE_BI FOR TBLULAZNICE
ACTIVE BEFORE INSERT POSITION 0
as
declare variable kontrolni varchar(2);
begin
  if (new.ulaznica is null) then
    new.ulaznica = gen_id(gen_tblulaznice_id,1);
    if (new.kontrolni_broj is null) then
    begin
  select REZULTAT from PROC_ZAR_KONTROLNI_BROJ(new.ulaznica) into :kontrolni;
  new.kontrolni_broj = :kontrolni;
  new.ulaznica_kontrola = new.ulaznica||new.kontrolni_broj;
  end
end
^


SET TERM ; ^


SET SQL DIALECT 3;



CREATE GENERATOR GEN_TBLULAZNICE_PROLAZ_ID;

CREATE TABLE TBLULAZNICE_PROLAZ (
    ULAZNICA       BIGINT,
    ULAZ           SMALLINT,
    VREME_PROLAZA  TIMESTAMP,
    ID             INTEGER NOT NULL,
    VREME_IZLAZA   TIMESTAMP,
    RADNIK_CHANGE  INTEGER
);


ALTER TABLE TBLULAZNICE_PROLAZ ADD CONSTRAINT PK_TBLULAZNICE_PROLAZ PRIMARY KEY (ID);


ALTER TABLE TBLULAZNICE_PROLAZ ADD CONSTRAINT FK_TBLULAZNICE_PROLAZ_1 FOREIGN KEY (ULAZNICA) REFERENCES TBLULAZNICE (ULAZNICA);


SET TERM ^ ;


/* Trigger: TBLULAZNICE_PROLAZ_BI */
CREATE OR ALTER TRIGGER TBLULAZNICE_PROLAZ_BI FOR TBLULAZNICE_PROLAZ
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tblulaznice_prolaz_id,1);
end
^


SET TERM ; ^



CREATE GENERATOR GEN_TBLULAZNICE_ARTIKLI_ID;

CREATE TABLE TBLULAZNICE_ARTIKLI (
    ID          INTEGER NOT NULL,
    SIFRA_ROBE  INTEGER
);


ALTER TABLE TBLULAZNICE_ARTIKLI ADD CONSTRAINT PK_TBLULAZNICE_ARTIKLI PRIMARY KEY (ID);


SET TERM ^ ;


/* Trigger: TBLULAZNICE_ARTIKLI_BI */
CREATE OR ALTER TRIGGER TBLULAZNICE_ARTIKLI_BI FOR TBLULAZNICE_ARTIKLI
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tblulaznice_artikli_id,1);
end
^


SET TERM ; ^


SET TERM ^ ;

create or alter procedure SP_GEN_TBLULAZNICE_ARTIKLI_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblulaznice_artikli_id, 1);
  suspend;
end^

SET TERM ; ^

/* Existing privileges on this procedure */

GRANT EXECUTE ON PROCEDURE SP_GEN_TBLULAZNICE_ARTIKLI_ID TO SYSDBA;



SET TERM ^ ;

create or alter procedure SP_GEN_TBLULAZNICE_ID (
    BROJ integer,
    BROJ_PROLAZA integer,
    SR integer,
    SK integer)
returns (
    ID bigint,
    ULAZNICA varchar(20))
as
declare variable BR integer;
begin
 br = 0;
  while (br< broj)
  do
  begin
      id = gen_id(gen_tblulaznice_id, 1);
    INSERT INTO TBLULAZNICE (ULAZNICA, BROJ_PROLAZA, RADNIK_CHANGE, DATE_CHANGE, AKTIVNA, SIFRA_KOMITENTA)
                 VALUES (:id, :BROJ_PROLAZA, :SR, current_timestamp, 1, :SK);
    br = br + 1;
    select REZULTAT from PROC_ZAR_KONTROLNI_BROJ(:id) into :ulaznica;
    ulaznica = :id || ulaznica;
    suspend;
  end
--  suspend;
end^

SET TERM ; ^



GRANT INSERT ON TBLULAZNICE TO PROCEDURE SP_GEN_TBLULAZNICE_ID;
GRANT EXECUTE ON PROCEDURE PROC_ZAR_KONTROLNI_BROJ TO PROCEDURE SP_GEN_TBLULAZNICE_ID;


GRANT EXECUTE ON PROCEDURE SP_GEN_TBLULAZNICE_ID TO SYSDBA;


SET TERM ^ ;

create or alter procedure SP_GEN_TBLULAZNICE_PROLAZ_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblulaznice_prolaz_id, 1);
  suspend;
end^

SET TERM ; ^


GRANT EXECUTE ON PROCEDURE SP_GEN_TBLULAZNICE_PROLAZ_ID TO SYSDBA;

ALTER TABLE HP_FISKAL
ADD STAMPAJ_ULAZNICE SMALLINT;

ALTER TABLE TBLULAZNICE
ADD GODINA SMALLINT;

ALTER TABLE TBLULAZNICE
ADD VAZI_OD DATE;

ALTER TABLE TBLULAZNICE
ADD VAZI_DO DATE;

ALTER TABLE TBLULAZNICE_ARTIKLI
ADD SEZONSKI SMALLINT;

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'HP_PARKING'
and f.rdb$field_name = 'PIB'
}   

ALTER TABLE HP_PARKING
ADD PIB VARCHAR(20);

{$ENDIF} 

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'DEF_NALOG_ISPRAVKE_JP'
}   

ALTER TABLE TBLMAGACIN
ADD DEF_NALOG_ISPRAVKE_JP INTEGER;

{$ENDIF} 

{$IFNOTEXISTS
select * from RDB$GENERATORS g where
g.rdb$generator_name = 'GEN_TBLKOMIT_BENEFIT_ID'
}

CREATE GENERATOR GEN_TBLKOMIT_BENEFIT_ID;

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_TBLKOMIT_BENEFIT_ID'}


SET TERM ^ ;

create or alter procedure SP_GEN_TBLKOMIT_BENEFIT_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblkomit_benefit_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'MINUS_LAGER'
}  

ALTER TABLE TBLMAGACIN
ADD MINUS_LAGER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'AUTO_PRINT_80MM'
}  

ALTER TABLE SYSTEM_MP
ADD AUTO_PRINT_80MM SMALLINT;

{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_KOMITENTA'} ALTER TABLE TBLKOMITENTI ADD SIFRA_KOMITENTA integer  not null ; commit work; {$ENDIF};                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_ZEMLJE'} ALTER TABLE TBLKOMITENTI ADD ID_ZEMLJE integer  ; commit work; {$ENDIF};                                       
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_KATEGORIJE'} ALTER TABLE TBLKOMITENTI ADD SIFRA_KATEGORIJE integer  ; commit work; {$ENDIF};                         
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_STATUSA'} ALTER TABLE TBLKOMITENTI ADD SIFRA_STATUSA integer  ; commit work; {$ENDIF};                               
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PLACANJE'} ALTER TABLE TBLKOMITENTI ADD PLACANJE integer  ; commit work; {$ENDIF};                                         
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'POSETA'} ALTER TABLE TBLKOMITENTI ADD POSETA integer  ; commit work; {$ENDIF};                                             
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_MESTA'} ALTER TABLE TBLKOMITENTI ADD SIFRA_MESTA integer  ; commit work; {$ENDIF};                                   
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_ULICE'} ALTER TABLE TBLKOMITENTI ADD ID_ULICE integer  ; commit work; {$ENDIF};                                         
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'RADNIK_CHANGE'} ALTER TABLE TBLKOMITENTI ADD RADNIK_CHANGE integer  ; commit work; {$ENDIF};                               
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_LINIJA'} ALTER TABLE TBLKOMITENTI ADD ID_LINIJA integer  ; commit work; {$ENDIF};                                       
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PLACANJE_DOB'} ALTER TABLE TBLKOMITENTI ADD PLACANJE_DOB integer  ; commit work; {$ENDIF};                                 
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_CASSA_GRUPE_KOM'} ALTER TABLE TBLKOMITENTI ADD ID_CASSA_GRUPE_KOM integer  ; commit work; {$ENDIF};                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_NAMENE'} ALTER TABLE TBLKOMITENTI ADD ID_NAMENE integer  ; commit work; {$ENDIF};                                       
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'TOLERANCIJA_KASNJENJA'} ALTER TABLE TBLKOMITENTI ADD TOLERANCIJA_KASNJENJA integer  ; commit work; {$ENDIF};               
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'IDRABATKAT'} ALTER TABLE TBLKOMITENTI ADD IDRABATKAT integer  ; commit work; {$ENDIF};                                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BENEFIT_PROGRAM'} ALTER TABLE TBLKOMITENTI ADD BENEFIT_PROGRAM integer  ; commit work; {$ENDIF};                           
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PROVERA_USLOVA_DOB'} ALTER TABLE TBLKOMITENTI ADD PROVERA_USLOVA_DOB integer  ; commit work; {$ENDIF};                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_PRODAVCA'} ALTER TABLE TBLKOMITENTI ADD ID_PRODAVCA integer  ; commit work; {$ENDIF};                                   
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PROVERA_BLOKADE_NBS'} ALTER TABLE TBLKOMITENTI ADD PROVERA_BLOKADE_NBS integer  ; commit work; {$ENDIF};                   
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_NAMENE_KUP'} ALTER TABLE TBLKOMITENTI ADD ID_NAMENE_KUP integer  ; commit work; {$ENDIF};                               
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_NAMENE_DOB'} ALTER TABLE TBLKOMITENTI ADD ID_NAMENE_DOB integer  ; commit work; {$ENDIF};                               
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_TIP_KJS_TREZOR'} ALTER TABLE TBLKOMITENTI ADD ID_TIP_KJS_TREZOR integer  ; commit work; {$ENDIF};                       
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PDV'} ALTER TABLE TBLKOMITENTI ADD PDV smallint  ; commit work; {$ENDIF};                                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_RADNIK'} ALTER TABLE TBLKOMITENTI ADD ID_RADNIK smallint  ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'WEB_VIDLJIV_PRODAVAC'} ALTER TABLE TBLKOMITENTI ADD WEB_VIDLJIV_PRODAVAC smallint  ; commit work; {$ENDIF};                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_CENOVNIKA'} ALTER TABLE TBLKOMITENTI ADD ID_CENOVNIKA smallint  ; commit work; {$ENDIF};                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_KOMERC'} ALTER TABLE TBLKOMITENTI ADD ID_KOMERC smallint  ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_KOMITENTA1'} ALTER TABLE TBLKOMITENTI ADD SIFRA_KOMITENTA1 smallint  ; commit work; {$ENDIF};                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'AKTIVAN'} ALTER TABLE TBLKOMITENTI ADD AKTIVAN smallint  ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ZAKLJUCANO'} ALTER TABLE TBLKOMITENTI ADD ZAKLJUCANO smallint  ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SLANJE_MAIL'} ALTER TABLE TBLKOMITENTI ADD SLANJE_MAIL smallint  ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PROVERA_ZADUZENJA'} ALTER TABLE TBLKOMITENTI ADD PROVERA_ZADUZENJA smallint  ; commit work; {$ENDIF};                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'JAVNA_USTANOVA'} ALTER TABLE TBLKOMITENTI ADD JAVNA_USTANOVA smallint  ; commit work; {$ENDIF};                            
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PO_NABAVNOJ'} ALTER TABLE TBLKOMITENTI ADD PO_NABAVNOJ smallint  ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PLATIVOO'} ALTER TABLE TBLKOMITENTI ADD PLATIVOO smallint  ; commit work; {$ENDIF};                                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'STANJE'} ALTER TABLE TBLKOMITENTI ADD STANJE decimal(15,2) ; commit work; {$ENDIF};                                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'RABAT'} ALTER TABLE TBLKOMITENTI ADD RABAT decimal(15,2) ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DOZVOLJENO_ZADUZENJE'} ALTER TABLE TBLKOMITENTI ADD DOZVOLJENO_ZADUZENJE decimal(15,2) ; commit work; {$ENDIF};            
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'RABATMP'} ALTER TABLE TBLKOMITENTI ADD RABATMP decimal(15,2) ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'EURO'} ALTER TABLE TBLKOMITENTI ADD EURO decimal(18,4) ; commit work; {$ENDIF};                                            
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'CENA_LAGEROVANJA'} ALTER TABLE TBLKOMITENTI ADD CENA_LAGEROVANJA decimal(18,4) ; commit work; {$ENDIF};                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'STARI_RABATI'} ALTER TABLE TBLKOMITENTI ADD STARI_RABATI decimal(18,4) ; commit work; {$ENDIF};                            
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'MINIMALNI_RUC'} ALTER TABLE TBLKOMITENTI ADD MINIMALNI_RUC decimal(18,4) ; commit work; {$ENDIF};                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'TOLERANCIJA_VV'} ALTER TABLE TBLKOMITENTI ADD TOLERANCIJA_VV decimal(18,2) ; commit work; {$ENDIF};                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATE_CHANGE'} ALTER TABLE TBLKOMITENTI ADD DATE_CHANGE TIMESTAMP  ; commit work; {$ENDIF};                                 
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_SMS'} ALTER TABLE TBLKOMITENTI ADD DATUM_SMS TIMESTAMP  ; commit work; {$ENDIF};                                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'KOMENTAR'} ALTER TABLE TBLKOMITENTI ADD KOMENTAR BLOB   ; commit work; {$ENDIF};                                           
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BROJ_KUCE'} ALTER TABLE TBLKOMITENTI ADD BROJ_KUCE varchar(6) ; commit work; {$ENDIF};                                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_DELATNOSTI'} ALTER TABLE TBLKOMITENTI ADD SIFRA_DELATNOSTI varchar(10) ; commit work; {$ENDIF};                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'POST_BROJ'} ALTER TABLE TBLKOMITENTI ADD POST_BROJ varchar(10) ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PDV_BROJ'} ALTER TABLE TBLKOMITENTI ADD PDV_BROJ varchar(10) ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'VALUTA'} ALTER TABLE TBLKOMITENTI ADD VALUTA varchar(10) ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ZABRANA_IZD_VV'} ALTER TABLE TBLKOMITENTI ADD ZABRANA_IZD_VV varchar(10) ; commit work; {$ENDIF};                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BROJ_LK'} ALTER TABLE TBLKOMITENTI ADD BROJ_LK varchar(10) ; commit work; {$ENDIF};                                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_GRUPE'} ALTER TABLE TBLKOMITENTI ADD ID_GRUPE varchar(10) ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_GRUPE_1'} ALTER TABLE TBLKOMITENTI ADD ID_GRUPE_1 varchar(10) ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BROJ_GAZDINSTVA'} ALTER TABLE TBLKOMITENTI ADD BROJ_GAZDINSTVA varchar(12) ; commit work; {$ENDIF};                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'JMBG'} ALTER TABLE TBLKOMITENTI ADD JMBG varchar(13) ; commit work; {$ENDIF};                                              
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PIB'} ALTER TABLE TBLKOMITENTI ADD PIB varchar(15) ; commit work; {$ENDIF};                                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BROJ_UGOVORA'} ALTER TABLE TBLKOMITENTI ADD BROJ_UGOVORA varchar(15) ; commit work; {$ENDIF};                              
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'USER_NAME'} ALTER TABLE TBLKOMITENTI ADD USER_NAME varchar(20) ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'LOZINKA'} ALTER TABLE TBLKOMITENTI ADD LOZINKA varchar(20) ; commit work; {$ENDIF};                                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'PAK'} ALTER TABLE TBLKOMITENTI ADD PAK varchar(20) ; commit work; {$ENDIF};                                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BR_POR_RES'} ALTER TABLE TBLKOMITENTI ADD BR_POR_RES varchar(20) ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'MAT_BROJ'} ALTER TABLE TBLKOMITENTI ADD MAT_BROJ varchar(20) ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'GLN'} ALTER TABLE TBLKOMITENTI ADD GLN varchar(20) ; commit work; {$ENDIF};                                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'TEL1'} ALTER TABLE TBLKOMITENTI ADD TEL1 varchar(25) ; commit work; {$ENDIF};                                              
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'TEL2'} ALTER TABLE TBLKOMITENTI ADD TEL2 varchar(25) ; commit work; {$ENDIF};                                              
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'FAX'} ALTER TABLE TBLKOMITENTI ADD FAX varchar(25) ; commit work; {$ENDIF};                                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'MOBIL_TEL'} ALTER TABLE TBLKOMITENTI ADD MOBIL_TEL varchar(25) ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'HOME_TEL'} ALTER TABLE TBLKOMITENTI ADD HOME_TEL varchar(25) ; commit work; {$ENDIF};                                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ZIRO_RACUN'} ALTER TABLE TBLKOMITENTI ADD ZIRO_RACUN varchar(30) ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ID_KOD_KOMITENTA'} ALTER TABLE TBLKOMITENTI ADD ID_KOD_KOMITENTA varchar(30) ; commit work; {$ENDIF};                      
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIGURNOST'} ALTER TABLE TBLKOMITENTI ADD SIGURNOST varchar(30) ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BENEFIT_KARTICA'} ALTER TABLE TBLKOMITENTI ADD BENEFIT_KARTICA varchar(30) ; commit work; {$ENDIF};                        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'SIFRA_DOB'} ALTER TABLE TBLKOMITENTI ADD SIFRA_DOB varchar(30) ; commit work; {$ENDIF};                                    
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DRZAVA_IZDAVANJA_PASOSA'} ALTER TABLE TBLKOMITENTI ADD DRZAVA_IZDAVANJA_PASOSA varchar(40) ; commit work; {$ENDIF};        
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ADRESA'} ALTER TABLE TBLKOMITENTI ADD ADRESA varchar(50) ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'E_MAIL'} ALTER TABLE TBLKOMITENTI ADD E_MAIL varchar(50) ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'WEB'} ALTER TABLE TBLKOMITENTI ADD WEB varchar(50) ; commit work; {$ENDIF};                                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'KONTAKT_OSOBA'} ALTER TABLE TBLKOMITENTI ADD KONTAKT_OSOBA varchar(50) ; commit work; {$ENDIF};                            
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'JBBK'} ALTER TABLE TBLKOMITENTI ADD JBBK varchar(50) ; commit work; {$ENDIF};                                              
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ADRESA_PTT'} ALTER TABLE TBLKOMITENTI ADD ADRESA_PTT varchar(50) ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'BROJ_PASOSA'} ALTER TABLE TBLKOMITENTI ADD BROJ_PASOSA varchar(50) ; commit work; {$ENDIF};                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'MESTO_RODJENJA'} ALTER TABLE TBLKOMITENTI ADD MESTO_RODJENJA varchar(70) ; commit work; {$ENDIF};                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'LK_IZATA_U_SUP'} ALTER TABLE TBLKOMITENTI ADD LK_IZATA_U_SUP varchar(150) ; commit work; {$ENDIF};                         
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'KOMITENT'} ALTER TABLE TBLKOMITENTI ADD KOMITENT varchar(255) ; commit work; {$ENDIF};                                     
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_KUP'} ALTER TABLE TBLKOMITENTI ADD DATUM_KUP DATE  ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_PTT'} ALTER TABLE TBLKOMITENTI ADD DATUM_PTT DATE  ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_RODJENJA'} ALTER TABLE TBLKOMITENTI ADD DATUM_RODJENJA DATE  ; commit work; {$ENDIF};                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_OTV'} ALTER TABLE TBLKOMITENTI ADD DATUM_OTV DATE  ; commit work; {$ENDIF};                                          
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'DATUM_OPOMENA'} ALTER TABLE TBLKOMITENTI ADD DATUM_OPOMENA DATE  ; commit work; {$ENDIF};                                  
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'FAKT_KOL'} ALTER TABLE TBLKOMITENTI ADD FAKT_KOL DOUBLE PRECISION  ; commit work; {$ENDIF};                                
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'ZABRANA_IZD'} ALTER TABLE TBLKOMITENTI ADD ZABRANA_IZD varchar(1) ; commit work; {$ENDIF};                                 
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'TBLKOMITENTI' and f.rdb$field_name = 'POL'} ALTER TABLE TBLKOMITENTI ADD POL varchar(1) ; commit work; {$ENDIF};                                                 


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'GODINA'
}  

ALTER TABLE TBLULAZNICE
ADD GODINA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'VAZI_OD'
}  

ALTER TABLE TBLULAZNICE
ADD VAZI_OD DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'VAZI_DO'
}  

ALTER TABLE TBLULAZNICE
ADD VAZI_DO DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'SEZONSKI'
}  

ALTER TABLE TBLULAZNICE
ADD SEZONSKI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'KUPAC_NA_KRAJU_FISK'
}  

ALTER TABLE SYSTEM_MP
ADD KUPAC_NA_KRAJU_FISK SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'OPIS'
} 

ALTER TABLE TBLULAZNICE
ADD OPIS VARCHAR(60);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLULAZNICE'
and f.rdb$field_name = 'SEZONSKI'
} 

ALTER TABLE TBLULAZNICE
ADD SEZONSKI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'OTVORI_RAMPU'
} 

ALTER TABLE SYSTEM_MP
ADD OTVORI_RAMPU SMALLINT;

update SYSTEM_MP set OTVORI_RAMPU = 1;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI_SUPERGRUPE'
and f.rdb$field_name = 'TIP_NABAVKE'
} 

ALTER TABLE TBLARTIKLI_SUPERGRUPE
ADD TIP_NABAVKE VARCHAR(10);

UPDATE TBLARTIKLI_SUPERGRUPE SET 
    TIP_NABAVKE = 'KAPILARNO'
WHERE (NAZIV = 'Kapilarno');

UPDATE TBLARTIKLI_SUPERGRUPE SET 
    TIP_NABAVKE = 'CENTRALNO'
WHERE (NAZIV = 'Centralno');

UPDATE TBLARTIKLI_SUPERGRUPE SET 
    TIP_NABAVKE = 'MESOVITO'
WHERE (NAZIV = 'Mesovito');


COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK'
and f.rdb$field_name = 'DATUM_CHANGE'
} 

ALTER TABLE TBL_CENOVNIK
ADD DATUM_CHANGE TIMESTAMP;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLDOKUMENTI'
and f.rdb$field_name = 'TIP_STAMPE_MATRIX'
} 

ALTER TABLE TBLDOKUMENTI
ADD TIP_STAMPE_MATRIX CHAR(1);


{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLARTIKLI_ASORTIMAN' 
} 


CREATE GENERATOR GEN_TBLARTIKLI_ASORTIMAN_ID;

CREATE TABLE TBLARTIKLI_ASORTIMAN (
    ID              INTEGER NOT NULL,
    SIFRA_MAGACINA  INTEGER,
    SIFRA_ROBE      INTEGER,
    AKTIVAN         INTEGER,
    SIFRA_RADNIKA   INTEGER,
    VREME           TIMESTAMP,
    RADNIK_CHANGE   INTEGER,
    DATUM_CHANGE    TIMESTAMP
);




ALTER TABLE TBLARTIKLI_ASORTIMAN ADD CONSTRAINT PK_TBLARTIKLI_ASORTIMAN PRIMARY KEY (ID);

ALTER TABLE TBLARTIKLI_ASORTIMAN ADD CONSTRAINT FK_TBLARTIKLI_ASORTIMAN_SA FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE TBLARTIKLI_ASORTIMAN ADD CONSTRAINT FK_TBLARTIKLI_ASORTIMAN_SM FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);
ALTER TABLE TBLARTIKLI_ASORTIMAN ADD CONSTRAINT FK_TBLARTIKLI_ASORTIMAN_SR FOREIGN KEY (SIFRA_RADNIKA) REFERENCES TBLRADNICI (SIFRA_RADNIKA);



SET TERM ^ ;

/* Trigger: TBLARTIKLI_ASORTIMAN_BI */
CREATE OR ALTER TRIGGER TBLARTIKLI_ASORTIMAN_BI FOR TBLARTIKLI_ASORTIMAN
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tblartikli_asortiman_id,1);
end
^


SET TERM ; ^


{$ENDIF}

{$IFNOTEXISTS
select  p.id
from SUF_PAYMENTTYPE P
where P.ID = 4
and p.naziv = 'WireTransfer'
} 

UPDATE OR INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                               VALUES (4, 'WireTransfer')
                             MATCHING (ID);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select  p.id
from SUF_PAYMENTTYPE P
where P.ID = 5
and p.naziv = 'Voucher'
} 

UPDATE OR INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                               VALUES (5, 'Voucher')
                             MATCHING (ID);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS
select  p.id
from SUF_PAYMENTTYPE P
where P.ID = 6
and p.naziv = 'MobileMoney'
} 

UPDATE OR INSERT INTO SUF_PAYMENTTYPE (ID, NAZIV)
                               VALUES (6, 'MobileMoney')
                             MATCHING (ID);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'TIP_BENEFITA'
} 

ALTER TABLE SYSTEM_MP
ADD TIP_BENEFITA VARCHAR(20);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLBENEFIT_PROCENTI'
} 

CREATE TABLE TBLBENEFIT_PROCENTI (
    ID        INTEGER NOT NULL,
    IZNOS     DECIMAL(15,2),
    PROCENAT  DECIMAL(15,2),
    IZNOS1    DECIMAL(15,2)
);


ALTER TABLE TBLBENEFIT_PROCENTI ADD CONSTRAINT PK_TBLBENEFIT_PROCENTI PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLKOMITENTI'
and f.rdb$field_name = 'RABAT_BENEFIT'
} 

ALTER TABLE TBLKOMITENTI
ADD RABAT_BENEFIT DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ'
and f.rdb$field_name = 'PRODAJA'
} 

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD PRODAJA DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ'
and f.rdb$field_name = 'REFUNDACIJA'
} 


ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD REFUNDACIJA DECIMAL(18,2);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ'
and f.rdb$field_name = 'BROJ_PRODATI'
} 


ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD BROJ_PRODATI INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ'
and f.rdb$field_name = 'BROJ_REFUNDACIJA'
} 


ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD BROJ_REFUNDACIJA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'FISKALNA_DNEVIN_IZVESTAJ'
and f.rdb$field_name = 'BROJ_DOKUMENATA'
} 

ALTER TABLE FISKALNA_DNEVIN_IZVESTAJ
ADD BROJ_DOKUMENATA INTEGER;

{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS'
} 

CREATE TABLE INVOICE_POS (
    ID INTEGER NOT NULL,
    INVOICENUMBER VARCHAR(255),
    TIN VARCHAR(10),
    REQUESTEDBY VARCHAR(255),
    DATEANDTIMEOFPOS VARCHAR(49),
    CASHIER VARCHAR(255),
    POSINVOICENUMBER VARCHAR(255),
    PAYMENTMETHOD VARCHAR(255),
    SDCTIME_SERVERTIMEZONE TIMESTAMP,
    INVOICECOUNTER VARCHAR(255),
    SIGNEDBY VARCHAR(255),
    TOTALAMOUNT DECIMAL(15,2),
    TRANSACTIONTYPE VARCHAR(255),
    INVOICETYPE VARCHAR(255));
alter table INVOICE_POS
add constraint PK_INVOICE_POS
primary key (ID);

CREATE TABLE ITEMS (
    ID INTEGER NOT NULL,
    ID_INVOICE INTEGER,
    GTIN VARCHAR(255),
    NAME VARCHAR(255),
    QUANTITY DECIMAL(15,2),
    "CHAR" VARCHAR(10),
    UNITPRICE DECIMAL(15,2),
    TOTALAMOUNT DECIMAL(15,2));
alter table ITEMS
add constraint PK_ITEMS
primary key (ID);

alter table ITEMS
add constraint FK_ITEMS_1
foreign key (ID_INVOICE)
references INVOICE_POS(ID);

CREATE TABLE TAXITEMS (
    ID INTEGER NOT NULL,
    ID_INVOICE INTEGER,
    LABEL VARCHAR(255),
    AMOUNT DECIMAL(15,2),
    RATE DECIMAL(15,2),
    CATEGORYNAME VARCHAR(255));
alter table TAXITEMS
add constraint PK_TAXITEMS
primary key (ID);

alter table TAXITEMS
add constraint FK_TAXITEMS_1
foreign key (ID_INVOICE)
references INVOICE_POS(ID);


CREATE SEQUENCE GEN_INVOICE_POS_ID;

CREATE SEQUENCE GEN_ITEMS_ID;
SET TERM ^ ;

CREATE TRIGGER ITEMS_BI FOR ITEMS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_ITEMS_ID,1);
END

^

SET TERM ; ^

CREATE SEQUENCE GEN_TAXITEMS_ID;
SET TERM ^ ;

CREATE TRIGGER TAXITEMS_BI FOR TAXITEMS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_TAXITEMS_ID,1);
END

^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'ID'} ALTER TABLE INVOICE ADD ID integer  not null ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'ID_KLIJENTA'} ALTER TABLE INVOICE ADD ID_KLIJENTA integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'IDPRED'} ALTER TABLE INVOICE ADD IDPRED integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'TOTALCOUNTER'} ALTER TABLE INVOICE ADD TOTALCOUNTER integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'TRANSACTIONTYPECOUNTER'} ALTER TABLE INVOICE ADD TRANSACTIONTYPECOUNTER integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'IDNOVCANO'} ALTER TABLE INVOICE ADD IDNOVCANO integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'IDZ'} ALTER TABLE INVOICE ADD IDZ integer  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'POSLATO'} ALTER TABLE INVOICE ADD POSLATO smallint  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'TOTALAMOUNT'} ALTER TABLE INVOICE ADD TOTALAMOUNT decimal(18,2) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'DATEADDED'} ALTER TABLE INVOICE ADD DATEADDED TIMESTAMP  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'TRANSACTIONTYPE'} ALTER TABLE INVOICE ADD TRANSACTIONTYPE varchar(40) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'SDCDATETIME'} ALTER TABLE INVOICE ADD SDCDATETIME varchar(40) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'INVOICETYPE'} ALTER TABLE INVOICE ADD INVOICETYPE varchar(40) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'INVOICENUMBER'} ALTER TABLE INVOICE ADD INVOICENUMBER varchar(50) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE' and f.rdb$field_name = 'VERIFICATIONURL'} ALTER TABLE INVOICE ADD VERIFICATIONURL varchar(1200) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'ID'} ALTER TABLE INVOICE_POS ADD ID integer  not null ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'TOTALAMOUNT'} ALTER TABLE INVOICE_POS ADD TOTALAMOUNT decimal(15,2) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'SDCTIME_SERVERTIMEZONE'} ALTER TABLE INVOICE_POS ADD SDCTIME_SERVERTIMEZONE TIMESTAMP  ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'TIN'} ALTER TABLE INVOICE_POS ADD TIN varchar(10) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'DATEANDTIMEOFPOS'} ALTER TABLE INVOICE_POS ADD DATEANDTIMEOFPOS varchar(49) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'CASHIER'} ALTER TABLE INVOICE_POS ADD CASHIER varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'POSINVOICENUMBER'} ALTER TABLE INVOICE_POS ADD POSINVOICENUMBER varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'PAYMENTMETHOD'} ALTER TABLE INVOICE_POS ADD PAYMENTMETHOD varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'INVOICECOUNTER'} ALTER TABLE INVOICE_POS ADD INVOICECOUNTER varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'SIGNEDBY'} ALTER TABLE INVOICE_POS ADD SIGNEDBY varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'INVOICENUMBER'} ALTER TABLE INVOICE_POS ADD INVOICENUMBER varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'TRANSACTIONTYPE'} ALTER TABLE INVOICE_POS ADD TRANSACTIONTYPE varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'REQUESTEDBY'} ALTER TABLE INVOICE_POS ADD REQUESTEDBY varchar(255) ; commit work; {$ENDIF};
{$IFNOTEXISTS select * from rdb$relation_fields f where f.rdb$relation_name = 'INVOICE_POS' and f.rdb$field_name = 'INVOICETYPE'} ALTER TABLE INVOICE_POS ADD INVOICETYPE varchar(255) ; commit work; {$ENDIF};


{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_AC_CREDIT_HISTORY_ID'}

CREATE SEQUENCE GEN_AC_CREDIT_HISTORY_ID;

SET TERM ^ ;

create or alter procedure SP_GEN_AC_CREDIT_HISTORY_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_ac_credit_history_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF};


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLELEKTRONSKE_DOPUNE'
and f.rdb$field_name = 'IDTRANSAKCIJE_MERIDIAN'
} 


ALTER TABLE TBLELEKTRONSKE_DOPUNE
ADD IDTRANSAKCIJE_MERIDIAN BIGINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_KARTICE'
} 

CREATE GENERATOR GEN_SUF_KARTICE_ID;

CREATE TABLE SUF_KARTICE (
    ID       INTEGER NOT NULL,
    KARTICA  VARCHAR(20),
    PIN      VARCHAR(10)
);

ALTER TABLE SUF_KARTICE ADD CONSTRAINT UNQ1_SUF_KARTICE UNIQUE (KARTICA);

ALTER TABLE SUF_KARTICE ADD CONSTRAINT PK_SUF_KARTICE PRIMARY KEY (ID);

SET TERM ^ ;

create or alter procedure SP_GEN_SUF_KARTICE_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_suf_kartice_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'SIFRA_SEKTORA'
} 

ALTER TABLE TBLMAGACIN
ADD SIFRA_SEKTORA SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'INVOICE_POS'
} 

CREATE TABLE INVOICE_POS (
    ID                      INTEGER NOT NULL,
    INVOICENUMBER           VARCHAR(255),
    TIN                     VARCHAR(10),
    REQUESTEDBY             VARCHAR(255),
    DATEANDTIMEOFPOS        VARCHAR(49),
    CASHIER                 VARCHAR(255),
    POSINVOICENUMBER        VARCHAR(255),
    PAYMENTMETHOD           VARCHAR(255),
    SDCTIME_SERVERTIMEZONE  TIMESTAMP,
    INVOICECOUNTER          VARCHAR(255),
    SIGNEDBY                VARCHAR(255),
    TOTALAMOUNT             DECIMAL(15,2),
    TRANSACTIONTYPE         VARCHAR(255),
    INVOICETYPE             VARCHAR(255)
);

ALTER TABLE INVOICE_POS ADD CONSTRAINT PK_INVOICE_POS PRIMARY KEY (ID);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLPOREZ'
and f.rdb$field_name = 'SIFRA_ROBE_AVANS'
} 

ALTER TABLE TBLPOREZ
ADD SIFRA_ROBE_AVANS INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'KORISTI_INTERNE_PRIJEMNICE'
} 

ALTER TABLE SYSTEM_MP
ADD KORISTI_INTERNE_PRIJEMNICE SMALLINT;

update SYSTEM_MP set KORISTI_INTERNE_PRIJEMNICE = 1;
{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLNOVCANO_AVANS'
} 

CREATE TABLE TBLNOVCANO_AVANS (
    IDNOVCANO   INTEGER,
    ID          INTEGER NOT NULL,
    SIFRA_ROBE  INTEGER,
    KOLICINA    DECIMAL(18,4),
    CENA        DECIMAL(18,4),
    IZNOS       DECIMAL(18,4)
);

ALTER TABLE TBLNOVCANO_AVANS ADD CONSTRAINT PK_TBLNOVCANO_AVANS PRIMARY KEY (ID);

ALTER TABLE TBLNOVCANO_AVANS ADD CONSTRAINT FK_TBLNOVCANO_AVANS_ARTIKLI FOREIGN KEY (SIFRA_ROBE) REFERENCES TBLARTIKLI (SIFRA_ROBE);
ALTER TABLE TBLNOVCANO_AVANS ADD CONSTRAINT FK_TBLNOVCANO_AVANS_NOVCANO FOREIGN KEY (IDNOVCANO) REFERENCES TBLNOVCANO (IDNOVCANO);

CREATE SEQUENCE GEN_TBLNOVCANO_AVANS_ID;
ALTER SEQUENCE GEN_TBLNOVCANO_AVANS_ID RESTART WITH 0;

SET TERM ^ ;

create or alter procedure SP_GEN_TBLNOVCANO_AVANS_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tblnovcano_avans_id, 1);
  suspend;
end^

SET TERM ; ^

-- PODESAVAM SIFRU_ROBE_POREZ KOJA SE PRIMENJUJE KOD AVANSNIH RACUNA
update TBLPOREZ P
set P.SIFRA_ROBE_AVANS = (select FIRST 1 A.SIFRA_ROBE
                          from TBLARTIKLI A
                          where upper(A.ARTIKAL) containing 'AVANS' and
                                A.SIFRA_POREZA = P.SIFRA_POREZA)
where STRLEN(P.LABEL) = 1 and
      P.SIFRA_ROBE_AVANS is null ;  
      

{$ENDIF}

{$IFNOTEXISTS 
select *
from TIP_PLACANJA f
where upper(NAZIV) = 'VAUCER'
} 

INSERT INTO TIP_PLACANJA ( NAZIV, TRGOVACKA, KONTO, PODRAZUMEVANI_DOKUMENT, AKTIVAN, "DEFAULT", DEFAULT_PREDRACUN, RAZDUZUJ_MP_AUTO, IDE_NA_KASU, SUF_PAYMENT, SIFRA_PLACANJA)
                  VALUES ( 'Vaucer', 1, NULL, NULL, 1, NULL, NULL, 1, 1, '5', NULL);

COMMIT WORK;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLMAGACIN'
and f.rdb$field_name = 'VAUCER'
} 

ALTER TABLE TBLMAGACIN
ADD VAUCER SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'MP_FISK_Z'
and f.rdb$field_name = 'VAUCER'
} 

ALTER TABLE MP_FISK_Z
ADD VAUCER DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_INVOICETYPE'
and f.rdb$field_name = 'IZNOS'
} 

ALTER TABLE SUF_INVOICETYPE
ADD IZNOS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_INVOICETYPE'
and f.rdb$field_name = 'PREVOD'
} 

ALTER TABLE SUF_INVOICETYPE
ADD PREVOD VARCHAR(50);

UPDATE SUF_INVOICETYPE SET 
    PREVOD = 'Račun',
    IZNOS = 1
WHERE (NAZIV = 'Normal');

UPDATE SUF_INVOICETYPE SET 
    PREVOD = 'Predračun',
    IZNOS = 0
WHERE (NAZIV = 'Proforma');

UPDATE SUF_INVOICETYPE SET 
    PREVOD = 'Kopija',
    IZNOS = 0
WHERE (NAZIV = 'Copy');

UPDATE SUF_INVOICETYPE SET 
    PREVOD = 'Trening',
    IZNOS = 0
WHERE (NAZIV = 'Training');

UPDATE SUF_INVOICETYPE SET 
    PREVOD = 'Avans',
    IZNOS = 1
WHERE (NAZIV = 'Advance');


COMMIT WORK;

CREATE INDEX SUF_INVOICETYPE_IDX1
ON SUF_INVOICETYPE (NAZIV);

CREATE INDEX INVOICE_IDX_TRTYPE
ON INVOICE (TRANSACTIONTYPE);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_TRANSACTIONTYPE'
and f.rdb$field_name = 'IZNOS'
} 

ALTER TABLE SUF_TRANSACTIONTYPE
ADD IZNOS SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SUF_TRANSACTIONTYPE'
and f.rdb$field_name = 'PREVOD'
} 

ALTER TABLE SUF_TRANSACTIONTYPE
ADD PREVOD VARCHAR(50);

UPDATE SUF_TRANSACTIONTYPE SET 
    PREVOD = 'Prodaja',
    IZNOS = 1
WHERE (NAZIV = 'Sale');

UPDATE SUF_TRANSACTIONTYPE SET 
    PREVOD = 'Refundacija',
    IZNOS = -1
WHERE (NAZIV = 'Refund');


COMMIT WORK;

{$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'ASORTIMAN'
} 
ALTER TABLE SYSTEM_MP
ADD ASORTIMAN INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from ICONS_SHORTCUTS f
where ID = 30
} 

INSERT INTO ICONS_SHORTCUTS (ID, ICON, VISIBLE, CAPTION)
                     VALUES (30, NULL, 1, 'Vaga');

COMMIT WORK;

{$ENDIF}

{$IFEXISTS 
select *
from ICONS_SHORTCUTS 
where ID = 24
and caption = 'Interna otpremnica'
} 

delete from ICONS_SHORTCUTS where ID = 24;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLELEKTRONSKE_DOPUNE'
and f.rdb$field_name = 'IDTRANSAKCIJE_MERIDIAN'
} 

ALTER TABLE TBLELEKTRONSKE_DOPUNE
ADD IDTRANSAKCIJE_MERIDIAN BIGINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK_VEZA'
} 

CREATE GENERATOR GEN_TBL_CENOVNIK_VEZA_ID;

CREATE TABLE TBL_CENOVNIK_VEZA (
    ID                   INTEGER NOT NULL,
    ID_CENOVNIKA         INTEGER,
    ID_CENOVNIKA_AKCIJA  INTEGER,
    RADNIK_CHANGE        INTEGER,
    DATUM_CHANGE         TIMESTAMP,
    AKTIVAN              SMALLINT
);

ALTER TABLE TBL_CENOVNIK_VEZA ADD CONSTRAINT PK_TBL_CENOVNIK_VEZA PRIMARY KEY (ID)
;

ALTER TABLE TBL_CENOVNIK_VEZA ADD CONSTRAINT FK_TBL_CENOVNIK_VEZA_AKC FOREIGN KEY (ID_CENOVNIKA) REFERENCES TIP_CENOVNIKA (ID)
;
ALTER TABLE TBL_CENOVNIK_VEZA ADD CONSTRAINT FK_TBL_CENOVNIK_VEZA_IDC FOREIGN KEY (ID_CENOVNIKA) REFERENCES TIP_CENOVNIKA (ID)
;

SET TERM ^ ;

CREATE OR ALTER TRIGGER TBL_CENOVNIK_VEZA_BI FOR TBL_CENOVNIK_VEZA
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_tbl_cenovnik_veza_id,1);
end
^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_MATICNOG_KOMITENTA'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_MATICNOG_KOMITENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'CYCLE_API'
} 

ALTER TABLE SYSTEM_MP
ADD CYCLE_API VARCHAR(255);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVRSTA_POREZA'
} 


CREATE GENERATOR GEN_TBLVRSTA_POREZA_ID;

CREATE TABLE TBLVRSTA_POREZA (
    ID     INTEGER NOT NULL,
    NAZIV  VARCHAR(100) NOT NULL,
    OPIS   VARCHAR(800),
    KOD    VARCHAR(20)
);

ALTER TABLE TBLVRSTA_POREZA ADD CONSTRAINT UNQ1_TBLVRSTA_POREZA UNIQUE (KOD);

ALTER TABLE TBLVRSTA_POREZA ADD CONSTRAINT PK_TBLVRSTA_POREZA_ID PRIMARY KEY (ID);

SET TERM ^ ;

/* Trigger: TBLVRSTA_POREZA_BI */
CREATE OR ALTER TRIGGER TBLVRSTA_POREZA_BI FOR TBLVRSTA_POREZA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_TBLVRSTA_POREZA_ID,1);
END
^

SET TERM ; ^

 {$ENDIF}


{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLVRSTA_POREZA'
and f.rdb$field_name = 'KOD'
} 

ALTER TABLE TBLVRSTA_POREZA
ADD KOD VARCHAR(20);

ALTER TABLE TBLVRSTA_POREZA
ADD CONSTRAINT UNQ1_TBLVRSTA_POREZA
UNIQUE (KOD);

alter table tblvrsta_poreza alter opis type varchar(800);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'VERZIJA'
and f.rdb$field_name = 'SINHRO'
} 

ALTER TABLE VERZIJA
ADD SINHRO VARCHAR(10);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'IDPOPDV_CYCLE'
} 

ALTER TABLE SYSTEM_MP
ADD IDPOPDV_CYCLE INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLTREBOVANJESTAVKE'
and f.rdb$field_name = 'POSLEDNJA_NAB_KOL'
} 

ALTER TABLE TBLTREBOVANJESTAVKE
ADD POSLEDNJA_NAB_KOL DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLTREBOVANJESTAVKE'
and f.rdb$field_name = 'POSLEDNJA_NAB_CENA'
} 

ALTER TABLE TBLTREBOVANJESTAVKE
ADD POSLEDNJA_NAB_CENA DECIMAL(18,4);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLTREBOVANJESTAVKE'
and f.rdb$field_name = 'DATUM_POSLEDNJE_NAB'
} 

ALTER TABLE TBLTREBOVANJESTAVKE
ADD DATUM_POSLEDNJE_NAB DATE;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLSTATUS'
and f.rdb$field_name = 'VIDLJIV_MP'
} 

ALTER TABLE TBLSTATUS
ADD VIDLJIV_MP SMALLINT DEFAULT 1;

update TBLSTATUS set VIDLJIV_MP = 1;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'DEF_TREBOVANJE_MAGACIN_IZ'
} 

ALTER TABLE SYSTEM_MP
ADD DEF_TREBOVANJE_MAGACIN_IZ INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_MAGACINA_AVANS'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_MAGACINA_AVANS INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_DOK_AVANS'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_DOK_AVANS INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'PRIKAZI_DUGME_POSEBNI'
} 

ALTER TABLE SYSTEM_MP
ADD PRIKAZI_DUGME_POSEBNI SMALLINT;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'VAGA'
and f.rdb$field_name = 'KOMANDA'
} 

ALTER TABLE VAGA
ADD KOMANDA VARCHAR(512);

{$ENDIF}

{$IFNOTEXISTS SELECT * FROM rdb$procedures WHERE rdb$procedure_name = 'SP_GEN_TBLCENOVNIK_ID'}

SET TERM ^ ;

create or alter procedure SP_GEN_TBLCENOVNIK_ID
returns (
    ID integer)
as
begin
  id = gen_id(gen_tbl_cenovnik_id, 1);
  suspend;
end^

SET TERM ; ^

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBL_CENOVNIK_MAGACIN'
} 

CREATE TABLE TBL_CENOVNIK_MAGACIN (
    ID              INTEGER NOT NULL,
    ID_CENOVNIKA    INTEGER,
    SIFRA_MAGACINA  INTEGER,
    AKTIVAN         INTEGER,
    DATE_CHANGE     INTEGER,
    RADNIK_CHANGE   INTEGER
);

ALTER TABLE TBL_CENOVNIK_MAGACIN ADD CONSTRAINT PK_TBL_CENOVNIK_MAGACIN PRIMARY KEY (ID);

ALTER TABLE TBL_CENOVNIK_MAGACIN ADD CONSTRAINT FK_TBL_CENOVNIK_MAGACIN_CEN FOREIGN KEY (ID_CENOVNIKA) REFERENCES TIP_CENOVNIKA (ID);
ALTER TABLE TBL_CENOVNIK_MAGACIN ADD CONSTRAINT FK_TBL_CENOVNIK_MAGACIN_MAG FOREIGN KEY (SIFRA_MAGACINA) REFERENCES TBLMAGACIN (SIFRA_MAGACINA);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'SIFRA_KOMITENTA'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD SIFRA_KOMITENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'IDZ'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD IDZ INTEGER;

CREATE INDEX BENEFIT_VOUCHER_IDX_IDZ ON BENEFIT_VOUCHER (IDZ);
CREATE INDEX BENEFIT_VOUCHER_IDX_SK ON BENEFIT_VOUCHER (SIFRA_KOMITENTA);
CREATE INDEX BENEFIT_VOUCHER_NEW_UID ON BENEFIT_VOUCHER (NEW_UID);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_ROBE_VAUCER_OS'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_ROBE_VAUCER_OS INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'ID_HP_OBRACUN'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD ID_HP_OBRACUN INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'BROJ_SERIJE'
} 

CREATE SEQUENCE GEN_BENEFIT_VOUCHER_IDZ;

ALTER TABLE BENEFIT_VOUCHER
ADD BROJ_SERIJE VARCHAR(30);

SET TERM ^ ;

CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BSERIJA FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
  if (new.broj_serije is null) then
  new.broj_serije = lpad('0', 6, new.id) || lpad('0',6, new.sifra_komitenta) || lpad('0', 7, new.new_uid);
end
^

SET TERM ; ^

CREATE INDEX HP_OBRACUN_IDX_bs ON HP_OBRACUN (BROJ_SERIJE);

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_DOKUMENTA_VAUCER'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_DOKUMENTA_VAUCER INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLIZVODI'
and f.rdb$field_name = 'IDVERZIJE_KP'
} 

ALTER TABLE TBLIZVODI
ADD IDVERZIJE_KP INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLIZVODI'
and f.rdb$field_name = 'IDSEKTORA'
} 

ALTER TABLE TBLIZVODI
ADD IDSEKTORA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'TBLIZVODI'
and f.rdb$field_name = 'ID_POPDV'
} 

ALTER TABLE TBLIZVODI
ADD ID_POPDV INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_ROBE_VAUCER_OS'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_ROBE_VAUCER_OS INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_DOKUMENTA_VAUCER'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_DOKUMENTA_VAUCER INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'SIFRA_KOMITENTA'
} 


ALTER TABLE BENEFIT_VOUCHER
ADD SIFRA_KOMITENTA INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'IDZ'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD IDZ INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'ID_HP_OBRACUN'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD ID_HP_OBRACUN INTEGER;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'BENEFIT_VOUCHER'
and f.rdb$field_name = 'BROJ_SERIJE'
} 

ALTER TABLE BENEFIT_VOUCHER
ADD BROJ_SERIJE VARCHAR(30);


SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: BENEFIT_VOUCHER_BI */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BI FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(GEN_BENEFIT_VOUCHER_ID,1);
end
^


/* Trigger: BENEFIT_VOUCHER_BI0 */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BI0 FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if(new.date_create is null) then
    new.date_create = 'now';
end
^


/* Trigger: BENEFIT_VOUCHER_BSERIJA */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BSERIJA FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
--  if (new.broj_serije is null) then
  new.broj_serije =  lpad(new.id,  6,'0') || lpad( new.sifra_komitenta,6,'0') || lpad(new.new_uid,  7,'0');
end
^


/* Trigger: BENEFIT_VOUCHER_BU0 */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BU0 FOR BENEFIT_VOUCHER
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  if(new.bill_uid is not null) then
  begin
    new.used = 1;
    new.date_used = 'now';
  end
  else
  begin
    new.used = 0;
    new.date_used = null;
  end
end
^


/* Trigger: BENEFIT_VOUCHER_BU12 */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_BU12 FOR BENEFIT_VOUCHER
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  if (new.amount <> old.amount and old.used = 1) then exception ZABRANJENO_MENJANJE;
end
^


/* Trigger: BENEFIT_VOUCHER_UID */
CREATE OR ALTER TRIGGER BENEFIT_VOUCHER_UID FOR BENEFIT_VOUCHER
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  if(new.uid is null) then
    new.uid = gen_uuid();
end
^


SET TERM ; ^


CREATE INDEX BENEFIT_VOUCHER_IDX1 ON BENEFIT_VOUCHER (DATE_CREATE);
CREATE INDEX BENEFIT_VOUCHER_IDX2 ON BENEFIT_VOUCHER COMPUTED BY (cast(DATE_CREATE as date));
CREATE INDEX BENEFIT_VOUCHER_IDX_IDZ ON BENEFIT_VOUCHER (IDZ);
CREATE INDEX BENEFIT_VOUCHER_IDX_SK ON BENEFIT_VOUCHER (SIFRA_KOMITENTA);
CREATE INDEX BENEFIT_VOUCHER_NEW_UID ON BENEFIT_VOUCHER (NEW_UID);

CREATE SEQUENCE GEN_BENEFIT_VOUCHER_IDZ;

{$ENDIF}

{$IFNOTEXISTS 
select *
from rdb$relation_fields f
where f.rdb$relation_name = 'SYSTEM_MP'
and f.rdb$field_name = 'SIFRA_ROBE_VAUCER_VN'
} 

ALTER TABLE SYSTEM_MP
ADD SIFRA_ROBE_VAUCER_VN INTEGER;

{$ENDIF}
