
{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220301 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;


CREATE OR ALTER TRIGGER INVOICE_AI0 FOR INVOICE
ACTIVE AFTER INSERT POSITION 0
AS
begin
  if (new.sdcdatetime is not null) then
  begin
      update invoice i set i.dateadded = cast( left( replace( new.sdcdatetime, 'T', ' '), 19) as timestamp )
      where i.id = new.id;
      if (new.idz is not null and new.invoicetype <> 'Copy') then
      begin
        update mp_fisk_z z set z.datumpravljenja = cast( left( replace( new.sdcdatetime, 'T', ' '), 19) as timestamp )
         where z.idz = new.idz;
      end
  end
end
^


/* Trigger: INVOICE_BI */
CREATE OR ALTER TRIGGER INVOICE_BI FOR INVOICE
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_invoice_id,1);
end
^


SET TERM ; ^

update verzija set maloprodaja = 20220301;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220302 }

SET TRPARAMS 'isc_tpb_wait';

UPDATE TIP_PLACANJA SET 
    SUF_PAYMENT = 'Check'
WHERE (NAZIV = 'Virmanski');

update verzija set maloprodaja = 20220302;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220303 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure STAMPA_POREZA_KNJIGOVODJA_MPFS (
    MG integer,
    DATUM date,
    DATUM_DO date,
    IDZ integer = null)
returns (
    OPIS varchar(50),
    POREZ decimal(18,2),
    OSNOVICA decimal(18,2))
as
begin
  for select Z.IDZ
      from MP_FISK_Z Z
      left join invoice iv on z.idz = iv.idz
      where (Z.DATUMDPO >= :DATUM and
            Z.DATUMDPO <= :DATUM_DO and
            Z.SIFRA_MAGACINA = :MG) or (Z.IDZ = :IDZ)
      into :IDZ
  do
  begin
    for select cast(sum(O.PDV) as decimal(18,2)) as POREZ, cast(sum(O.IZNOS - O.PDV) as decimal(18,2)) as OSNOVICA,
               P.OPIS
        from HP_OBRACUN O
        join MP_FISK_Z Z on O.IDZG = Z.IDZ
        left join TBLPOREZ P on O.SIFRA_POREZA = P.SIFRA_POREZA
        where O.IDZG = :IDZ
        group by P.OPIS
        into :POREZ, :OSNOVICA, :OPIS
    do
    begin
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220303;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220304 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PLACANJE (
    D1 date,
    D2 date,
    SM integer,
    FISKAL_PUSTEN integer)
returns (
    IDZ integer,
    DUGUJE decimal(18,4),
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    BENEFIT decimal(18,4),
    OPIS varchar(255),
    DATUMDPO date,
    BROJ_FISKALNOG integer,
    INVOICENUMBER varchar(50),
    TOTALAMOUNT decimal(18,2),
    NARUKVICA decimal(18,2),
    SIFRA_MAGACINA integer,
    INVOICETYPE varchar(40),
    TRANSACTIONTYPE varchar(40))
as
BEGIN
  FOR
    select Z.IDZ,
           Z.DUGUJE,
           Z.KES,
           Z.CEK,
           Z.KARTICA,
           Z.VIRMAN,
           Z.BENEFIT,
           Z.OPIS,
           Z.DATUMDPO,
           Z.BROJ_FISKALNOG,
           z.sifra_magacina,
           IV.INVOICETYPE,
           IV.TRANSACTIONTYPE
    from MP_FISK_Z Z
    left join INVOICE IV on IV.IDZ = Z.IDZ
    where Z.DATUMDPO between :D1 and :D2 and
          (Z.SIFRA_MAGACINA = :SM or :sm = -1) and
          Z.PLACENO = 'Y' and iv.invoicetype = 'Normal'
    INTO :IDZ,
         :DUGUJE,
         :KES,
         :CEK,
         :KARTICA,
         :VIRMAN,
         :BENEFIT,
         :OPIS,
         :DATUMDPO,
         :BROJ_FISKALNOG,
         :sifra_magacina,
         :INVOICETYPE,
         :TRANSACTIONTYPE
  DO
  BEGIN
    select  first 1 i.invoicenumber, i.totalamount
    from invoice i
    where i.idz = :idz
    and i.transactiontype = 'Sale'
    and i.invoicetype = 'Normal'
    into :INVOICENUMBER, :TOTALAMOUNT;

    select sum(h."VALUE") as narukvica
    from ac_credit_history h
    where h.mp_fisk_z_id = :idz
    into :narukvica;

    if (FISKAL_PUSTEN = -1 or :invoicenumber is not null ) then
    SUSPEND;
    TOTALAMOUNT = 0;
    INVOICENUMBER = 0;
    narukvica = 0;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20220304;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220306 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure TK_KNJIGA_S (
    MG integer,
    OD_DATUMA date,
    DO_DATUMA date)
returns (
    IDNOVCANO integer,
    DATUMDPO date,
    SIFRA_KOMITENTA integer,
    OPIS varchar(1000),
    BUD varchar(20),
    BID integer,
    SIFRA_DOKUMENTA integer,
    DUGUJE decimal(15,2),
    POTRAZUJE decimal(18,4),
    FAKTURE decimal(15,2),
    DATUM_UPLATE date,
    PLACENO decimal(15,2),
    NACIN_PLACANJA integer,
    KOMITENT varchar(150),
    DOKUMENT varchar(50),
    MAGACIN_U varchar(150))
as
declare variable BENEFIT integer;
declare variable MP integer;
declare variable KARTICA_IZNOS decimal(18,4);
declare variable KARTICA integer;
declare variable CEK_IZNOS decimal(18,4);
declare variable CEK integer;
declare variable KES_IZNOS decimal(18,4);
declare variable KES integer;
declare variable VIRMAN integer;
declare variable IDN integer;
declare variable IDN1 integer;
declare variable VIRMANSKI integer;
declare variable IZNOS double precision;
declare variable VIRAMAN_IZNOS decimal(18,4);
declare variable VOJNI integer;
declare variable RAZDUZENJE_PAZAROM integer;
declare variable RAZDUZUJ_VIR_AUTO integer;
declare variable RAZDUZUJ_CEK_AUTO integer;
declare variable RAZDUZUJ_KART_AUTO integer;
declare variable RAZDUZUJ_GOT_AUTO integer;
declare variable PARTICIP integer;
declare variable RAZDUZUJ_PAR_AUTO integer;
declare variable PARTICIP_IZNOS decimal(18,2);
begin
  select first 1 idplacanja, RAZDUZUJ_MP_AUTO from tip_placanja where UPPER(naziv) = UPPER('Gotovina') and ide_na_kasu=1 into :kes, :razduzuj_got_auto;
  select idplacanja, RAZDUZUJ_MP_AUTO from tip_placanja where UPPER(naziv) = UPPER('Kartica') and ide_na_kasu=1  into :kartica, :RAZDUZUJ_KART_AUTO;
  select idplacanja, RAZDUZUJ_MP_AUTO from tip_placanja where UPPER(naziv) = UPPER('Cekovi') and ide_na_kasu=1  into :cek, :RAZDUZUJ_CEK_AUTO;
  select idplacanja, RAZDUZUJ_MP_AUTO from tip_placanja where UPPER(naziv) = UPPER('Virmanski') and ide_na_kasu=1  into :virman, :RAZDUZUJ_VIR_AUTO;
  
  select idplacanja from tip_placanja where UPPER(naziv) = UPPER('Benefit') into :BENEFIT;
  select idplacanja, RAZDUZUJ_MP_AUTO from tip_placanja where UPPER(naziv) = UPPER('Virman participacija') into :particip, :RAZDUZUJ_PAR_AUTO;
  select tk_razduzenje_pazarom from tblmagacin where sifra_magacina = :mg into razduzenje_pazarom;

  select k.sifra_komitenta from tblkomitenti k where UPPER(k.komitent) =  UPPER('Vojni osiguranik') into vojni;
  if (:vojni is null) then vojni = -1;
  -- DUGUJE - ulazne_kalkulacije i povracaj u mp
  FOR SELECT n.idnovcano, n.datum_prijema, n.sifra_komitenta, d.dokument  , n.BUD, n.BID, n.Sifra_dokumenta, k.komitent ,
        CAST(SUM(p.dug_mg) as DECIMAL(18,2)),
        CAST(SUM(p.pot_mg) as DECIMAL(18,2)),
        0 --, CAST(SUM(p.pot_mg) as DECIMAL(18,2))
        FROM tblNovcano n, tblPromene p, tblDokumenti d, Tip_placanja pl , tblkomitenti k
        WHERE n.idnovcano=p.idnovcano
            AND n.sifra_dokumenta=d.sifra_dokumenta
            AND d.kepu=1
            AND n.datum_prijema>=:od_datuma
            AND n.datum_prijema<=:do_datuma
            AND pl.idplacanja=n.sifra_placanja
           -- AND pl.trgovacka=1
            AND p.magacin1=:mg
            AND d.pr_doc = 0
            and n.sifra_komitenta = k.sifra_komitenta
        GROUP BY n.datum_prijema, n.idnovcano, n.sifra_komitenta, n.BUD, n.BID, n.Sifra_dokumenta, d.dokument, k.komitent
        INTO     :idnovcano, :datumdpo, :sifra_komitenta, :dokument, :bud, :bid, :sifra_dokumenta, :komitent, :duguje, :potrazuje, :fakture
  DO
    BEGIN    
            if (dokument is null) then
                dokument = ' ';
            if (komitent is null) then
                komitent = ' ';
            if (bid is null) then
                bid = ' ';
            if (bud is null) then
                bud = ' ';

                
            if (strlen(dokument)> 50) then
                dokument = '_____1';
                
            if (strlen(komitent)> 70) then
                komitent = '_____2';
                
            if (strlen(bid)> 50) then
                bid = '_____3';
                
            if (strlen(bud)> 50) then
                bud = '_____4';

            opis = substring( :dokument|| ' :' || coalesce(:bid, 0)   || ' ' || :komitent || ' ' || :bud from 1 for 500 );
       -- opis = substr(:opis|| ' :' || coalesce(:bid, '')   || ' ' || :komitent || ' ' || coalesce(:bud, '') ,1,255);
        suspend;
    END
     idnovcano = null; datumdpo = null; sifra_komitenta = null; opis = null;
     bud = null; bid = null; sifra_dokumenta = null; komitent = null;
     duguje = null; potrazuje = null; fakture = 0;

  --POTRAZUJE  - izlazni dokumenti
  FOR SELECT n.idnovcano, n.datumdpo, n.sifra_komitenta, d.dokument, n.BUD, n.BID,
        n.Sifra_dokumenta,k.komitent,
        CAST(SUM(p.dug_mg) as DECIMAL(18,2)),
        CAST(SUM(p.pot_mg) as DECIMAL(18,2)),
        0--CAST(n.pl_iznos as DECIMAL(18,2))
        FROM tblNovcano n, tblPromene p, tblDokumenti d , tblkomitenti k
        WHERE n.idnovcano=p.idnovcano
            AND n.sifra_dokumenta=d.sifra_dokumenta
            AND d.kepu=1
            AND n.datumdpo>=:od_datuma
            AND n.datumdpo<=:do_datuma
            AND d.pr_doc = 1
            AND p.magacin1=:mg
            and n.sifra_komitenta = k.sifra_komitenta
            and n.sifra_komitenta <> :vojni
        GROUP BY n.datumdpo, n.idnovcano, n.sifra_komitenta, n.BUD, n.BID, n.Sifra_dokumenta, n.pl_iznos, d.dokument , k.komitent
        INTO     :idnovcano, :datumdpo, :sifra_komitenta, :dokument, :bud, :bid, :sifra_dokumenta, :komitent, :duguje, :potrazuje, :fakture
  DO
    BEGIN

        select COUNT(*),SUM(IZNOS)
        from tblnov_placanje p
        where p.idnovcano = :idnovcano
        and p.idnacin_placanja  in ( :virman, :benefit)
        into :virmanski, :potrazuje;

        if(virmanski > 0) then
        begin

           if (dokument is null) then
                dokument = ' ';
            if (komitent is null) then
                komitent = ' ';
            if (bid is null) then
                bid = ' ';
            if (bud is null) then
                bud = ' ';

--                
--                if (strlen(dokument)> 50) then
--                    dokument = '_____1';
--                    
--                if (strlen(komitent)> 70) then
--                    komitent = '_____2';
--                    
--                if (strlen(bid)> 50) then
--                    bid = '_____3';
--                    
--                if (strlen(bud)> 50) then
--                    bud = '_____4';

            opis = substring( :dokument|| ' :' || coalesce(:bid, 0)   || ' ' || :komitent || ' ' || :bud from 1 for 500 );
           -- opis = substr(:opis|| ' :' || coalesce(:bid, 0)   || ' ' || :komitent || ' ' || coalesce(:bud, '') ,1,255);
            suspend;
        end
    END

     idnovcano = null; datumdpo = null; sifra_komitenta = null; opis = null;
     bud = null; bid = null; sifra_dokumenta = null; komitent = null;
     duguje = 0; potrazuje = 0; fakture = 0;

-- specijalan slucaj vojni osiguranik
/*
FOR SELECT  n.datumdpo, n.sifra_komitenta, d.dokument||' ' as opis, n.Sifra_dokumenta,
        CAST(SUM(p.dug_mg) as DECIMAL(18,2)),
        CAST(SUM(p.pot_mg) as DECIMAL(18,2)),
        0--CAST(n.pl_iznos as DECIMAL(18,2))
        FROM tblNovcano n, tblPromene p, tblDokumenti d
        WHERE n.idnovcano=p.idnovcano
            AND n.sifra_dokumenta=d.sifra_dokumenta
            AND d.kepu=1
            AND n.datumdpo>=:od_datuma
            AND n.datumdpo<=:do_datuma
            AND d.pr_doc = 1
            AND p.magacin1=:mg
            and n.sifra_komitenta = :vojni
            and p.sifra_robe <> 17415
GROUP BY n.datumdpo,  n.sifra_komitenta, n.BUD,  n.Sifra_dokumenta, n.pl_iznos, d.dokument
INTO      :datumdpo, :sifra_komitenta, :opis,  :sifra_dokumenta, :duguje, :potrazuje, :fakture
do begin
   idnovcano = 0; bid = 0; bud = 0;
   suspend;
end

     idnovcano = null; datumdpo = null; sifra_komitenta = null; opis = null;
     bud = null; bid = null; sifra_dokumenta = null; komitent = null;
     duguje = 0; potrazuje = 0; fakture = 0;
 */
if (razduzenje_pazarom = 0) then  begin
  -- POTRAZUJE  razduzenja (pazar) za placanja iz tblnov_placanje
  -- vodi se racuna o vise magacina u jednom racunu i deli placanja
  -- na proporcionalno vrednostima po magacinima
FOR
 with tblnovmag as
(select  cast(sum(case when p.magacin1 = n.sifra_magacina then p.duguje else 0 end) as double precision) as duguje_isti_magacin,
        cast(sum(case when p.magacin1 <> n.sifra_magacina then p.duguje else 0 end) as double precision) as duguje_razlicit_magacin,
        cast(case when(sum(p.duguje) = 0) then 1 else sum(p.duguje) end as double precision) as duguje_ukupno,

        n.datumdpo,
        n.idnovcano
from tblnovcano n
join tblpromene p on n.idnovcano = p.idnovcano
join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta
where n.datumdpo between :od_datuma and :do_datuma
and n.sifra_magacina = :mg
and d.pr_doc = 1

group by  n.datumdpo , n.idnovcano
)

select
cast(sum(case when pl.idnacin_placanja = :kes then (pl.iznos*duguje_isti_magacin)/duguje_ukupno else 0 end) as decimal( 18,2)) as kes,
cast(sum(case when pl.idnacin_placanja = :cek then (pl.iznos*duguje_isti_magacin)/duguje_ukupno else 0 end) as decimal( 18,2)) as cek,
cast(sum(case when pl.idnacin_placanja = :kartica then (pl.iznos*duguje_isti_magacin)/duguje_ukupno else 0 end) as decimal( 18,2)) as kartica,
cast(sum(case when (pl.idnacin_placanja = :virman or (pl.idnacin_placanja = :benefit)) then (pl.iznos*duguje_isti_magacin)/duguje_ukupno else 0 end) as decimal( 18,2)) as virman,
cast(sum(case when pl.idnacin_placanja = :particip then (pl.iznos*duguje_isti_magacin)/duguje_ukupno else 0 end) as decimal( 18,2)) as participacija,
cast(sum( (pl.iznos*duguje_isti_magacin)/duguje_ukupno ) as decimal( 18,2)) as ukupno,
m.datumdpo
from tblnovmag m join tblnov_placanje pl
on m.idnovcano = pl.idnovcano

group by  m.datumdpo

into :kes_iznos, :cek_iznos, :kartica_iznos, :VIRAMAN_IZNOS, :particip_iznos, :iznos, :datumdpo

do
begin
        sifra_komitenta = 0;  bud = '';  bid = 0;
     idnovcano = 10000000; sifra_komitenta = 0; opis = null;
     bud = ''; bid = 0; sifra_dokumenta = 3008; komitent = null;
     duguje = 0; potrazuje = 0; fakture = 0;


        duguje = 0;
        if (kes_iznos > 0)
        then begin
                 potrazuje = :kes_iznos;
                 opis = '- Razduzenje gotovina ';
                 if (razduzuj_got_auto = 1) then fakture = potrazuje;
                 suspend;
                 fakture = 0;
             end
        if ( cek_iznos > 0)
        then begin
                 potrazuje = :cek_iznos;
                 opis = '- Razduzenje cek ';
                 if (razduzuj_cek_auto = 1) then
                 begin
                     fakture = potrazuje;
                     suspend;
                 end
                 fakture = 0;
             end
        if ( kartica_iznos > 0)
        then begin
                 potrazuje = :kartica_iznos;
                 opis = '- Razduzenje kartica ';
                 if (razduzuj_kart_auto = 1) then
                 begin
                     fakture = potrazuje;
                     suspend;
                 end
                 fakture = 0;
             end
        if ( VIRAMAN_IZNOS > 0)
        then begin
                 potrazuje = :VIRAMAN_IZNOS;
                 opis = '- Razduzenje virman ';
                 if (razduzuj_vir_auto = 1) then
                 begin
                    fakture = potrazuje;
                    suspend;
                 end
                 potrazuje = 0;
                 fakture = 0;
             end
        if ( particip_iznos <> 0)
        then begin
                 potrazuje = :particip_iznos;
                 opis = '- Razduzenje recepti ';
                 if (RAZDUZUJ_PAR_AUTO = 1) then
                 begin
                     fakture = potrazuje;
                     suspend;
                 end
                 fakture = 0;
             end

    END

end

else begin
  --POTRAZUJE  razduzenja (pazar) za placanja iz tblnov_placanje
  FOR SELECT n.idnovcano,n.datumdpo, n.sifra_komitenta, n.opis,
  '' as BUD, 0 as BID, 3008 as Sifra_dokumenta,
        CAST(SUM(0*dug_din) as DECIMAL(18,2)),
        CAST(0 as DECIMAL(18,2)),
        CAST(SUM(b.dug_din+b.porez_ulaz) as DECIMAL(18,2)),
         n.datumvalute
        FROM tblNovcano n, tblBlagajna b, tblDokumenti d 
        WHERE n.idnovcano=b.idnovcano
            AND n.sifra_dokumenta=d.sifra_dokumenta
            AND d.kepu=1
            AND n.datumdpo>=:od_datuma
            AND n.datumdpo<=:do_datuma
            AND n.sifra_magacina=:mg
        GROUP BY n.datumdpo, n.idnovcano, n.sifra_komitenta, n.opis, n.BUD, n.BID, n.Broj_kalkulacije, n.Sifra_dokumenta, n.datumvalute
        INTO     :idnovcano, :datumdpo, :sifra_komitenta, :opis, :bud, :bid, :sifra_dokumenta,
                 :duguje, :fakture, :potrazuje, :datum_uplate
  DO
    BEGIN
        suspend;
    END
end

     idnovcano = null; datumdpo = null; sifra_komitenta = null; opis = null;
     bud = null; bid = null; sifra_dokumenta = null; komitent = null;
     duguje = 0; potrazuje = 0; fakture = 0;

  --UPLACENO NA RACUN  razduzenja za pazare
  FOR SELECT n.idnovcano,n.datumdpo, n.sifra_komitenta, n.opis, n.BUD, n.BID, n.Sifra_dokumenta,
        CAST(SUM(0*dug_din) as DECIMAL(18,2)),
        CAST(SUM(b.dug_din+b.porez_ulaz) as DECIMAL(18,2)),
        CAST(0 as DECIMAL(18,2)), n.datumvalute
        FROM tblNovcano n, tblBlagajna b, tblDokumenti d, tip_placanja p
        WHERE n.idnovcano=b.idnovcano
            AND n.sifra_dokumenta=d.sifra_dokumenta
            AND d.kepu=1
            AND n.datumdpo>=:od_datuma
            AND n.datumdpo<=:do_datuma
            AND n.sifra_magacina=:mg
            and b.sifra_placanja = p.idplacanja
      --      and p.trgovacka = 1
        GROUP BY n.datumdpo, n.idnovcano, n.sifra_komitenta, n.opis, n.BUD, n.BID, n.Broj_kalkulacije, n.Sifra_dokumenta, n.datumvalute
        INTO     :idnovcano, :datumdpo, :sifra_komitenta, :opis, :bud, :bid, :sifra_dokumenta,
                 :duguje, :fakture, :potrazuje, :datum_uplate
  DO
    BEGIN
        suspend;
    END

     idnovcano = null; datumdpo = null; sifra_komitenta = null; opis = null;
     bud = null; bid = null; sifra_dokumenta = null; komitent = null;
     duguje = 0; potrazuje = 0; fakture = 0;

        -- UPLACENO NA RACUN  placeni virmanski racuni koji su povezani
        FOR select n.idnovcano, r.datum_rada, n.sifra_komitenta,
            'Placeno i povezano: ', n.bud, n.bid, n.sifra_dokumenta
            ,0,r.duguje,0, i.datum
            from tblnovcano n, tblizvodraspod r, tblizvodi i
            where n.idnovcano = r.idnovcano
            AND r.datum_rada>=:od_datuma
            AND r.datum_rada<=:do_datuma
            AND n.sifra_magacina = :mg
            and n.sifra_placanja in (:virman,:benefit)
            AND r.idizvoda = i.id
        INTO     :idnovcano, :datumdpo, :sifra_komitenta, :opis, :bud, :bid, :sifra_dokumenta,
                 :duguje, :fakture, :potrazuje, :datum_uplate
  DO
    BEGIN
        suspend;
    END
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_TIP_PLACANJA (
    IDN integer)
returns (
    IDPLACANJA integer,
    NAZIV varchar(30),
    TRGOVACKA smallint,
    IZNOS decimal(18,2))
as
BEGIN
  FOR
    select  k.idplacanja, k.naziv, k.trgovacka ,
    (
     select p.iznos from  tblnov_placanje p where p.idnacin_placanja=k.idplacanja
     and p.idnovcano = :idn
    ) as iznos
    from    tip_placanja k
    where  k.idplacanja>0
    and k.ide_na_kasu = 1
    and k.aktivan = 1
    order by k.idplacanja
    INTO :IDPLACANJA,
         :NAZIV,
         :TRGOVACKA,
         :IZNOS
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20220306;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220307 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure STAMPA_POREZA_KNJIGOVODJA_MPFS (
    MG integer,
    DATUM date,
    DATUM_DO date,
    IDZ integer = null)
returns (
    OPIS varchar(50),
    POREZ decimal(18,2),
    OSNOVICA decimal(18,2))
as
begin
  for select Z.IDZ
      from MP_FISK_Z Z
      join invoice iv on z.idz = iv.idz
      where (Z.DATUMDPO >= :DATUM and
            Z.DATUMDPO <= :DATUM_DO and
            Z.SIFRA_MAGACINA = :MG) or (Z.IDZ = :IDZ)
      into :IDZ
  do
  begin
    for select cast(sum(O.PDV) as decimal(18,2)) as POREZ, cast(sum(O.IZNOS - O.PDV) as decimal(18,2)) as OSNOVICA,
               P.OPIS
        from HP_OBRACUN O
        join MP_FISK_Z Z on O.IDZG = Z.IDZ
        left join TBLPOREZ P on O.SIFRA_POREZA = P.SIFRA_POREZA
        where O.IDZG = :IDZ
        group by P.OPIS
        into :POREZ, :OSNOVICA, :OPIS
    do
    begin
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220307;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220309 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PLACANJE (
    D1 date,
    D2 date,
    SM integer,
    FISKAL_PUSTEN integer)
returns (
    IDZ integer,
    DUGUJE decimal(18,4),
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    BENEFIT decimal(18,4),
    OPIS varchar(255),
    DATUMDPO date,
    BROJ_FISKALNOG integer,
    INVOICENUMBER varchar(50),
    TOTALAMOUNT decimal(18,2),
    NARUKVICA decimal(18,2),
    SIFRA_MAGACINA integer,
    INVOICETYPE varchar(40),
    TRANSACTIONTYPE varchar(40),
    STORNO decimal(18,4))
as
BEGIN
  FOR
    select Z.IDZ,
           Z.DUGUJE,
            z.kes ,
            z.CEK ,
           Z.KARTICA,
           Z.VIRMAN,
           Z.BENEFIT,
           Z.OPIS,
           Z.DATUMDPO,
           Z.BROJ_FISKALNOG,
           z.sifra_magacina,
           IV.INVOICETYPE,
           IV.TRANSACTIONTYPE,
           case
           when z.kes < 0 or z.cek < 0 or z.kartica <0 or z.virman < 0 then z.kes + z.cek + z.kartica + z.virman
           else 0
           end as storno
    from MP_FISK_Z Z
    left join INVOICE IV on IV.IDZ = Z.IDZ
    where Z.DATUMDPO between :D1 and :D2 and
          (Z.SIFRA_MAGACINA = :SM or :sm = -1) and
          Z.PLACENO = 'Y' and iv.invoicetype = 'Normal'
    INTO :IDZ,
         :DUGUJE,
         :KES,
         :CEK,
         :KARTICA,
         :VIRMAN,
         :BENEFIT,
         :OPIS,
         :DATUMDPO,
         :BROJ_FISKALNOG,
         :sifra_magacina,
         :INVOICETYPE,
         :TRANSACTIONTYPE,
         :storno
  DO
  BEGIN
    select  first 1 i.invoicenumber,
    case
        when i.transactiontype = 'Sale' then i.totalamount
        when i.transactiontype = 'Refund' then (-1)*i.totalamount
    end
    from invoice i
    where i.idz = :idz
    and i.invoicetype in ( 'Normal', 'Advance' )
    into :INVOICENUMBER, :TOTALAMOUNT;

    select sum(h."VALUE") as narukvica
    from ac_credit_history h
    where h.mp_fisk_z_id = :idz
    into :narukvica;

    if (FISKAL_PUSTEN = -1 or :invoicenumber is not null ) then
    SUSPEND;
    TOTALAMOUNT = 0;
    INVOICENUMBER = 0;
    narukvica = 0;
  END
END^

SET TERM ; ^



update verzija set maloprodaja = 20220309;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220311 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_INVOICE_AGAIN (
    INVNUM varchar(50),
    IDZ integer)
as
declare variable ID integer;
declare variable INVTYPE varchar(50);
declare variable POSLATO integer;
begin
    for
        select i.id, i.invoicetype, i.poslato
        from invoice i
        where i.idz = :idz
        into :id, :invtype, :poslato
        do
        begin
           if (:invtype = 'Training') then
           begin
               update invoice i set i.idz = (-1) * i.idz, i.poslato = 0
               where i.id = :id;
           end
           invtype = '';
        end

    update MP_FISK_Z Z
    set Z.FISKAL_PUSTEN = 1,
        Z.INVOICENUMBER = :INVNUM
    where Z.IDZ = :IDZ;

end^

SET TERM ; ^


update verzija set maloprodaja = 20220311;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220315 }

SET TRPARAMS 'isc_tpb_wait';


CREATE INDEX INVOICE_IDX_TYPE
ON INVOICE (INVOICETYPE);

CREATE INDEX INVOICE_IDX_INVNUM
ON INVOICE (INVOICENUMBER);

CREATE INDEX INVOICE_IDX_IDZ
ON INVOICE (IDZ);

CREATE INDEX INVOICE_IDX_NOVCANO
ON INVOICE (IDNOVCANO);

CREATE INDEX INVOICE_IDX_PRED
ON INVOICE (IDPRED);

update verzija set maloprodaja = 20220315;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220317 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_ISPRAVI_INVOICE
returns (
    BROJ bigint,
    IDZ integer,
    IDNOVCANO integer,
    INVOICETYPE varchar(40),
    ID integer)
as
declare variable I integer;
BEGIN
  FOR
    select  count(*), i.idz, i.idnovcano,  i.invoicetype
    from invoice i
    group by  i.idz, i.invoicetype, i.idnovcano
    having count(*) > 1
    INTO :broj,
         :IDZ,
         :IDNOVCANO,
         :INVOICETYPE
  DO
  BEGIN
    i = 0;
    for 
        select i.id
        from invoice i where i.idz is not distinct from :idz  and i.idnovcano is not distinct from :idnovcano
        into :id
        do
        begin
           i = i + 1;
           if (i > 1) then
           begin
                update invoice i set i.invoicetype = 'Copy' where i.id = :id;
           end
        end
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20220317;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220320 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'euro'
  into :KURS;
  if (:datum is null) then datum = current_date;

  select M.CENA_MAGACIN, M.ID_CENOVNIK, M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;

  -- uzimas cene iz posebnog dokumenta za izabrani magacin i izabrani datum
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, P.CENA_MG, A.KOD,
               A.SIFRA_ROBE, N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA, P.IZLAZ_CENA, P.ULAZ_CENA, K.PROIZVODJAC, V.KATEGORIJA_GRUPE,
               N.DATUMDPO, P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK,
               L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA, P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
             :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK,
             :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA,
             :ZEMLJA_UVOZA, :STATUS_CENE
    do
    begin
     select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
      COUNTER = COUNTER + 1;

        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO, C.CENAMP_SA_POPUSTOM
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end

      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, L.CENA, A.KOD,
                 A.SIFRA_ROBE, P.IDNOVCANO, PS.KOLICINA as KOLICINA, PS.IZLAZ_CENA, 0 as ULAZ_CENA, K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE, P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK,
                 L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE

          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
               :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end

    else
    begin
      for select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, L.CENA, A.KOD,
                 A.SIFRA_ROBE, N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA, P.IZLAZ_CENA, P.ULAZ_CENA, K.PROIZVODJAC, V.KATEGORIJA_GRUPE,
                 N.DATUMDPO, P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK,
                 L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA, P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)

          union

          select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, L.CENA, A.KOD,
                 A.SIFRA_ROBE, NA.IDNOVCANO, NS.KOLICINA as KOLICINA, NS.CENA, NS.ULAZ_CENA, K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE, NA.DATUM, null, NA.BROJ_DOK, A.CENAVP as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK, L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA, '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)

          union

          select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, L.CENA, A.KOD,
                 A.SIFRA_ROBE, RE.IDNOVCANO, RS.KOLICINA as KOLICINA, RS.CENA, RS.CENA, K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE, RE.DATUM1, null, RE.BROJ_REZERVACIJE, A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK, L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA, '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)

          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
               :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK,
               :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA,
               :ZEMLJA_UVOZA, :STATUS_CENE
      do
      begin
        select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
        COUNTER = COUNTER + 1;

        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO, C.CENAMP_SA_POPUSTOM
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end

        suspend;
      end
    end
  end

  -- uzimas cene iz lager liste
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP, L.CENA, A.KOD, A.SIFRA_ROBE,
               1 as IDNOVCANO, L.KOLICINA as KOLICINA, L.CENA as IZLAZ_CENA, L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC, V.KATEGORIJA_GRUPE, A.CENAVP as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)), A.CENOVNIK, L.SKLADISNI_PROSTOR, Z.ZEMLJA, Z2.ZEMLJA,
               a.cenamp_stara, a.akcija_od, a.akcija_do
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL

        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
             :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS,
             :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO

    do
    begin
      select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
      if (:TIP_CENA = 1) then -- prosecna cena
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --veleprodajna---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- cena iz tlokacije
        begin
          -- cena = cena
        end
        else
        if (:CENA_MAGACIN = 1) then -- cena iz artikala
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- cena iz cenovnika
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO, C.CENAMP_SA_POPUSTOM
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --maloprodajna--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- cena iz tlokacije
        begin
          -- cena = cena
        end
        else
        if (:CENA_MAGACIN = 0) then -- cena iz artikala
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- cena iz cenovnika
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO, C.CENAMP_SA_POPUSTOM
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end

      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- uzimas cene iz cenovnika
  else
  if (:DOC = -2) then
  begin
    for select A.ARTIKAL, A.CENAMP, cast(c.cena * :KURS as integer), A.CENAVP,
               c.CENA,
               A.KOD, A.SIFRA_ROBE, 1 as IDNOVCANO, 0 as KOLICINA, c.CENA as IZLAZ_CENA,
               c.CENA as ULAZ_CENA, K.PROIZVODJAC as PROIZVODJAC, V.KATEGORIJA_GRUPE, A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), c.CENOVNIK,  Z.ZEMLJA, Z2.ZEMLJA,
               C.DATE_CHANGE, c.akcija_od, c.akcija_do
        from TBL_CENOVNIK C
        join TBLARTIKLI A on a.sifra_robe = c.sifra_robe and c.id_cenovnika = :mag
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
     --   inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where c.cena > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
             :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS,
             :AKCIJA_OZNAKA,  :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO

    do
    begin
      select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- uzimas cene iz cenovnika
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL, A.CENAMP, cast(A.CENAMP * :KURS as integer), A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD, A.SIFRA_ROBE, 1 as IDNOVCANO, L.KOLICINA as KOLICINA, L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA, K.PROIZVODJAC as PROIZVODJAC, V.KATEGORIJA_GRUPE, A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)), C.CENOVNIK, L.SKLADISNI_PROSTOR, C.STARA_CENA, Z.ZEMLJA,
               Z2.ZEMLJA, C.DATE_CHANGE, a.akcija_od, a.akcija_do
        from  TBL_CENOVNIK C
        join tblartikli a on c.sifra_robe = a.sifra_robe
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and c.id_cenovnika = m.id_cenovnik
         join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
         join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :datum))
        where (M.CENA_MAGACIN <> 2 and A.DATE_CHANGE >= :DATUM) or
              (M.CENA_MAGACIN = 2 and  C.DATE_CHANGE >= :DATUM)
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
             :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS,
             :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE,
             :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO

    do
    begin
      select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
      COUNTER = COUNTER + 1;

      suspend;
    end
  end

  -- stampa artikle
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL, A.CENAMP, A.CENAMP as CENAMPKURS, A.CENAVP, 0.0 as CENA, A.KOD, A.SIFRA_ROBE,
               0 as IDNOVCANO, 1.0 as KOLICINA, 0.0 as IZLAZ_CENA, 0.0 as ULAZ_CENA, K.PROIZVODJAC, V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS, A.CENAMP_SA_POPUSTOM, cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS, A.CENAMP_STARA,
               A.CENOVNIK, Z.ZEMLJA, Z2.ZEMLJA, a.akcija_od, a.akcija_do
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA,
             :IZLAZ_CENA, :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS,
             :STARA_CENA, :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO

    do
    begin
        if (:CENA_MAGACIN = 2 and (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- cena iz cenovnika
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO, C.CENAMP_SA_POPUSTOM
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA, C.STARA_CENA, C.vazi_OD, C.vazi_DO
          from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      select b.barkod from proc_mp_barkod(:sifra_robe) b into :barkod;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^




CREATE INDEX TBL_CENOVNIK_IDX_DATUM
ON TBL_CENOVNIK (DATE_CHANGE);

CREATE INDEX TBLARTIKLI_IDX_DATUM
ON TBLARTIKLI (DATE_CHANGE);

CREATE INDEX TBLARTIKLI_IDX_ZEMLJA
ON TBLARTIKLI (ID_ZEMLJE_POREKLO);


update verzija set maloprodaja = 20220320;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220325 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PLACANJE (
    D1 date,
    D2 date,
    SM integer,
    FISKAL_PUSTEN integer)
returns (
    IDZ integer,
    DUGUJE decimal(18,4),
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    BENEFIT decimal(18,4),
    OPIS varchar(255),
    DATUMDPO date,
    BROJ_FISKALNOG integer,
    INVOICENUMBER varchar(50),
    TOTALAMOUNT decimal(18,2),
    NARUKVICA decimal(18,2),
    SIFRA_MAGACINA integer,
    INVOICETYPE varchar(40),
    TRANSACTIONTYPE varchar(40),
    STORNO decimal(18,4))
as
BEGIN
  FOR
    select Z.IDZ,
           Z.DUGUJE,
            z.kes ,
            z.CEK ,
           Z.KARTICA,
           Z.VIRMAN,
           Z.BENEFIT,
           Z.OPIS,
           Z.DATUMDPO,
           Z.BROJ_FISKALNOG,
           z.sifra_magacina,
           IV.INVOICETYPE,
           IV.TRANSACTIONTYPE,
           case
           when z.kes < 0 or z.cek < 0 or z.kartica <0 or z.virman < 0 then z.kes + z.cek + z.kartica + z.virman
           else 0
           end as storno
    from MP_FISK_Z Z
    left join INVOICE IV on IV.IDZ = Z.IDZ
    where Z.DATUMDPO between :D1 and :D2 and
          (Z.SIFRA_MAGACINA = :SM or :sm = -1) and
          Z.PLACENO = 'Y' and upper(iv.invoicetype) = 'NORMAL'
    INTO :IDZ,
         :DUGUJE,
         :KES,
         :CEK,
         :KARTICA,
         :VIRMAN,
         :BENEFIT,
         :OPIS,
         :DATUMDPO,
         :BROJ_FISKALNOG,
         :sifra_magacina,
         :INVOICETYPE,
         :TRANSACTIONTYPE,
         :storno
  DO
  BEGIN
    select  first 1 i.invoicenumber,
    case
        when upper(i.transactiontype) = 'SALE' then i.totalamount
        when UPPER(i.transactiontype) = 'REFUND' then (-1)*i.totalamount
    end
    from invoice i
    where i.idz = :idz
    and UPPER(i.invoicetype) in ( 'NORMAL', 'ADVANCE' )
    into :INVOICENUMBER, :TOTALAMOUNT;

    select sum(h."VALUE") as narukvica
    from ac_credit_history h
    where h.mp_fisk_z_id = :idz
    into :narukvica;

    if (FISKAL_PUSTEN = -1 or :invoicenumber is not null ) then
    SUSPEND;
    TOTALAMOUNT = 0;
    INVOICENUMBER = 0;
    narukvica = 0;
  END
END
^

SET TERM ; ^

update verzija set maloprodaja = 20220325;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220327 }

SET TRPARAMS 'isc_tpb_wait';

DROP TRIGGER INVOICE_AI0;

update verzija set maloprodaja = 20220327;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220328 }

SET TRPARAMS 'isc_tpb_wait';

ALTER TRIGGER MP_FISK_Z_BI0  INACTIVE ;

update verzija set maloprodaja = 20220328;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220329 }

SET TRPARAMS 'isc_tpb_wait';

ALTER TRIGGER MP_FISK_Z_BI_RBR INACTIVE ;

update verzija set maloprodaja = 20220329;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220330 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_INVOICE_AGAIN (
    INVNUM varchar(50),
    IDZ integer,
    DATEADDED timestamp)
as
declare variable ID integer;
declare variable INVTYPE varchar(50);
declare variable POSLATO integer;
begin
    for
        select i.id, i.invoicetype, i.poslato
        from invoice i
        where i.idz = :idz
        into :id, :invtype, :poslato
        do
        begin
           if (:invtype = 'Training') then
           begin
               update invoice i set i.idz = (-1) * i.idz, i.poslato = 0
               where i.id = :id;
           end
           invtype = '';
        end

    update MP_FISK_Z Z
    set Z.FISKAL_PUSTEN = 1,
        Z.INVOICENUMBER = :INVNUM,
        z.datumpravljenja = :dateadded
    where Z.IDZ = :IDZ;

end^

SET TERM ; ^

update verzija set maloprodaja = 20220330;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220401 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_AVANSI (
    IDNOVCANO integer)
returns (
    ZBIR decimal(15,2),
    IDPLACANJA integer)
as
declare variable I integer;
declare variable ZBIR1 decimal(15,2);
declare variable VEZA integer;
declare variable IDN integer;
begin

    idn = idnovcano;
    for
    select p.idplacanja
    from tip_placanja p
    where p.ide_na_kasu = 1
    and p.suf_payment is not null
    into :idplacanja
    do
    begin
    idnovcano = idn;


    i = -1;
    zbir = 0;
    while (i <0)
    do
    begin
        
        select n.veza
        from tblnovcano n
        where n.idnovcano = :idnovcano
        into :veza;

        select  coalesce(sum(p.iznos),0) from tblnov_placanje p where p.idnovcano = :idnovcano
        and p.idnacin_placanja = :idplacanja
        into :zbir1;
        zbir = zbir + zbir1;

        idnovcano = :veza;
        begin
           if (:veza is null) then
           i = 1;
        end
        veza = null;
    end
   if (zbir <> 0) then
    suspend;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220401;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220405 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure BUS_HELL_4 (
    TABELA varchar(100))
returns (
    XSQL varchar(32000))
as
declare variable POLJE varchar(93);
declare variable TIP varchar(93);
declare variable ZAREZ varchar(10);
declare variable VSQL varchar(32000);
declare variable CR char(1);
declare variable NOVI_RED varchar(10);
declare variable VZAREZ varchar(20);
declare variable VSTRING1 varchar(20);
declare variable VSTRING2 varchar(20);
BEGIN
    CR = '''';
    xsql = 'xsql ='|| CR||'UPDATE OR INSERT INTO '||:tabela||'(';
    ZAREZ = '';
    NOVI_RED = '  ';
    VSTRING1 = '';
    VSTRING2 = '';
    VZAREZ = '';
    VSQL = '('||cr||';'||novi_red||'xsql = xsql||';

  FOR
    select LTRIM(RTRIM(UPPER (f.rdb$field_name))) as polje,
    
      t.rdb$type_name as tip
      from rdb$relation_fields f, RDB$FIELDS r, rdb$types t
      where f.rdb$field_source=r.rdb$field_name
      and r.rdb$field_type = t.rdb$type
      and f.rdb$system_flag=0
      and t.rdb$field_name = 'RDB$FIELD_TYPE'
      and f.rdb$relation_name not like 'IBE$%'
      and f.rdb$relation_name not like 'ML_%'
      and f.rdb$relation_name  = :TABELA
    
      order by 1
    INTO :POLJE,
         :TIP
  DO
  BEGIN
     xsql = xsql || :ZAREZ || :polje ;
     if (:tip in ('DOUBLE', 'INT64', 'LONG', 'SHORT')) then
     BEGIN
        VSTRING1 = '';
        VSTRING2 = '';
     END
     ELSE
     BEGIN
        VSTRING1 = CR||CR||CR||CR||'||replace(';
        VSTRING2 =  ','||CR||CR||CR||CR||','||CR|| ' ' || CR|| ') ||'||CR||CR||CR||CR;
     END

     --  vsql = VSQL || :NOVI_RED || :VZAREZ || 'coalesce('|| :VSTRING1 ||'NEW.' ||:POLJE ||:VSTRING2 || ','||CR||'NULL'||CR||')||';
       vsql = VSQL || :NOVI_RED || :VZAREZ || 'coalesce('|| :VSTRING1  ||'NEW.' ||:POLJE ||:VSTRING2 || ','||CR||'NULL'||CR||')||';

     if (ZAREZ = '') then zarez = ',';
     if (VZAREZ = '') then VZAREZ = CR||','||CR||'||';

--||coalesce(''''||replace( new.ARTIKAL,'''',' ')||'''','NULL')|| 
--||coalesce(''''||         NEW.LOKALNI_NAZIV    ||'''','NULL')||
  END
  xsql = xsql || ')';
 -- VSQL = VSQL || ')';
  XSQL = XSQL || ' VALUES '  || VSQL || cr ||')'||CR||';';
  SUSPEND;
END^

SET TERM ; ^



update verzija set maloprodaja = 20220405;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220407 }

UPDATE TIP_PLACANJA SET     SUF_PAYMENT = '4' WHERE (upper(NAZIV) = 'VIRMANSKI');

update verzija set maloprodaja = 20220407;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220408 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure CENA_IZ_CENOVNIKA_KOMITENTA (
    KOM integer,
    SR integer,
    DATUM date)
returns (
    CENA decimal(15,2),
    RABAT decimal(15,4),
    RABAT2 decimal(15,4),
    RABAT3 decimal(15,4),
    RABAT4 decimal(15,4),
    RABATAP decimal(15,4),
    SIFRA_ROBE integer)
as
begin
  for select FIRST 1 C.sifra_robe,
             C.CENA,
             C.RABAT,
             C.RABAT2,
             C.RABAT3,
             C.RABAT4,
             C.RABAT_AP
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA T on C.ID_CENOVNIKA = T.ID
      where T.SIFRA_KOMITENTA = :KOM
      AND T.vrsta_komitenta = 2
      AND C.sifra_robe = :SR
      AND C.aktivan = 1
      AND  (:DATUM between C.VAZI_OD and C.VAZI_DO or (:DATUM >= C.VAZI_OD and C.VAZI_DO is null))
      into   :SIFRA_ROBE,
             :CENA,
             :RABAT,
             :RABAT2,
             :RABAT3,
             :RABAT4,
             :RABATAP
  do
  begin
    suspend;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220408;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220410 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure KARTICA_ARTIKLA_MP (
    SIFRA integer,
    MG integer,
    DATUM_OD date,
    DATUM_DO date)
returns (
    FISKALNA_KASA varchar(255),
    DATUMVALUTE date,
    DATUMPDV date,
    DATUMDPO date,
    IDNOVCANO integer,
    KURS decimal(18,4),
    OPIS varchar(400),
    IDPROMENE integer,
    CENA decimal(18,4),
    IZLAZ_CENA decimal(18,4),
    IZLAZ_KOL decimal(18,4),
    BID integer,
    BUD varchar(20),
    PROSECNA_CENA decimal(18,4),
    PROSEK decimal(18,4),
    SIFRA_ROBE integer,
    STARA_CENA decimal(18,4),
    ULAZ_CENA decimal(18,4),
    ULAZ_KOL decimal(18,4),
    ZAVISNI_TROSKOVI decimal(18,4),
    CENA_MG decimal(18,4),
    SORTIRANJE integer,
    POSNOVI decimal(18,4),
    POSNOVU decimal(18,4),
    SALDO decimal(18,4),
    STANJE decimal(18,4),
    NIVEL_KOL decimal(18,4),
    DUGUJE decimal(18,4),
    POTRAZUJE decimal(18,4),
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    SIFRA_MAGACINA_U integer,
    SIFRA_DOKUMENTA integer,
    ID_TROSKA integer,
    KOMITENT varchar(255),
    DOKUMENT varchar(50),
    OPIS_PROMENE varchar(30),
    MESTO_TROSKA varchar(255),
    MAGACIN varchar(50),
    MESTO_ISPORUKE varchar(50),
    DATUM_PRIJEMA date,
    RADNIK varchar(50),
    CENA_DOB decimal(18,4),
    NV_ULAZ decimal(18,4),
    NV_IZLAZ decimal(18,4),
    POREZ decimal(18,2),
    POREZ_ULAZ decimal(18,2),
    PIB varchar(15),
    PONDER_CENA double precision,
    NV_SALDO decimal(18,4))
as
declare variable SKRACENICA varchar(10);
declare variable MAGACIN_U varchar(51);
begin
    saldo=0;
    stanje=0;
    nv_saldo=0;

    for select  n.datum_prijema,
                n.datumdpo,
                n.idnovcano,
                n.kurs,
                n.opis,
                n.sifra_komitenta,
                n.sifra_magacina,
                n.sifra_magacina_u,
                p.idpromene,
                p.cena_dob,
                p.cena,
                p.izlaz_cena,
                p.izlaz_kol,
                p.nivel_kol,
                p.prosecna_cena,
                p.prosek,
                p.ponder_cena,
                n.sifra_dokumenta,
                p.sifra_robe,
                p.stara_cena,
                p.ulaz_cena,
                p.ulaz_kol,
                p.zavisni_troskovi,
                n.bid,
                p.cena_mg,
                coalesce(n.bud, ''),
                d.sortiranje,
                p.posnovi,
                p.posnovu,
                n.id_troska,
                cast(dug_mg as decimal(18,3)) as duguje,
                cast(pot_mg as decimal(18,3)) as potrazuje,
                k.komitent,
                k.pib,
                d.dokument,
                p.pr_dok,
                m.skracenica,
                coalesce(m2.magacin, ''),
                coalesce(mt.naziv, ''),
                coalesce(km.opis, ''),
                r.radnik,
                coalesce(p.nv_ulaz,0),
                coalesce(p.nv_izlaz,0),
                p.porez,
                p.porez_ulaz,
                n.datumvalute,
                n.datumpdv,
                I.NAZIV as FISKALNA_KASA
    from tblpromene p join tblnovcano n   on (n.idnovcano=p.idnovcano)
                      join tblkomitenti k on (n.sifra_komitenta=k.sifra_komitenta)
                      join tbldokumenti d on (n.sifra_dokumenta=d.sifra_dokumenta and d.kepu=1)
                      join tblmagacin m   on (m.sifra_magacina=n.sifra_magacina)
                      join tblradnici r   on (r.sifra_radnika = n.sifra_radnika)
                      left join tblmagacin m2 on (m2.sifra_magacina=n.sifra_magacina_u)
                      left join tblmestotroska mt on (mt.id=n.id_troska)
                      left join tblkomitmesto km on (km.id = n.id_mesto_isp)
                      left join FISKALNA_KASA_ISECAK I on n.SIFRA_KASE = I.ID
     WHERE p.sifra_robe=:sifra and (n.sifra_magacina=:mg) and (n.datumdpo between :datum_od and :datum_do)
    order by n.datum_prijema, d.sortiranje, n.idnovcano, p.idpromene
    into :datum_prijema,
         :datumdpo,
         :idnovcano,
         :kurs,
         :opis,
         :sifra_komitenta,
         :sifra_magacina,
         :sifra_magacina_u,
         :idpromene,
         :cena_dob,
         :cena,
         :izlaz_cena,
         :izlaz_kol,
         :nivel_kol,
         :prosecna_cena,
         :prosek,
         :ponder_cena,
         :sifra_dokumenta,
         :sifra_robe,
         :stara_cena,
         :ulaz_cena,
         :ulaz_kol,
         :zavisni_troskovi,
         :bid,
         :cena_mg,
         :bud,
         :sortiranje,
         :posnovi,
         :posnovu,
         :id_troska,
         :duguje,
         :potrazuje,
         :komitent,
         :pib, 
         :dokument,
         :opis_promene,
         :skracenica,
         :magacin_u,
         :mesto_troska,
         :mesto_isporuke,
         :radnik,
         :nv_ulaz,
         :nv_izlaz,
         :porez,
         :porez_ulaz,
         :datumvalute,
         :datumpdv,
         :FISKALNA_KASA
    do
       begin
        if (ulaz_kol=0 and izlaz_kol=0 and zavisni_troskovi<>0) then duguje=zavisni_troskovi;

        saldo = saldo + duguje-potrazuje;
        stanje = stanje+ulaz_kol-izlaz_kol;
        nv_saldo = nv_saldo+nv_ulaz-nv_izlaz;
        opis='';

        if(trim(coalesce(magacin_u,'')) <> '')   then opis = ', '||coalesce(magacin_u,'');
        if(trim(coalesce(bud,'')) <> '')         then opis = opis||', '||coalesce(bud,'');
        if(trim(coalesce(mesto_troska,'')) <> '')then opis = opis||', '||coalesce(mesto_troska,'');

        if (sifra_komitenta = 0) then opis = dokument||': '||bid||skracenica||opis;                             --  ','||coalesce(magacin_u,'')   ||', '||coalesce(bud,'')   ||', '||coalesce(mesto_troska,'');
        else                          opis = dokument||': '||bid||', '||komitent||', PIB:'||coalesce(pib,'0')||'; '||coalesce(bud,'');

        suspend;
       end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_LAGER (
    MG integer,
    GODINA integer,
    NULE integer = null)
returns (
    FAKTURNA_CENA decimal(18,4),
    SIFRA_ROBE integer,
    POREZ decimal(15,2),
    KOD varchar(20),
    SIFRA_PROIZVODJACA integer,
    SIFRA_KATEGORIJE integer,
    ARTIKAL varchar(255),
    LOKALNI_NAZIV varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOD_PR varchar(20),
    CENA decimal(18,2),
    IDLOKACIJA integer,
    STANJE_LAGERA decimal(18,3),
    KOLICINA numeric(18,3),
    PRODATA_KOLICINA decimal(18,3),
    PROS_CENA decimal(18,4),
    PROIZVODJAC varchar(100),
    NAZIV varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    DATUMMP date,
    MAGACIN varchar(50),
    CENA_MAGACIN smallint,
    CENA_LAGERA decimal(18,4),
    VREDNOST_LAGERA numeric(18,7),
    SKLADISNI_PROSTOR varchar(20),
    CENAMP_SA_POPUSTOM decimal(18,2),
    REZERVISANO numeric(18,4),
    BARKOD varchar(50),
    PODKATEGORIJA varchar(100),
    DOBAVLJAC varchar(255),
    SIFRA_DOBAVLJACA integer)
as
declare variable KOLICINA_TMP decimal(18,3);
declare variable GOD integer;
declare variable RS_KORISNIK integer;
declare variable APOTEKA integer;
begin
  select first 1 GODINA,
                 coalesce(APOTEKA, 0)
  from SYSTEM
  into :GOD, :APOTEKA;
  select first 1 coalesce(RS_KORISNIK, 0)
  from TBLHOST
  into :RS_KORISNIK;
  RS_KORISNIK = 1;
  for select TBLARTIKLI.SIFRA_ROBE,
             TBLARTIKLI.KOD,
             TBLARTIKLI.SIFRA_PROIZVODJACA,
             TBLARTIKLI.SIFRA_KATEGORIJE,
             TBLARTIKLI.ARTIKAL,
             TBLARTIKLI.LOKALNI_NAZIV,
             TBLARTIKLI.CENAVP,
             TBLARTIKLI.CENAMP,
             TBLARTIKLI.KOD_PR,
             TLOKACIJA.CENA,
             TLOKACIJA.IDLOKACIJA,
             TLOKACIJA.KOLICINA as STANJE_LAGERA,
             TLOKACIJA.PROS_CENA,
             TLOKACIJA.POREZ,
             coalesce(TLOKACIJA.HP_KOL, 0),
             TBLPROIZVODJAC.PROIZVODJAC,
             TBLJM.NAZIV,
             TBLVRSTAROBE.KATEGORIJA_GRUPE,
             TBLARTIKLI.DATUMMP,
             TBLMAGACIN.MAGACIN,
             TBLMAGACIN.CENA_MAGACIN,
             case
               when TBLMAGACIN.CENA_MAGACIN = 1 then TLOKACIJA.CENA
               when TBLMAGACIN.CENA_MAGACIN = 2 and :GODINA = :GOD then coalesce((select C.CENA
                                                                                  from CENA_ARTIKLA_IZ_CENOVNIKA(TBLARTIKLI.SIFRA_ROBE, TBLMAGACIN.ID_CENOVNIK, current_date) C), TBLARTIKLI.CENAMP)
               when TBLMAGACIN.CENA_MAGACIN = 2 and :GODINA <> :GOD then coalesce(TLOKACIJA.CENA, TBLARTIKLI.CENAMP)
               else TBLARTIKLI.CENAMP
             end as CENA_LAGERA,
             TLOKACIJA.SKLADISNI_PROSTOR,
             TBLARTIKLI.CENAMP_SA_POPUSTOM,
             coalesce(TLOKACIJA.REZERVISANO, 0),
             TBLPODVRSTAROBE.NAZIV,
             K.KOMITENT as DOBAVLJAC,
             K.SIFRA_KOMITENTA as SIFRA_DOBAVLJACA
      from TBLARTIKLI
      inner join TLOKACIJA on (TBLARTIKLI.SIFRA_ROBE = TLOKACIJA.SIFRA_ROBE and TLOKACIJA.GODINA = :GODINA)
      inner join TBLMAGACIN on (TLOKACIJA.SIFRA_MAGACINA = TBLMAGACIN.SIFRA_MAGACINA)
      inner join TBLPROIZVODJAC on (TBLARTIKLI.SIFRA_PROIZVODJACA = TBLPROIZVODJAC.SIFRA_PROIZVODJACA)
      inner join TBLVRSTAROBE on (TBLARTIKLI.SIFRA_KATEGORIJE = TBLVRSTAROBE.SIFRA_KATEGORIJE)
      left outer join TBLJM on (TBLARTIKLI.IDJM = TBLJM.ID)
      left join TBLKOMITENTI K on TBLARTIKLI.SIFRA_DOBAVLJACA = K.SIFRA_KOMITENTA
      left join TBLPODVRSTAROBE on (TBLARTIKLI.ID_PODKATEGORIJE = TBLPODVRSTAROBE.ID), TBLHOST H
      where ((TLOKACIJA.SIFRA_MAGACINA = :MG) and
            (TLOKACIJA.KOLICINA > 0 or (:NULE = 1)) and
            H.IDHOST = 1)
      order by TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC, TBLARTIKLI.ARTIKAL
      into :SIFRA_ROBE, :KOD, :SIFRA_PROIZVODJACA, :SIFRA_KATEGORIJE, :ARTIKAL, :LOKALNI_NAZIV, :CENAVP, :CENAMP,
           :KOD_PR, :CENA, :IDLOKACIJA, :STANJE_LAGERA, :PROS_CENA, :POREZ, :KOLICINA_TMP, :PROIZVODJAC, :NAZIV,
           :KATEGORIJA_GRUPE, :DATUMMP, :MAGACIN, :CENA_MAGACIN, :CENA_LAGERA, :SKLADISNI_PROSTOR, :CENAMP_SA_POPUSTOM,
           :REZERVISANO, :PODKATEGORIJA, :DOBAVLJAC, :SIFRA_DOBAVLJACA

  do
  begin
    -----------------------------------------------------------------------------------------------------
    -- prodata a neprebacena kolicina za artikle koji se trose kroz noramtiv
    select sum(O.KOLICINA * N.KOLICINA)
    from PRTEH P
    join PRTEHPROCES C on P.ID = C.ID_PRTEH
    join PRNORMATIV N on C.ID = N.ID_TEHPROCES
    join HP_OBRACUN O on O.SIFRA_ROBE = P.SIFRA_PROIZVODA
    join MP_FISK_Z Z on O.IDZG = Z.IDZ
    inner join TBLHOST H on H.RS_KORISNIK = 1
    where N.SIFRA_MATERIJALA = :SIFRA_ROBE and
          P.SIFRA_MAGACINA = :MG and
          O.POSLATOUKNJIGOVODSTVO = 'N' and
          Z.FISKAL_PUSTEN > 0 and
          extract(year from O.DATUM) = (:GOD)
    into :PRODATA_KOLICINA;
    if (:PRODATA_KOLICINA is null) then
      PRODATA_KOLICINA = 0;
    ---------------------------------------------------------------------------------------------------
    PRODATA_KOLICINA = :PRODATA_KOLICINA + :KOLICINA_TMP + :REZERVISANO;
    FAKTURNA_CENA = (select C.CENA
    from PROC_MP_CENA_ARTIKLA(:SIFRA_ROBE, :MG, -1, 'now') C);
    KOLICINA = :STANJE_LAGERA - :PRODATA_KOLICINA;
    VREDNOST_LAGERA = CENA_LAGERA * :STANJE_LAGERA;
    if (CENAMP = 0 or CENAMP is null or CENA_LAGERA = 0 or CENA_LAGERA is null) then
      select LS.CENA as CENAMP,
             LS.CENA as CENA_LAGERA,
             LS.CENA * LS.KOLICINA as VREDNOST_LAGERA
      from TLOKACIJA LS
      where LS.SIFRA_ROBE = :SIFRA_ROBE and
            LS.SIFRA_MAGACINA = :MG and
            LS.GODINA = :GODINA
      into :CENAMP, :CENA_LAGERA, :VREDNOST_LAGERA;
    select first 1 BARKOD
    from TBLBARKOD
    where SIFRA_ROBE = :SIFRA_ROBE
    into :BARKOD;
    suspend;
    BARKOD = null;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_TREBOVANJE_DOB_ART (
    MG integer,
    OD_DATUMA date,
    DO_DATUMA date,
    SIFRA_DOBAVLJACA integer,
    BROJ_DANA integer,
    MG1 integer = null)
returns (
    SIFRA_ROBE integer,
    PRODATA_KOLICINA decimal(18,4),
    SIFRA_MAGACINA integer,
    LAGER_KOL integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    ODNOSPJM double precision,
    JED_MERE varchar(20),
    PJED_MERE varchar(20),
    REZERVISANO decimal(18,4),
    KOLICINA decimal(18,4),
    BROJ_DANA_LAGER integer,
    KOEF_DINAMIKE decimal(18,4),
    CENA decimal(18,2),
    PROS_CENA decimal(18,2),
    KOLICINA1 decimal(18,4))
as
declare variable PRODATA_KOL_HP decimal(15,2);
declare variable HP integer;
begin
    select first 1 s.hp_tabele
    from tblhost s
    into :hp;

    for
    select  distinct a.sifra_robe
    from tblartikli a
    where (a.sifra_dobavljaca = :SIFRA_DOBAVLJACA)
 --   and p.sifra_robe = 40344
    into :sifra_robe
    do
    begin
        kod = null; artikal = null;

        BROJ_DANA_LAGER = 0; prodata_kolicina = 0; prodata_kol_hp = 0;
        select z.broj_dana from zegin_br_dana_lagera_mp(:mg, :od_datuma, :do_datuma, :sifra_robe) z  into :BROJ_DANA_LAGER;

        if (hp = 0) then
        begin
            select  coalesce(sum(p.izlaz_kol),0), n.sifra_magacina
            from tblnovcano n
            join tblpromene p on n.idnovcano = p.idnovcano
            join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta
            where n.datumdpo between :od_datuma and :do_datuma   and d.tip = 10
            and p.sifra_robe = :sifra_robe
            and n.sifra_magacina = :mg
            group by 2
            into :prodata_kolicina, :sifra_magacina;
        end
        else
        begin
            select coalesce(sum(o.kolicina),0), z.sifra_magacina
            from hp_obracun o join mp_fisk_z z on o.idzg = z.idz
            where z.datumdpo between :od_datuma and :do_datuma 
            and o.sifra_robe = :sifra_robe
            and z.sifra_magacina = :mg
            and z.placeno = 'Y'
            group by 2
            into :prodata_kol_hp, :sifra_magacina;
        end
        prodata_kolicina = coalesce(prodata_kolicina,0) + coalesce(prodata_kol_hp, 0);

        if (:BROJ_DANA_LAGER > 0) then
        begin
          koef_dinamike = prodata_kolicina/BROJ_DANA_LAGER;
        end 
        else if (:do_datuma - :od_datuma > 0) then
        begin
          koef_dinamike = prodata_kolicina/(:do_datuma - :od_datuma  );
        end
        else
            begin
              koef_dinamike =  0;
            end

        select first 1
            coalesce(l.kolicina,0), coalesce(l.rezervisano,0) , l.cena, l.pros_cena,
            A.KOD,
            A.ODNOSPJM,
            A.ARTIKAL,
            J2.NAZIV as JED_MERE,
            J.NAZIV as PJED_MERE
        from TBLARTIKLI A
            left join tlokacija l on (A.SIFRA_ROBE = L.SIFRA_ROBE)
            and l.sifra_magacina = :mg
            and l.godina = extract(year from current_date)
        inner join TBLJM J on (J.ID = A.IDJM)
        inner join TBLJM J2 on J2.ID = A.IDPJM
        where a.sifra_robe = :sifra_robe
        into :kolicina,  :rezervisano, :cena, :pros_cena, :kod, :odnospjm, :artikal, :jed_mere, :pjed_mere ;

  --      rezervisano = :rezervisano + :prodata_kol_hp;
        kolicina = :kolicina ;-- :prodata_kol_hp;

        select coalesce(l.kolicina,0) - coalesce(l.rezervisano,0)
        from tlokacija l
        where l.sifra_magacina = :mg1
        and l.godina = extract(year from current_date)
        and l.sifra_robe = :sifra_robe
        into :kolicina1;

        suspend;
        kolicina1 = 0;
        kolicina = 0;
        prodata_kol_hp = 0;
    end
end^

SET TERM ; ^



update verzija set maloprodaja = 20220410;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220412 }


INSERT INTO SUF_BUYERID (ID, OPIS) VALUES (12, 'Pib i jbks kupca PIB:JBKJS');

update verzija set maloprodaja = 20220412;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220414 }
             
--update tip_placanja p set p.suf_payment = 'Cash' where p.suf_payment = 'Card';
--update tip_placanja p set p.suf_payment = 'Cash' where p.suf_payment = 'Check';

update verzija set maloprodaja = 20220414;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220416 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_AVANSI (
    IDNOVCANO integer)
returns (
    ZBIR decimal(15,2),
    IDPLACANJA integer)
as
declare variable I integer;
declare variable ZBIR1 decimal(15,2);
declare variable VEZA integer;
declare variable IDN integer;
begin
  IDN = IDNOVCANO;
  update tbluslugepromene p set p.idnovcano_veza = :idn where p.idnovcano = :idn;
  for select P.IDPLACANJA
      from TIP_PLACANJA P
      where P.IDE_NA_KASU = 1 and
            P.SUF_PAYMENT is not null
      into :IDPLACANJA
  do
  begin
    IDNOVCANO = IDN;
    I = -1;
    ZBIR = 0;
    while (I < 0) do
    begin
      select N.VEZA
      from TBLNOVCANO N
      where N.IDNOVCANO = :IDNOVCANO
      into :VEZA;
      update tbluslugepromene p set p.idnovcano_veza = :idn where p.idnovcano = :VEZA;
      select coalesce(sum(P.IZNOS), 0)
      from TBLNOV_PLACANJE P
      where P.IDNOVCANO = :IDNOVCANO and
            P.IDNACIN_PLACANJA = :IDPLACANJA
      into :ZBIR1;
      ZBIR = ZBIR + ZBIR1;
      IDNOVCANO = :VEZA;
      begin
        if (:VEZA is null) then
          I = 1;
      end
      VEZA = null;
    end
    if (ZBIR <> 0) then
      suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_UPDATE_AVANSI (
    IDNOVCANO integer)
as
declare variable I integer;
declare variable ZBIR1 decimal(15,2);
declare variable VEZA integer;
declare variable IDN integer;
declare variable ZBIR integer;
begin
--upise u idnovcano_veza idnovcano od poslednjeg avansnog racuna u sve povezane avansne racune
  IDN = IDNOVCANO;
  update tbluslugepromene p set p.idnovcano_veza = :idn where p.idnovcano = :idn;

  begin
    IDNOVCANO = IDN;
    I = -1;
    ZBIR = 0;
    while (I < 0) do
    begin
      select N.VEZA
      from TBLNOVCANO N
      where N.IDNOVCANO = :IDNOVCANO
      into :VEZA;
      update tbluslugepromene p set p.idnovcano_veza = :idn where p.idnovcano = :VEZA;

      ZBIR = ZBIR + 1;
      IDNOVCANO = :VEZA;
      begin
        if (:VEZA is null) then
          I = 1;
      end
      VEZA = null;
    end
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_AVANSI_STAVKE (
    ID integer)
returns (
    VREDNOST decimal(18,4),
    POREZ decimal(18,4),
    KOLICINA decimal(18,2),
    USLUGE varchar(255),
    STOPA decimal(18,2),
    JED_MERE varchar(10),
    SIFRA_POREZA integer,
    ID_POPDV integer,
    SIFRA_ROBE integer,
    CENA decimal(18,2),
    IDNOVCANO integer,
    IDPROMENE integer)
as
BEGIN
    idnovcano = :id;
    idpromene = 0;
  FOR
    select sum(P.VREDNOST) as vrednost,
           sum(P.POREZ) as porez,
           --   P.CENA,
           P.KOLICINA,
           P.USLUGE,
           P.STOPA,
           P.JED_MERE,
           P.SIFRA_POREZA,
           P.ID_POPDV,
           P.SIFRA_ROBE
    from TBLUSLUGEPROMENE P
    where P.IDNOVCANO_VEZA = :ID
    group by P.KOLICINA, P.USLUGE, P.STOPA, P.JED_MERE, P.SIFRA_POREZA, P.ID_POPDV, P.SIFRA_ROBE
    INTO :VREDNOST,
         :POREZ,
         :KOLICINA,
         :USLUGE,
         :STOPA,
         :JED_MERE,
         :SIFRA_POREZA,
         :ID_POPDV,
         :SIFRA_ROBE
  DO
  BEGIN
    if (KOLICINA <> 0) then
    begin
       cena = VREDNOST / kolicina;
    end
    idpromene = idpromene - 1;
    SUSPEND;
  END
END^

SET TERM ; ^



update verzija set maloprodaja = 20220416;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220418 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PRODAJE (
    D1 date,
    D2 date)
returns (
    SIFRA_ROBE integer,
    IZLAZ_KOL decimal(18,2),
    IZLAZ_VREDNOST decimal(18,2),
    ULAZ_KOL decimal(18,2),
    ULAZ_VREDNOST decimal(18,2),
    PROSEK_IZLAZ decimal(18,2),
    PROSEK_ULAZ decimal(18,2),
    KATEGORIJA varchar(255),
    ARTIKAL varchar(255),
    PROIZVODJAC varchar(255),
    KOD varchar(20))
as
begin
    for
  select p.sifra_robe,
  sum ( case when d.tip_dokumenta = 'IFK' then p.izlaz_kol else 0 end) as izlaz,
  sum ( case when d.tip_dokumenta = 'IFK' then p.posnovi else 0 end) as izlaz_vrednost,
  sum ( case when d.tip_dokumenta = 'UF' then p.ulaz_kol else 0 end) as ulaz ,
  sum ( case when d.tip_dokumenta = 'UF' then p.posnovu else 0 end) as ulaz_vrednost
  from tblnovcano n
  join tblpromene p on n.idnovcano = p.idnovcano
  join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta

  where n.datumdpo between :d1 and :d2
  group by 1
  into :sifra_robe, :izlaz_kol, :izlaz_vrednost, :ulaz_kol, :ulaz_vrednost
  do
  begin
  if (izlaz_kol <> 0 or ulaz_kol <>0 ) then
  begin
    if (izlaz_kol <> 0) then       prosek_izlaz = izlaz_vrednost/izlaz_kol;
    else prosek_izlaz = 0;

    if (ulaz_kol <> 0) then       prosek_ulaz = ulaz_vrednost/ulaz_kol;
    else prosek_ulaz = 0;

    select  a.kod, a.artikal,  v.kategorija_grupe, p.proizvodjac
    from tblartikli a
    join tblvrstarobe v on a.sifra_kategorije = v.sifra_kategorije
    join tblproizvodjac p on a.sifra_proizvodjaca = p.sifra_proizvodjaca
    where a.sifra_robe = :sifra_robe
    into :kod, :artikal,  :kategorija,  :proizvodjac;
    suspend;
  end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220418;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220420 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_PLACANJA (
    IDZ integer)
returns (
    IDPLACANJA integer,
    NAZIV varchar(100),
    SUF_PAYMENT varchar(50),
    IZNOS decimal(18,4))
as
BEGIN
  FOR
    select p.idplacanja, p.naziv, p.suf_payment,
    (
     select  case
        when upper(p.naziv) = 'GOTOVINA' then z.kes
        when upper(p.naziv) = 'VIRMANSKI' then z.virman
        when upper(p.naziv) = 'CEKOVI' then z.cek
        when upper(p.naziv) = 'KARTICA' then z.kartica
        end as iznos
     from mp_fisk_z z
     where z.idz = :idz
    
    )
    from tip_placanja p
    where p.aktivan = 1
    and p.ide_na_kasu = 1
    and p.suf_payment is not null
    INTO :IDPLACANJA,
         :NAZIV,
         :SUF_PAYMENT,
         :IZNOS
  DO
  BEGIN
    if (iznos <> 0) then
    SUSPEND;
  END
END^

SET TERM ; ^



update verzija set maloprodaja = 20220420;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220422 }
             
update tip_placanja p set p.suf_payment = 'Card' where upper(p.naziv) = 'KARTICA' AND P.aktivan = 1 AND P.ide_na_kasu = 1 and ( SELECT first 1 hotel from system ) <> 1;
update tip_placanja p set p.suf_payment = 'Check' where upper(p.naziv) = 'CEKOVI' AND P.aktivan = 1 AND P.ide_na_kasu = 1 and ( SELECT first 1 hotel from system ) <> 1;

update verzija set maloprodaja = 20220422;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220424 }

SET TRPARAMS 'isc_tpb_wait';

update hp_fiskal f set f.trazi_benefit_komitenta = 1 where (select first 1 pib from tblhost) <> '101427058';

update verzija set maloprodaja = 20220424;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220426 }

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20))
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           where
               (upper(T.NAZIV) = 'CEKOVI'
               or upper(T.NAZIV) = 'VIRMANSKI')) as CEK_VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK_VIRMAN,
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK_VIRMAN is null) then
      CEK_VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;
    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;
    RAZLIKA = :UKUPNO - :UKUPNO_DI;
    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    DATUM1 date,
    DATUM2 date)
returns (
    MAGACIN varchar(50),
    MESTO varchar(20),
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    CEK decimal(18,2),
    PROMET_PO_RADNIKU decimal(18,2),
    DATUM date,
    SIFRA_MAGACINA integer,
    STORNO decimal(18,2))
as
BEGIN
 datum = :datum1;
 while (datum <= :datum2) do
 begin
  FOR
    select m.magacin, m.mesto,m.sifra_magacina,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where t.naziv = 'Gotovina'
    ) as Gotovina,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where (t.naziv = 'Virmanski' or t.naziv =  'Virman participacija' )
     ) as Virman,
     (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where (t.naziv = 'Cekovi' )
     ) as Cek,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where t.naziv = 'Kartica'
     ) as kartica,
     (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
    
     ) as Ukupno ,
    (
     select count(*) from tblradnici r where r.id_def_mg_mp = m.sifra_magacina
    ) as br_radnika,
      (
     select sum(pr.duguje)
     from tblnovcano n inner join tblpromene pr on n.idnovcano = pr.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
     where pr.izlaz_kol < 0
    
     ) as storno
    
    
    from tblmagacin m
    where m.vidljiv_mp = 1
    order by m.mesto,m.magacin
    INTO :MAGACIN,
         :MESTO,
         :SIFRA_MAGACINA,
         :GOTOVINA,
         :VIRMAN,
         :CEK,
         :KARTICA,
         :UKUPNO,
         :BR_RADNIKA,
         :STORNO
  DO
  BEGIN
    if (:gotovina is null) then gotovina = 0;
    if (:virman is null) then virman = 0;
    if (:cek is null) then cek = 0;
    if (:kartica is null) then kartica = 0;
    if (:ukupno is null ) then ukupno = 0;
    if (:storno is null) then  storno = 0;
    if (:br_radnika > 0) then promet_po_radniku = :ukupno / :br_radnika;
    else promet_po_radniku = 0;
    if (:ukupno <> 0) then
    SUSPEND;
  END
  datum = datum + 1;
 end
END^

SET TERM ; ^



update verzija set maloprodaja = 20220426;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220428 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure BUS_ISPRAVI_KOMITENTA (
    IDN integer,
    SKNOVI integer)
as
declare variable SK integer;
declare variable DATUM date;
declare variable BID integer;
declare variable OPIS varchar(200);
declare variable MAGACIN varchar(20);
declare variable IDNOVCANO_IZVOD integer;
declare variable IDP integer;
declare variable IDIZVOD integer;
declare variable IDNPLACANJE integer;
begin
  select b.sifra_komitenta , b.datumdpo, b.bid, m.skracenica
  from tblnovcano b, tblmagacin m
  where b.idnovcano = :idn
  and b.sifra_magacina = m.sifra_magacina
  into :sk, :datum, :bid, :magacin;

  opis = 'Placeno u maloprodaji po racunu:' || CAST(:bid as varchar(10))|| :magacin;

  select i.idnovcano, i.id
  from tblizvodi i
  where i.veza = :idn and i.sifra_komitenta = :sk
--  and i.opis = :opis
  into :idnovcano_izvod, :idizvod;

  SELECT N.IDNOVCANO
  FROM TBLNOVCANO N
  WHERE N.veza = :idn
  AND N.opis = 'Placanje'
  and N.sifra_komitenta = :SK
  INTO :IDNPLACANJE;

  update tblnovcano n
  set n.sifra_komitenta = :sknovi
  where n.idnovcano = :idnplacanje;

  update tblnovcano n
  set n.sifra_komitenta = :sknovi
  where n.idnovcano = :idn;

  UPDATE tblizvodi i
  SET I.sifra_komitenta = :SKNOVI
  where i.veza = :idn and i.sifra_komitenta = :sk;

  UPDATE tblizvodraspod r SET R.sifra_komitenta = :sknovi
  where r.idizvoda = :idizvod;

  UPDATE tblizvodi i
  SET I.sifra_komitenta = :sknovi
  where i.veza = :idn and i.sifra_komitenta = :sk
--  and i.opis = :opis
;

  UPDATE tblnovcano a
  SET A.sifra_komitenta = :SKNOVI
  where a.opis = 'Placanje' and a.sifra_komitenta = :sk and a.datumdpo = :datum
  and a.idnovcano = :idnovcano_izvod ;


end^

SET TERM ; ^

update verzija set maloprodaja = 20220428;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220430 }

SET TERM ^ ;

create or alter procedure PROC_MP_BACKUP_TRIGERA
as
begin
  DELETE FROM PS_TRIGERI;
  

 
INSERT INTO PS_TRIGERI (ID, TRIGER_NAME, TRIGER_INACTIV, RELATION_NAME, TRIGER_SEQUENCE, TRIGER_TYPE, TRIGER_SYSTEMFLAG, TRIGER_FLAG)

select gen_id(GEN_PS_TRIGERI_ID, 1),
       T.RDB$TRIGGER_NAME as TRIGER_NAME,
       T.RDB$TRIGGER_INACTIVE as TRIGER_INACTIV,
       T.RDB$RELATION_NAME as RELATION_NAME,
       T.RDB$TRIGGER_SEQUENCE as TRIGER_SEQUENCE,
       T.RDB$TRIGGER_TYPE as TRIGER_TYPE,
       T.RDB$SYSTEM_FLAG as TRIGER_SYSTEMFLAG,
       T.RDB$SYSTEM_FLAG as TRIGER_FLAG
from RDB$TRIGGERS T
where T.RDB$SYSTEM_FLAG = 0;


end^

SET TERM ; ^


update verzija set maloprodaja = 20220430;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220530 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure PROC_MP_PREGLED_TROSKOVA_Z (
    DATUM_OD date,
    DATUM_DO date)
returns (
    ID integer,
    NAZIV varchar(250),
    AKTIVAN smallint,
    VREDNOST decimal(18,2))
as
declare variable VREDNOST1 decimal(18,2);
declare variable VREDNOST2 decimal(18,2);
declare variable VREDNOST3 decimal(18,2);
begin
  for select M.ID, M.NAZIV, M.AKTIVAN
      from TBLMESTOTROSKA M
      order by M.NAZIV
      into :ID, :NAZIV, :AKTIVAN
  do
  begin
    vrednost = 0; vrednost1 = 0; vrednost2  = 0; vrednost3 = 0;
    select coalesce(sum(P.DUG_MG + P.POT_MG),0)
    from TBLNOVCANO N
    join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
    where N.ID_TROSKA = :ID and
          (N.DATUMDPO between :DATUM_OD and :DATUM_DO)
     into vrednost1;

    select coalesce(sum((b.pot_din+b.drugi_iznosi)),0)
    from tblnovcano n
                      join tblblagajna b on b.idnovcano=n.idnovcano and b.id_troska=:ID
    where (n.datumdpo between :datum_od and :datum_do)
    into vrednost2;

    select coalesce(sum(i.duguje+i.potrazuje),0 )
    from tblnovcano n
                      join tblizvodi i on i.idnovcano=n.idnovcano and i.id_troska=:ID
    where (n.datumdpo between :datum_od and :datum_do)
    into :vrednost3;
          vrednost = vrednost1 + vrednost2 + vrednost3;
          suspend;

  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_PREGLED_TROSKOVA_S (
    SIFRA_TROSKA integer,
    DATUM_OD date,
    DATUM_DO date)
returns (
    TIP char(50),
    KOD varchar(20),
    OPIS varchar(255),
    KOLICINA decimal(18,4),
    CENA_MG decimal(18,4),
    VREDNOST decimal(18,4),
    IDNOVCANO integer,
    OPIS_PROMENE varchar(255),
    DATUMDPO date,
    KURS decimal(18,4),
    DATUMVALUTE date,
    ID_TROSKA integer,
    MESTO_TROSKA varchar(250),
    SIFRA_KOMITENTA integer,
    KOMITENT varchar(250),
    BUD varchar(20))
as
begin
  for
    select d.dokument, a.kod, (a.artikal||', '||j.naziv),                       --'materijalni trosk.'
           (p.izlaz_kol+p.ulaz_kol), p.cena_mg, (p.dug_mg+p.pot_mg), n.opis, n.idnovcano, n.datumdpo, n.kurs, n.datumvalute,
           n.id_troska, m.naziv, k1.sifra_komitenta, k1.komitent,n.bud
    from tblnovcano n join tbldokumenti d on d.sifra_dokumenta=n.sifra_dokumenta
                      join tblpromene p on n.idnovcano = p.idnovcano
                      join tblartikli a on a.sifra_robe=p.sifra_robe
                      join tblmestotroska m on m.id=n.id_troska
                      join tblkomitenti k1 on k1.sifra_komitenta = n.sifra_komitenta
                      left join  tbljm j on a.idjm=j.id
    where n.id_troska=:sifra_troska
    and (n.datumdpo between :datum_od and :datum_do)
    into :tip,
         :kod,
         :opis_promene,
         :kolicina,
         :cena_mg,
         :vrednost,
         :opis,
         :idnovcano,
         :datumdpo,
         :kurs,
         :datumvalute,
         :id_troska,
         :mesto_troska,
         :sifra_komitenta,
         :komitent,
         :bud
  do
  begin
    suspend;
  end

  opis=''; kolicina=0; vrednost=0; kod=''; cena_mg=0;

  for
    select d.dokument, k.naziv_konta,                                                    --'finansijski trosk.'
            b.opis_promene, b.konto, (b.pot_din+b.drugi_iznosi),
            n.idnovcano, n.datumdpo, n.kurs, n.datumvalute, b.id_troska, m.naziv, k1.sifra_komitenta, k1.komitent,n.bud
    from tblnovcano n join tbldokumenti d on d.sifra_dokumenta=n.sifra_dokumenta
                      join tblblagajna b on b.idnovcano=n.idnovcano and b.id_troska=:sifra_troska
                      join tblmestotroska m on m.id=b.id_troska
                      join tblkomitenti k1 on k1.sifra_komitenta = n.sifra_komitenta
                      left join tblkonto k on k.analitika=b.konto
    where (n.datumdpo between :datum_od and :datum_do)
    into :tip,
         :opis_promene,
         :opis,
         :kod,
         :vrednost,
         :idnovcano,
         :datumdpo,
         :kurs,
         :datumvalute,
         :id_troska, 
         :mesto_troska,
         :sifra_komitenta,
         :komitent,
         :bud
  do
  begin
    suspend;
  end

  for
    select d.dokument, k.naziv_konta,                                                    --'finansijski trosk.'
            i.opis, i.konto, (i.duguje+i.potrazuje),
            n.idnovcano, n.datumdpo, n.kurs, n.datumdpo, i.id_troska, m.naziv, k1.sifra_komitenta, k1.komitent,n.bud
    from tblnovcano n join tbldokumenti d on d.sifra_dokumenta=n.sifra_dokumenta
                      join tblizvodi i on i.idnovcano=n.idnovcano and i.id_troska=:sifra_troska
                      join tblmestotroska m on m.id=i.id_troska
                      join tblkomitenti k1 on k1.sifra_komitenta = i.sifra_komitenta
                      left join tblkonto k on k.analitika=i.konto
    where (n.datumdpo between :datum_od and :datum_do)
    into :tip,
         :opis_promene,
         :opis,
         :kod,
         :vrednost,
         :idnovcano,
         :datumdpo,
         :kurs,
         :datumvalute,
         :id_troska,
         :mesto_troska,
         :sifra_komitenta,
         :komitent,
         :bud
  do
  begin
    suspend;
  end
end^

SET TERM ; ^


update verzija set maloprodaja = 20220530;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220605 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure HP_RACUNI_STAVKEN (
    BROJ integer,
    SK integer,
    DATUMDPO date,
    SM integer,
    SD integer,
    LAGER integer,
    SK2 integer,
    NAP varchar(255),
    BID integer,
    ID_MESTO_ISP integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDZ integer = null)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    KOLICINA decimal(18,4),
    STOPA decimal(15,2),
    RABAT decimal(15,2),
    CENA decimal(15,2),
    POREZ decimal(18,2),
    OSNOVICA decimal(18,2),
    IZNOS decimal(18,2),
    MAGACIN1 integer,
    VODI_SE_LAGER integer,
    SIFRA_POREZA integer,
    STARA_CENA decimal(18,4),
    PRODAJNA_CENA decimal(18,4),
    ID_POPDV integer)
as
declare variable FISK_PUSTEN integer;
declare variable PROMET_KASE decimal(18,4);
declare variable PROMET_PROGRAM decimal(18,4);
begin
    select d.id_popdv from tbldokumenti d where d.sifra_dokumenta = :sd into :ID_POPDV;

  FISK_PUSTEN = 0;
  select coalesce(sum(D.PROMETT), 0)
  from FISKALNA_DNEVIN_IZVESTAJ D
  inner join FISKALNA_KASA K on D.IDKASE = K.ID_BROJ_ISECKA and K.SIFRA_MAGACINA = :SM and D.DATUM = :DATUMDPO
  into :PROMET_KASE;
  select coalesce(sum(Z.KES) + sum(Z.KARTICA) + sum(Z.CEK) + sum(Z.VIRMAN) + sum(Z.BENEFIT), 0)
  from MP_FISK_Z Z
  where Z.SIFRA_MAGACINA = :SM and
        Z.DATUMDPO = :DATUMDPO  and z.fiskal_pusten > 0   and
        coalesce((Z.KES) + (Z.KARTICA) + (Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT), 0) > 0
  into PROMET_PROGRAM;
  if (abs(promet_kase - promet_program)>1) then
  fisk_pusten = -3;

  for select A.SIFRA_ROBE,
             A.KOD,
             A.ARTIKAL,
             O.PROCENATPDVA,
             O.PROCENAT as RABAT,
         --    O.CENA,
             O.CENA + O.UCESCE_CENA,
             O.STARA_CENA,
             O.SIFRA_MAGACINA,
             O.VODI_SE_LAGER,
             O.SIFRA_POREZA,
             sum(O.KOLICINA),
             sum(O.PDV + O.UCESCE_PDV),
             sum(O.IZNOS + O.UCESCE - O.PDV - O.UCESCE_PDV),
             sum(O.IZNOS + O.UCESCE)
      from MP_FISK_Z Z
      join hp_obracun  O on O.IDZG = Z.IDZ
      inner join TBLARTIKLI A on A.SIFRA_ROBE = O.SIFRA_ROBE --AND A.VODI_SE_LAGER = :LAGER
       WHERE Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.PLACENO = 'Y'   and
        z.sifra_komitenta = :sk
        and z.sifra_magacina = :sm
        and z.sifra_dokumenta = :sd
        and z.datumdpo = :DATUMDPO
        and (z.idz = :idz or :idz = 0)
      group by 1, 2, 3, 4, 5, 6, 7, 8, 9,10
      into :SIFRA_ROBE, :KOD, :ARTIKAL, :STOPA, :RABAT,  :CENA, :STARA_CENA, :MAGACIN1, :VODI_SE_LAGER, :SIFRA_POREZA, :KOLICINA,
           :POREZ, :OSNOVICA, :IZNOS
  do
  begin

    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure HP_RACUNIN (
    D1 date,
    D2 date,
    SM integer)
returns (
    BENEFIT decimal(18,2),
    KONTO_KUPCA integer,
    KUPAC_KONTO_K integer,
    DATUMDPO date,
    BROJ_RACUNA integer,
    DATUM date,
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    KOMITENT varchar(255),
    IZNOS decimal(18,2),
    SIFRA_DOKUMENTA integer,
    DOKUMENT varchar(50),
    SKRACENICA varchar(10),
    ADRESA_MG varchar(50),
    MESTO_MG varchar(50),
    PLACANJE varchar(255),
    VODI_SE_LAGER integer,
    KES decimal(18,2),
    KARTICA decimal(18,2),
    CEK decimal(18,2),
    VIRMAN decimal(18,2),
    SIFRA_KOMITENTA2 integer,
    NAPOMENA varchar(255),
    BID integer,
    UCESCE decimal(18,2),
    ID_MESTO_ISP integer,
    D_ROBNO integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDNOVCANO integer,
    UKUPNO decimal(18,2),
    IDZ integer,
    INVOICENUMBER varchar(50),
    DATEADDED timestamp)
as
declare variable SORTIRANJE integer;
declare variable VREDNOST decimal(18,2);
declare variable PROMET_KASE decimal(18,2);
declare variable PROMET_PROGRAM decimal(18,2);
declare variable FISK_PUSTEN integer;
declare variable KONTROLA integer;
BEGIN

    fisk_pusten = 0;
    
    select coalesce(sum(d.promett),0) from fiskalna_dnevin_izvestaj d inner join fiskalna_kasa k on d.idkase = k.id_broj_isecka
    and d.datum between :d1 and :d2
    and k.sifra_magacina = :sm
    into :promet_kase;
    
    select  coalesce(SUM(Z.KES) + SUM(Z.KARTICA) +SUM(Z.CEK) + SUM(Z.VIRMAN),0)
    from  MP_FISK_Z Z where  z.datumdpo between :D1 AND :D2   and z.fiskal_pusten > 0
    and z.sifra_magacina = :sm  and
    coalesce((Z.KES) + (Z.KARTICA) +(Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT),0) > 0
    into :promet_program;
    
    if (abs(promet_kase - promet_program)>1) then
    fisk_pusten = -3;
    
    select first 1 s.kontrolisi_promet_kasa from system s into :kontrola;
    if (:kontrola = 0) then fisk_pusten = 0;
    else if (:kontrola = -1) then fisk_pusten = -3;

    SELECT M.MAGACIN, M.SIFRA_MAGACINA, M.SKRACENICA, M.ADRESA, M.MESTO
    FROM TBLMAGACIN M
    WHERE M.SIFRA_MAGACINA = :SM
    INTO :MAGACIN, :SIFRA_MAGACINA, SKRACENICA, ADRESA_MG, MESTO_MG;

   FOR
        select
        case
            when Z.SIFRA_KOMITENTA <> 1071 then Z.IDZ
            else 0
        end as IDZ,
        Z.SIFRA_KOMITENTA,
        Z.SIFRA_MAGACINA,
        Z.SIFRA_DOKUMENTA,
        Z.DATUMDPO,
        sum(Z.KES) as KES,
        sum(Z.KARTICA) as KARTICA,
        sum(Z.CEK) as CEK,
        sum(Z.VIRMAN) as VIRMAN,
        sum(Z.BENEFIT) as BENEFIT
        from MP_FISK_Z Z
        where Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.DATUMDPO between :D1 and :D2 and
        z.sifra_magacina = :sm and
        Z.PLACENO = 'Y'
        group by 1, 2, 3, 4, 5
into :idz, :sifra_komitenta, :sifra_magacina, :sifra_dokumenta, :datum ,
:kes, :kartica, :cek,  :virman, :benefit
do
begin
    if (:idz > 0) then
    begin
        SELECT
        z.broj_fiskalnog,
        Z.SIFRA_KOMITENTA2, d.dokument, Z.BID , Z.NAPOMENA, Z.ID_MESTO_ISP, Z.BROJ_RATA, Z.DATUMVALUTE,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO, z.invoicenumber, z.datumpravljenja
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA) --AND K.SIFRA_KOMITENTA NOT IN (555, 501, 2000)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE z.idz = :idz
        into :broj_racuna, :sifra_komitenta2, :dokument,  :bid, :napomena, :id_mesto_isp, :broj_rata, :datum_valute,
        :konto_kupca,:KUPAC_KONTO_K, :D_ROBNO, :invoicenumber, :dateadded ;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        WHERE Z.idz = :idz
        INTO :VREDNOST, :ucesce ;
    end

    else
    begin
        SELECT first 1  Z.DATUMDPO , Z.SIFRA_KOMITENTA, K.KOMITENT, Z.SIFRA_DOKUMENTA, D.DOKUMENT,
        Z.SIFRA_MAGACINA,Z.DATUMDPO,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.PLACENO = 'Y'   and
        z.sifra_komitenta = :sifra_komitenta
        and z.sifra_magacina = :sifra_magacina
        and z.sifra_dokumenta = :sifra_dokumenta
        and z.datumdpo = :datum
     INTO
         :DATUM,
         :SIFRA_KOMITENTA,
         :KOMITENT,
         :SIFRA_DOKUMENTA,
         :DOKUMENT,
         :SIFRA_MAGACINA,
         :DATUMDPO,
         :KONTO_KUPCA,
         :KUPAC_KONTO_K,
         :D_ROBNO;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        join tbldokumenti d on z.sifra_dokumenta = d.sifra_dokumenta
        WHERE Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA
        AND Z.PLACENO = 'Y' AND Z.POSLATOUKNJIGOVODSTVO = 'P'
        AND Z.DATUMDPO = :DATUM
        AND o.SIFRA_MAGACINA = :sifra_magacina
        AND Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA

        
        INTO :VREDNOST, :ucesce ;
      end

    PLACANJE = '';

    IF (KES>0) THEN PLACANJE = PLACANJE||'KES:'||KES||' ';
    IF (KARTICA>0) THEN PLACANJE = PLACANJE||'KARTICA:'||KARTICA||' ';
    IF (CEK>0) THEN PLACANJE = PLACANJE||'CEK:'||CEK||' ';
    IF (VIRMAN>0) THEN PLACANJE = PLACANJE||'VIRMAN:'||VIRMAN||' ';
    IF (BENEFIT>0) THEN PLACANJE = PLACANJE||'BENEFIT:'||BENEFIT||' ';
    IF (UCESCE>0) THEN PLACANJE = PLACANJE||'UCESCCE:'||UCESCE||' ';
    IZNOS = :KES + :CEK + :KARTICA + :VIRMAN + BENEFIT + :UCESCE;
    IF (IZNOS <> VREDNOST) THEN KES = KES - (IZNOS - VREDNOST);
    IZNOS = VREDNOST;
    SUSPEND;
    kes = 0; kartica =0; cek = 0; virman = 0; BENEFIT= 0;
 end
END^

SET TERM ; ^

update verzija set maloprodaja = 20220605;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220607 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select C.cena
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :PRIJEM, :DATUM) C
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and
              A.DATE_CHANGE >= :DATUM) or (M.CENA_MAGACIN = 2 and
              C.DATE_CHANGE >= :DATUM)
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220607;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220609 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :mag, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select C.cena
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :PRIJEM, :DATUM) C
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and
              A.DATE_CHANGE >= :DATUM) or (M.CENA_MAGACIN = 2 and
              C.DATE_CHANGE >= :DATUM)
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^


update verzija set maloprodaja = 20220609;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220611 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :mag, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :MAG, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select min(G.cena)
          from TBL_CENOVNIK G
          where g.id_cenovnika = :prijem   and
          g.sifra_robe = :sifra_robe --and
    --      (:DATUM between g.VAZI_OD and g.VAZI_DO or (:datum >= g.vazi_od and  g.VAZI_DO is null) )
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and
              A.DATE_CHANGE >= :DATUM) or (M.CENA_MAGACIN = 2 and
              C.DATE_CHANGE >= :DATUM)
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220611;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220613 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure HP_RACUNIN (
    D1 date,
    D2 date,
    SM integer)
returns (
    BENEFIT decimal(18,2),
    KONTO_KUPCA integer,
    KUPAC_KONTO_K integer,
    DATUMDPO date,
    BROJ_RACUNA integer,
    DATUM date,
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    KOMITENT varchar(255),
    IZNOS decimal(18,2),
    SIFRA_DOKUMENTA integer,
    DOKUMENT varchar(50),
    SKRACENICA varchar(10),
    ADRESA_MG varchar(50),
    MESTO_MG varchar(50),
    PLACANJE varchar(255),
    VODI_SE_LAGER integer,
    KES decimal(18,2),
    KARTICA decimal(18,2),
    CEK decimal(18,2),
    VIRMAN decimal(18,2),
    SIFRA_KOMITENTA2 integer,
    NAPOMENA varchar(255),
    BID integer,
    UCESCE decimal(18,2),
    ID_MESTO_ISP integer,
    D_ROBNO integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDNOVCANO integer,
    UKUPNO decimal(18,2),
    IDZ integer,
    INVOICENUMBER varchar(50),
    DATEADDED timestamp)
as
declare variable SORTIRANJE integer;
declare variable VREDNOST decimal(18,2);
declare variable PROMET_KASE decimal(18,2);
declare variable PROMET_PROGRAM decimal(18,2);
declare variable FISK_PUSTEN integer;
declare variable KONTROLA integer;
declare variable SIFRA_DEFAULT_KUPCA integer;
BEGIN

    fisk_pusten = 0;
    
    select coalesce(sum(d.promett),0) from fiskalna_dnevin_izvestaj d inner join fiskalna_kasa k on d.idkase = k.id_broj_isecka
    and d.datum between :d1 and :d2
    and k.sifra_magacina = :sm
    into :promet_kase;
    
    select  coalesce(SUM(Z.KES) + SUM(Z.KARTICA) +SUM(Z.CEK) + SUM(Z.VIRMAN),0)
    from  MP_FISK_Z Z where  z.datumdpo between :D1 AND :D2   and z.fiskal_pusten > 0
    and z.sifra_magacina = :sm  and
    coalesce((Z.KES) + (Z.KARTICA) +(Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT),0) > 0
    into :promet_program;
    
    if (abs(promet_kase - promet_program)>1) then
    fisk_pusten = -3;
    
    select first 1 s.kontrolisi_promet_kasa from system s into :kontrola;
    if (:kontrola = 0) then fisk_pusten = 0;
    else if (:kontrola = -1) then fisk_pusten = -3;

    SELECT M.MAGACIN, M.SIFRA_MAGACINA, M.SKRACENICA, M.ADRESA, M.MESTO
    FROM TBLMAGACIN M
    WHERE M.SIFRA_MAGACINA = :SM
    INTO :MAGACIN, :SIFRA_MAGACINA, SKRACENICA, ADRESA_MG, MESTO_MG;

    select first 1 f.sifra_default_kupca
    from hp_fiskal f into :sifra_default_kupca;
   FOR
        select
        case
            when Z.SIFRA_KOMITENTA <> :sifra_default_kupca then Z.IDZ
            else 0
        end as IDZ,
        Z.SIFRA_KOMITENTA,
        Z.SIFRA_MAGACINA,
        Z.SIFRA_DOKUMENTA,
        Z.DATUMDPO,
        sum(Z.KES) as KES,
        sum(Z.KARTICA) as KARTICA,
        sum(Z.CEK) as CEK,
        sum(Z.VIRMAN) as VIRMAN,
        sum(Z.BENEFIT) as BENEFIT
        from MP_FISK_Z Z
        where Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.DATUMDPO between :D1 and :D2 and
        z.sifra_magacina = :sm and
        Z.PLACENO = 'Y'
        group by 1, 2, 3, 4, 5
into :idz, :sifra_komitenta, :sifra_magacina, :sifra_dokumenta, :datum ,
:kes, :kartica, :cek,  :virman, :benefit
do
begin
    if (:idz > 0) then
    begin
        SELECT
        z.broj_fiskalnog,
        Z.SIFRA_KOMITENTA2, d.dokument, Z.BID , Z.NAPOMENA, Z.ID_MESTO_ISP, Z.BROJ_RATA, Z.DATUMVALUTE,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO, z.invoicenumber, z.datumpravljenja, k.komitent
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA) --AND K.SIFRA_KOMITENTA NOT IN (555, 501, 2000)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE z.idz = :idz
        into :broj_racuna, :sifra_komitenta2, :dokument,  :bid, :napomena, :id_mesto_isp, :broj_rata, :datum_valute,
        :konto_kupca,:KUPAC_KONTO_K, :D_ROBNO, :invoicenumber, :dateadded, :komitent ;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        WHERE Z.idz = :idz
        INTO :VREDNOST, :ucesce ;
    end

    else
    begin
        SELECT first 1  Z.DATUMDPO , Z.SIFRA_KOMITENTA, K.KOMITENT, Z.SIFRA_DOKUMENTA, D.DOKUMENT,
        Z.SIFRA_MAGACINA,Z.DATUMDPO,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.PLACENO = 'Y'   and
        z.sifra_komitenta = :sifra_komitenta
        and z.sifra_magacina = :sifra_magacina
        and z.sifra_dokumenta = :sifra_dokumenta
        and z.datumdpo = :datum
     INTO
         :DATUM,
         :SIFRA_KOMITENTA,
         :KOMITENT,
         :SIFRA_DOKUMENTA,
         :DOKUMENT,
         :SIFRA_MAGACINA,
         :DATUMDPO,
         :KONTO_KUPCA,
         :KUPAC_KONTO_K,
         :D_ROBNO;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        join tbldokumenti d on z.sifra_dokumenta = d.sifra_dokumenta
        WHERE Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA
        AND Z.PLACENO = 'Y' AND Z.POSLATOUKNJIGOVODSTVO = 'P'
        AND Z.DATUMDPO = :DATUM
        AND o.SIFRA_MAGACINA = :sifra_magacina
        AND Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA

        
        INTO :VREDNOST, :ucesce ;
      end

    PLACANJE = '';

    IF (KES>0) THEN PLACANJE = PLACANJE||'KES:'||KES||' ';
    IF (KARTICA>0) THEN PLACANJE = PLACANJE||'KARTICA:'||KARTICA||' ';
    IF (CEK>0) THEN PLACANJE = PLACANJE||'CEK:'||CEK||' ';
    IF (VIRMAN>0) THEN PLACANJE = PLACANJE||'VIRMAN:'||VIRMAN||' ';
    IF (BENEFIT>0) THEN PLACANJE = PLACANJE||'BENEFIT:'||BENEFIT||' ';
    IF (UCESCE>0) THEN PLACANJE = PLACANJE||'UCESCCE:'||UCESCE||' ';
    IZNOS = :KES + :CEK + :KARTICA + :VIRMAN + BENEFIT + :UCESCE;
    IF (IZNOS <> VREDNOST) THEN KES = KES - (IZNOS - VREDNOST);
    IZNOS = VREDNOST;
    SUSPEND;
    kes = 0; kartica =0; cek = 0; virman = 0; BENEFIT= 0;
 end
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_HP_SYNC_PROVERA (
    D1 date,
    SM integer,
    D2 date = null)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    CENA decimal(18,2),
    ARTIKAL varchar(255),
    PROCENATPDVA decimal(18,2),
    PRODAJA decimal(18,3),
    VREDNOST decimal(18,2),
    LAGER decimal(18,3),
    PROIZVODNJA decimal(18,3),
    PROIZVEDI decimal(18,3),
    DODAJ_PROIZ decimal(18,3),
    DOZVOLJEN_PRENOS char(1),
    VODI_SE_LAGER integer,
    STOPA decimal(18,4),
    SIFRA_POREZA integer,
    ULAZ_CENA decimal(18,4),
    UCESCE decimal(18,2),
    SIFRA_MAGACINA integer)
as
declare variable DOKUMENT_FISKAL integer;
declare variable SIFRA_KATEGORIJE integer;
declare variable ZA_PROIZ decimal(18,3);
declare variable UKUPNO_PRODATO decimal(18,4);
declare variable STARA_SIFRA integer;
declare variable VEC_PROIZVEDENO decimal(18,4);
declare variable FISK_PUSTEN integer;
declare variable PROMET_KASE decimal(18,4);
declare variable PROMET_PROGRAM decimal(18,4);
declare variable KONTROLA integer;
declare variable GODINA integer;
declare variable FORSIRAJ integer;
begin
  za_proiz = 0;
  proizvodnja = 0;
  lager = 0;
  prodaja = 0;
  proizvedi = 0;
  dozvoljen_prenos = 'N';
  dodaj_proiz = 0;
  proizvodnja = 0;
  stara_sifra = -1;
  fisk_pusten = 0;

  if(d2 is null) then
    d2 = :d1;
  godina = extract (year from :d1);

  select m.PREBACI_PRODAJU from tblmagacin m where m.sifra_magacina = :sm into :forsiraj;

   if (forsiraj = 0) then
   begin
    for
    select a.sifra_robe
    from azuriranje_lagera_hp(:sm, :godina) a
    into :SIFRA_ROBE
    do
    begin

    end
   end
  SIFRA_ROBE = null;

  select coalesce(sum(d.promett), 0)
  from fiskalna_dnevin_izvestaj d join fiskalna_kasa k on d.idkase = k.id_broj_isecka and d.datum = :d1 and k.sifra_magacina = :sm
  into :promet_kase;

  select coalesce(sum(z.kes) + sum(z.kartica) + sum(z.cek) + sum(z.virman), 0)
  from mp_fisk_z z
  where z.datumdpo between :d1 and :d2 and
        z.sifra_magacina = :sm  and
        coalesce((z.kes) + (z.kartica) + (z.cek) + (z.virman), 0) > 0
  into promet_program;

  if (abs(promet_kase - promet_program) < 1) then fisk_pusten = -3;

  select first 1 s.kontrolisi_promet_kasa from system s into :kontrola;
  if (:kontrola = 0) then fisk_pusten = 0;
  else if (:kontrola = -1) then fisk_pusten = -3;


  for select o.sifra_robe,
             a.kod,
             o.cena,
             a.artikal,
             o.procenatpdva,
             a.sifra_kategorije,
             a.vodi_se_lager,
             o.procenatpdva,
             o.sifra_poreza,
             a.plan_cena,
             o.sifra_magacina,
             sum(o.kolicina) as kolicina,
             sum(o.cena * o.kolicina) as vrednost,
             sum(o.ucesce) as ucesce
            -- ,d.fiskalni

      from hp_obracun o    join tblartikli a on o.sifra_robe = a.sifra_robe
                           join mp_fisk_z z on o.idzg = z.idz
                           join tbldokumenti d on z.sifra_dokumenta = d.sifra_dokumenta
      where z.placeno = 'Y' and
           -- z.poslatouknjigovodstvo is distinct from 'D' and
           z.poslatouknjigovodstvo = 'P' and
            z.datumdpo between :d1 and :d2 and
            o.sifra_magacina = :sm and
            (z.fiskal_pusten > :fisk_pusten or d.fiskalni = 0)
           -- and o.sifra_robe = 140001
      group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, o.sifra_magacina--,d.fiskalni
      into :sifra_robe, :kod, :cena, :artikal, :procenatpdva, :sifra_kategorije, :vodi_se_lager, :stopa, :sifra_poreza,
           :ulaz_cena, :sifra_magacina, :prodaja, :vrednost, :ucesce--, :DOKUMENT_FISKAL
  do
  begin
    sm = :sifra_magacina;
    -- koliko ih ima na stanju u magacinu
    select (l.kolicina - l.rezervisano), l.hp_kol
    from tlokacija l join tblmagacin m on ((m.sifra_magacina = l.sifra_magacina) or (m.vezani_mg = l.sifra_magacina))
    where l.sifra_robe = :sifra_robe and
          l.sifra_magacina = :sm and
          l.kolicina >= 0 and
          l.godina = extract(year from :d1)
    into :lager, ukupno_prodato;

    --koliko moze da se proizvede
    select min(k.kol)
    from artikli_proveri_materijal(:sm, :sifra_robe, extract(year from :d1)) k
    into :proizvodnja;
/*
    -- koliko je ukupno prodato tog artikla
    select sum(o.kolicina)
    from hp_obracun o
    inner join mp_fisk_z z on o.idzg = z.idz
    where   z.datumdpo between :d1 and :d2 and
            z.placeno = 'Y' and
            z.poslatouknjigovodstvo is distinct from 'D' and
            o.sifra_magacina = :sm and
            (z.fiskal_pusten > :fisk_pusten or :DOKUMENT_FISKAL = 0  ) and
            o.sifra_robe = :sifra_robe

    into :ukupno_prodato;
*/
--proizvodnja = moguce napraviti AKO JE PROIZVODNJA=NULL ZNACI DA NEMA NORMATIVA
--proizvedi = potrebno napraviti
--za_proiz = toliko treba da se napravi
    begin
      if (lager is null) then
        lager = 0;
      if (za_proiz is null) then
        za_proiz = 0;
--      if (proizvodnja is null) then
--        proizvodnja = 0;

      --ako je prodaja veca od lagera i forsiraj=1 onda proizvedi koliko treba
      if ((prodaja - lager) > 0 or (forsiraj = 1) ) then
         za_proiz = (prodaja - lager);
      else
         za_proiz = 0;

      --ako treba da se napravi vise nego sto moze da se napravi i forsiraj = 1 onda napravi sve
      if ((za_proiz - proizvodnja) > 0 and forsiraj = 0) then
        proizvedi = proizvodnja;
      else
        proizvedi = za_proiz;

      if (proizvedi = 0 and
          (lager < prodaja)) then
        dodaj_proiz = (prodaja - lager - proizvodnja);
      if (proizvodnja is null) then
      begin
        dodaj_proiz = proizvedi;
        proizvedi = 0;
      end
      if (prodaja > lager and
          (proizvodnja + lager < prodaja)) then
        dozvoljen_prenos = 'N';
      else
        dozvoljen_prenos = 'D';
--      if (stara_sifra <> sifra_robe) then
      begin
        stara_sifra = sifra_robe;
        vec_proizvedeno = proizvedi;
      end
      if (prodaja <= vec_proizvedeno) then
      begin
        proizvedi = prodaja;
        vec_proizvedeno = vec_proizvedeno - prodaja;
      end
      else
      begin
        proizvedi = vec_proizvedeno;
        vec_proizvedeno = 0;
      end
      suspend;
      za_proiz = 0;
      lager = 0;
      prodaja = 0;
      proizvedi = 0;
      prodaja = 0;
      proizvodnja = 0;
      dodaj_proiz = 0;
      proizvodnja = 0;
      ukupno_prodato = 0;
    end
  end
end^

SET TERM ; ^



update verzija set maloprodaja = 20220613;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220615 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure HP_RACUNIN (
    D1 date,
    D2 date,
    SM integer)
returns (
    BENEFIT decimal(18,2),
    KONTO_KUPCA integer,
    KUPAC_KONTO_K integer,
    DATUMDPO date,
    BROJ_RACUNA integer,
    DATUM date,
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    KOMITENT varchar(255),
    IZNOS decimal(18,2),
    SIFRA_DOKUMENTA integer,
    DOKUMENT varchar(50),
    SKRACENICA varchar(10),
    ADRESA_MG varchar(50),
    MESTO_MG varchar(50),
    PLACANJE varchar(255),
    VODI_SE_LAGER integer,
    KES decimal(18,2),
    KARTICA decimal(18,2),
    CEK decimal(18,2),
    VIRMAN decimal(18,2),
    SIFRA_KOMITENTA2 integer,
    NAPOMENA varchar(255),
    BID integer,
    UCESCE decimal(18,2),
    ID_MESTO_ISP integer,
    D_ROBNO integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDNOVCANO integer,
    UKUPNO decimal(18,2),
    IDZ integer,
    INVOICENUMBER varchar(50),
    DATEADDED timestamp)
as
declare variable SORTIRANJE integer;
declare variable VREDNOST decimal(18,2);
declare variable PROMET_KASE decimal(18,2);
declare variable PROMET_PROGRAM decimal(18,2);
declare variable FISK_PUSTEN integer;
declare variable KONTROLA integer;
declare variable SIFRA_DEFAULT_KUPCA integer;
BEGIN

    fisk_pusten = 0;
    
    select coalesce(sum(d.promett),0) from fiskalna_dnevin_izvestaj d inner join fiskalna_kasa k on d.idkase = k.id_broj_isecka
    and d.datum between :d1 and :d2
    and k.sifra_magacina = :sm
    into :promet_kase;
    
    select  coalesce(SUM(Z.KES) + SUM(Z.KARTICA) +SUM(Z.CEK) + SUM(Z.VIRMAN),0)
    from  MP_FISK_Z Z where  z.datumdpo between :D1 AND :D2   and z.fiskal_pusten > 0
    and z.sifra_magacina = :sm  and
    coalesce((Z.KES) + (Z.KARTICA) +(Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT),0) > 0
    into :promet_program;
    
    if (abs(promet_kase - promet_program)>1) then
    fisk_pusten = -3;
    
    select first 1 s.kontrolisi_promet_kasa from system s into :kontrola;
    if (:kontrola = 0) then fisk_pusten = 0;
    else if (:kontrola = -1) then fisk_pusten = -3;

    SELECT M.MAGACIN, M.SIFRA_MAGACINA, M.SKRACENICA, M.ADRESA, M.MESTO
    FROM TBLMAGACIN M
    WHERE M.SIFRA_MAGACINA = :SM
    INTO :MAGACIN, :SIFRA_MAGACINA, SKRACENICA, ADRESA_MG, MESTO_MG;

    select first 1 f.sifra_default_kupca
    from hp_fiskal f into :sifra_default_kupca;
   FOR
        select
        case
            when Z.SIFRA_KOMITENTA <> :sifra_default_kupca then Z.IDZ
            else 0
        end as IDZ,
        Z.SIFRA_KOMITENTA,
        Z.SIFRA_MAGACINA,
        Z.SIFRA_DOKUMENTA,
        Z.DATUMDPO,
        sum(Z.KES) as KES,
        sum(Z.KARTICA) as KARTICA,
        sum(Z.CEK) as CEK,
        sum(Z.VIRMAN) as VIRMAN,
        sum(Z.BENEFIT) as BENEFIT
        from MP_FISK_Z Z
        where Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.DATUMDPO between :D1 and :D2 and
        z.sifra_magacina = :sm and
        Z.PLACENO = 'Y'
        group by 1, 2, 3, 4, 5
into :idz, :sifra_komitenta, :sifra_magacina, :sifra_dokumenta, :datum ,
:kes, :kartica, :cek,  :virman, :benefit
do
begin
    if (:idz > 0) then
    begin
        SELECT
        z.broj_fiskalnog,
        Z.SIFRA_KOMITENTA2, d.dokument, Z.BID , Z.NAPOMENA, Z.ID_MESTO_ISP, Z.BROJ_RATA, Z.DATUMVALUTE,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO, z.invoicenumber, z.datumpravljenja, k.komitent
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA) --AND K.SIFRA_KOMITENTA NOT IN (555, 501, 2000)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE z.idz = :idz
        into :broj_racuna, :sifra_komitenta2, :dokument,  :bid, :napomena, :id_mesto_isp, :broj_rata, :datum_valute,
        :konto_kupca,:KUPAC_KONTO_K, :D_ROBNO, :invoicenumber, :dateadded, :komitent ;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        WHERE Z.idz = :idz
        INTO :VREDNOST, :ucesce ;
    end

    else
    begin
        SELECT first 1  Z.DATUMDPO , Z.SIFRA_KOMITENTA, K.KOMITENT, Z.SIFRA_DOKUMENTA, D.DOKUMENT,
        Z.SIFRA_MAGACINA,Z.DATUMDPO,Z.DATUMVALUTE,
        M.KONTO_KUPCA, S.KUPAC, Z.ROBNO
        
        FROM  MP_FISK_Z Z
        INNER JOIN TBLKOMITENTI K      ON (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA)
        INNER JOIN TBLDOKUMENTI D      ON (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
        INNER JOIN TBLMAGACIN M        ON M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
        INNER JOIN TBLSTATUS S         ON S.SIFRA_STATUSA = K.SIFRA_STATUSA
        WHERE Z.POSLATOUKNJIGOVODSTVO = 'P' and
        Z.PLACENO = 'Y'   and
        z.sifra_komitenta = :sifra_komitenta
        and z.sifra_magacina = :sifra_magacina
        and z.sifra_dokumenta = :sifra_dokumenta
        and z.datumdpo = :datum
     INTO
         :DATUM,
         :SIFRA_KOMITENTA,
         :KOMITENT,
         :SIFRA_DOKUMENTA,
         :DOKUMENT,
         :SIFRA_MAGACINA,
         :DATUMDPO,
         :datum_valute,
         :KONTO_KUPCA,
         :KUPAC_KONTO_K,
         :D_ROBNO;

        SELECT SUM ( cast((O.CENA + coalesce(O.ucesce_cena,0)) * (case when (O.SIFRA_ROBE_RECEPT > 0 and o.kolicina_fiskal is not null) then o.kolicina_fiskal
                                else o.kolicina end) as decimal(18,2))) , coalesce(sum(o.ucesce),0)
        FROM HP_OBRACUN O INNER JOIN MP_FISK_Z Z ON O.IDZG = Z.IDZ
        join tbldokumenti d on z.sifra_dokumenta = d.sifra_dokumenta
        WHERE Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA
        AND Z.PLACENO = 'Y' AND Z.POSLATOUKNJIGOVODSTVO = 'P'
        AND Z.DATUMDPO = :DATUM
        AND o.SIFRA_MAGACINA = :sifra_magacina
        AND Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA

        
        INTO :VREDNOST, :ucesce ;
      end

    PLACANJE = '';

    IF (KES>0) THEN PLACANJE = PLACANJE||'KES:'||KES||' ';
    IF (KARTICA>0) THEN PLACANJE = PLACANJE||'KARTICA:'||KARTICA||' ';
    IF (CEK>0) THEN PLACANJE = PLACANJE||'CEK:'||CEK||' ';
    IF (VIRMAN>0) THEN PLACANJE = PLACANJE||'VIRMAN:'||VIRMAN||' ';
    IF (BENEFIT>0) THEN PLACANJE = PLACANJE||'BENEFIT:'||BENEFIT||' ';
    IF (UCESCE>0) THEN PLACANJE = PLACANJE||'UCESCCE:'||UCESCE||' ';
    IZNOS = :KES + :CEK + :KARTICA + :VIRMAN + BENEFIT + :UCESCE;
    IF (IZNOS <> VREDNOST) THEN KES = KES - (IZNOS - VREDNOST);
    IZNOS = VREDNOST;
    SUSPEND;
    kes = 0; kartica =0; cek = 0; virman = 0; BENEFIT= 0;
 end
END^

SET TERM ; ^

update verzija set maloprodaja = 20220615;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220617 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure HP_RACUNI_STAVKEN (
    BROJ integer,
    SK integer,
    DATUMDPO date,
    SM integer,
    SD integer,
    LAGER integer,
    SK2 integer,
    NAP varchar(255),
    BID integer,
    ID_MESTO_ISP integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDZ integer = null)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    KOLICINA decimal(18,4),
    STOPA decimal(15,2),
    RABAT decimal(15,2),
    CENA decimal(15,2),
    POREZ decimal(18,2),
    OSNOVICA decimal(18,2),
    IZNOS decimal(18,2),
    MAGACIN1 integer,
    VODI_SE_LAGER integer,
    SIFRA_POREZA integer,
    STARA_CENA decimal(18,4),
    PRODAJNA_CENA decimal(18,4),
    ID_POPDV integer)
as
declare variable FISK_PUSTEN integer;
declare variable PROMET_KASE decimal(18,4);
declare variable PROMET_PROGRAM decimal(18,4);
begin
  select D.ID_POPDV
  from TBLDOKUMENTI D
  where D.SIFRA_DOKUMENTA = :SD
  into :ID_POPDV;
  FISK_PUSTEN = 0;
  select coalesce(sum(D.PROMETT), 0)
  from FISKALNA_DNEVIN_IZVESTAJ D
  inner join FISKALNA_KASA K on D.IDKASE = K.ID_BROJ_ISECKA and K.SIFRA_MAGACINA = :SM and D.DATUM = :DATUMDPO
  into :PROMET_KASE;
  select coalesce(sum(Z.KES) + sum(Z.KARTICA) + sum(Z.CEK) + sum(Z.VIRMAN) + sum(Z.BENEFIT), 0)
  from MP_FISK_Z Z
  where Z.SIFRA_MAGACINA = :SM and
        Z.DATUMDPO = :DATUMDPO and
        Z.FISKAL_PUSTEN > 0 and
        coalesce((Z.KES) + (Z.KARTICA) + (Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT), 0) > 0
  into PROMET_PROGRAM;
  if (abs(PROMET_KASE - PROMET_PROGRAM) > 1) then
    FISK_PUSTEN = -3;
  for select A.SIFRA_ROBE,
             A.KOD,
             A.ARTIKAL,
             O.PROCENATPDVA,
             O.PROCENAT as RABAT,
             --    O.CENA,
             (O.CENA + coalesce(O.UCESCE_CENA, 0)),
             O.STARA_CENA,
             O.SIFRA_MAGACINA,
             O.VODI_SE_LAGER,
             O.SIFRA_POREZA,
             sum(O.KOLICINA),
             sum(O.PDV + O.UCESCE_PDV),
             sum(O.IZNOS + O.UCESCE - O.PDV - O.UCESCE_PDV),
             sum(O.IZNOS + O.UCESCE)
      from MP_FISK_Z Z
      join HP_OBRACUN O on O.IDZG = Z.IDZ
      inner join TBLARTIKLI A on A.SIFRA_ROBE = O.SIFRA_ROBE --AND A.VODI_SE_LAGER = :LAGER
      where Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.PLACENO = 'Y' and
            Z.SIFRA_KOMITENTA = :SK and
            Z.SIFRA_MAGACINA = :SM and
            Z.SIFRA_DOKUMENTA = :SD and
            Z.DATUMDPO = :DATUMDPO and
            (Z.IDZ = :IDZ or :IDZ = 0)
      group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10
      into :SIFRA_ROBE, :KOD, :ARTIKAL, :STOPA, :RABAT, :CENA, :STARA_CENA, :MAGACIN1, :VODI_SE_LAGER, :SIFRA_POREZA,
           :KOLICINA, :POREZ, :OSNOVICA, :IZNOS
  do
  begin
    suspend;
  end
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure HP_RACUNIN (
    D1 date,
    D2 date,
    SM integer)
returns (
    BENEFIT decimal(18,2),
    KONTO_KUPCA integer,
    KUPAC_KONTO_K integer,
    DATUMDPO date,
    BROJ_RACUNA integer,
    DATUM date,
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    KOMITENT varchar(255),
    IZNOS decimal(18,2),
    SIFRA_DOKUMENTA integer,
    DOKUMENT varchar(50),
    SKRACENICA varchar(10),
    ADRESA_MG varchar(50),
    MESTO_MG varchar(50),
    PLACANJE varchar(255),
    VODI_SE_LAGER integer,
    KES decimal(18,2),
    KARTICA decimal(18,2),
    CEK decimal(18,2),
    VIRMAN decimal(18,2),
    SIFRA_KOMITENTA2 integer,
    NAPOMENA varchar(255),
    BID integer,
    UCESCE decimal(18,2),
    ID_MESTO_ISP integer,
    D_ROBNO integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDNOVCANO integer,
    UKUPNO decimal(18,2),
    IDZ integer,
    INVOICENUMBER varchar(50),
    DATEADDED timestamp)
as
declare variable SORTIRANJE integer;
declare variable VREDNOST decimal(18,2);
declare variable PROMET_KASE decimal(18,2);
declare variable PROMET_PROGRAM decimal(18,2);
declare variable FISK_PUSTEN integer;
declare variable KONTROLA integer;
declare variable SIFRA_DEFAULT_KUPCA integer;
begin
  FISK_PUSTEN = 0;
  select coalesce(sum(D.PROMETT), 0)
  from FISKALNA_DNEVIN_IZVESTAJ D
  inner join FISKALNA_KASA K on D.IDKASE = K.ID_BROJ_ISECKA and D.DATUM between :D1 and :D2 and K.SIFRA_MAGACINA = :SM
  into :PROMET_KASE;
  select coalesce(sum(Z.KES) + sum(Z.KARTICA) + sum(Z.CEK) + sum(Z.VIRMAN), 0)
  from MP_FISK_Z Z
  where Z.DATUMDPO between :D1 and :D2 and
        Z.FISKAL_PUSTEN > 0 and
        Z.SIFRA_MAGACINA = :SM and
        coalesce((Z.KES) + (Z.KARTICA) + (Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT), 0) > 0
  into :PROMET_PROGRAM;
  if (abs(PROMET_KASE - PROMET_PROGRAM) > 1) then
    FISK_PUSTEN = -3;
  select first 1 S.KONTROLISI_PROMET_KASA
  from SYSTEM S
  into :KONTROLA;
  if (:KONTROLA = 0) then
    FISK_PUSTEN = 0;
  else
  if (:KONTROLA = -1) then
    FISK_PUSTEN = -3;
  select M.MAGACIN,
         M.SIFRA_MAGACINA,
         M.SKRACENICA,
         M.ADRESA,
         M.MESTO
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :SM
  into :MAGACIN, :SIFRA_MAGACINA, SKRACENICA, ADRESA_MG, MESTO_MG;
  select first 1 F.SIFRA_DEFAULT_KUPCA
  from HP_FISKAL F
  into :SIFRA_DEFAULT_KUPCA;
  for select
             case
               when Z.SIFRA_KOMITENTA <> :SIFRA_DEFAULT_KUPCA then Z.IDZ
               else 0
             end as IDZ,
             Z.SIFRA_KOMITENTA,
             Z.SIFRA_MAGACINA,
             Z.SIFRA_DOKUMENTA,
             Z.DATUMDPO,
             sum(Z.KES) as KES,
             sum(Z.KARTICA) as KARTICA,
             sum(Z.CEK) as CEK,
             sum(Z.VIRMAN) as VIRMAN,
             sum(Z.BENEFIT) as BENEFIT
      from MP_FISK_Z Z
      where Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.DATUMDPO between :D1 and :D2 and
            Z.SIFRA_MAGACINA = :SM and
            Z.PLACENO = 'Y'
      group by 1, 2, 3, 4, 5
      into :IDZ, :SIFRA_KOMITENTA, :SIFRA_MAGACINA, :SIFRA_DOKUMENTA, :DATUM, :KES, :KARTICA, :CEK, :VIRMAN, :BENEFIT
  do
  begin
    if (:IDZ > 0) then
    begin
      select Z.BROJ_FISKALNOG,
             Z.SIFRA_KOMITENTA2,
             D.DOKUMENT,
             Z.BID,
             Z.NAPOMENA,
             Z.ID_MESTO_ISP,
             Z.BROJ_RATA,
             Z.DATUMVALUTE,
             M.KONTO_KUPCA,
             S.KUPAC,
             Z.ROBNO,
             Z.INVOICENUMBER,
             Z.DATUMPRAVLJENJA,
             K.KOMITENT
      from MP_FISK_Z Z
      inner join TBLKOMITENTI K on (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA) --AND K.SIFRA_KOMITENTA NOT IN (555, 501, 2000)
      inner join TBLDOKUMENTI D on (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
      inner join TBLMAGACIN M on M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
      inner join TBLSTATUS S on S.SIFRA_STATUSA = K.SIFRA_STATUSA
      where Z.IDZ = :IDZ
      into :BROJ_RACUNA, :SIFRA_KOMITENTA2, :DOKUMENT, :BID, :NAPOMENA, :ID_MESTO_ISP, :BROJ_RATA, :DATUM_VALUTE,
           :KONTO_KUPCA, :KUPAC_KONTO_K, :D_ROBNO, :INVOICENUMBER, :DATEADDED, :KOMITENT;
      select sum(cast((O.CENA + coalesce(O.UCESCE_CENA, 0)) * (
             case
               when (O.SIFRA_ROBE_RECEPT > 0 and O.KOLICINA_FISKAL is not null) then O.KOLICINA_FISKAL
               else O.KOLICINA
             end) as decimal(18,2))),
             coalesce(sum(O.UCESCE), 0)
      from HP_OBRACUN O
      inner join MP_FISK_Z Z on O.IDZG = Z.IDZ
      where Z.IDZ = :IDZ
      into :VREDNOST, :UCESCE;
    end
    else
    begin
      select first 1 Z.DATUMDPO,
                     Z.SIFRA_KOMITENTA,
                     K.KOMITENT,
                     Z.SIFRA_DOKUMENTA,
                     D.DOKUMENT,
                     Z.SIFRA_MAGACINA,
                     Z.DATUMDPO,
                     Z.DATUMVALUTE,
                     M.KONTO_KUPCA,
                     S.KUPAC,
                     Z.ROBNO
      from MP_FISK_Z Z
      inner join TBLKOMITENTI K on (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA)
      inner join TBLDOKUMENTI D on (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
      inner join TBLMAGACIN M on M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
      inner join TBLSTATUS S on S.SIFRA_STATUSA = K.SIFRA_STATUSA
      where Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.PLACENO = 'Y' and
            Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA and
            Z.SIFRA_MAGACINA = :SIFRA_MAGACINA and
            Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA and
            Z.DATUMDPO = :DATUM
      into :DATUM, :SIFRA_KOMITENTA, :KOMITENT, :SIFRA_DOKUMENTA, :DOKUMENT, :SIFRA_MAGACINA, :DATUMDPO, :DATUM_VALUTE,
           :KONTO_KUPCA, :KUPAC_KONTO_K, :D_ROBNO;
      select sum(cast((O.CENA + coalesce(O.UCESCE_CENA, 0)) * (
             case
               when (O.SIFRA_ROBE_RECEPT > 0 and O.KOLICINA_FISKAL is not null) then O.KOLICINA_FISKAL
               else O.KOLICINA
             end) as decimal(18,2))),
             coalesce(sum(O.UCESCE), 0)
      from HP_OBRACUN O
      inner join MP_FISK_Z Z on O.IDZG = Z.IDZ
      join TBLDOKUMENTI D on Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
      where Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA and
            Z.PLACENO = 'Y' and
            Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.DATUMDPO = :DATUM and
            O.SIFRA_MAGACINA = :SIFRA_MAGACINA and
            Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA
      into :VREDNOST, :UCESCE;
    end
    PLACANJE = '';
    if (KES > 0) then
      PLACANJE = PLACANJE || 'KES:' || KES || ' ';
    if (KARTICA > 0) then
      PLACANJE = PLACANJE || 'KARTICA:' || KARTICA || ' ';
    if (CEK > 0) then
      PLACANJE = PLACANJE || 'CEK:' || CEK || ' ';
    if (VIRMAN > 0) then
      PLACANJE = PLACANJE || 'VIRMAN:' || VIRMAN || ' ';
    if (BENEFIT > 0) then
      PLACANJE = PLACANJE || 'BENEFIT:' || BENEFIT || ' ';
    if (UCESCE > 0) then
      PLACANJE = PLACANJE || 'UCESCCE:' || UCESCE || ' ';
    IZNOS = :KES + :CEK + :KARTICA + :VIRMAN + BENEFIT + :UCESCE;
    if (IZNOS <> VREDNOST) then
      KES = KES - (IZNOS - VREDNOST);
    IZNOS = VREDNOST;
    suspend;
    KES = 0;
    KARTICA = 0;
    CEK = 0;
    VIRMAN = 0;
    BENEFIT = 0;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220617;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220619 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_TREBOVANJE_DOB_ART (
    MG integer,
    OD_DATUMA date,
    DO_DATUMA date,
    SIFRA_DOBAVLJACA integer,
    BROJ_DANA integer,
    MG1 integer = null,
    SIFRA_KATEGORIJE integer = -1)
returns (
    SIFRA_ROBE integer,
    PRODATA_KOLICINA decimal(18,4),
    SIFRA_MAGACINA integer,
    LAGER_KOL integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    ODNOSPJM double precision,
    JED_MERE varchar(20),
    PJED_MERE varchar(20),
    REZERVISANO decimal(18,4),
    KOLICINA decimal(18,4),
    BROJ_DANA_LAGER integer,
    KOEF_DINAMIKE decimal(18,4),
    CENA decimal(18,2),
    PROS_CENA decimal(18,2),
    KOLICINA1 decimal(18,4))
as
declare variable PRODATA_KOL_HP decimal(15,2);
declare variable HP integer;
declare variable GODINA integer;
begin
  select first 1 S.HP_TABELE
  from TBLHOST S
  into :HP;
  godina = extract(year from DO_DATUMA);

  if (:SIFRA_KATEGORIJE is null) then SIFRA_KATEGORIJE = -1;
  for select distinct A.SIFRA_ROBE
      from TBLARTIKLI A
      left join tlokacija l on a.sifra_robe = l.sifra_robe and l.godina = :godina
      where (A.SIFRA_DOBAVLJACA = :SIFRA_DOBAVLJACA or  :SIFRA_DOBAVLJACA = -1)
      and (a.sifra_kategorije = :sifra_kategorije or :sifra_kategorije = -1)
      and ( (l.sifra_magacina = :mg1 and l.kolicina > 0) or :mg1 = :mg)
            --   AND P.SIFRA_ROBE = 40344
      into :SIFRA_ROBE
  do
  begin
    KOD = null;
    ARTIKAL = null;
    BROJ_DANA_LAGER = 0;
    PRODATA_KOLICINA = 0;
    PRODATA_KOL_HP = 0;
    select Z.BROJ_DANA
    from ZEGIN_BR_DANA_LAGERA_MP(:MG, :OD_DATUMA, :DO_DATUMA, :SIFRA_ROBE) Z
    into :BROJ_DANA_LAGER;
    if (HP = 0) then
    begin
      select coalesce(sum(P.IZLAZ_KOL), 0),
             N.SIFRA_MAGACINA
      from TBLNOVCANO N
      join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
      join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
      where N.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            D.TIP = 10 and
            P.SIFRA_ROBE = :SIFRA_ROBE and
            N.SIFRA_MAGACINA = :MG
      group by 2
      into :PRODATA_KOLICINA, :SIFRA_MAGACINA;
    end
    else
    begin
      select coalesce(sum(O.KOLICINA), 0),
             Z.SIFRA_MAGACINA
      from HP_OBRACUN O
      join MP_FISK_Z Z on O.IDZG = Z.IDZ
      where Z.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            O.SIFRA_ROBE = :SIFRA_ROBE and
            Z.SIFRA_MAGACINA = :MG and
            Z.PLACENO = 'Y'
      group by 2
      into :PRODATA_KOL_HP, :SIFRA_MAGACINA;
    end
    PRODATA_KOLICINA = coalesce(PRODATA_KOLICINA, 0) + coalesce(PRODATA_KOL_HP, 0);
    if (:BROJ_DANA_LAGER > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / BROJ_DANA_LAGER;
    end
    else
    if (:DO_DATUMA - :OD_DATUMA > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / (:DO_DATUMA - :OD_DATUMA);
    end
    else
    begin
      KOEF_DINAMIKE = 0;
    end
    select first 1 coalesce(L.KOLICINA, 0),
                   coalesce(L.REZERVISANO, 0),
                   L.CENA,
                   L.PROS_CENA,
                   A.KOD,
                   A.ODNOSPJM,
                   A.ARTIKAL,
                   J2.NAZIV as JED_MERE,
                   J.NAZIV as PJED_MERE
    from TBLARTIKLI A
    left join TLOKACIJA L on (A.SIFRA_ROBE = L.SIFRA_ROBE) and L.SIFRA_MAGACINA = :MG and L.GODINA = extract(year from current_date)
    inner join TBLJM J on (J.ID = A.IDJM)
    inner join TBLJM J2 on J2.ID = A.IDPJM
    where A.SIFRA_ROBE = :SIFRA_ROBE
    into :KOLICINA, :REZERVISANO, :CENA, :PROS_CENA, :KOD, :ODNOSPJM, :ARTIKAL, :JED_MERE, :PJED_MERE;
    --      REZERVISANO = :REZERVISANO + :PRODATA_KOL_HP;
    KOLICINA = :KOLICINA;-- :PRODATA_KOL_HP;
    select coalesce(L.KOLICINA, 0) - coalesce(L.REZERVISANO, 0)
    from TLOKACIJA L
    where L.SIFRA_MAGACINA = :MG1 and
          L.GODINA = extract(year from current_date) and
          L.SIFRA_ROBE = :SIFRA_ROBE
    into :KOLICINA1;
    suspend;
    KOLICINA1 = 0;
    KOLICINA = 0;
    PRODATA_KOL_HP = 0;
  end
end^

SET TERM ; ^


update verzija set maloprodaja = 20220619;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220719 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_TREBOVANJE_SPISAK_ART (
    SIFRA_DOBAVLJACA integer,
    CENTRALNO_KAPILARNO integer,
    SIFRA_MAGACINA integer,
    SIFRA_KATEGORIJE integer)
returns (
    SIFRA_ROBE integer)
as
begin
    if (CENTRALNO_KAPILARNO = 1) then  -- KAPILARNO(ZNACI IZ MAGACINA)
    begin
        for
          select  distinct a.sifra_robe
        from tblartikli a
        join tblartikli_asortiman s on a.sifra_robe = s.sifra_robe and s.sifra_magacina = :sifra_magacina
        join tblartikli_supergrupe g on a.idsupergrupe = g.id and g.tip_nabavke in ('MESOVITO', 'KAPILARNO')
        where (a.sifra_dobavljaca = :SIFRA_DOBAVLJACA or :sifra_dobavljaca = -1 )
        and (a.sifra_kategorije = :sifra_kategorije or :sifra_kategorije = -1)
        into :sifra_robe
        do
        begin
            suspend;
        end
    end
    ELSE
    begin
        for
          select  distinct a.sifra_robe
        from tblartikli a
        join tblartikli_asortiman s on a.sifra_robe = s.sifra_robe and s.sifra_magacina = :sifra_magacina
        join tblartikli_supergrupe g on a.idsupergrupe = g.id and g.tip_nabavke in ('MESOVITO', 'CENTRALNO')
        where (a.sifra_dobavljaca = :SIFRA_DOBAVLJACA or :sifra_dobavljaca = -1 )
        and (a.sifra_kategorije = :sifra_kategorije or :sifra_kategorije = -1)
        into :sifra_robe
        do
        begin
            suspend;
        end
    end

end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_TREBOVANJE_DOB_ART (
    MG integer,
    OD_DATUMA date,
    DO_DATUMA date,
    SIFRA_DOBAVLJACA integer,
    BROJ_DANA integer,
    MG1 integer = null,
    SIFRA_KATEGORIJE integer = -1)
returns (
    SIFRA_ROBE integer,
    PRODATA_KOLICINA decimal(18,4),
    SIFRA_MAGACINA integer,
    LAGER_KOL integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    ODNOSPJM double precision,
    JED_MERE varchar(20),
    PJED_MERE varchar(20),
    REZERVISANO decimal(18,4),
    KOLICINA decimal(18,4),
    BROJ_DANA_LAGER integer,
    KOEF_DINAMIKE decimal(18,4),
    CENA decimal(18,2),
    PROS_CENA decimal(18,2),
    KOLICINA1 decimal(18,4))
as
declare variable PRODATA_KOL_HP decimal(15,2);
declare variable HP integer;
declare variable GODINA integer;
declare variable KAPILARNO integer;
begin
  select first 1 S.HP_TABELE
  from TBLHOST S
  into :HP;
  godina = extract(year from DO_DATUMA);

    if (:MG = :MG1) then  KAPILARNO = 1;
    ELSE KAPILARNO = 0;

  if (:SIFRA_KATEGORIJE is null) then SIFRA_KATEGORIJE = -1;
  /*
  for select distinct A.SIFRA_ROBE
      from TBLARTIKLI A
      left join tlokacija l on a.sifra_robe = l.sifra_robe and l.godina = :godina
      where (A.SIFRA_DOBAVLJACA = :SIFRA_DOBAVLJACA or  :SIFRA_DOBAVLJACA = -1)
      and (a.sifra_kategorije = :sifra_kategorije or :sifra_kategorije = -1)
      and ( (l.sifra_magacina = :mg1 and l.kolicina > 0) or :mg1 = :mg)

    select  distinct a.sifra_robe
    from tblartikli a
    where (a.sifra_dobavljaca = :SIFRA_DOBAVLJACA)
    */
    for
    SELECT A.SIFRA_ROBE
    FROM PROC_MP_TREBOVANJE_SPISAK_ART( :SIFRA_DOBAVLJACA, :kapilarno,  :MG, :SIFRA_KATEGORIJE) A
    into :sifra_robe

  do
  begin
    KOD = null;
    ARTIKAL = null;
    BROJ_DANA_LAGER = 0;
    PRODATA_KOLICINA = 0;
    PRODATA_KOL_HP = 0;

    select Z.BROJ_DANA
    from ZEGIN_BR_DANA_LAGERA_MP(:MG, :OD_DATUMA, :DO_DATUMA, :SIFRA_ROBE) Z
    into :BROJ_DANA_LAGER;

    if (HP = 0) then
    begin
      select coalesce(sum(P.IZLAZ_KOL), 0),
             N.SIFRA_MAGACINA
      from TBLNOVCANO N
      join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
      join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
      where N.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            D.TIP = 10 and
            P.SIFRA_ROBE = :SIFRA_ROBE and
            N.SIFRA_MAGACINA = :MG
      group by 2
      into :PRODATA_KOLICINA, :SIFRA_MAGACINA;
    end
    else
    begin
      select coalesce(sum(O.KOLICINA), 0),
             Z.SIFRA_MAGACINA
      from HP_OBRACUN O
      join MP_FISK_Z Z on O.IDZG = Z.IDZ
      where Z.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            O.SIFRA_ROBE = :SIFRA_ROBE and
            Z.SIFRA_MAGACINA = :MG and
            Z.PLACENO = 'Y'
      group by 2
      into :PRODATA_KOL_HP, :SIFRA_MAGACINA;
    end
    PRODATA_KOLICINA = coalesce(PRODATA_KOLICINA, 0) + coalesce(PRODATA_KOL_HP, 0);
    if (:BROJ_DANA_LAGER > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / BROJ_DANA_LAGER;
    end
    else
    if (:DO_DATUMA - :OD_DATUMA > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / (:DO_DATUMA - :OD_DATUMA);
    end
    else
    begin
      KOEF_DINAMIKE = 0;
    end
    select first 1 coalesce(L.KOLICINA, 0),
                   coalesce(L.REZERVISANO, 0),
                   L.CENA,
                   L.PROS_CENA,
                   A.KOD,
                   A.ODNOSPJM,
                   A.ARTIKAL,
                   J2.NAZIV as JED_MERE,
                   J.NAZIV as PJED_MERE
    from TBLARTIKLI A
    left join TLOKACIJA L on (A.SIFRA_ROBE = L.SIFRA_ROBE) and L.SIFRA_MAGACINA = :MG and L.GODINA = extract(year from current_date)
    inner join TBLJM J on (J.ID = A.IDJM)
    inner join TBLJM J2 on J2.ID = A.IDPJM
    where A.SIFRA_ROBE = :SIFRA_ROBE
    into :KOLICINA, :REZERVISANO, :CENA, :PROS_CENA, :KOD, :ODNOSPJM, :ARTIKAL, :JED_MERE, :PJED_MERE;
    --      REZERVISANO = :REZERVISANO + :PRODATA_KOL_HP;
    KOLICINA = :KOLICINA;-- :PRODATA_KOL_HP;
    select coalesce(L.KOLICINA, 0) - coalesce(L.REZERVISANO, 0)
    from TLOKACIJA L
    where L.SIFRA_MAGACINA = :MG1 and
          L.GODINA = extract(year from current_date) and
          L.SIFRA_ROBE = :SIFRA_ROBE
    into :KOLICINA1;
    suspend;
    KOLICINA1 = 0;
    KOLICINA = 0;
    PRODATA_KOL_HP = 0;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220719;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220722 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_PUSTI_FISK (
    IDN integer)
returns (
    IDPROMENE integer,
    KOLICINA decimal(18,4),
    IDNOVCANO integer,
    CENA decimal(18,4),
    POREZ decimal(18,2),
    ARTIKAL varchar(255),
    KOD varchar(20),
    LABEL varchar(10),
    JED_MERE varchar(20),
    BARKOD varchar(50))
as
BEGIN
  FOR
    select P.IDPROMENE,
           P.IZLAZ_KOL as KOLICINA,
           P.IDNOVCANO,
           P.CENA_MG as CENA,
           P.POREZ,
           A.ARTIKAL,
           A.KOD,
           Z.LABEL,
           M.NAZIV as JED_MERE,
           coalesce((select first 1 BARKOD
                     from TBLBARKOD B
                     where B.SIFRA_ROBE = P.SIFRA_ROBE
                     order by B.ID desc), A.KOD) as BARKOD
    from TBLPROMENE P
    join TBLARTIKLI A on P.SIFRA_ROBE = A.SIFRA_ROBE
    join TBLPOREZ Z on P.SIFRA_POREZA = Z.SIFRA_POREZA
    join TBLJM M on A.IDPJM = M.ID
    where P.IDNOVCANO = :IDN
    INTO :IDPROMENE,
         :KOLICINA,
         :IDNOVCANO,
         :CENA,
         :POREZ,
         :ARTIKAL,
         :KOD,
         :LABEL,
         :JED_MERE,
         :BARKOD
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20220722;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220724 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    SM integer,
    DATUM1 date,
    DATUM2 date)
returns (
    MAGACIN varchar(50),
    MESTO varchar(20),
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    CEK decimal(18,2),
    PROMET_PO_RADNIKU decimal(18,2),
    DATUM date,
    SIFRA_MAGACINA integer,
    STORNO decimal(18,2))
as
BEGIN
 datum = :datum1;
 while (datum <= :datum2) do
 begin
  FOR
    select m.magacin, m.mesto,m.sifra_magacina,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where t.naziv = 'Gotovina'
    ) as Gotovina,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where (t.naziv = 'Virmanski' or t.naziv =  'Virman participacija' )
     ) as Virman,
     (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where (t.naziv = 'Cekovi' )
     ) as Cek,
    (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
     where t.naziv = 'Kartica'
     ) as kartica,
     (
     select sum(p.iznos)
     from tblnovcano n inner join  tblnov_placanje p on n.idnovcano = p.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
                            inner join tip_placanja t on t.idplacanja=p.idnacin_placanja
    
     ) as Ukupno ,
    (
     select count(*) from tblradnici r where r.id_def_mg_mp = m.sifra_magacina
    ) as br_radnika,
      (
     select sum(pr.duguje)
     from tblnovcano n inner join tblpromene pr on n.idnovcano = pr.idnovcano  and n.datumdpo= :datum and n.sifra_magacina=m.sifra_magacina
     where pr.izlaz_kol < 0
    
     ) as storno
    
    
    from tblmagacin m
    where m.vidljiv_mp = 1 and m.sifra_magacina = :SM or (:sm = -1)
    order by m.mesto,m.magacin
    INTO :MAGACIN,
         :MESTO,
         :SIFRA_MAGACINA,
         :GOTOVINA,
         :VIRMAN,
         :CEK,
         :KARTICA,
         :UKUPNO,
         :BR_RADNIKA,
         :STORNO
  DO
  BEGIN
    if (:gotovina is null) then gotovina = 0;
    if (:virman is null) then virman = 0;
    if (:cek is null) then cek = 0;
    if (:kartica is null) then kartica = 0;
    if (:ukupno is null ) then ukupno = 0;
    if (:storno is null) then  storno = 0;
    if (:br_radnika > 0) then promet_po_radniku = :ukupno / :br_radnika;
    else promet_po_radniku = 0;
    if (:ukupno <> 0) then
    SUSPEND;
  END
  datum = datum + 1;
 end
END^

SET TERM ; ^

update verzija set maloprodaja = 20220724;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220820 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROMET_MAGACINA_SVE (
    DATUM_OD date,
    DATUM_DO date)
returns (
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    KOD_PR varchar(20),
    KOD varchar(20),
    ARTIKAL varchar(255),
    JM varchar(20),
    KONTO integer,
    KOD_INFO varchar(10),
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    SIFRA_ROBE integer,
    ULAZ_KOL decimal(18,3),
    IZLAZ_KOL decimal(18,3),
    STANJE decimal(18,3),
    ZADUZENJE_MG decimal(18,2),
    RAZDUZENJE_MG decimal(18,2),
    POSNOVU decimal(18,2),
    POSNOVI decimal(18,2),
    NAB_VRED decimal(18,2),
    ODNOSPJM double precision,
    STOPA1 decimal(18,2),
    PROIZVODJAC varchar(100),
    KATEGORIJA_GRUPE varchar(50),
    PODKATEGORIJA varchar(100),
    SALDO_NAB_VRED decimal(18,2),
    SALDO_MG decimal(18,2),
    SALDO_POSL_CENA decimal(18,2),
    SEKTOR varchar(150),
    KOMITENT varchar(250),
    SIFRA_DOBAVLJACA integer,
    TRENUTI_LAGER decimal(18,4))
as
declare variable GODINA integer;
begin
/*
   koristi je cashit za izvestaj Bus_prodaja_nabavka.h
*/
    godina = extract(year from datum_od);
  for select A.SIFRA_KATEGORIJE,
             A.SIFRA_PROIZVODJACA,
             A.KOD_PR,
             A.KOD,
             a.sifra_robe,
             A.ARTIKAL,
             J.NAZIV as JM,
             A.KONTO,
             A.KOD_INFO,
             A.ODNOSPJM,
             Z.STOPA1,
             PR.PROIZVODJAC,
             V.KATEGORIJA_GRUPE,
             PK.NAZIV as PODKATEGORIJA,
             S.NAZIV as SEKTOR,
             M.SIFRA_MAGACINA,
             M.MAGACIN,
             P1.ULAZ_KOL,
             P1.IZLAZ_KOL,
             P1.STANJE,
             P1.ZADUZENJE_MG,
             P1.RAZDUZENJE_MG,
             P1.SALDO_MG,
             P1.POSNOVU,
             P1.POSNOVI,
             P1.NAB_VRED,
             P1.SALDO_NAB_VRED,
             (A.NAB_CENA * P1.STANJE) as SALDO_POSL_CENA,
             A.SIFRA_DOBAVLJACA,
             K.KOMITENT
      from (select N.SIFRA_MAGACINA,
                   P.SIFRA_ROBE,
                   cast(sum(P.ULAZ_KOL) as decimal(18,3)) as ULAZ_KOL,
                   cast(sum(P.IZLAZ_KOL) as decimal(18,3)) as IZLAZ_KOL,
                   cast(sum(P.ULAZ_KOL - P.IZLAZ_KOL) as decimal(18,3)) as STANJE,
                   cast(sum(P.DUG_MG) as decimal(18,2)) as ZADUZENJE_MG,
                   cast(sum(P.POT_MG) as decimal(18,2)) as RAZDUZENJE_MG,
                   cast(sum(P.DUG_MG - P.POT_MG) as decimal(18,2)) as SALDO_MG,
                   cast(sum(P.POSNOVU) as decimal(18,2)) as POSNOVU,
                   cast(sum(P.POSNOVI) as decimal(18,2)) as POSNOVI,
                   cast(sum(P.IZLAZ_KOL * P.PROSEK) as decimal(18,2)) as NAB_VRED,
                   cast((sum(P.POSNOVU) - sum(P.IZLAZ_KOL * P.PROSEK)) as decimal(18,2)) as SALDO_NAB_VRED
            from TBLNOVCANO N
            join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO between :DATUM_OD and :DATUM_DO
            join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA and D.KEPU = 1
            group by 1, 2) P1
      join TBLARTIKLI A on A.SIFRA_ROBE = P1.SIFRA_ROBE --AND a.tip_artikla <> 2
      join TBLPOREZ Z on Z.SIFRA_POREZA = A.SIFRA_POREZA
      join TBLMAGACIN M on M.SIFRA_MAGACINA = P1.SIFRA_MAGACINA
      join TBLPROIZVODJAC PR on PR.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
      join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
      left join TBLPODVRSTAROBE PK on PK.ID = A.ID_PODKATEGORIJE
      left join TBLJM J on J.ID = A.IDJM
      left join TBLSEKTOR S on S.IDSEKTORA = M.SIFRA_SEKTORA
      left join TBLKOMITENTI K on K.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
      into :SIFRA_KATEGORIJE, :SIFRA_PROIZVODJACA, :KOD_PR, :KOD, :sifra_robe, :ARTIKAL, :JM, :KONTO, :KOD_INFO, :ODNOSPJM, :STOPA1,
           :PROIZVODJAC, :KATEGORIJA_GRUPE, :PODKATEGORIJA, :SEKTOR, :SIFRA_MAGACINA, :MAGACIN, :ULAZ_KOL, :IZLAZ_KOL,
           :STANJE, :ZADUZENJE_MG, :RAZDUZENJE_MG, :SALDO_MG, :POSNOVU, :POSNOVI, :NAB_VRED, :SALDO_NAB_VRED,
           :SALDO_POSL_CENA, :SIFRA_DOBAVLJACA, :KOMITENT
  do
  begin
    select coalesce(l.kolicina,0) - coalesce(l.rezervisano,0) - coalesce(l.hp_kol, 0)
    from tlokacija l
    where l.sifra_magacina = :sifra_magacina
    and l.sifra_robe = :sifra_robe
    and l.godina = :godina
    into :trenuti_lager;
    suspend;
  end
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROMET_MAGACINA (
    MG integer,
    DATUM_OD date,
    DATUM_DO date)
returns (
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    KONTO integer,
    SIFRA_MAGACINA integer,
    ULAZ decimal(18,4),
    IZLAZ decimal(18,4),
    STANJE decimal(18,4),
    DUG_MG decimal(18,4),
    POT_MG decimal(18,4),
    KOLICINA_MG decimal(18,4),
    VREDNOST_MG decimal(18,4),
    ODNOSPJM double precision,
    NAZIV varchar(20),
    NAZIV_PJM varchar(20),
    RAZLIKA_SALDA decimal(18,4),
    KOD_PR varchar(20),
    STOPA decimal(15,2),
    PROIZVODJAC varchar(100),
    KATEGORIJA_GRUPE varchar(50),
    POSNOVI decimal(18,2),
    POSNOVU decimal(18,2),
    NAB_VREDNOST_ULAZ decimal(18,2),
    NAB_VREDNOST_IZLAZ decimal(18,2),
    KOD_INFO varchar(20),
    SALDO decimal(18,2),
    PODKATEGORIJA varchar(100),
    COLOR integer,
    SIFRA_ROBE integer,
    CENA decimal(18,2),
    NEDOZVOLJENI_MINUS double precision,
    SIFRA_DOBAVLJACA integer,
    DOBAVLJAC varchar(255))
as
declare variable TIP_CENA integer;
BEGIN
  select m.tip_cena from tblmagacin m where m.sifra_magacina=:mg into :tip_cena;

  FOR
    SELECT a.sifra_kategorije,  a.sifra_proizvodjaca, a.kod_pr, a.kod, a.Artikal,
           a.Jed_mere, a.Konto, a.kod_info, n.sifra_magacina, a.sifra_robe,
     CAST(SUM(ulaz_kol) as DECIMAL(18,3)),
     CAST(SUM(izlaz_kol) as DECIMAL(18,3)),
     CAST(SUM(ulaz_kol-izlaz_kol) as DECIMAL(18,3)),
     CAST(SUM(dug_mg)as DECIMAL(18,2)),
     CAST(SUM(pot_mg)as DECIMAL(18,2)),
     CAST(SUM(p.posnovu) as DECIMAL(18,2)),                       -- poreske osnovice
     CAST(SUM(p.posnovi) as DECIMAL(18,2)),
     CAST(SUM(p.posnovu) as DECIMAL(18,2)),                       -- nabavne vrednosti
     CAST(SUM(p.izlaz_kol*p.prosek) as DECIMAL(18,2)),
     a.odnospjm, j.naziv, z.stopa1,
     (SELECT naziv FROM TBLJM WHERE id=a.idpjm),
     pr.proizvodjac,
     v.kategorija_grupe,
     pk.naziv as podkategorija
     FROM tblnovcano n INNER JOIN tblpromene p ON p.idnovcano=n.idnovcano AND n.sifra_magacina=:mg 

AND (n.datumdpo between :datum_od AND :datum_do)
                       INNER JOIN tbldokumenti d ON n.sifra_dokumenta=d.sifra_dokumenta AND 

d.robni_kartica=1
                       INNER JOIN tblartikli a ON a.sifra_robe=p.sifra_robe AND a.tip_artikla <> 2
                       INNER JOIN tblporez z   ON z.sifra_poreza=a.sifra_poreza
                       LEFT JOIN tbljm j ON j.id=a.idjm
                       INNER JOIN tblproizvodjac pr ON pr.sifra_proizvodjaca=a.sifra_proizvodjaca
                       INNER JOIN tblvrstarobe v ON v.sifra_kategorije = a.sifra_kategorije
                       LEFT JOIN  tblpodvrstarobe pk ON pk.id=a.id_podkategorije
    GROUP BY a.sifra_kategorije, a.sifra_proizvodjaca, a.kod_pr, a.kod, a.Artikal, a.Jed_mere, 

a.Konto,
             n.sifra_magacina, p.sifra_robe, a.odnospjm, j.naziv, a.idpjm, z.stopa1, 

pr.proizvodjac,
             v.kategorija_grupe, a.kod_info, pk.naziv, a.sifra_robe
    INTO :SIFRA_KATEGORIJE,
         :SIFRA_PROIZVODJACA,
         :KOD_PR,
         :KOD,
         :ARTIKAL,
         :NAZIV,
         :KONTO,
         :KOD_INFO,
         :SIFRA_MAGACINA,
         :sifra_robe, 
         :ULAZ,
         :IZLAZ,
         :STANJE,
         :DUG_MG,
         :POT_MG,
         :posnovi,
         :posnovu,
         :nab_vrednost_ulaz,
         :nab_vrednost_izlaz,
         :ODNOSPJM,
         :JED_MERE,
         :STOPA,
         :NAZIV_PJM ,
         :PROIZVODJAC,
         :KATEGORIJA_GRUPE,
         :PODKATEGORIJA
  DO
  BEGIN
    cena=0; nedozvoljeni_minus=0; kolicina_mg=0;

    select a.sifra_dobavljaca, k.komitent
    from tblartikli a
    join tblkomitenti k on a.sifra_dobavljaca = k.sifra_komitenta
    where a.sifra_robe = :sifra_robe
    into :sifra_dobavljaca, :dobavljac;

    select l.cena, l.nedozvoljeni_minus, l.kolicina
    from tlokacija l
    where l.sifra_robe=:sifra_robe and l.sifra_magacina=:mg and l.godina = extract(year from 

:datum_do)
    into :cena, :nedozvoljeni_minus, :kolicina_mg;

    if(tip_cena = 1) then
      begin
        vrednost_mg=cena;
        if(kolicina_mg<>0) then cena=vrednost_mg/kolicina_mg;
      end
    else
      begin
        vrednost_mg=cena*kolicina_mg;
      end

    saldo = dug_mg-pot_mg;
    razlika_salda= (dug_mg-pot_mg)-vrednost_mg;

    SUSPEND;
  END
END^

SET TERM ; ^



update verzija set maloprodaja = 20220820;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220822 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT_GOGA (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       select first 1 p.procenat
       from tblbenefit_procenti p
       where :benefit_isplata between p.iznos and p.iznos1 or (:benefit_isplata > p.iznos and p.iznos1 is null)
       into :BENEFIT_PROCENAT;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT_KALA (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT (
    D1 date,
    D2 date)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TIP_BENEFITA varchar(20);
begin
  select first 1 m.tip_benefita
  from system_mp m
  into :tip_benefita;

  for select K.SIFRA_KOMITENTA,
             K.KOMITENT
      from TBLKOMITENTI K
      where K.BENEFIT_KARTICA is not null
      into :SIFRA_KOMITENTA, :KOMITENT
  do
  begin
    DUGUJE = 0;
    IZNOS = 0;
    if (tip_benefita = 'GOGA') then
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT_goga(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    ELSE if (tip_benefita = 'KALA') then
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT_KALA(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    ELSE
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT_GOGA (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       select first 1 p.procenat
       from tblbenefit_procenti p
       where :benefit_isplata between p.iznos and p.iznos1 or (:benefit_isplata > p.iznos and p.iznos1 is null)
       into :BENEFIT_PROCENAT;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^



update verzija set maloprodaja = 20220822;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220902 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_PLACANJA (
    IDZ integer)
returns (
    IDPLACANJA integer,
    NAZIV varchar(100),
    SUF_PAYMENT varchar(50),
    IZNOS decimal(18,4))
as
BEGIN
  FOR
    select p.idplacanja, p.naziv, p.suf_payment,
    (
     select  case
        when upper(p.naziv) = 'GOTOVINA' then z.kes
        when upper(p.naziv) = 'VIRMANSKI' then z.virman
        when upper(p.naziv) = 'CEKOVI' then z.cek
        when upper(p.naziv) = 'KARTICA' then z.kartica
        when upper(p.naziv) = 'BENEFIT' then z.benefit
        end as iznos
     from mp_fisk_z z
     where z.idz = :idz
    
    )
    from tip_placanja p
    where p.aktivan = 1
    and p.ide_na_kasu = 1
    and p.suf_payment is not null
    INTO :IDPLACANJA,
         :NAZIV,
         :SUF_PAYMENT,
         :IZNOS
  DO
  BEGIN
    if (iznos <> 0) then
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;



CREATE OR ALTER TRIGGER TBLKOMIT_BENEFIT_BI0 FOR TBLKOMIT_BENEFIT
ACTIVE BEFORE INSERT POSITION 0
AS
    declare variable benefit varchar(20);
begin
    select m.tip_benefita
    from system_mp m
    into :benefit;
    if (benefit = 'GOGA') then
    INSERT INTO AC_CREDIT_HISTORY ( "VALUE", DATE_INSERT,  CARD_ID, MP_FISK_Z_ID, SIFRA_MAGACINA, GUID_MPFISKZ, POSLATO)
    VALUES ( new.iznos_isplate, current_timestamp,  new.sifra_komitenta, NULL, null, NULL, 0);
end
^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT_MAXVIL (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    select k.rabat_benefit
    from tblkomitenti k
    where k.sifra_komitenta = :SIFRA_KOMITENTA
    into :BENEFIT_PROCENAT;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT (
    D1 date,
    D2 date)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TIP_BENEFITA varchar(20);
begin
  select first 1 m.tip_benefita
  from system_mp m
  into :tip_benefita;

  for select K.SIFRA_KOMITENTA,
             K.KOMITENT
      from TBLKOMITENTI K
      where K.BENEFIT_KARTICA is not null
      into :SIFRA_KOMITENTA, :KOMITENT
  do
  begin
    DUGUJE = 0;
    IZNOS = 0;
    if (tip_benefita = 'GOGA') then
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT_goga(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    ELSE if (tip_benefita = 'KALA') then
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT_KALA(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    ELSE if (tip_benefita = 'MAXVIL') then
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT_MAXVIL(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    ELSE
    BEGIN
        select B.DUGUJE,
               B.IZNOS,
               B.BENEFIT_PROCENAT,
               B.IZNOS_ZA_ISPLATU
        from PROC_MP_BENEFIT_KOMITENT(:D1, :D2, :SIFRA_KOMITENTA) B
        into :DUGUJE, :IZNOS, :BENEFIT_PROCENAT, :IZNOS_ZA_ISPLATU;
    END
    suspend;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20220902;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20220905 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_POREZ_IZLAZ (
    SIFRA_ROBE integer)
returns (
    SIFRA_POREZ_IZLAZ integer,
    STOPA_POREZ_IZLAZ decimal(15,2),
    SIFRA_POREZ integer,
    STOPA_POREZ decimal(15,2),
    LABEL varchar(10),
    LABEL_IZLAZ varchar(10))
as
begin
  select coalesce(A.SIFRA_POREZ_IZLAZ, A.SIFRA_POREZA),
         P.STOPA1,
         coalesce(U.LABEL, P.LABEL) as LABEL_IZLAZ,
         A.SIFRA_POREZA,
         U.STOPA1,
         U.LABEL
  from TBLARTIKLI A
  join TBLPOREZ U on U.SIFRA_POREZA = A.SIFRA_POREZA
  join TBLPOREZ P on P.SIFRA_POREZA = coalesce(A.SIFRA_POREZ_IZLAZ, A.SIFRA_POREZA)
  where A.SIFRA_ROBE = :SIFRA_ROBE
  into :SIFRA_POREZ_IZLAZ, :STOPA_POREZ_IZLAZ, :LABEL_IZLAZ, :SIFRA_POREZ, :STOPA_POREZ, :LABEL;
  suspend;
end^

SET TERM ; ^



SET TERM ^ ;

create or alter procedure CENA_ARTIKLA_IZ_CENOVNIKA (
    SR integer,
    ID_CENOVNIK integer,
    DATUM date,
    IDCK integer)
returns (
    CENA decimal(18,4),
    CENOVNIK varchar(1),
    ID integer,
    AKCIJA smallint,
    VAZI_OD date,
    VAZI_DO date,
    RABAT decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    STARA_CENA decimal(18,2),
    CENAMP_SA_POPUSTOM decimal(18,2),
    CENASAPDV decimal(15,2))
as
declare variable IDC_OLD integer;
begin
    if(IDCK > 0)  then  ID_CENOVNIK = IDCK; /* ovo radi na osnovu cenovnika komitenta*/
   -- cena iz specijalnog cenovnika, za kupca ili ... vasno da je tip_cenovnika.id <> tip_cenovnika.id_cenovnik_old
   /* uzmi cenu iz akcijskog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            (A.id_cenovnika_old = :ID_CENOVNIK and a.id <> :ID_CENOVNIK ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or (:DATUM >= C.VAZI_OD and C.VAZI_DO is null))
            and a.aktivan = 1
            and a.id_tip_cenovnika = 3
            and a.vrsta_komitenta=1
      order by C.CENA

      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;
   if (CENA is null or CENA < 0 ) then
   begin
   -- happy hour
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            ( A.ID_CENOVNIKA_OLD = :ID_CENOVNIK or A.ID_CENOVNIKA_OLD = -1 ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
            and current_time between a.happy_od and a.happy_do
            and a.aktivan = 1
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;
   end

   if (CENA is null or CENA < 0 ) then
   begin
   -- ako nema cene u specijalnom cenovniku onda daj cenu iz lifleta ili bilo kog cenovnika koja vazi a najmanja je
   /* uzmi cenu iz posebnog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV ,
                     a.id_cenovnika_old
      from   TIP_CENOVNIKA A
      left join TBL_CENOVNIK C on C.ID_CENOVNIKA = A.ID
      and C.SIFRA_ROBE = :SR and

            (:DATUM between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
      where
            ( A.ID = :ID_CENOVNIK )
            and a.aktivan = 1
            and a.vrsta_komitenta=1
            and a.id_tip_cenovnika = 2
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV, :idc_old;
   end

   if (CENA is null or CENA <= 0 ) then
   begin

   if(idc_old is not null) then ID_CENOVNIK = idc_old;
          /* uzmi cenu iz osnovnog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            ( A.ID = :ID_CENOVNIK ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or (:DATUM >= C.VAZI_OD and C.VAZI_DO is null))
            and a.aktivan = 1
            and a.vrsta_komitenta=1
            and a.id_tip_cenovnika = 1
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;

    end

  begin
    if (cena is null or cena = 0 ) then
    begin
       select b.cenamp  from tblartikli b where b.sifra_robe = :sr into :cena;
    end
    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure KNJIGA_SANKA (
    DAT date,
    MG integer)
returns (
    KOD varchar(20),
    OPIS varchar(255),
    JM varchar(10),
    STANJE_PRS decimal(18,4),
    ULAZ decimal(18,4),
    UKUPNO decimal(18,4),
    IZLAZ decimal(18,4),
    VREDNOST decimal(18,4),
    CENA decimal(18,4),
    PR_STANJE decimal(18,4),
    STOPA integer,
    POREZ decimal(18,4),
    LAGER decimal(18,4),
    PODVRSTA varchar(100))
as
declare variable C_CENA integer;
declare variable T_CENA integer;
declare variable TIP_CENA integer;
declare variable ID_CENOVNIK integer;
declare variable CENOVNIK integer;
declare variable SR integer;
declare variable GODINA integer;
begin
        -- ako je cena_magacina=0 vuce cenu iz artikala
        -- ako je cena_magacina=1 vuce cenu iz tlokacije
        -- ako je cena_magacina=2 vuce cenu iz tbl_cenovnik
        godina = extract(year from :dat);
        select  m.cena_magacin,
                m.id_cenovnik,
                m.tip_cena
        from tblmagacin m
        where m.sifra_magacina = :mg
        into :cenovnik, :id_cenovnik, :tip_cena;
  for
  select distinct p.sifra_robe
  from tblnovcano n join tblpromene p on n.idnovcano = p.idnovcano
  join tblartikli a on p.sifra_robe = a.sifra_robe
  left join TBLKNJIGA_SANKA_GRUPA v on a.id_sank = v.id
  where  n.datumdpo between :dat-1 and :dat and n.sifra_magacina = :mg and a.kepu = 0
  order BY V.naziv
  into :sr
    do
  begin
select   a.kod,
              a.artikal, 
              m.naziv, 
              a.cenamp, 
              b.stopa1,
              l.kolicina,
              v.naziv as podvrsta,
      sum(p.ulaz_kol - p.izlaz_kol) as predhodno_stanje
      from tblnovcano n inner join tblpromene p on n.idnovcano = p.idnovcano
                  inner join tblartikli a on a.sifra_robe = p.sifra_robe
                  inner join tbljm m on a.idjm = m.id
                  inner join tblporez b on b.sifra_poreza = a.sifra_poreza
                  left join tlokacija l on a.sifra_robe = l.sifra_robe and l.sifra_magacina = n.sifra_magacina and l.godina=:godina
                  left join TBLKNJIGA_SANKA_GRUPA v on a.id_sank = v.id
      where -- n.datumdpo between cast('01/01/'||extract(year from :dat) as date) and :dat - 1
      extract(year from n.datumdpo) = :godina
      and n.datumdpo <= :dat - 1
      and a.sifra_robe = :sr
      and a.kepu = 0
      and n.sifra_magacina = :mg
      group by 1,2,3,4,5,6,7
      order BY V.naziv, A.artikal

       into  :kod , :opis, :jm, :cena, :stopa, :lager, :podvrsta, :pr_stanje  ;
       select a.kod, a.artikal, m.naziv, a.cenamp from tblartikli a join tbljm m on a.idpjm = m.id where a.sifra_robe = :sr into  :kod, :opis, :jm,  :cena;
  --    pr_stanje = 0; cena = 0;
     ulaz = 0; izlaz = 0; vrednost = 0; porez = 0;
     select sum(p.ulaz_kol),sum(p.izlaz_kol), sum(p.duguje), sum(p.porez)
     from tblnovcano n inner join  tblpromene p
                             on (n.idnovcano = p.idnovcano
                                 and p.sifra_robe = :sr
                                 and n.datumdpo = :dat and n.sifra_magacina = :mg)
                       inner join tblmagacin ma on
                         (ma.sifra_magacina = n.sifra_magacina
                          and ma.robno = 1 )
     into :ulaz, :izlaz, :vrednost, :porez;

     if(:cenovnik = 1)
     then
        begin
            select x.cena
            from tlokacija x
            where   x.sifra_magacina = :mg and
                    x.sifra_robe = :sr and
                    x.godina=extract(year from :DAT)
            into :T_cena;
        cena = :T_cena;
     end
     if(:cenovnik = 2)
     then
        begin
            select c.cena from cena_artikla_iz_cenovnika(:sr, :id_cenovnik, :dat, null) c
            into :c_cena;
            cena = :c_cena;
        end

     if (ulaz is null) then ulaz = 0;
     if (izlaz is null) then izlaz = 0;
     if(izlaz>0) then cena = :vrednost/:izlaz;
     if (pr_stanje is null) then pr_stanje = 0;
     if (ulaz is null) then ulaz = 0;
     if (izlaz is null) then izlaz = 0;
     if (stanje_prs is null) then stanje_prs = 0;
     stanje_prs = :pr_stanje + :ulaz - :izlaz;
     ukupno = :pr_stanje + ulaz;
     if(ulaz <>0 or izlaz<>0 or lager>0   )  then
     suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PRED_RABAT (
    SIFRA_ROBE integer,
    SM integer,
    SK integer,
    SIFRA_PROIZVODJACA integer)
returns (
    RABAT decimal(18,4),
    D_RABAT decimal(18,4),
    D_RABAT_KAT decimal(18,4))
as
declare variable PROIZVOD_RABAT decimal(18,4);
declare variable RABAT_PROIZ smallint;
declare variable KATEGORIJA_RABAT decimal(18,4);
declare variable RABAT_KAT smallint;
declare variable CENOVNIK_KOMITENTA integer;
declare variable TIP_MAGACINA integer;
declare variable AKCIJA integer;
declare variable IMA_RABAT integer;
declare variable AKCIJA_ART varchar(10);
declare variable ID_CENOVNIK integer;
declare variable SIFRA_KATEGORIJE integer;
begin

    CENOVNIK_KOMITENTA  = 0;

    select s.d_rabat from system s
     into :ima_rabat ;
   select m.tip,
   m.id_cenovnik
   from tblmagacin m
   where m.sifra_magacina = :sm
   into :tip_magacina , :id_cenovnik;

   select first 1 case when c.cenovnik = 'A' then 1 else 0 end as akcija
   from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, CURRENT_DATE, null) c
   into :akcija;

       select a.cenovnik,a.sifra_kategorije
       from tblartikli a
       WHERE a.sifra_robe = :SIFRA_ROBE
       into :akcija_art , :sifra_kategorije ;
--if (:ima_rabat = 1 and (:tip_magacina in (2,20)) or (:tip_magacina not in (2,20)) and (:akcija is distinct from 1 and :akcija_art is distinct from 'A') and :CENOVNIK_KOMITENTA <= 1) then zbog mixtrade
   if (:ima_rabat = 1 and  (:akcija is distinct from 1 and :akcija_art is distinct from 'A') and :CENOVNIK_KOMITENTA <= 1) then
    begin
        select r.rabat
        from TBLRABATI r


       -- left join tbl_cenovnik c on r.sifra_robe = c.sifra_robe
        WHERE ID_KOMITENTA=:sk
        AND  ID_PROIZVODJACA=:sifra_proizvodjaca
        into :d_rabat;

        SELECT S.RABAT
        FROM   TBLKOMITENTI K
        INNER JOIN TBLRABATI_GRUPE G ON G.ID=K.IDRABATKAT
        INNER JOIN TBLRABATI_GRUPE_STAVKE S ON G.ID=S.ID_KEY
        WHERE K.SIFRA_KOMITENTA=:sk
        AND S.ID_KATEGORIJE=:sifra_kategorije
        into :d_rabat_kat;

        SELECT case when k.rabat is null then 0
                    else k.rabat
               end as rabat
        FROM   TBLKOMITENTI K

        WHERE K.SIFRA_KOMITENTA=:sk 
        into :rabat ;

        if (:rabat is null) then  rabat = 0;
        if (:d_rabat is null) then  d_rabat = 0;
        if (:d_rabat_kat is null) then  d_rabat_kat = 0;
        rabat = :rabat + :d_rabat + :d_rabat_kat;

    end
        if (:rabat is null) then
            rabat = 0;

        if (:d_rabat is null) then
            d_rabat = 0;

        if (:d_rabat_kat is null) then
            d_rabat_kat = 0;
    if(:tip_magacina in (2,20)) then
    begin
        SELECT case when k.rabat is null then 0
                        else k.rabat
                   end as rabat
            FROM   TBLKOMITENTI K 
            WHERE K.SIFRA_KOMITENTA=:sk 
        into :rabat ;
    end
    if(:RABAT_PROIZ = 1 and :tip_magacina in (2,20)) then
    begin
        SELECT first 1 p.rabat
        FROM tblrabati_pro p

        WHERE   p.id_komitenta = :sk and
                p.id_proizvodjaca = :sifra_proizvodjaca
        INTO :PROIZVOD_RABAT;

        if(:PROIZVOD_RABAT is null) then
            PROIZVOD_RABAT = 0;

        rabat = :rabat + :PROIZVOD_RABAT;
    end

    if(:RABAT_KAT = 1 and :tip_magacina in (2,20)) then
    begin
        select first 1 K.RABAT
        from TBLRABATI_KAT K
        WHERE   ID_KOMITENTA=:SK and
                k.id_kategorije = :sifra_kategorije
        INTO :KATEGORIJA_RABAT;

        if(:KATEGORIJA_RABAT is null) then
            KATEGORIJA_RABAT = 0;

        rabat = :rabat + :KATEGORIJA_RABAT;
    end

    if (:akcija_art is not distinct from 'A') then
    begin
        rabat = 0; d_rabat = 0; d_rabat_kat = 0;
    end

    if(:CENOVNIK_KOMITENTA > 1) then
    begin
        rabat = 0; d_rabat = 0; d_rabat_kat = 0;
    end
  suspend;
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PRET_ARTIKLI_KOD (
    MG integer,
    KOL decimal(18,4),
    CODE varchar(255),
    KOD_ARTIKLA varchar(255),
    KATEG varchar(255),
    PROIZV varchar(255),
    IDCENOVNIKA integer,
    DATUM_F date,
    TIP_CENA integer)
returns (
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_POREZA integer,
    STOPA1 decimal(18,2),
    SIFRA_KATEGORIJE integer,
    KATEGORIJA_GRUPE varchar(50),
    SIFRA_PROIZVODJACA integer,
    PROIZVODJAC varchar(100),
    ARTIKAL varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    CENA decimal(18,4),
    UKUPNA_KOL decimal(18,4),
    KOLICINA decimal(18,4),
    REZERVISANO decimal(18,2),
    NAB_VREDNOST decimal(18,4),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    GARANCIJA integer,
    PLAN_CENA numeric(18,2),
    MARZA numeric(18,2),
    MARZA_MP decimal(18,2),
    NAB_CENA decimal(18,4),
    CENOVNIK varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA double precision,
    JED_MERE varchar(20),
    PROSECNA_CENA decimal(18,4),
    BARKOD varchar(20),
    KLASA integer,
    KOD_ROBE_KUPCA varchar(20),
    RABAT decimal(15,2),
    CENA_CENOVNIKA decimal(18,4),
    VALUTA decimal(15,4),
    NAB_CENA_DEV decimal(18,4),
    NAB_CENA_DEV_MG decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    AKCIJA_OD date,
    AKCIJA_DO date,
    TAKSA decimal(18,4),
    PROSECNA_CENA_DEV decimal(18,4),
    NAB_VREDNOST_DEV decimal(18,4),
    TIP_PRACENJA varchar(2),
    COLOR integer,
    KONTO varchar(15),
    KONTO_ART varchar(15),
    KONTO_KAT varchar(15),
    LAGER integer)
as
declare variable KONTO_MG varchar(15);
BEGIN
  select first 1 tip_cena, konto from tblmagacin where sifra_magacina=:mg into :tip_cena, :konto_mg;
  if (datum_f is null) then  datum_f = current_date;

  FOR
    SELECT  tblartikli.kod,
            tblartikli.sifra_robe,
            tblartikli.sifra_poreza,
            tblPorez.Stopa1,
            tblartikli.sifra_kategorije,
            tblvrstarobe.Kategorija_grupe,
            tblartikli.sifra_proizvodjaca,
            tblProizvodjac.Proizvodjac,
            tblartikli.ARTIKAL,
            tblartikli.cenavp,
            tblartikli.cenamp,
            tblartikli.Garancija,
            tblartikli.plan_cena,
            tblartikli.marza,
            tblartikli.marza_mp,
            tblartikli.nab_cena,
            tblartikli.cenovnik,
            tblartikli.tarifni_broj,
            tblartikli.tarifna_stopa,
            tblartikli.Nab_cena_dev,
            tblartikli.konto,
            coalesce(tblartikli.vodi_se_lager,0),
            tbljm.naziv,
            tblartikli.taksa,
            tblartikli.boja,
            tblvrstarobe.konto,
            tblbarkod.barkod

            FROM  tblartikli
            inner join tblProizvodjac on(tblartikli.sifra_proizvodjaca=tblProizvodjac.sifra_proizvodjaca)
            inner join tblvrstarobe   on(tblartikli.sifra_kategorije=tblvrstarobe.sifra_kategorije)
            inner join tblPorez       on(tblartikli.sifra_poreza=tblPorez.sifra_poreza)
            inner join tbljm          on(tblartikli.idjm=tbljm.id)
            left join tblbarkod       on(tblbarkod.sifra_robe = tblartikli.sifra_robe)

            WHERE
                    tblartikli.KOD = :kod_artikla

           ORDER BY tblvrstarobe.Kategorija_grupe, tblProizvodjac.Proizvodjac

    INTO :KOD,
         :SIFRA_ROBE,
         :SIFRA_POREZA,
         :STOPA1,
         :SIFRA_KATEGORIJE,
         :KATEGORIJA_GRUPE,
         :SIFRA_PROIZVODJACA,
         :PROIZVODJAC,
         :ARTIKAL,
         :CENAVP,
         :CENAMP,
         :GARANCIJA,
         :PLAN_CENA,
         :MARZA,
         :MARZA_MP,
         :NAB_CENA,
         :CENOVNIK,
         :TARIFNI_BROJ,
         :TARIFNA_STOPA,
         :NAB_CENA_DEV,
         :KONTO_ART,                -- dodao nesa 07.05.2011.
         :LAGER,
         :JED_MERE,
         :TAKSA,
         :COLOR,
         :KONTO_KAT,
         :BARKOD
  DO
  BEGIN

    KOLICINA=0; UKUPNA_KOL=0; REZERVISANO=0; CENA=0; NAB_VREDNOST=0; PROSECNA_CENA=0;

    SELECT Kolicina, Rezervisano, Cena, Nab_vrednost, Pros_cena, Nab_cena_dev
    FROM TLOKACIJA
    WHERE sifra_magacina=:mg and sifra_robe=:sifra_robe and godina = extract(year from :datum_f)
    INTO :KOLICINA, :REZERVISANO, :CENA, :NAB_VREDNOST, :PROSECNA_CENA, :NAB_CENA_DEV_MG;

    SELECT SUM(Kolicina)
    FROM TLOKACIJA
    WHERE sifra_robe=:sifra_robe
    INTO :UKUPNA_KOL;

    rabat=0;

    if(konto_art is not null) then      konto = konto_art;
    else if(konto_kat is not null) then konto = konto_kat;
    else if(konto_mg is not null) then  konto = konto_mg;

    if(idcenovnika = 0) then
        begin
           cena_cenovnika=cenamp;
        end
    else if(idcenovnika = 1) then
        begin
           cena_cenovnika=cenavp;
        end
    else if(idcenovnika > 1) then
        begin
           select  c.cena, c.rabat,  coalesce(c.akcijski_rabat,0), c.vazi_od, c.vazi_do
           from cena_artikla_iz_cenovnika(:sifra_robe, :idcenovnika, :datum_f, null) c
           into  :cenavp, :rabat,  :akcijski_rabat, :akcija_od, :akcija_do;

            cena_cenovnika=cenavp;
        end

    if(tip_cena = 1 AND kolicina <> 0 AND cena <> 0) then cena = cena/kolicina;

    if(kol > -1) then
        begin
          if(  KOLICINA>:kol) then
          SUSPEND;
        end
    else  SUSPEND;

  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PRET_ARTIKAL_KOD (
    MG integer,
    KOL decimal(18,4),
    CODE varchar(50),
    IDCENOVNIKA integer,
    DATUM_F date,
    TIP_CENA integer)
returns (
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_POREZA integer,
    STOPA1 decimal(18,2),
    SIFRA_KATEGORIJE integer,
    KATEGORIJA_GRUPE varchar(50),
    SIFRA_PROIZVODJACA integer,
    PROIZVODJAC varchar(100),
    ARTIKAL varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    CENA decimal(18,4),
    UKUPNA_KOL decimal(18,4),
    KOLICINA decimal(18,4),
    REZERVISANO decimal(18,2),
    NAB_VREDNOST decimal(18,4),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    GARANCIJA integer,
    PLAN_CENA numeric(18,2),
    MARZA numeric(18,2),
    MARZA_MP decimal(18,2),
    NAB_CENA decimal(18,4),
    CENOVNIK varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA double precision,
    JED_MERE varchar(20),
    PROSECNA_CENA decimal(18,4),
    BARKOD varchar(20),
    KLASA integer,
    KOD_ROBE_KUPCA varchar(20),
    RABAT decimal(15,2),
    CENA_CENOVNIKA decimal(18,4),
    VALUTA decimal(15,4),
    NAB_CENA_DEV decimal(18,4),
    NAB_CENA_DEV_MG decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    AKCIJA_OD date,
    AKCIJA_DO date,
    TAKSA decimal(18,4),
    PROSECNA_CENA_DEV decimal(18,4),
    NAB_VREDNOST_DEV decimal(18,4),
    TIP_PRACENJA varchar(2),
    COLOR integer,
    KONTO varchar(15),
    KONTO_ART varchar(15),
    KONTO_KAT varchar(15),
    LAGER integer,
    ID_GRUPE_CASSA integer,
    PROIZVODJAC_SKR varchar(10),
    BROJAC_PRISTUPA integer,
    BRUTO decimal(18,4),
    NETO decimal(18,4),
    ID_VALUTE integer,
    OPIS_CENE varchar(50))
as
declare variable U_CENOVNIKU integer;
declare variable KONTO_MG varchar(15);
begin
  select tip_cena, konto from tblmagacin where sifra_magacina=:mg into :tip_cena, :konto_mg;
  if (datum_f is null) then datum_f = current_date;
  for
    select  a.kod,
            a.sifra_robe,
            a.sifra_poreza,
            z.stopa1,
            a.sifra_kategorije,
            v.kategorija_grupe,
            a.sifra_proizvodjaca,
            p.proizvodjac,
            a.artikal,
            a.cenavp,
            a.cenamp,
            a.garancija,
            a.plan_cena,
            a.marza,
            a.marza_mp,
            a.nab_cena,
            a.cenovnik,
            a.tarifni_broj,
            a.tarifna_stopa,
            a.nab_cena_dev,
            a.konto,
            j.naziv,
            a.taksa,
            a.boja,
            coalesce(a.vodi_se_lager,0),
            v.konto,
            a.id_grupe_cassa,
            a.tip_pracenja,
            p.naziv_skr
            from tblartikli a join tblvrstarobe v   on (a.sifra_kategorije = v.sifra_kategorije)
                              join tblproizvodjac p on (a.sifra_proizvodjaca = p.sifra_proizvodjaca)
                              join tblporez z       on (a.sifra_poreza = z.sifra_poreza)
                              join tbljm j          on (a.idjm = j.id)
            where  (a.kod = substr(:CODE,1,20)) and a.aktivan=1
    into :kod,
         :sifra_robe,
         :sifra_poreza,
         :stopa1,
         :sifra_kategorije,
         :kategorija_grupe,
         :sifra_proizvodjaca,
         :proizvodjac,
         :artikal,
         :cenavp,
         :cenamp,
         :garancija,
         :plan_cena,
         :marza,
         :marza_mp,
         :nab_cena,
         :cenovnik,
         :tarifni_broj,
         :tarifna_stopa,
         :nab_cena_dev,
         :konto_art,                -- dodao nesa 07.05.2011.
         :jed_mere,
         :taksa,
         :color,
         :lager,                    -- nesa 20.05.2013
         :konto_kat,
         :id_grupe_cassa,
         :tip_pracenja,
         :proizvodjac_skr
  do
  begin

    rabat=0; kolicina=0; ukupna_kol=0; rezervisano=0; cena=0; nab_vrednost=0; prosecna_cena=0;
    akcijski_rabat=0; akcija_od=null; akcija_do=null; barkod=null;

    select first 1 barkod from tblbarkod b where b.sifra_robe = :sifra_robe into :barkod;

    select kolicina, rezervisano, cena, nab_vrednost, pros_cena, nab_cena_dev
    from tlokacija
    where sifra_magacina=:mg and sifra_robe=:sifra_robe and godina = EXTRACT(YEAR from :datum_f)
    into :kolicina, :rezervisano, :cena, :nab_vrednost, :prosecna_cena, :nab_cena_dev_mg;

    if(konto_art is not null) then      konto = konto_art;
    else if(konto_kat is not null) then konto = konto_kat;
    else if(konto_mg is not null) then  konto = konto_mg;

    if(idcenovnika = 0) then        cena_cenovnika=cenamp;
    else if(idcenovnika = 1) then   cena_cenovnika=cenavp;
    else if(idcenovnika > 1) then
        begin
           select c.cena, c.rabat, c.akcijski_rabat, c.vazi_od, c.vazi_do
           from cena_artikla_iz_cenovnika(:sifra_robe, :idcenovnika, :datum_f, null) c
           into :cenavp, :rabat, :akcijski_rabat, :akcija_od, :akcija_do;

            cena_cenovnika=cenavp;
        end

    if(tip_cena = 1 and kolicina <> 0) then cena = cena/kolicina;

    if(kol > -1) then begin if(  kolicina>:kol) then suspend; end
    else  suspend;

  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PRET_ARTIKLI_MP (
    MG integer,
    KOL decimal(18,4),
    CODE varchar(255),
    NAZIV_ARTIKLA varchar(255),
    KATEG varchar(255),
    PROIZV varchar(255),
    IDCENOVNIKA integer,
    DATUM_F date,
    TIP_CENA integer,
    KOM integer = null)
returns (
    ZAPREMINA decimal(18,4),
    BROJ_REZERVACIJE integer,
    ID_REZERVACIJE integer,
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_POREZA integer,
    STOPA1 decimal(18,2),
    SIFRA_KATEGORIJE integer,
    KATEGORIJA_GRUPE varchar(50),
    SIFRA_PROIZVODJACA integer,
    PROIZVODJAC varchar(100),
    ARTIKAL varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    CENA decimal(18,4),
    UKUPNA_KOL decimal(18,4),
    KOLICINA decimal(18,4),
    REZERVISANO decimal(18,2),
    NAB_VREDNOST decimal(18,4),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    GARANCIJA integer,
    PLAN_CENA numeric(18,2),
    MARZA numeric(18,2),
    MARZA_MP decimal(18,2),
    NAB_CENA decimal(18,4),
    CENOVNIK varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA double precision,
    JED_MERE varchar(20),
    PROSECNA_CENA decimal(18,4),
    BARKOD varchar(50),
    KLASA integer,
    KOD_ROBE_KUPCA varchar(20),
    RABAT decimal(15,2),
    CENA_CENOVNIKA decimal(18,4),
    VALUTA decimal(15,4),
    NAB_CENA_DEV decimal(18,4),
    NAB_CENA_DEV_MG decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    AKCIJA_OD date,
    AKCIJA_DO date,
    TAKSA decimal(18,4),
    PROSECNA_CENA_DEV decimal(18,4),
    NAB_VREDNOST_DEV decimal(18,4),
    TIP_PRACENJA varchar(2),
    KOL_SARZE decimal(18,4),
    BROJ_SERIJE varchar(30),
    ROK_TRAJANJA date,
    KOL_LAGER decimal(18,4),
    KOD_PR varchar(20),
    CENA_MAGACINA integer,
    ID_CENOVNIK integer,
    LAGER smallint,
    RASPOLOZIVO decimal(18,4),
    ODNOSPJM double precision,
    AKCIJA_OZNAKA varchar(1))
as
declare variable U_CENOVNIKU integer;
declare variable HP_TABELE integer;
declare variable RS_KORISNIK integer;
declare variable KOL_NEPOSLATO decimal(18,4);
declare variable KOD_BK varchar(20);
declare variable GODINA integer;
begin
--zpharm
  -- AKO JE CENA_MAGACINA=0 VUCE CENU IZ ARTIKALA
  -- AKO JE CENA_MAGACINA=1 VUCE CENU IZ TLOKACIJE
  -- AKO JE CENA_MAGACINA=2 VUCE CENU IZ TBL_CENOVNIK
  -- AKO JE KOMITENT VECI OD 0 GLEDA SAMO ARTIKLE REZERVISANE ZA TOG KOMITENTA
  -- PROSECNU CENU VUCE IZ TLOKACIJE A AKO JE TA CENA 0 ONDA VUCE POSLEDNJU NABAVNU CENU IZ CENA_ARTIKLA_MP
--    datum_f = null;
  if (DATUM_F is not null) then godina = extract(year from datum_f);
  else
    godina = (select first 1 godina from system);
    select first 1 H.RS_KORISNIK,
                   H.HP_TABELE
    from TBLHOST H
    into :RS_KORISNIK, :HP_TABELE;
    select M.CENA_MAGACIN,
           M.ID_CENOVNIK,
           M.TIP_CENA
    from TBLMAGACIN M
    where M.SIFRA_MAGACINA = :MG
    into :CENA_MAGACINA, :ID_CENOVNIK, :TIP_CENA;
    if (:CENA_MAGACINA = 2) then
      IDCENOVNIKA = :ID_CENOVNIK;


  if (:KOM < 0 or :KOM is null) then
  begin
 /*
    select A.KOD
    from ARTIKAL_PRONADJI(:NAZIV_ARTIKLA) A
    into :KOD_BK;
    if (:KOD_BK is not null) then
      CODE = :KOD_BK;
 */
if (CODE is not null) then
      begin
          select a.tmp_sifra
          from artikal_pronadji(:CODE)  a
          into :SIFRA_ROBE;
      end

        for select sifra from ARTIKAL_PRONADJI_ABP(:SIFRA_ROBE, :code,  :NAZIV_ARTIKLA)
            into :SIFRA_ROBE
        do
        begin
     for
     select TBLARTIKLI.KOD,
       TBLARTIKLI.SIFRA_ROBE,
       TBLARTIKLI.SIFRA_POREZA,
       TBLPOREZ.STOPA1,
       TBLARTIKLI.SIFRA_KATEGORIJE,
       TBLVRSTAROBE.KATEGORIJA_GRUPE,
       TBLARTIKLI.SIFRA_PROIZVODJACA,
       TBLPROIZVODJAC.PROIZVODJAC,
       TBLARTIKLI.ARTIKAL,
       TBLARTIKLI.CENAVP,
       TBLARTIKLI.CENAMP,
       TBLARTIKLI.GARANCIJA,
       TBLARTIKLI.PLAN_CENA,
       TBLARTIKLI.MARZA,
       TBLARTIKLI.MARZA_MP,
       TBLARTIKLI.NAB_CENA,
       TBLARTIKLI.CENOVNIK,
       TBLARTIKLI.TARIFNI_BROJ,
       TBLARTIKLI.TARIFNA_STOPA,
       TBLARTIKLI.NAB_CENA_DEV,
       TBLARTIKLI.ODNOSPJM,
       TBLJM.NAZIV,
       TBLARTIKLI.TIP_PRACENJA,
       coalesce(L.KOLICINA,0),
       coalesce(L.REZERVISANO,0),
       L.CENA,
       L.NAB_VREDNOST,
       L.NAB_VREDNOST_DEV,
       L.PROS_CENA,
       L.NAB_CENA_DEV,
       coalesce(S.KOL,0),
       S.BROJ_SERIJE,
       S.ROK_VAZENJA as DATUM,
       coalesce(L.KOLICINA,0),
       coalesce(l.hp_kol,0),
       TBLARTIKLI.KOD_PR,
       TBLARTIKLI.VODI_SE_LAGER,
       TBLARTIKLI.ZAPREMINA,
       TBLARTIKLI.CENOVNIK
from TBLARTIKLI
inner join TBLPROIZVODJAC on TBLARTIKLI.SIFRA_PROIZVODJACA = TBLPROIZVODJAC.SIFRA_PROIZVODJACA
inner join TBLVRSTAROBE on TBLARTIKLI.SIFRA_KATEGORIJE = TBLVRSTAROBE.SIFRA_KATEGORIJE
inner join TBLPOREZ on TBLARTIKLI.SIFRA_POREZA = TBLPOREZ.SIFRA_POREZA
inner join TBLJM on TBLARTIKLI.IDPJM = TBLJM.ID
left join TLOKACIJA L on (L.SIFRA_ROBE = TBLARTIKLI.SIFRA_ROBE and L.SIFRA_MAGACINA = :MG and L.GODINA = :godina)
left join TLOKACIJA_SARZA S on L.SIFRA_ROBE = S.SIFRA_ROBE and L.SIFRA_MAGACINA = S.SIFRA_MAGACINA
where TBLARTIKLI.sifra_robe = :SIFRA_ROBE

        order by TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC
        into :KOD, :SIFRA_ROBE, :SIFRA_POREZA, :STOPA1, :SIFRA_KATEGORIJE, :KATEGORIJA_GRUPE, :SIFRA_PROIZVODJACA,
             :PROIZVODJAC, :ARTIKAL, :CENAVP, :CENAMP, :GARANCIJA, :PLAN_CENA, :MARZA, :MARZA_MP, :NAB_CENA, :CENOVNIK,
             :TARIFNI_BROJ, :TARIFNA_STOPA, :NAB_CENA_DEV, :ODNOSPJM, :JED_MERE, :TIP_PRACENJA, :KOLICINA, :REZERVISANO,
             :CENA, :NAB_VREDNOST, :NAB_VREDNOST_DEV, :PROSECNA_CENA, :NAB_CENA_DEV_MG, :KOL_SARZE, :BROJ_SERIJE,
             :ROK_TRAJANJA, :KOL_LAGER,:KOL_NEPOSLATO, :KOD_PR, :LAGER, :ZAPREMINA, :AKCIJA_OZNAKA
       do
       begin



      if ((:PROSECNA_CENA = 0 or :PROSECNA_CENA is null)) then
      begin
        select first 1 C.PROS_CENA
        from CENA_ARTIKLA_MP(:SIFRA_ROBE,:MG, :godina, :DATUM_F, null ) C
        into PROSECNA_CENA;
      end

      if (:KOL_SARZE > 0) then
        KOLICINA = :KOL_SARZE;

      select sum(coalesce(KOLICINA,0)),
             sum(coalesce(KOLICINA,0) - coalesce(REZERVISANO,0) - coalesce(HP_KOL,0))
      from TLOKACIJA
      where SIFRA_ROBE = :SIFRA_ROBE and
            SIFRA_MAGACINA = :MG and
            GODINA = :godina
      into :UKUPNA_KOL, :RASPOLOZIVO;

      if (ukupna_kol is null ) then ukupna_kol = 0;
      if (RASPOLOZIVO is null ) then RASPOLOZIVO = 0;

      KOLICINA = KOLICINA - coalesce(:KOL_NEPOSLATO, 0);
      RABAT = 0;

      --**************************************  C E N E
      if (IDCENOVNIKA = 0) then
      begin
        CENA_CENOVNIKA = CENAMP;
      end
      else
      if (IDCENOVNIKA = 1) then
      begin
        CENA_CENOVNIKA = CENAVP;
      end
      else
      if (IDCENOVNIKA > 1) then
      begin
        CENA_CENOVNIKA = 0;
        select
               c.CENA,
               c.RABAT,
               c.AKCIJSKI_RABAT,
               c.vazi_OD,
               c.vazi_DO,
               C.cenovnik
        from cena_artikla_iz_cenovnika(:sifra_robe, :idcenovnika, :datum_f, null) c
        into  :CENA_CENOVNIKA, :RABAT, :AKCIJSKI_RABAT, :AKCIJA_OD, :AKCIJA_DO, :AKCIJA_OZNAKA;

        if (DATUM_F < AKCIJA_OD or AKCIJA_DO < DATUM_F) then
        begin
          AKCIJSKI_RABAT = 0;
          AKCIJA_OD = null;
          AKCIJA_DO = null;
        end

        if ((CENA is null or CENA = 0) and
            CENA_CENOVNIKA > 0) then
        begin
          CENA = CENA_CENOVNIKA;
        end
      end
      if (:CENA is null) then
      begin
        select A.CENAMP
        from TBLARTIKLI A
        where A.SIFRA_ROBE = :SIFRA_ROBE
        into :CENA;
      end
      if (CENA_CENOVNIKA is null or CENA_CENOVNIKA = 1) then
        CENA_CENOVNIKA = :CENA;
      select first 1 B.BARKOD
      from TBLBARKOD B
      where B.SIFRA_ROBE = :SIFRA_ROBE
      into :BARKOD;

      if (TIP_CENA = 1 and
          KOLICINA <> 0) then
        CENA = CENA / KOLICINA;
      if (KOL > -1) then
      begin
        if (:CENA is null and
            :CENAMP > 0) then
        begin
          CENA = :CENAMP;
        end
        if((select first 1 pib from tblhost) = '100871849') then
            cenamp = :cena;
        suspend;
      end

      else
        suspend;
    end
  end
  end

  --VRACANJE IZ REZERVACIJE
  else
  if (:KOM > 0) then
  begin

    for select A.KOD,
               A.SIFRA_ROBE,
               A.SIFRA_POREZA,
               TBLPOREZ.STOPA1,
               A.SIFRA_KATEGORIJE,
               TBLVRSTAROBE.KATEGORIJA_GRUPE,
               A.SIFRA_PROIZVODJACA,
               TBLPROIZVODJAC.PROIZVODJAC,
               A.ARTIKAL,
               A.CENAVP,
               A.CENAMP,
               A.GARANCIJA,
               A.PLAN_CENA,
               A.MARZA,
               A.MARZA_MP,
               A.NAB_CENA,
               A.CENOVNIK,
               A.TARIFNI_BROJ,
               A.TARIFNA_STOPA,
               A.NAB_CENA_DEV,
               A.ODNOSPJM,
               TBLJM.NAZIV,
               A.TIP_PRACENJA,
               RS.KOLICINA - coalesce(RS.OTPREMLJENO, 0),
               cast(0 as integer),
               L.CENA,
               L.NAB_VREDNOST,
               L.NAB_VREDNOST_DEV,
               L.PROS_CENA,
               L.NAB_CENA_DEV,
               S.KOL,
               S.BROJ_SERIJE,
               S.DATUM,
               RS.KOLICINA,
               A.KOD_PR,
               A.VODI_SE_LAGER,
               R.IDREZERVACIJE,
               R.BROJ_REZERVACIJE,
               A.ZAPREMINA
        from TBLREZERVACIJA R
        inner join TBLREZERVACIJASASTAV RS on RS.IDREZERVACIJE = R.IDREZERVACIJE
        inner join TBLARTIKLI A on A.SIFRA_ROBE = RS.SIFRA_ROBE and A.AKTIVAN = 1
        inner join TBLPROIZVODJAC on A.SIFRA_PROIZVODJACA = TBLPROIZVODJAC.SIFRA_PROIZVODJACA
        inner join TBLVRSTAROBE on A.SIFRA_KATEGORIJE = TBLVRSTAROBE.SIFRA_KATEGORIJE
        inner join TBLPOREZ on A.SIFRA_POREZA = TBLPOREZ.SIFRA_POREZA
        inner join TBLJM on A.IDPJM = TBLJM.ID
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = :MG and L.GODINA = :godina)
        left join TLOKACIJA_SARZA S on L.IDLOKACIJA = S.IDLOKACIJA
        where R.SIFRA_KOMITENTA = :KOM and
              (R.ID_STATUSA in (200, 201, 202) or R.ID_STATUSA is null) and
              (RS.KOLICINA - coalesce(RS.OTPREMLJENO, 0) > 0) and
              (A.KOD containing :CODE or (upper(cast(A.ARTIKAL as varchar(255) character set WIN1250)) containing upper(cast(:NAZIV_ARTIKLA as varchar(255) character set WIN1250)) ) )
        order by TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC
        into :KOD, :SIFRA_ROBE, :SIFRA_POREZA, :STOPA1, :SIFRA_KATEGORIJE, :KATEGORIJA_GRUPE, :SIFRA_PROIZVODJACA,
             :PROIZVODJAC, :ARTIKAL, :CENAVP, :CENAMP, :GARANCIJA, :PLAN_CENA, :MARZA, :MARZA_MP, :NAB_CENA, :CENOVNIK,
             :TARIFNI_BROJ, :TARIFNA_STOPA, :NAB_CENA_DEV, :ODNOSPJM, :JED_MERE, :TIP_PRACENJA, :KOLICINA, :REZERVISANO,
             :CENA, :NAB_VREDNOST, :NAB_VREDNOST_DEV, :PROSECNA_CENA, :NAB_CENA_DEV_MG, :KOL_SARZE, :BROJ_SERIJE,
             :ROK_TRAJANJA, :KOL_LAGER, :KOD_PR, :LAGER, :ID_REZERVACIJE, :BROJ_REZERVACIJE, :ZAPREMINA
    do
    begin

      if (:KOL_SARZE > 0) then
        KOLICINA = :KOL_SARZE;

      select sum(coalesce(KOLICINA,0)) --, SUM(KOLICINA - REZERVISANO)
      from TLOKACIJA
      where SIFRA_ROBE = :SIFRA_ROBE and
            SIFRA_MAGACINA = :MG and
            GODINA = :godina
      into :UKUPNA_KOL;--, :REZERVISANO;

      RABAT = 0;
      -- AKO JE :CENOVNIK=0 VUCE CENU IZ ARTIKALA
      -- AKO JE :CENOVNIK=1 VUCE CENU IZ TLOKACIJE
      -- AKO JE :CENOVNIK=2 VUCE CENU IZ TBL_CENOVNIK
      if (:IDCENOVNIKA = 0) then
      begin
        CENA = :CENAMP;
        CENA_CENOVNIKA = :CENAMP;
      end
      if (:IDCENOVNIKA = 2) then
      begin
        select c.cena, c.cenovnik
        from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum_f, null) c
        into :CENA_CENOVNIKA, :CENOVNIK;
      end
      if (:IDCENOVNIKA = 2 and
          :CENA_CENOVNIKA is not null) then
        CENA = :CENA_CENOVNIKA;
      if (:IDCENOVNIKA = 2 and
          :CENAMP is not null and
          :CENA_CENOVNIKA is null and
          :CENAMP > 0) then
        CENA = :CENAMP;
      if (:IDCENOVNIKA = 1 and
          (:CENA is null or :CENA = 0)) then
      begin
        if (:CENAMP is not null or :CENAMP > 0) then
          CENA = :CENAMP;
        else
        if (:CENA_CENOVNIKA is not null or :CENA_CENOVNIKA > 0) then
          CENA = :CENA_CENOVNIKA;
      end
      else
      if (:IDCENOVNIKA = 1) then
        CENA_CENOVNIKA = :CENA;
      select first 1 B.BARKOD
      from TBLBARKOD B
      where B.SIFRA_ROBE = :SIFRA_ROBE
      into :BARKOD;
      if (KOL > -1) then
      begin
        --      IF ((KOLICINA > :KOL AND
        --          KOL_SARZE IS NULL) OR (KOL_SARZE > 0 AND
        --          KOL_LAGER > 0)) THEN
        suspend;
      end
      else
        suspend;
    end
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_LAGER1 (
    MG integer,
    GODINA integer,
    NULE integer = null)
returns (
    FAKTURNA_CENA decimal(18,4),
    SIFRA_ROBE integer,
    POREZ decimal(15,2),
    KOD varchar(20),
    SIFRA_PROIZVODJACA integer,
    SIFRA_KATEGORIJE integer,
    ARTIKAL varchar(255),
    LOKALNI_NAZIV varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOD_PR varchar(20),
    CENA decimal(18,2),
    IDLOKACIJA integer,
    STANJE_LAGERA decimal(18,3),
    KOLICINA numeric(18,3),
    PRODATA_KOLICINA decimal(18,3),
    PROS_CENA decimal(18,4),
    PROIZVODJAC varchar(100),
    NAZIV varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    DATUMMP date,
    MAGACIN varchar(50),
    CENA_MAGACIN smallint,
    CENA_LAGERA decimal(18,4),
    VREDNOST_LAGERA numeric(18,7),
    SKLADISNI_PROSTOR varchar(20),
    CENAMP_SA_POPUSTOM decimal(18,2),
    REZERVISANO numeric(18,4),
    BARKOD varchar(50),
    PODKATEGORIJA varchar(100))
as
declare variable KOLICINA_TMP decimal(18,3);
declare variable GOD integer;
declare variable RS_KORISNIK integer;
declare variable APOTEKA integer;
BEGIN
    select  first 1 godina,
            coalesce(apoteka,0)
    from system
        into :god, :apoteka;

    select first 1  coalesce(rs_korisnik,0)
    from tblhost
        into :rs_korisnik;

    rs_korisnik = 1;

  FOR
    SELECT 
        TBLARTIKLI.SIFRA_ROBE,
        TBLARTIKLI.KOD,
        TBLARTIKLI.SIFRA_PROIZVODJACA,
        TBLARTIKLI.SIFRA_KATEGORIJE,
        TBLARTIKLI.ARTIKAL,
        TBLARTIKLI.LOKALNI_NAZIV,
        TBLARTIKLI.CENAVP,
        TBLARTIKLI.CENAMP,
        TBLARTIKLI.kod_pr,
        TLOKACIJA.CENA,
        TLOKACIJA.IDLOKACIJA,
        TLOKACIJA.KOLICINA as stanje_lagera,
        TLOKACIJA.PROS_CENA,
        TLOKACIJA.POREZ,
        coalesce(tlokacija.hp_kol,0),
        TBLPROIZVODJAC.PROIZVODJAC,
        TBLJM.NAZIV,
        TBLVRSTAROBE.KATEGORIJA_GRUPE,
        TBLARTIKLI.DATUMMP,
        TBLMAGACIN.MAGACIN,
        TBLMAGACIN.CENA_MAGACIN,
        CASE
         WHEN TBLMAGACIN.CENA_MAGACIN = 1 THEN TLOKACIJA.CENA
         when tblmagacin.cena_magacin = 2 and :GODINA = :god  then coalesce((select c.cena
                                                                    from cena_artikla_iz_cenovnika(TBLARTIKLI.SIFRA_ROBE, TBLMAGACIN.ID_CENOVNIK, current_date, null) C),
                                                                    tblartikli.cenamp)
         when tblmagacin.cena_magacin = 2 and :GODINA <> :god then coalesce(TLOKACIJA.CENA ,tblartikli.cenamp)
         ELSE TBLARTIKLI.CENAMP
        END AS CENA_LAGERA ,
        TLOKACIJA.SKLADISNI_PROSTOR , tblartikli.CENAMP_SA_POPUSTOM, coalesce(TLOKACIJA.rezervisano ,0) ,
        tblpodvrstarobe.naziv
    FROM TBLARTIKLI
       INNER JOIN TLOKACIJA         ON (TBLARTIKLI.SIFRA_ROBE           = TLOKACIJA.SIFRA_ROBE and
                                        TLOKACIJA.godina                = :godina)
       INNER JOIN TBLMAGACIN        ON (TLOKACIJA.SIFRA_MAGACINA        = TBLMAGACIN.SIFRA_MAGACINA)
       INNER JOIN TBLPROIZVODJAC    ON (TBLARTIKLI.SIFRA_PROIZVODJACA   = TBLPROIZVODJAC.SIFRA_PROIZVODJACA)
       INNER JOIN TBLVRSTAROBE      ON (TBLARTIKLI.SIFRA_KATEGORIJE     = TBLVRSTAROBE.SIFRA_KATEGORIJE)
       LEFT OUTER JOIN TBLJM        ON (TBLARTIKLI.IDJM                 = TBLJM.ID)
       left join tblpodvrstarobe    on (tblartikli.id_podkategorije     = tblpodvrstarobe.id)
       , TBLHOST H
    WHERE 
       (( TLOKACIJA.SIFRA_MAGACINA  = :MG ) AND
       (TLOKACIJA.KOLICINA          >0 or (:NULE = 1) )       AND
       H.idhost                     = 1
       )
    ORDER BY TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC, TBLARTIKLI.ARTIKAL
    INTO :SIFRA_ROBE,
         :KOD,
         :SIFRA_PROIZVODJACA,
         :SIFRA_KATEGORIJE,
         :ARTIKAL,
         :LOKALNI_NAZIV,
         :CENAVP,
         :CENAMP,
         :KOD_PR,
         :CENA,
         :IDLOKACIJA,
         :STANJE_LAGERA,
         :PROS_CENA,
         :POREZ,
         :kolicina_tmp,
         :PROIZVODJAC,
         :NAZIV,
         :KATEGORIJA_GRUPE,
         :DATUMMP,
         :MAGACIN,
         :CENA_MAGACIN,
         :CENA_LAGERA,
         :SKLADISNI_PROSTOR ,
         :CENAMP_SA_POPUSTOM ,
         :rezervisano,
         :PODKATEGORIJA
  DO
  BEGIN
    -----------------------------------------------------------------------------------------------------


             -- prodata a neprebacena kolicina za artikle koji se trose kroz noramtiv
             select
                sum(o.kolicina * n.kolicina)
             from prteh p
             join prtehproces c on p.id = c.id_prteh
             join prnormativ n on c.id = n.id_tehproces
             join hp_obracun o on o.sifra_robe = p.sifra_proizvoda
             join mp_fisk_z z on o.idzg = z.idz
             inner join tblhost h on h.rs_korisnik = 1
            
             where   n.sifra_materijala             = :SIFRA_ROBE
                     and  p.sifra_magacina          = :mg
                     and o.poslatouknjigovodstvo    = 'N'
                     AND z.fiskal_pusten            > 0
                     and extract(year from o.datum) = (:god)
             into :prodata_kolicina;

            if (:prodata_kolicina is  null ) then
                prodata_kolicina = 0;
    ---------------------------------------------------------------------------------------------------

    PRODATA_KOLICINA    = :prodata_kolicina + :kolicina_tmp + :rezervisano;
    FAKTURNA_CENA       = (select
                                 C.CENA
                             from
                                 PROC_MP_CENA_ARTIKLA(:sifra_robe, :MG, -1, 'now') C);
    kolicina            = :STANJE_LAGERA - :PRODATA_KOLICINA;
    vrednost_lagera     = CENA_LAGERA * :STANJE_LAGERA;
    
    if ( cenamp = 0 or cenamp is null or  cena_lagera = 0 or cena_lagera is null ) then
        select  ls.cena as cenamp,
                ls.cena as cena_lagera,
                ls.cena * ls.kolicina as vrednost_lagera
        from tlokacija ls
        where   ls.sifra_robe       = :sifra_robe and
                ls.sifra_magacina   = :mg and
                ls.godina           = :godina
        into :cenamp, :cena_lagera, :vrednost_lagera;
    select first 1 barkod from tblbarkod where sifra_robe = :sifra_robe into :barkod;
    SUSPEND;
    barkod = null;
    END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure WEB_LAGER_SVI_ARTIKLI (
    ID_CENOVNIKA integer,
    DATUM date)
returns (
    KOD varchar(20),
    SIFRA_ROBE integer,
    ARTIKAL varchar(255),
    LOKALNI_NAZIV varchar(255),
    SIFRA_PROIZVODJACA integer,
    SIFRA_KATEGORIJE integer,
    ID_PODKATEGORIJE integer,
    CENA decimal(18,2),
    CENOVNIK varchar(1),
    IDC integer,
    RABAT decimal(18,2),
    STARA_CENA decimal(18,2),
    KOLICINA decimal(18,4),
    REZERVISANO decimal(15,2),
    KATEGORIJA_GRUPE varchar(255),
    PROIZVODJAC varchar(255),
    BARKOD varchar(255))
as
begin
  if (:DATUM is null) then
    DATUM = current_date;
  for select A.KOD,
             A.SIFRA_ROBE,
             A.ARTIKAL,
             A.LOKALNI_NAZIV,
             A.SIFRA_PROIZVODJACA,
             A.SIFRA_KATEGORIJE,
             A.ID_PODKATEGORIJE,
             sum(L.REZERVISANO),
             V.KATEGORIJA_GRUPE,
             P.PROIZVODJAC,
             (select first 1 B.BARKOD
              from TBLBARKOD B
              where B.SIFRA_ROBE = A.SIFRA_ROBE) as BARKOD,
             sum(L.KOLICINA)
      from TLOKACIJA L
      join TBLMAGACIN M on L.SIFRA_MAGACINA = M.SIFRA_MAGACINA
      join TBLARTIKLI A on L.SIFRA_ROBE = A.SIFRA_ROBE
      join TBLVRSTAROBE V on A.SIFRA_KATEGORIJE = V.SIFRA_KATEGORIJE
      join TBLPROIZVODJAC P on A.SIFRA_PROIZVODJACA = P.SIFRA_PROIZVODJACA
      where M.WEB_LAGER = 1 and
            A.WEB_B2C = 1 and
            L.KOLICINA > 0
      group by A.KOD, A.SIFRA_ROBE, A.ARTIKAL, A.LOKALNI_NAZIV, A.SIFRA_PROIZVODJACA, A.SIFRA_KATEGORIJE, A.ID_PODKATEGORIJE, V.KATEGORIJA_GRUPE, P.PROIZVODJAC, BARKOD
      into :KOD, :SIFRA_ROBE, :ARTIKAL, :LOKALNI_NAZIV, :SIFRA_PROIZVODJACA, :SIFRA_KATEGORIJE, :ID_PODKATEGORIJE,
           :REZERVISANO, :KATEGORIJA_GRUPE, :PROIZVODJAC, :BARKOD, :KOLICINA
  do
  begin
    select C.CENA,
           C.CENOVNIK,
           C.ID as IDC,
           C.RABAT,
           C.STARA_CENA
    from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIKA, :DATUM, null) C
    into :CENA, :CENOVNIK, :IDC, :RABAT, :STARA_CENA;
    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :mag, :DATUM, null) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :MAG, :DATUM, null) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select min(G.cena)
          from TBL_CENOVNIK G
          where g.id_cenovnika = :prijem   and
          g.sifra_robe = :sifra_robe --and
    --      (:DATUM between g.VAZI_OD and g.VAZI_DO or (:datum >= g.vazi_od and  g.VAZI_DO is null) )
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and
              A.DATE_CHANGE >= :DATUM) or (M.CENA_MAGACIN = 2 and
              (( cast(C.DATE_CHANGE as date) = :DATUM and (:datum between c.vazi_od and c.vazi_do or (:datum >= c.vazi_od and c.vazi_do is null) )  ) or :datum = c.vazi_od) )
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM, null) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_ULAZ_CENA (
    SIFRA_ROBE integer,
    SIFRA_KOMITENTA integer,
    DATUM date,
    SIFRA_MAGACINA integer)
returns (
    CENA_CENOVNIK decimal(18,4),
    CENA_SA_PDV_CENOVNIK decimal(18,4),
    POSLEDNJA_NAB_CENA decimal(18,4),
    NAB_CENA decimal(18,4),
    CENA decimal(18,4))
as
begin
  select c.cena , c.cenasapdv
  from
  cena_artikla_iz_cenovnika(:sifra_robe, (select t.id from tip_cenovnika t where t.sifra_komitenta = :sifra_komitenta), :datum, null) c
  into :cena_cenovnik, cena_sa_pdv_cenovnik  ;

  select first 1 p.ulaz_cena
  from tblnovcano n join tblpromene p on n.idnovcano = p.idnovcano
  where n.datumdpo <= :datum
  and p.sifra_robe = :sifra_robe
  and n.sifra_komitenta = :sifra_komitenta
  order by n.datumdpo desc
  into :poslednja_nab_cena;

  select a.nab_cena
  from tblartikli a
  where a.sifra_robe = :sifra_robe
  into :nab_cena;

  if (cena_cenovnik > 0) then
    cena = :cena_cenovnik ;
  else if (poslednja_nab_cena > 0) then
    cena = :poslednja_nab_cena ;
  else if (nab_cena > 0) then
    cena = :nab_cena;
  suspend;
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_MP_PORUCIVANJE (
    SM integer,
    KOL decimal(18,3),
    SK integer,
    KODART varchar(50),
    GODINA integer)
returns (
    KATEGORIJA_GRUPE varchar(50),
    RASPOLOZIVO decimal(18,4),
    PROIZVODJAC varchar(100),
    SIFRA_ROBE integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    CENAMP decimal(18,4),
    CENAVP decimal(18,4),
    SIFRA_POREZA integer,
    IDJM smallint,
    KOLICINA decimal(18,3),
    CENA decimal(18,4),
    SLIKA smallint,
    REZERVISANO decimal(18,2),
    STOPA decimal(18,2),
    JED_MERE varchar(20),
    IMA_RABAT integer,
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    D_RABAT decimal(18,4),
    D_RABAT_KAT decimal(18,4),
    RABAT decimal(18,4),
    TIP_MAGACINA integer,
    CENA_SA_PDV decimal(18,4),
    AKCIJA integer,
    AKCIJA_ART varchar(1),
    BARKOD varchar(50),
    PROSECNA_CENA decimal(18,4))
as
declare variable USE_ONLY_BARCODE smallint;
declare variable ARTICAL_NAME varchar(50);
declare variable PROIZVOD_RABAT decimal(18,4);
declare variable RABAT_PROIZ smallint;
declare variable KATEGORIJA_RABAT decimal(18,4);
declare variable RABAT_KAT smallint;
declare variable TODAY date;
declare variable CENOVNIK_KOMITENTA integer;
declare variable ID_CENOVNIKA_KOMITENT integer;
declare variable TMP_SIFRA integer;
declare variable TMP_BARKOD varchar(20);
declare variable CENA_MAGACINA integer;
BEGIN
  select first 1 b.SIFRA_ROBE, b.barkod
  from TBLBARKOD B
  where B.BARKOD = :KODART
  into :TMP_SIFRA, :TMP_BARKOD;

  select id_cenovnika
  from tblkomitenti
  where sifra_komitenta = :SK
  into :ID_CENOVNIKA_KOMITENT;

  select cast('Now' as Date) from rdb$database
  into :TODAY;

  select RABAT_PO_KATEGORIJI,RABAT_PO_PROIZVODJACU from system_mp
  into :RABAT_KAT,RABAT_PROIZ;

  select s.d_rabat from system s
  into :ima_rabat;

  select sm.search_only_barcode from system_mp sm
  into :use_only_barcode;

  artical_name = :KODART;

  if(:use_only_barcode = 1) then
    artical_name = null;



For
    select  v.kategorija_grupe,
            p.proizvodjac,
            a.sifra_robe,
            a.kod,
            a.artikal,
            a.cenamp,
            a.cenavp,
            a.sifra_poreza,
            a.idjm,
            coalesce(l.kolicina,0),
            case when m.cena_magacin = 0 and m.tip in (2,20) then a.cenamp
                 when m.cena_magacin = 0 and m.tip not in (2,20) then a.cenavp
                 when m.cena_magacin = 1 then l.cena
                 when m.cena_magacin = 2 then c.cena
            end as cena,
            a.slika,
            l.rezervisano,
            r.stopa1 as stopa,
            j.naziv as jed_mere,
            p.sifra_proizvodjaca,
            v.sifra_kategorije,
            m.tip,
            c.akcija ,
            a.cenovnik,
            l.pros_cena,
            (l.kolicina - l.rezervisano) as raspolozivo,
            m.cena_magacin
    
    from tblartikli a
    
    inner join tblvrstarobe     v on (a.sifra_kategorije = v.sifra_kategorije)
    inner join tblporez         r on (a.sifra_poreza = r.sifra_poreza)
    inner join tbljm            j on (j.id = a.idjm)
    inner join tblmagacin       m on (m.sifra_magacina = :sm)
    inner join tblproizvodjac   p on (a.sifra_proizvodjaca = p.sifra_proizvodjaca)
    left join tbl_cenovnik      c on (c.sifra_robe = a.sifra_robe and m.id_cenovnik = c.id_cenovnika) and ((C.VAZI_DO is null and
            :TODAY >= C.VAZI_OD) or :TODAY between C.VAZI_OD and C.VAZI_DO)
    left join tlokacija         l on (a.sifra_robe = l.sifra_robe and l.sifra_magacina =:sm and l.kolicina >:kol and l.godina = :godina)
    
    where  a.web = 1
            and
             (
                    upper(a.KOD) containing upper(substr( :KODart,1,20))
                    OR
                    upper(a.ARTIKAL)  containing upper(:artical_name)
                    or
                    a.sifra_robe = :tmp_sifra
               )
    order by v.sortiranje, p.proizvodjac, a.artikal, a.kod
    INTO :KATEGORIJA_GRUPE,
         :PROIZVODJAC,
         :SIFRA_ROBE,
         :KOD,
         :ARTIKAL,
         :CENAMP,
         :CENAVP,
         :SIFRA_POREZA,
         :IDJM,
         :KOLICINA,
         :CENA,
         :SLIKA,
         :REZERVISANO,
         :STOPA,
         :JED_MERE,
         :sifra_proizvodjaca, 
         :sifra_kategorije,
         :tip_magacina,
         :akcija ,
         :akcija_art,
         :prosecna_cena,
         :raspolozivo,
         :CENA_MAGACINA
  DO
  BEGIN
    CENOVNIK_KOMITENTA  = 0;
    RABAT               = 0;
    PROIZVOD_RABAT      = 0;
    KATEGORIJA_RABAT    = 0;
    if (:tip_magacina in (2,20)) then
    begin
        cena_sa_pdv = :cena ;
        cena = cast(:cena/(1 + :stopa/100.00) as decimal(18,4)) ;
    end
    else
    begin
       cena_sa_pdv = :cena * (100.00 + :stopa)/100.00;
    end
    if(:ID_CENOVNIKA_KOMITENT > 1 and :CENA_MAGACINA = 0 and :tip_magacina not in (2,20) ) then

        select first 1
        c.cena as cenamp,
        c.cena as cena,
        c.cena * (100.00 + :stopa)/100.00 as cena_sa_pdv,
        c.id
        from cena_artikla_iz_cenovnika(:sifra_robe, :ID_CENOVNIKA_KOMITENT, :TODAY, null) c
        order by c.id desc

        into :cenamp, :cena, :cena_sa_pdv,:CENOVNIK_KOMITENTA;

    if (:ima_rabat = 1 and (:tip_magacina not in (2,20)) and (:akcija is distinct from 1 and :akcija_art is distinct from 'A') and :CENOVNIK_KOMITENTA < 1) then
    begin
        select r.rabat
        from TBLRABATI r
        WHERE ID_KOMITENTA=:sk
        AND  ID_PROIZVODJACA=:sifra_proizvodjaca
        into :d_rabat;

        SELECT S.RABAT
        FROM   TBLKOMITENTI K
        INNER JOIN TBLRABATI_GRUPE G ON G.ID=K.IDRABATKAT
        INNER JOIN TBLRABATI_GRUPE_STAVKE S ON G.ID=S.ID_KEY
        WHERE K.SIFRA_KOMITENTA=:sk
        AND S.ID_KATEGORIJE=:sifra_kategorije
        into :d_rabat_kat;

        SELECT case when k.rabat is null then 0
                    else k.rabat
               end as rabat
        FROM   TBLKOMITENTI K 
        WHERE K.SIFRA_KOMITENTA=:sk 
        into :rabat ;

        if (:rabat is null) then  rabat = 0;
        if (:d_rabat is null) then  d_rabat = 0;
        if (:d_rabat_kat is null) then  d_rabat_kat = 0;
        rabat = :rabat + :d_rabat + :d_rabat_kat;

    end
        if (:rabat is null) then
            rabat = 0;

        if (:d_rabat is null) then
            d_rabat = 0;

        if (:d_rabat_kat is null) then
            d_rabat_kat = 0;
    if(:tip_magacina not in (2,20)) then
    begin
        SELECT case when k.rabat is null then 0
                        else k.rabat
                   end as rabat
            FROM   TBLKOMITENTI K 
            WHERE K.SIFRA_KOMITENTA=:sk 
        into :rabat ;
    end
    if(:RABAT_PROIZ = 1 and :tip_magacina not in (2,20)) then
    begin
        SELECT first 1 p.rabat
        FROM tblrabati_pro p

        WHERE   p.id_komitenta = :sk and
                p.id_proizvodjaca = :sifra_proizvodjaca
        INTO :PROIZVOD_RABAT;

        if(:PROIZVOD_RABAT is null) then
            PROIZVOD_RABAT = 0;

        rabat = :rabat + :PROIZVOD_RABAT;
    end

    if(:RABAT_KAT = 1 and :tip_magacina not in (2,20)) then
    begin
        select first 1 K.RABAT
        from TBLRABATI_KAT K
        WHERE   ID_KOMITENTA=:SK and
                k.id_kategorije = :sifra_kategorije
        INTO :KATEGORIJA_RABAT;

        if(:KATEGORIJA_RABAT is null) then
            KATEGORIJA_RABAT = 0;

        rabat = :rabat + :KATEGORIJA_RABAT;
    end

    if (:akcija_art is not distinct from 'A') then
    begin
        rabat = 0; d_rabat = 0; d_rabat_kat = 0;
    end

    if(:CENOVNIK_KOMITENTA > 1) then
    begin
        rabat = 0; d_rabat = 0; d_rabat_kat = 0;
    end

    if ( (cenamp = 0 or cena = 0) or ( cenamp is null or (cena is null) )  ) then
        select
        a.cenamp as cenamp,
        cast(a.cenamp/(1 + :stopa/100.00) as decimal(18,4)) as cena,
        a.cenamp as cena_sa_pdv

        from tblartikli a
        where (a.sifra_robe = :sifra_robe)
        --and ls.sifra_magacina = :sm
        --and ls.godina = :GODINA
        into :cenamp, :cena, :cena_sa_pdv;

    if ( (cenamp = 0 or cena = 0) or ( cenamp is null or (cena is null) )  ) then
        select
        ls.cena as cenamp,
        cast(ls.cena/(1 + :stopa/100.00) as decimal(18,4)) as cena,
        ls.cena as cena_sa_pdv
        from tlokacija ls
        join tblartikli la on la.sifra_robe = ls.sifra_robe
        where (la.sifra_robe = :sifra_robe)
        and ls.sifra_magacina = :sm
        and ls.godina = :GODINA
        into :cenamp, :cena, :cena_sa_pdv;

    if (KOLICINA > kol) then
    begin
        if (:sifra_robe = :tmp_sifra ) then barkod = tmp_barkod;
        else barkod = null;
     SUSPEND;
    end
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_DOCD (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer,
    IDC integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  if (IDC is not null and
      IDC <> ID_CENOVNIK) then
    ID_CENOVNIK = IDC;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              (N.DATUMDPO = :DATUM or :DATUM = current_date) and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (IDC is not null) then
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDC, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :AKCIJA_OZNAKA;
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        if (IDC is not null) then
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENOVNIK
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDC, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :AKCIJA_OZNAKA;
        end
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        if (IDC is not null) then
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENOVNIK
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDC, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :AKCIJA_OZNAKA;
        end
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, NULl) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               C.AKCIJA_OD,
               C.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBL_CENOVNIK C on M.ID_CENOVNIK = C.ID_CENOVNIKA and C.SIFRA_ROBE = A.SIFRA_ROBE
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :AKCIJA_OZNAKA;
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               C.CENA,
               C.CENA as CENAMPKURS,
               case
                 when CK.CENASAPDV = 1 then round(C.CENA / (1 + P.STOPA1 / 100.00), 2)
                 else C.CENA
               end as CENAVP,
               C.CENA as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               C.STARA_CENA,
               C.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        join TBL_CENOVNIK C on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        join TIP_CENOVNIKA CK on C.ID_CENOVNIKA = CK.ID
        join TBLPOREZ P on A.SIFRA_POREZA = P.SIFRA_POREZA
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM, null) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure CENA_ARTIKLA_MP_ZA_NIVELACIJE (
    IDCENONIKA integer,
    SR integer)
returns (
    CENA decimal(18,4))
as
begin
  for /*

    SELECT
         CASE
           WHEN C.CENA > 0 THEN C.CENA
           ELSE A.CENAMP
         END AS CENA
     FROM
         TBLARTIKLI A
     LEFT JOIN TBL_CENOVNIK C ON C.SIFRA_ROBE = A.SIFRA_ROBE AND C.ID_CENOVNIKA = :IDCENONIKA
     WHERE
         A.SIFRA_ROBE = :SR
         */
      select CENA
      from CENA_ARTIKLA_IZ_CENOVNIKA(:SR, :IDCENONIKA, current_date, null)
      into :CENA
  do
  begin
    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure CENA_ARTIKLA_IZ_CENOVNIKA (
    SR integer,
    ID_CENOVNIK integer,
    DATUM date,
    IDCK integer = null)
returns (
    CENA decimal(18,4),
    CENOVNIK varchar(1),
    ID integer,
    AKCIJA smallint,
    VAZI_OD date,
    VAZI_DO date,
    RABAT decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    STARA_CENA decimal(18,2),
    CENAMP_SA_POPUSTOM decimal(18,2),
    CENASAPDV decimal(15,2))
as
declare variable IDC_OLD integer;
begin
    idck = null;
    if(IDCK > 0)  then  ID_CENOVNIK = IDCK; /* ovo radi na osnovu cenovnika komitenta*/
   -- cena iz specijalnog cenovnika, za kupca ili ... vasno da je tip_cenovnika.id <> tip_cenovnika.id_cenovnik_old
   /* uzmi cenu iz akcijskog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            (A.id_cenovnika_old = :ID_CENOVNIK and a.id <> :ID_CENOVNIK ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or (:DATUM >= C.VAZI_OD and C.VAZI_DO is null))
            and a.aktivan = 1
            and a.id_tip_cenovnika = 3
            and a.vrsta_komitenta=1
      order by C.CENA

      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;
   if (CENA is null or CENA < 0 ) then
   begin
   -- happy hour
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            ( A.ID_CENOVNIKA_OLD = :ID_CENOVNIK or A.ID_CENOVNIKA_OLD = -1 ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
            and current_time between a.happy_od and a.happy_do
            and a.aktivan = 1
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;
   end

   if (CENA is null or CENA < 0 ) then
   begin
   -- ako nema cene u specijalnom cenovniku onda daj cenu iz lifleta ili bilo kog cenovnika koja vazi a najmanja je
   /* uzmi cenu iz posebnog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV ,
                     a.id_cenovnika_old
      from   TIP_CENOVNIKA A
      left join TBL_CENOVNIK C on C.ID_CENOVNIKA = A.ID
      and C.SIFRA_ROBE = :SR and

            (:DATUM between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
      where
            ( A.ID = :ID_CENOVNIK )
            and a.aktivan = 1
            and a.vrsta_komitenta=1
            and a.id_tip_cenovnika = 2
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV, :idc_old;
   end

   if (CENA is null or CENA <= 0 ) then
   begin

   if(idc_old is not null) then ID_CENOVNIK = idc_old;
          /* uzmi cenu iz osnovnog cenovnika*/
   select first 1 coalesce(C.CENA, 0),
                     C.CENOVNIK,
                     C.ID,
                     C.RABAT,
                     C.AKCIJSKI_RABAT,
                     C.VAZI_OD,
                     C.VAZI_DO,
                     C.STARA_CENA,
                     C.CENAMP_SA_POPUSTOM,
                     C.CENASAPDV
      from TBL_CENOVNIK C
      join TIP_CENOVNIKA A on C.ID_CENOVNIKA = A.ID
      where C.SIFRA_ROBE = :SR and
            ( A.ID = :ID_CENOVNIK ) and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or (:DATUM >= C.VAZI_OD and C.VAZI_DO is null))
            and a.aktivan = 1
            and a.vrsta_komitenta=1
            and a.id_tip_cenovnika = 1
      order by a.id_cenovnika_old , C.CENA
      into :CENA, :CENOVNIK, :ID, :RABAT, :AKCIJSKI_RABAT, :VAZI_OD, :VAZI_DO, :STARA_CENA, :CENAMP_SA_POPUSTOM,
           :CENASAPDV;

    end

  begin
    if (cena is null or cena = 0 ) then
    begin
       select b.cenamp  from tblartikli b where b.sifra_robe = :sr into :cena;
    end
    suspend;
  end
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure ARTIKLI_CENA (
    MG integer,
    KOLIN decimal(18,4),
    SR integer,
    MG1 integer,
    DATUM_F date,
    GODINA integer,
    IDCK integer = null)
returns (
    SKLADISNI_PROSTOR varchar(20),
    AKTIVAN integer,
    AKCIJA_OZNAKA varchar(1),
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOL decimal(18,4),
    REZER_KOL decimal(18,4),
    PROSECNA_CENA decimal(18,4),
    SIFRA_POREZA integer,
    KATEGORIJA varchar(50),
    PROIZVODJAC varchar(100),
    POREZ decimal(18,2),
    GARANCIJA integer,
    CENA decimal(18,2),
    CENA1 decimal(18,4),
    PL_CENA decimal(18,2),
    MARZA decimal(18,2),
    MARZA_MP decimal(18,2),
    PROSEK decimal(18,2),
    EXTRA_CENA varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA decimal(18,2),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    BARKOD varchar(50),
    FISKAL smallint,
    BOJA integer,
    KOL_SARZA decimal(18,4),
    ROK_TRAJANJA date,
    BROJ_SERIJE varchar(30),
    LAGER_KOL decimal(18,4),
    KOD_PR varchar(20),
    ID_CENOVNIK integer,
    CENA_CENOVNIK decimal(18,4),
    VODI_SE_LAGER integer,
    NAB_VREDNOST decimal(18,4),
    ODNOSPJM double precision,
    PRODAJA_CEO_BROJ integer,
    POVRATNA_AMBALAZA integer,
    VAGA_KOMAD integer,
    ODNOSJMNALEPNICE double precision,
    RABATC decimal(18,4),
    LABEL varchar(10))
as
declare variable CENOVNIK integer;
declare variable TIP_CENA integer;
declare variable KOL_PROIZVEDI decimal(18,4);
declare variable PROIZVODNJA integer;
declare variable HP_TABELE integer;
declare variable KOL_FAKTURISANO decimal(18,4);
declare variable CENOVNIK1 integer;
declare variable ID_CENOVNIK1 integer;
declare variable TIP_CENA1 integer;
declare variable HP_KOL decimal(18,4);
declare variable KOLICINA_OTP decimal(18,4);
begin
  -- AKO JE CENA_MAGACINA=0 VUCE CENU IZ ARTIKALA
  -- AKO JE CENA_MAGACINA=1 VUCE CENU IZ TLOKACIJE
  -- AKO JE CENA_MAGACINA=2 VUCE CENU IZ TBL_CENOVNIK
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MG1
  into :CENOVNIK, :ID_CENOVNIK, :TIP_CENA;
  for select A.KOD,
             A.SIFRA_ROBE,
             A.SIFRA_KATEGORIJE,
             A.SIFRA_PROIZVODJACA,
             A.ARTIKAL,
             J.NAZIV as JED_MERE,
             A.CENAVP,
             A.CENAMP,
             A.SIFRA_POREZA,
             V.KATEGORIJA_GRUPE as KATEGORIJA,
             PR.PROIZVODJAC,
             P.STOPA1,
             A.GARANCIJA,
             A.PLAN_CENA,
             A.MARZA,
             A.MARZA_MP,
             A.NAB_CENA as PROSEK,
             A.CENOVNIK as EXTRA_CENA,
             A.TARIFNI_BROJ,
             A.TARIFNA_STOPA,
             TBLPODVRSTAROBE.NAZIV as PODVRSTA,
             TBLARTIKLI_GRUPE.NAZIV as GRUPA,
             A.BOJA,
             P.FISKAL,
             A.KOD_PR,
             A.VODI_SE_LAGER,
             A.CENOVNIK,
             A.AKTIVAN,
             A.ODNOSPJM,
             A.PRODAJA_CEO_BROJ,
             A.POVRATNA_AMBALAZA,
             J.VAGA_KOMAD,
             A.ODNOSJMNALEPNICE,
             P.LABEL
      from TBLARTIKLI A
      left join TBLVRSTAROBE V on (A.SIFRA_KATEGORIJE = V.SIFRA_KATEGORIJE)
      inner join TBLPOREZ P on A.SIFRA_POREZA = P.SIFRA_POREZA
      inner join TBLPROIZVODJAC PR on A.SIFRA_PROIZVODJACA = PR.SIFRA_PROIZVODJACA
      left join TBLPODVRSTAROBE on A.ID_PODKATEGORIJE = TBLPODVRSTAROBE.ID
      left join TBLARTIKLI_GRUPE on A.IDGRUPE = TBLARTIKLI_GRUPE.ID
      left join TBLJM J on A.IDPJM = J.ID
      where (A.SIFRA_ROBE = :SR)
      order by A.SIFRA_ROBE
      into :KOD, :SIFRA_ROBE, :SIFRA_KATEGORIJE, :SIFRA_PROIZVODJACA, :ARTIKAL, :JED_MERE, :CENAVP, :CENAMP,
           :SIFRA_POREZA, :KATEGORIJA, :PROIZVODJAC, :POREZ, :GARANCIJA, :PL_CENA, :MARZA, :MARZA_MP, :PROSEK,
           :EXTRA_CENA, :TARIFNI_BROJ, :TARIFNA_STOPA, :PODVRSTA, :GRUPA, :BOJA, :FISKAL, :KOD_PR, :VODI_SE_LAGER,
           :AKCIJA_OZNAKA, :AKTIVAN, :ODNOSPJM, :PRODAJA_CEO_BROJ, :POVRATNA_AMBALAZA, :VAGA_KOMAD, :ODNOSJMNALEPNICE,
           :LABEL
  do
  begin
    -- :MG - VUCE KOLICINU, :MG1 - VUCE CENU
    KOL = 0;
    HP_KOL = 0;
    REZER_KOL = 0;
    LAGER_KOL = 0;
    KOL_SARZA = null;
    CENA = null;
    CENA1 = null;
    CENA_CENOVNIK = null;
    PROSECNA_CENA = null;
    ROK_TRAJANJA = null;
    BROJ_SERIJE = null;
    select M.CENA_MAGACIN,
           M.ID_CENOVNIK,
           M.TIP_CENA
    from TBLMAGACIN M
    where M.SIFRA_MAGACINA = :MG
    into :CENOVNIK1, :ID_CENOVNIK1, :TIP_CENA1;
    -- VUCE KOLICINU I IZLAZNU CENU ZA INTERNU OTPREMNICU
    select X.CENA,
           coalesce(X.KOLICINA, 0),
           coalesce(X.REZERVISANO, 0),
           X.PROS_CENA,
           coalesce(X.KOLICINA, 0),
           X.NAB_VREDNOST,
           X.SKLADISNI_PROSTOR,
           X.KOLICINA_OTP,
           coalesce(X.HP_KOL, 0)
    from TLOKACIJA X
    where X.SIFRA_MAGACINA = :MG and
          X.SIFRA_ROBE = :SIFRA_ROBE and
          X.KOLICINA > :KOLIN and
          X.GODINA = :GODINA
    into :CENA1, :KOL, :REZER_KOL, :PROSECNA_CENA, :LAGER_KOL, :NAB_VREDNOST, :SKLADISNI_PROSTOR, :KOLICINA_OTP,
         :HP_KOL;
    if ((PROSECNA_CENA is null or PROSECNA_CENA = 0) and
        NAB_VREDNOST > 0 and
        KOL > 0) then
      PROSECNA_CENA = NAB_VREDNOST / KOL;
    else
    if (PROSEK > 0 and
        (PROSECNA_CENA is null or PROSECNA_CENA = 0)) then
      PROSECNA_CENA = PROSEK;
    if (TIP_CENA1 = 1 and
        :KOL > 0) then
      CENA1 = CENA1 / :KOL;
    -- VUCE PRODAJNU CENU
    select
           case
             when :CENOVNIK = 0 then :CENAMP
             else M1.CENA
           end as CENA
    from TLOKACIJA M1
    where M1.SIFRA_MAGACINA = :MG1 and
          M1.SIFRA_ROBE = :SIFRA_ROBE and
          M1.GODINA = :GODINA
    into :CENA;
    if (:KOL = 0) then
    begin
      PROSECNA_CENA = 0;
    end
    if (:TIP_CENA = 1) then -- PROSECNA CENA
    begin
      if (:LAGER_KOL > 0) then
      begin
        CENA1 = :CENA1 / :LAGER_KOL;
        if (:CENOVNIK <> 0) then
        begin
          CENA = :CENA / :LAGER_KOL;
        end
      end
    end
    -- AKO JE :CENOVNIK=0 VUCE CENU IZ ARTIKALA
    -- AKO JE :CENOVNIK=1 VUCE CENU IZ TLOKACIJE
    -- AKO JE :CENOVNIK=2 VUCE CENU IZ TBL_CENOVNIK
    if (:CENOVNIK = 0 and
        :TIP_CENA = 3) then
    begin
      CENA = :CENAMP;
      CENA_CENOVNIK = :CENAMP;
    end
    else
    if (:CENOVNIK = 0 and
        :TIP_CENA = 0) then
    begin
      CENA = :CENAVP;
      CENA_CENOVNIK = :CENAVP;
    end
    if (:CENOVNIK = 2) then
    begin
      select C.CENA,
             C.CENOVNIK,
             C.RABAT
      from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM_F, :idck) C
      into :CENA_CENOVNIK, :AKCIJA_OZNAKA, :RABATC;
    end
    if (:CENOVNIK = 2 and
        :CENA_CENOVNIK is not null) then
      CENA = :CENA_CENOVNIK;
    if (:CENOVNIK = 2 and
        :CENAMP is not null and
        :CENA_CENOVNIK is null and
        :CENAMP > 0) then
      CENA = :CENAMP;
    if (:CENOVNIK = 1 and
        (:CENA is null or :CENA = 0)) then
    begin
      if (:CENAMP is not null or :CENAMP > 0) then
        CENA = :CENAMP;
      else
      if (:CENA_CENOVNIK is not null or :CENA_CENOVNIK > 0) then
        CENA = :CENA_CENOVNIK;
    end
    else
    if (:CENOVNIK = 1) then
      CENA_CENOVNIK = :CENA;
    -- KOLICINA U PROIZVODNJI PREKO NORMATIVA
    select first 1 MP_PROIZVODNJA_NORMATIV
    from TBLHOST
    into :PROIZVODNJA;
    if (PROIZVODNJA = 1) then
    begin
      select min(D.KOL)
      from ARTIKLI_PROVERI_MATERIJAL(:MG, :SIFRA_ROBE, :GODINA) D
      into :KOL_PROIZVEDI;
      if (:KOL_PROIZVEDI > 0) then
      begin
        KOL = KOL + :KOL_PROIZVEDI - :HP_KOL;
        LAGER_KOL = LAGER_KOL + :KOL_PROIZVEDI;
      end
    end
    else
    begin
      KOL = KOL - REZER_KOL - HP_KOL;
      if (KOLICINA_OTP > 0) then
        KOL = KOL - KOLICINA_OTP;
    end
    if (:LAGER_KOL is null) then
      LAGER_KOL = 0;
    if (:REZER_KOL is null) then
      REZER_KOL = 0;
    if ((KOL > 0) or (LAGER_KOL > 0) or :KOLIN < 0 or :VODI_SE_LAGER = 0) then
    begin
      if (:BARKOD is null) then
        select first 1 BARKOD
        from TBLBARKOD
        where SIFRA_ROBE = :SIFRA_ROBE
        into :BARKOD;
      if (KOL < 0) then
        KOL = 0;
      suspend;
    end
    KOLICINA_OTP = 0;
  end
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure ARTIKLI_OFLINE (
    MG integer,
    KAT integer,
    KOLIN decimal(18,4),
    KODIN varchar(20),
    BK varchar(50),
    SR integer,
    NAZIV_ARTIKLA varchar(250),
    MG1 integer,
    DATUM_F date,
    IDCK integer,
    GODINA integer = null)
returns (
    SKLADISNI_PROSTOR varchar(20),
    AKTIVAN integer,
    AKCIJA varchar(1),
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOL decimal(18,4),
    REZER_KOL decimal(18,4),
    PROSECNA_CENA decimal(18,4),
    SIFRA_POREZA integer,
    KATEGORIJA varchar(50),
    PROIZVODJAC varchar(100),
    POREZ decimal(18,2),
    GARANCIJA integer,
    CENA decimal(18,2),
    CENA1 decimal(18,4),
    PL_CENA decimal(18,2),
    MARZA decimal(18,2),
    MARZA_MP decimal(18,2),
    PROSEK decimal(18,2),
    EXTRA_CENA varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA decimal(18,2),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    BARKOD varchar(50),
    FISKAL smallint,
    BOJA integer,
    KOL_SARZA decimal(18,4),
    ROK_TRAJANJA date,
    BROJ_SERIJE varchar(30),
    LAGER_KOL decimal(18,4),
    KOD_PR varchar(20),
    ID_CENOVNIK integer,
    CENA_CENOVNIK decimal(18,4),
    VODI_SE_LAGER integer,
    NAB_VREDNOST decimal(18,4),
    ODNOSPJM double precision,
    POVRATNA_AMBALAZA integer,
    VAGA_KOMAD integer,
    PRODAJA_CEO_BROJ integer,
    RABATC decimal(18,4),
    LABEL varchar(10))
as
declare variable CUSTOM_WHERE varchar(500);
declare variable ABP smallint;
declare variable GODINA_RADA integer;
declare variable CENOVNIK integer;
declare variable TIP_CENA integer;
declare variable KOL_PROIZVEDI decimal(18,4);
declare variable PROIZVODNJA integer;
declare variable HP_TABELE integer;
declare variable KOL_FAKTURISANO decimal(18,4);
declare variable CENOVNIK1 integer;
declare variable ID_CENOVNIK1 integer;
declare variable TIP_CENA1 integer;
declare variable KOL_ decimal(18,4);
declare variable TMP_SIFRA integer;
declare variable SIFRA integer;
begin
  --ZPHARM
  select GODINA
  from SYSTEM
  into :GODINA_RADA;
  if (:GODINA is null) then
    GODINA = GODINA_RADA;
  if (KODIN = '-1') then
    TMP_SIFRA = SR;
  else
  if (BK = '-1') then
  begin
    select A.TMP_SIFRA
    from ARTIKAL_PRONADJI(:KODIN) A
    into :TMP_SIFRA;
  end
  for select SIFRA
      from ARTIKAL_PRONADJI_ABP(:TMP_SIFRA, :KODIN, :NAZIV_ARTIKLA)
      into :SIFRA
  do
  begin
    select A.KOD,
           A.SIFRA_ROBE,
           A.SIFRA_KATEGORIJE,
           A.SIFRA_PROIZVODJACA,
           A.ARTIKAL,
           A.JED_MERE,
           A.CENAVP,
           A.CENAMP,
           A.KOL,
           A.REZER_KOL,
           A.PROSECNA_CENA,
           A.SIFRA_POREZA,
           A.KATEGORIJA,
           A.PROIZVODJAC,
           A.POREZ,
           A.GARANCIJA,
           A.CENA,
           A.CENA1,
           A.PL_CENA,
           A.MARZA,
           A.MARZA_MP,
           A.PROSEK,
           A.EXTRA_CENA,
           A.TARIFNI_BROJ,
           A.TARIFNA_STOPA,
           A.PODVRSTA,
           A.GRUPA,
           A.BARKOD,
           A.FISKAL,
           A.BOJA,
           A.KOL_SARZA,
           A.ROK_TRAJANJA,
           A.BROJ_SERIJE,
           A.LAGER_KOL,
           A.KOD_PR,
           A.ID_CENOVNIK,
           A.CENA_CENOVNIK,
           A.VODI_SE_LAGER,
           A.NAB_VREDNOST,
           A.AKCIJA_OZNAKA,
           A.AKTIVAN,
           A.SKLADISNI_PROSTOR,
           A.ODNOSPJM,
           A.POVRATNA_AMBALAZA,
           A.VAGA_KOMAD,
           A.PRODAJA_CEO_BROJ,
           A.RABATC,
           A.LABEL
    from ARTIKLI_CENA(:MG, :KOLIN, :SIFRA, :MG1, :DATUM_F, :GODINA, :idck) A
    into :KOD, :SIFRA_ROBE, :SIFRA_KATEGORIJE, :SIFRA_PROIZVODJACA, :ARTIKAL, :JED_MERE, :CENAVP, :CENAMP, :KOL,
         :REZER_KOL, :PROSECNA_CENA, :SIFRA_POREZA, :KATEGORIJA, :PROIZVODJAC, :POREZ, :GARANCIJA, :CENA, :CENA1,
         :PL_CENA, :MARZA, :MARZA_MP, :PROSEK, :EXTRA_CENA, :TARIFNI_BROJ, :TARIFNA_STOPA, :PODVRSTA, :GRUPA, :BARKOD,
         :FISKAL, :BOJA, :KOL_SARZA, :ROK_TRAJANJA, :BROJ_SERIJE, :LAGER_KOL, :KOD_PR, :ID_CENOVNIK, :CENA_CENOVNIK,
         :VODI_SE_LAGER, :NAB_VREDNOST, :AKCIJA, :AKTIVAN, :SKLADISNI_PROSTOR, :ODNOSPJM, :POVRATNA_AMBALAZA,
         :VAGA_KOMAD, :PRODAJA_CEO_BROJ, :RABATC, :LABEL;
    if (:SIFRA_ROBE is not null and
        :AKTIVAN = 1) then
    begin
      select first 1 R.SIFRA_POREZ_IZLAZ,
                     R.STOPA_POREZ_IZLAZ,
                     R.LABEL_IZLAZ
      from ARTIKLI_POREZ_IZLAZ(:SIFRA_ROBE) R
      into :SIFRA_POREZA, :POREZ, :LABEL;
      suspend;
      SIFRA_ROBE = null;
    end
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure ARTIKLI_APOTEKA (
    MG integer,
    KAT integer,
    KOLI decimal(18,4),
    KODI varchar(20),
    BK varchar(50),
    SR integer,
    ARTIKALI varchar(250),
    MG1 integer,
    LEKOVI integer,
    DATUM_F date,
    GODINA integer,
    PARALELA integer)
returns (
    KOD varchar(20),
    SIFRA_ROBE integer,
    ARTIKAL varchar(255),
    CENA decimal(18,2),
    CENAMP decimal(18,4),
    KOL decimal(18,4),
    LAGER_KOL decimal(18,4),
    CENALEKA varchar(16),
    VAZIDANA varchar(16),
    VODI_SE_LAGER integer)
as
BEGIN
--  select paralela from system into paralela;

if (lekovi = 1) then
begin
if (sr = -1) then
-- uzimas sve lekove sa istio atc sifrom
begin

  for
    select ar.sifra_robe, sl.cenaleka, sl.vazidana
    from ap_lekovi_lek l
    join ap_lekovi_atc ac on l.id_atc = ac.id_atc
    join ap_lekovi_lek l2 on ac.id_atc = l2.id_atc
    join ap_lekovi_slek sl on l2.id_lek = sl.id_lek
    join tblartikli ar on l2.sifraleka = ar.jkl
    where l.sifraleka = :BK
    and (SL.DATUMK = '' or sl.datumk is null  or current_date between cast(SL.DATUMP as date) and cast(SL.DATUMK as date))
    and (l2.sifraleka = :BK or :paralela = 1)
    into :SIFRA_ROBE,
         :CENALEKA,
         :VAZIDANA
   do
   begin
    for
    select A.KOD,
           A.ARTIKAL,
           A.CENA,
           A.CENAMP,
           A.KOL,
           A.LAGER_KOL,
           A.VODI_SE_LAGER
    from ARTIKLI_OFLINE(:MG, :KAT, :KOLI, :KODI, :BK, :SIFRA_ROBE, :ARTIKALI, :MG1, :datum_f, null, :GODINA) A
    where A.KOL > :KOLI
    INTO :KOD,
         :ARTIKAL,
         :CENA,
         :CENAMP,
         :KOL,
         :LAGER_KOL,
         :VODI_SE_LAGER
  DO
  BEGIN
    SUSPEND;
  END
   end

end
else
begin
  FOR
    select A.KOD,
           A.SIFRA_ROBE,
           A.ARTIKAL,
           A.CENA,
           A.CENAMP,
           A.KOL,
           A.LAGER_KOL,
           A.VODI_SE_LAGER,
           SL.CENALEKA,
           SL.VAZIDANA
    from (select A1.KOD,
                 A1.SIFRA_ROBE,
                 A1.ARTIKAL,
                 A1.CENA,
                 A1.CENAMP,
                 A1.KOL,
                 A1.LAGER_KOL,
                 A1.VODI_SE_LAGER
          from ARTIKLI_OFLINE(:MG, :KAT, :KOLI, :KODI, :BK, :SR, :ARTIKALI, :MG1, :datum_f, :GODINA) A1) A
    inner join TBLARTIKLI AR on A.SIFRA_ROBE = AR.SIFRA_ROBE
    inner join AP_LEKOVI_LEK L on L.SIFRALEKA = AR.JKL
    inner join AP_LEKOVI_SLEK SL on (L.ID_LEK = SL.ID_LEK)
    left join TBLBARKOD B on A.SIFRA_ROBE = B.SIFRA_ROBE
    where A.KOL > :KOLI and
          (SL.DATUMK = '' or sl.datumk is null  or current_date between cast(SL.DATUMP as date) and cast(SL.DATUMK as date))
    INTO :KOD,
         :SIFRA_ROBE,
         :ARTIKAL,
         :CENA,
         :CENAMP,
         :KOL,
         :LAGER_KOL,
         :VODI_SE_LAGER,
         :CENALEKA,
         :VAZIDANA
  DO
  BEGIN
    SUSPEND;
  END
 end
end
 else
begin
  FOR
    select A.KOD,
       A.SIFRA_ROBE,
       A.ARTIKAL,
       A.CENA,
       A.CENAMP,
       A.KOL,
       A.LAGER_KOL,
       A.VODI_SE_LAGER,
       sp.cena as CENALEKA,
       '0' as VAZIDANA
from (select A1.KOD,
             A1.SIFRA_ROBE,
             A1.ARTIKAL,
             A1.CENA,
             A1.CENAMP,
             A1.KOL,
             A1.LAGER_KOL ,
             A1.VODI_SE_LAGER
      from ARTIKLI_OFLINE(:MG, :KAT, :KOLI, :KODI, :BK, :SR, :ARTIKALI, :MG1, :datum_f, :GODINA) A1) A
inner join TBLARTIKLI AR on A.SIFRA_ROBE = AR.SIFRA_ROBE
inner join AP_p_mtp L on L.siframtp = AR.JKL
inner join ap_p_smtp SL on (L.id_mtp = SL.id_mtp)
inner join AP_P_SMTPPONUDJAC sp on (sp.id_mtp = sl.id_mtp and sl.rednibrojpromene = sp.rednibrojpromene)
left join TBLBARKOD B on A.SIFRA_ROBE = B.SIFRA_ROBE
where A.KOL > :KOLI and
      (SL.vazi_do = '' or sl.vazi_do is null  or current_date between cast(SL.vazi_od as date) and cast(SL.vazi_do as date))
    INTO :KOD,
         :SIFRA_ROBE,
         :ARTIKAL,
         :CENA,
         :CENAMP,
         :KOL,
         :LAGER_KOL,
         :VODI_SE_LAGER,
         :CENALEKA,
         :VAZIDANA
  DO
  BEGIN
    SUSPEND;
  END
 end
END^

SET TERM ; ^

update tblkomitenti k
set k.id_cenovnika = null
where k.id_cenovnika not in (select id from tip_cenovnika);


SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PRODAJE_ROBE (
    GODINA integer,
    DATUMOD date,
    DATUMDO date,
    MG integer = -103)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    KOD_PR varchar(20),
    KOD_INFO varchar(10),
    ARTIKAL varchar(255),
    PJM varchar(20),
    PROIZVODJAC varchar(100),
    JM varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    IZLAZ_CENA decimal(18,4),
    LAGER decimal(18,4),
    STOPA decimal(18,2),
    STARA_CENA decimal(18,2),
    POPUST numeric(18,6),
    KOLICINA_PJM double precision,
    KOLICINA decimal(18,4),
    VREDNOST numeric(18,8),
    RUC numeric(18,10),
    BARKOD varchar(50))
as
declare variable IZVESTAJ_PO_SATIMA integer;
BEGIN
select IZVESTAJ_PO_SATIMA from system into:IZVESTAJ_PO_SATIMA;
if(:IZVESTAJ_PO_SATIMA > 1) then
begin
  FOR
    select
        A.SIFRA_ROBE,
        A.KOD,
        A.KOD_PR,
        A.KOD_INFO,
        A.ARTIKAL,
        J2.NAZIV as PJM,
        PR.PROIZVODJAC,
        J1.NAZIV as JM,
        V.KATEGORIJA_GRUPE,
        P.IZLAZ_CENA,
        L.KOLICINA as LAGER,
        R.STOPA1 as STOPA,
        P.STARA_CENA,
        case
          when P.STARA_CENA > 0 then 100.00 - 100 * (P.IZLAZ_CENA) / P.STARA_CENA
          else 0
        end as POPUST,
        (sum(P.IZLAZ_KOL * A.ODNOSPJM)) as KOLICINA_PJM,
        sum(P.IZLAZ_KOL) as KOLICINA,
        sum(P.IZLAZ_KOL * P.IZLAZ_CENA) as VREDNOST,
        sum(P.IZLAZ_KOL * (P.CENA_MG / (1.00 + P.STOPA / 100) - P.PROSEK)) as RUC,
        (select first 1
             BARKOD
         from TBLBARKOD B
         where B.SIFRA_ROBE = A.SIFRA_ROBE
         order by B.DATE_CHANGE desc)
    
    from TBLNOVCANO N
    inner join TBLPROMENE P on (P.IDNOVCANO = N.IDNOVCANO and (N.SIFRA_MAGACINA = :MG or (:mg = -103))  and P.IZLAZ_KOL <> 0)
    inner join TBLARTIKLI A on A.SIFRA_ROBE = P.SIFRA_ROBE
    inner join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
    inner join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
    inner join TBLPROIZVODJAC PR on A.SIFRA_PROIZVODJACA = PR.SIFRA_PROIZVODJACA
    
    left join TLOKACIJA L on (A.SIFRA_ROBE = L.SIFRA_ROBE and L.GODINA = :GODINA and (l.sifra_magacina = :mg or :mg = -103 ))
    
    inner join TBLJM J1 on J1.ID = A.IDJM
    left join TBLJM J2 on J2.ID = A.IDJM
    inner join TBLPOREZ R on A.SIFRA_POREZA = R.SIFRA_POREZA
    where N.DATUMDPO >= :DATUMOD and
          N.DATUMDPO <= :DATUMDO and
          D.TIP >= 10 and
          D.TIP < 20
    group by A.SIFRA_ROBE, A.KOD, A.KOD_PR, A.KOD_INFO, A.ARTIKAL, PR.PROIZVODJAC, J1.NAZIV, V.KATEGORIJA_GRUPE, J2.NAZIV, P.IZLAZ_CENA, L.KOLICINA, R.STOPA1, P.STARA_CENA
    order by V.KATEGORIJA_GRUPE, PR.PROIZVODJAC
    INTO :SIFRA_ROBE,
         :KOD,
         :KOD_PR,
         :KOD_INFO,
         :ARTIKAL,
         :PJM,
         :PROIZVODJAC,
         :JM,
         :KATEGORIJA_GRUPE,
         :IZLAZ_CENA,
         :LAGER,
         :STOPA,
         :STARA_CENA,
         :POPUST,
         :KOLICINA_PJM,
         :KOLICINA,
         :VREDNOST,
         :RUC,
         :BARKOD
  DO
  BEGIN
    SUSPEND;
  END
  end
  else if(:IZVESTAJ_PO_SATIMA = 1) then
  begin
    FOR
        select
            A.SIFRA_ROBE,
            A.KOD,
            A.KOD_PR,
            A.KOD_INFO,
            A.ARTIKAL,
            J2.NAZIV as PJM,
            PR.PROIZVODJAC,
            J1.NAZIV as JM,
            V.KATEGORIJA_GRUPE,
            P.CENA as IZLAZ_CENA,
            L.KOLICINA as LAGER,
            R.STOPA1 as STOPA,
            P.STARA_CENA,
            case
              when P.STARA_CENA > 0 then 100.00 - 100 * (P.CENA) / P.STARA_CENA
              else 0
            end as POPUST,
            (sum(P.KOLICINA * A.ODNOSPJM)) as KOLICINA_PJM,
            sum(P.KOLICINA) as KOLICINA,
            sum(P.KOLICINA * P.CENA) as VREDNOST,
            sum(P.KOLICINA * (P.CENA / (1.00 + P.PROCENATPDVA / 100) - P.PROSECNA_CENA)) as RUC,
            (select first 1
                 BARKOD
             from TBLBARKOD B
             where B.SIFRA_ROBE = A.SIFRA_ROBE
             order by B.DATE_CHANGE desc)
        
        from MP_FISK_Z N
        inner join HP_OBRACUN P on (P.IDZG = N.IDZ and (N.SIFRA_MAGACINA = :MG or (:MG = -103) )  and P.KOLICINA <> 0)
        inner join TBLARTIKLI A on A.SIFRA_ROBE = P.SIFRA_ROBE
        inner join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        inner join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
        inner join TBLPROIZVODJAC PR on A.SIFRA_PROIZVODJACA = PR.SIFRA_PROIZVODJACA
        
        left join TLOKACIJA L on (A.SIFRA_ROBE = L.SIFRA_ROBE and L.GODINA = :GODINA and (l.sifra_magacina = :mg or :mg = -103 ))
        
        inner join TBLJM J1 on J1.ID = A.IDJM
        left join TBLJM J2 on J2.ID = A.IDJM
        inner join TBLPOREZ R on A.SIFRA_POREZA = R.SIFRA_POREZA
        where N.DATUMDPO >= :DATUMOD and
              N.DATUMDPO <= :DATUMDO and
              D.TIP >= 10 and
              D.TIP < 20
        group by A.SIFRA_ROBE, A.KOD, A.KOD_PR, A.KOD_INFO, A.ARTIKAL, PR.PROIZVODJAC, J1.NAZIV, V.KATEGORIJA_GRUPE, J2.NAZIV, P.CENA, L.KOLICINA, R.STOPA1, P.STARA_CENA
        order by V.KATEGORIJA_GRUPE, PR.PROIZVODJAC
    INTO :SIFRA_ROBE,
         :KOD,
         :KOD_PR,
         :KOD_INFO,
         :ARTIKAL,
         :PJM,
         :PROIZVODJAC,
         :JM,
         :KATEGORIJA_GRUPE,
         :IZLAZ_CENA,
         :LAGER,
         :STOPA,
         :STARA_CENA,
         :POPUST,
         :KOLICINA_PJM,
         :KOLICINA,
         :VREDNOST,
         :RUC,
         :BARKOD
  DO
  BEGIN
    SUSPEND;
  END  
  end
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_SINHRO_DNEVNI (
    SM integer,
    D1 date = null)
returns (
    SIFRA_MAGACINA integer,
    DATUMDPO date,
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    IZNOS decimal(18,4),
    ID integer,
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer)
as
declare variable BAZA varchar(200);
declare variable DATUM timestamp;
declare variable D2 date;
declare variable SQL2 varchar(1024);
BEGIN
   if (:d1 is null) then D1 = current_date-1;
   D2 = :D1 + 1;
begin

SQL2 = 'select
sum(case when i.transactiontype = ''Sale'' and i.invoicetype = ''Normal'' then  i.totalamount else 0 end) as Prodaja,
sum(case when i.transactiontype = ''Refund'' and i.invoicetype = ''Normal'' then  i.totalamount else 0 end) as Storno ,
sum(case when i.transactiontype = ''Sale'' and i.invoicetype = ''Normal'' then  1 else 0 end) as brProdatih,
sum(case when i.transactiontype = ''Refund'' and i.invoicetype = ''Normal'' then  1 else 0 end) as brRefundacija
, max(i.totalcounter) - min(i.totalcounter) + 1 - count(i.id)
from invoice i
where   i.dateadded between '''||:d1 ||''' and '''||:d2 ||'''' ;


for
select   m.ip_adresa||':C:\BUS\baza\luki_klijent.FDB' , m.sifra_magacina
from tblmagacin m
where m.sifra_magacina = :sm  or (:sm = -1)
and m.ip_adresa is not null
--and m.sifra_magacina not in (127,153,201,211)
into :baza , :SIFRA_MAGACINA


do
begin
  FOR
  EXECUTE STATEMENT 
    'select Z.SIFRA_MAGACINA, sum(Z.KES + Z.CEK + Z.KARTICA + Z.VIRMAN) as IZNOS, sum(z.kes) as kes,
sum(z.cek) as cek, sum(z.kartica) as kartica, sum(z.virman) as virman, Z.DATUMDPO

from MP_FISK_Z Z
where Z.PLACENO = ''Y'' and z.datumdpo = '''||:d1 ||'''
and z.sifra_dokumenta <> 1013
and z.sifra_magacina = '||:SIFRA_MAGACINA||'
group by Z.SIFRA_MAGACINA, Z.DATUMDPO '
ON EXTERNAL DATA SOURCE :BAZA AS USER 'sysdba' PASSWORD 'masterkey'
    INTO
         :SIFRA_MAGACINA,
         :iznos,
         :kes,
         :cek, 
         :kartica,
         :virman,
         :datumdpo
  DO
  BEGIN

      EXECUTE STATEMENT SQL2 ON EXTERNAL DATA SOURCE :BAZA AS USER 'SYSDBA' PASSWORD 'masterkey'
      INTO :PRODAJA, :REFUNDACIJA, :BROJ_PRODATI,  :BROJ_REFUNDACIJA, :BROJ_DOKUMENATA ;


      select first 1 i.id
      from fiskalna_dnevin_izvestaj i
      where i.idkase = :sifra_magacina
      and i.datum = :datumdpo
      into :id ;
      if (:id is null) then
      begin
        suspend;
        INSERT INTO FISKALNA_DNEVIN_IZVESTAJ ( IDKASE, DATUM,  PROMETT,   KES, CEK, KARTICA, VIRMAN, PRODAJA, REFUNDACIJA, BROJ_PRODATI,  BROJ_REFUNDACIJA, BROJ_DOKUMENATA) VALUES
        (:sifra_magacina, :datumdpo, :iznos, :kes, :cek, :kartica, :virman, :PRODAJA, :REFUNDACIJA, :BROJ_PRODATI,  :BROJ_REFUNDACIJA, :BROJ_DOKUMENATA);
      end
      else
      begin
           update FISKALNA_DNEVIN_IZVESTAJ i set
           IDKASE = :sifra_magacina, i.datum = :datumdpo,  PROMETT = :iznos,   KES = :kes, CEK= :cek, KARTICA= :kartica, VIRMAN=:virman ,
           prodaja = :PRODAJA, refundacija = :REFUNDACIJA, broj_prodati = :BROJ_PRODATI, broj_refundacija = :BROJ_REFUNDACIJA , BROJ_DOKUMENATA = :BROJ_DOKUMENATA
           where i.id = :id;
            suspend;
      end

  END
  when any
  do
  begin
  /*
         iznos=0;
         kes=0;
         cek=0;
         kartica=0;
         virman=0;
        PRODAJA=0;
        REFUNDACIJA=0;
        BROJ_PRODATI=0;
        BROJ_REFUNDACIJA=0;
        BROJ_DOKUMENATA=0;
        */
        if (id is  null) then
        begin
          id = -1;
          suspend;
        end
        id = null;
  end
  end
  end
END

/*
select
sum(case when i.transactiontype = 'Sale' and i.invoicetype = 'Normal' then  i.totalamount else 0 end) as Prodaja,
sum(case when i.transactiontype = 'Refund' and i.invoicetype = 'Normal' then  i.totalamount else 0 end) as Storno ,
count( i.id), max(i.totalcounter), min(i.totalcounter) , max(i.totalcounter) - min(i.totalcounter)

from invoice i
where i.dateadded between :d1 and :d2
*/^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer)
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               (upper(T.NAZIV) = 'CEKOVI'
               or upper(T.NAZIV) = 'VIRMANSKI')) as CEK_VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK_VIRMAN,
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK_VIRMAN is null) then
      CEK_VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;
    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;
    RAZLIKA = :UKUPNO - :UKUPNO_DI;

    select sum(d.prodaja), sum(d.refundacija), sum(d.broj_prodati), sum(d.broj_refundacija), sum(d.broj_dokumenata)
    from fiskalna_dnevin_izvestaj d
    where d.datum = :datum
    and d.idkase = :SIFRA_MAGACINA
    into :prodaja, :refundacija, :broj_prodati, :broj_refundacija, :broj_dokumenata ;
    suspend;
  end
end^

SET TERM ; ^

update tblkomitenti k
set k.id_cenovnika =null
where k.id_cenovnika not in (select c.id_cenovnika from tbl_cenovnik c);

update verzija set maloprodaja = 20220905;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
            FROM verzija
             WHERE maloprodaja < 20220915 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date,
    SM integer = -1)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer)
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               (upper(T.NAZIV) = 'CEKOVI'
               or upper(T.NAZIV) = 'VIRMANSKI')) as CEK_VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
          and (m.sifra_magacina = :sm or :sm = -1 )
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK_VIRMAN,
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK_VIRMAN is null) then
      CEK_VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;



    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;
    RAZLIKA = :UKUPNO - :UKUPNO_DI;

    select sum(d.prodaja), sum(d.refundacija), sum(d.broj_prodati), sum(d.broj_refundacija), sum(d.broj_dokumenata)
    from fiskalna_dnevin_izvestaj d
    where d.datum = :datum
    and d.idkase = :SIFRA_MAGACINA
    into :prodaja, :refundacija, :broj_prodati, :broj_refundacija, :broj_dokumenata ;

    if (:PRODAJA is null) then
      PRODAJA = 0;
    if (:REFUNDACIJA is null) then
      REFUNDACIJA = 0;
    if (:BROJ_PRODATI is null) then
      BROJ_PRODATI = 0;
    if (:BROJ_REFUNDACIJA is null) then
      BROJ_REFUNDACIJA = 0;
    if (:BROJ_DOKUMENATA is null) then
      BROJ_DOKUMENATA = 0;

    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    DATUM1 date,
    DATUM2 date,
    SM integer = -1)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    DATUM date)
as
begin
 datum = datum1;
while (datum < :datum2)
do
begin
  for
  select   MAGACIN,
           MESTO,
           SIFRA_MAGACINA,
           GOTOVINA,
           CEK_VIRMAN,
           KARTICA,
           BENEFIT,
           UKUPNO,
           BR_RADNIKA,
           UKUPNO_DI,
           MALOPRODAJA,
           MP_UPDATE,
           VERINFO_MP,
           STORNO,
           PROMET,
           prodaja,
           refundacija,
           broj_prodati,
           broj_refundacija,
           broj_dokumenata
  from PROC_MP_IZVESTAJ_PAZAR(:datum, :sm)
  into
           :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK_VIRMAN,
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET,
           :prodaja,
           :refundacija,
           :broj_prodati,
           :broj_refundacija,
           :broj_dokumenata
         do
         begin
            razlika = UKUPNO - UKUPNO_DI;
            suspend;
         end
     datum = datum + 1;
  end

 end
^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_PREBACI_PRODAJU
returns (
    INVOICENUMBER varchar(30),
    ID integer,
    GTIN varchar(30),
    KOL decimal(18,3),
    CENA decimal(18,2),
    UKUPNO decimal(18,2),
    IDZ integer,
    SIFRA_KOMITENTA integer,
    SIFRA_DOKUMENTA integer,
    DATUM date,
    SIFRA_RADNIKA integer,
    TOTAL decimal(18,2),
    SIFRA_MAGACINA integer,
    SIFRA_ROBE integer,
    KOD varchar(20),
    SIFRA_POREZA integer,
    POREZ decimal(15,2),
    PDV decimal(15,2),
    IDH integer,
    POSTOJI integer)
as
begin
    sifra_komitenta = 1500027;
    sifra_dokumenta = 1009;
    sifra_magacina = 120;
    datum = '05/23/2022';
    sifra_radnika = 11;
    postoji = 0;
  for
  select p.invoicenumber, p.id, p.totalamount
  from invoice_pos p
  where p.id between 4455 and 4458
  and p.transactiontype = 'Sale'
  and p.invoicetype = 'Normal'
  into :invoicenumber, :id, :total
  do
  begin
    postoji = 0;
    select first 1 z.idz
    from mp_fisk_z z
    where z.invoicenumber = :invoicenumber
    into :postoji;
    if (:postoji = 0) then
    begin
        idz = GEN_ID(GEN_MP_FISK_Z_ID, 1);
        insert into mp_fisk_z (idz, sifra_magacina, sifra_dokumenta, sifra_komitenta, bid, datumdpo, datumvalute, zavrseno, sifra_radnika, kes, placeno, poslatouknjigovodstvo, invoicenumber, cek, kartica, virman, BROJ_FISKALNOG, fiskal_pusten )
        values (:idz, :sifra_magacina, :sifra_dokumenta, :sifra_komitenta, 0, :datum, :datum, 1, :sifra_radnika, :total, 'Y', 'N', :invoicenumber,0,0,0,0, 1);
    
        for
        select  coalesce(I.GTIN, LEFT(I.NAME, STRLEN(I.NAME) - 6)), i.quantity, i.unitprice, i.totalamount
        from items i
        where i.id_invoice = :id
        into :gtin, :kol, :cena, :ukupno
        do
        begin
            select g.tmp_sifra, g.kod, a.sifra_poreza, p.stopa1
            from ARTIKAL_PRONADJI(:gtin) g
            join tblartikli a on g.tmp_sifra = a.sifra_robe
            join tblporez p on a.sifra_poreza = p.sifra_poreza
            into :sifra_robe, :kod, :sifra_poreza, :porez;
            if (:sifra_robe is not null) then
            begin
                idh = GEN_ID(GEN_HP_OBRACUN_ID,1);
                pdv = :ukupno - :ukupno/(1 + :porez / 100.00);
                insert into hp_obracun (id, sifra_robe, kolicina, cena, iznos, kod, procenatpdva, placeno, poslatouknjigovodstvo, datum, sifra_radnika, pdv, sifra_komitenta, greska, sifra_magacina, naplataizvrsena, zadnjapromena, idzg, sifra_dokumenta, sifra_poreza, id_popdv, barkod, vodi_se_lager )
                values (:idh, :sifra_robe, :kol, :cena, :ukupno, :kod, :porez, 'Y', 'N', :datum, :sifra_radnika, :pdv, :sifra_komitenta, 0, :sifra_magacina, :datum, :datum, :idz, :sifra_dokumenta, :sifra_poreza, 21, :gtin, 1 );
            end
            else
            begin
                sifra_robe = -1;
            end
           suspend;
    
        end
    end
  end

end^

SET TERM ; ^



update verzija set maloprodaja = 20220915;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
            FROM verzija
             WHERE maloprodaja < 20220920 }

SET TRPARAMS 'isc_tpb_wait';

CREATE INDEX INVOICE_TC_IDX1
ON INVOICE (TOTALCOUNTER);


update verzija set maloprodaja = 20220920;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221005 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date,
    SM integer = -1)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer)
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               (upper(T.NAZIV) = 'CEKOVI'
               or upper(T.NAZIV) = 'VIRMANSKI')) as CEK_VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           and n.sifra_dokumenta <> 1013
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
          and (m.sifra_magacina = :sm or :sm = -1)
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK_VIRMAN,
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK_VIRMAN is null) then
      CEK_VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;
    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;


    select sum(d.prodaja), sum(d.refundacija), sum(d.broj_prodati), sum(d.broj_refundacija), sum(d.broj_dokumenata)
    from fiskalna_dnevin_izvestaj d
    where d.datum = :datum
    and d.idkase = :SIFRA_MAGACINA
    into :prodaja, :refundacija, :broj_prodati, :broj_refundacija, :broj_dokumenata ;

    if ( abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > ABS(:UKUPNO - :UKUPNO_DI) and abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > 1) then
        RAZLIKA = :UKUPNO - :PRODAJA - :storno;
    ELSE
        RAZLIKA = :UKUPNO - :UKUPNO_DI;

    suspend;
  end
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    SM integer,
    DATUM1 date,
    DATUM2 date)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    CEK_VIRMAN decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    DATUM date)
as
begin
 datum = :datum1;
 while (datum <= :datum2) do
 begin
     for
        select M.BENEFIT,
               M.MAGACIN,
               M.MESTO,
               M.SIFRA_MAGACINA,
               sum(M.GOTOVINA),
               sum(M.CEK_VIRMAN),
               sum(M.KARTICA),
               sum(M.UKUPNO),
               sum(M.BR_RADNIKA),
               sum(M.PROMET_PO_RADNIKU),
               sum(M.UKUPNO_DI),
               sum(M.RAZLIKA) ,
               sum(M.STORNO),
               sum(M.PROMET),
               sum(M.PRODAJA),
               sum(M.REFUNDACIJA),
               sum(M.BROJ_PRODATI),
               sum(M.BROJ_REFUNDACIJA),
               sum(M.BROJ_DOKUMENATA)
        from PROC_MP_IZVESTAJ_PAZAR(:DATUM, :SM) M
        group by M.BENEFIT, M.MAGACIN, M.MESTO, M.SIFRA_MAGACINA
        into :BENEFIT,
               :MAGACIN,
               :MESTO,
               :SIFRA_MAGACINA,
               :GOTOVINA,
               :CEK_VIRMAN,
               :KARTICA,
               :UKUPNO,
               :BR_RADNIKA,
               :PROMET_PO_RADNIKU,
               :UKUPNO_DI,
               :RAZLIKA ,
               :STORNO,
               :PROMET,
               :PRODAJA,
               :REFUNDACIJA,
               :BROJ_PRODATI,
               :BROJ_REFUNDACIJA,
               :BROJ_DOKUMENATA
     do
     begin
        suspend;

     end
   datum = datum + 1; 
 end

end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_PRETRAGA_POPIS (
    SM integer,
    SR integer,
    KOD1 varchar(20),
    ART varchar(255),
    BK varchar(50),
    TRAZI_ART integer,
    GODINA integer)
returns (
    ARTIKAL varchar(255),
    KOD varchar(20),
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    CENAMP decimal(18,4),
    CENAVP decimal(18,4),
    KOLICINA decimal(18,3),
    KATEGORIJA varchar(50),
    PROIZVODJAC varchar(100),
    CENA decimal(18,4),
    PROS_CENA decimal(18,4),
    CENA_LOKACIJA decimal(18,2),
    JED_MERE varchar(20))
as
declare variable SR1 integer;
BEGIN
    select sifra_robe, barkod from tblbarkod g where g.barkod = :bk
    into :sr1, :BARKOD;

    if (sr1 is not null) then SR = sr1;
if (trazi_art = 1) then
begin
  FOR
    select a.artikal, a.kod, a.sifra_robe,-- b.barkod,
     a.cenamp, a.cenavp,
    l.kolicina, k.kategorija_grupe as kategorija, p.proizvodjac,
    case when m.cena_magacin = 0 then a.cenamp
         when m.cena_magacin = 1 then l.cena
         when m.cena_magacin = 2 then coalesce( c.cena , a.cenamp, l.cena )
    end as cena,
    l.pros_cena , l.cena as cena_lokacija, jm.naziv as jed_mere
    
    from tblartikli a
    inner join tblmagacin m on m.sifra_magacina = :sm
--    left join tblbarkod b on a.sifra_robe = b.sifra_robe
    left join tlokacija l on (a.sifra_robe = l.sifra_robe and l.sifra_magacina = m.sifra_magacina and l.godina = :godina)
    left join tblvrstarobe k on a.sifra_kategorije = k.sifra_kategorije
    left join tblproizvodjac p on a.sifra_proizvodjaca = p.sifra_proizvodjaca
    left join tbl_cenovnik c on a.sifra_robe = c.sifra_robe and m.id_cenovnik = c.id_cenovnika and (current_date between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
    left join tbljm jm on a.idjm = jm.id
    where
    (a.sifra_robe = :sr
    
     or
     a.kod = :kod1 or ( upper(a.artikal) like '%' || upper( :art ) || '%' ) --or
--     b.barkod =  :bk
    
     )

    INTO :ARTIKAL,
         :KOD,
         :SIFRA_ROBE,

         :CENAMP,
         :CENAVP,
         :KOLICINA,
         :KATEGORIJA,
         :PROIZVODJAC,
         :CENA,
         :PROS_CENA,
         :CENA_LOKACIJA,
         :JED_MERE
  DO
  BEGIN
    SUSPEND;
  END
END

else
begin
  FOR
    select a.artikal, a.kod, a.sifra_robe,-- b.barkod,
     a.cenamp, a.cenavp,
    l.kolicina, k.kategorija_grupe as kategorija, p.proizvodjac,
    case when m.cena_magacin = 0 then a.cenamp
         when m.cena_magacin = 1 then l.cena
         when m.cena_magacin = 2 then coalesce( c.cena , a.cenamp, l.cena )
    end as cena,
    l.pros_cena , l.cena as cena_lokacija, jm.naziv as jed_mere
    
    from tblartikli a
    inner join tblmagacin m on m.sifra_magacina = :sm
--    left join tblbarkod b on a.sifra_robe = b.sifra_robe
    left join tlokacija l on (a.sifra_robe = l.sifra_robe and l.sifra_magacina = m.sifra_magacina and l.godina = :godina)
    left join tblvrstarobe k on a.sifra_kategorije = k.sifra_kategorije
    left join tblproizvodjac p on a.sifra_proizvodjaca = p.sifra_proizvodjaca
    left join tbl_cenovnik c on a.sifra_robe = c.sifra_robe and m.id_cenovnik = c.id_cenovnika  and (current_date between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
    left join tbljm jm on a.idjm = jm.id
    where
    (a.sifra_robe = :sr
    
     or
     a.kod = :kod1 --or ( upper(a.artikal) like '%' || upper( :art ) || '%' ) --or
--     b.barkod =  :bk
    
     )

    INTO :ARTIKAL,
         :KOD,
         :SIFRA_ROBE,

         :CENAMP,
         :CENAVP,
         :KOLICINA,
         :KATEGORIJA,
         :PROIZVODJAC,
         :CENA,
         :PROS_CENA,
         :CENA_LOKACIJA,
         :JED_MERE
  DO
  BEGIN
    SUSPEND;
  END
END
end^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_SINHRO_DNEVNI (
    SM integer,
    D1 date = null)
returns (
    SIFRA_MAGACINA integer,
    DATUMDPO date,
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    IZNOS decimal(18,4),
    ID integer,
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    IDKASE integer)
as
declare variable BAZA varchar(200);
declare variable DATUM timestamp;
declare variable D2 date;
declare variable SQL2 varchar(1024);
BEGIN
   if (:d1 is null) then D1 = current_date-1;
   D2 = :D1 + 1;
begin

SQL2 = 'select
sum(case when i.transactiontype = ''Sale'' and i.invoicetype = ''Normal'' then  i.totalamount else 0 end) as Prodaja,
sum(case when i.transactiontype = ''Refund'' and i.invoicetype = ''Normal'' then  i.totalamount else 0 end) as Storno ,
sum(case when i.transactiontype = ''Sale'' and i.invoicetype = ''Normal'' then  1 else 0 end) as brProdatih,
sum(case when i.transactiontype = ''Refund'' and i.invoicetype = ''Normal'' then  1 else 0 end) as brRefundacija
, max(i.totalcounter) - min(i.totalcounter) + 1 - count(i.id)
from invoice i
where   i.dateadded between '''||:d1 ||''' and '''||:d2 ||'''' ;


for
select   m.ip_adresa||':'||m.naziv_baze , m.sifra_magacina
from tblmagacin m
where m.sifra_magacina = :sm  or (:sm = -1)
and m.ip_adresa is not null
--and m.sifra_magacina not in (127,153,201,211)
into :baza , :SIFRA_MAGACINA


do
begin
  FOR
  EXECUTE STATEMENT 
    'select Z.SIFRA_MAGACINA, sum(Z.KES + Z.CEK + Z.KARTICA + Z.VIRMAN) as IZNOS, sum(z.kes) as kes,
sum(z.cek) as cek, sum(z.kartica) as kartica, sum(z.virman) as virman, Z.DATUMDPO

from MP_FISK_Z Z
where Z.PLACENO = ''Y'' and z.datumdpo = '''||:d1 ||'''
and z.sifra_dokumenta <> 1013
and z.sifra_magacina = '||:SIFRA_MAGACINA||'
group by Z.SIFRA_MAGACINA, Z.DATUMDPO '
ON EXTERNAL DATA SOURCE :BAZA AS USER 'sysdba' PASSWORD 'masterkey'
    INTO
         :SIFRA_MAGACINA,
         :iznos,
         :kes,
         :cek, 
         :kartica,
         :virman,
         :datumdpo
  DO
  BEGIN

      EXECUTE STATEMENT SQL2 ON EXTERNAL DATA SOURCE :BAZA AS USER 'SYSDBA' PASSWORD 'masterkey'
      INTO :PRODAJA, :REFUNDACIJA, :BROJ_PRODATI,  :BROJ_REFUNDACIJA, :BROJ_DOKUMENATA ;

      select first 1 k.id_broj_isecka
      from fiskalna_kasa k
      where k.sifra_magacina = :sm
      into :idkase;

      select first 1 i.id
      from fiskalna_dnevin_izvestaj i
      where i.idkase = :sifra_magacina
      and i.datum = :datumdpo
      into :id ;
      if (:id is null) then
      begin
        suspend;
        INSERT INTO FISKALNA_DNEVIN_IZVESTAJ ( IDKASE, DATUM,  PROMETT,   KES, CEK, KARTICA, VIRMAN, PRODAJA, REFUNDACIJA, BROJ_PRODATI,  BROJ_REFUNDACIJA, BROJ_DOKUMENATA) VALUES
        (:idkase, :datumdpo, :iznos, :kes, :cek, :kartica, :virman, :PRODAJA, :REFUNDACIJA, :BROJ_PRODATI,  :BROJ_REFUNDACIJA, :BROJ_DOKUMENATA);
      end
      else
      begin
           update FISKALNA_DNEVIN_IZVESTAJ i set
           IDKASE = :sifra_magacina, i.datum = :datumdpo,  PROMETT = :iznos,   KES = :kes, CEK= :cek, KARTICA= :kartica, VIRMAN=:virman ,
           prodaja = :PRODAJA, refundacija = :REFUNDACIJA, broj_prodati = :BROJ_PRODATI, broj_refundacija = :BROJ_REFUNDACIJA , BROJ_DOKUMENATA = :BROJ_DOKUMENATA
           where i.id = :id;
            suspend;
      end

  END
  when any
  do
  begin
  /*
         iznos=0;
         kes=0;
         cek=0;
         kartica=0;
         virman=0;
        PRODAJA=0;
        REFUNDACIJA=0;
        BROJ_PRODATI=0;
        BROJ_REFUNDACIJA=0;
        BROJ_DOKUMENATA=0;
        */
        if (id is  null) then
        begin
          id = -1;
          suspend;
        end
        id = null;
  end
  end
  end
END
^

SET TERM ; ^



update verzija set maloprodaja = 20221005;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221006 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_HP_SYNC_PROVERA (
    D1 date,
    SM integer,
    D2 date = null)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    CENA decimal(18,2),
    ARTIKAL varchar(255),
    PROCENATPDVA decimal(18,2),
    PRODAJA decimal(18,3),
    VREDNOST decimal(18,2),
    LAGER decimal(18,3),
    PROIZVODNJA decimal(18,3),
    PROIZVEDI decimal(18,3),
    DODAJ_PROIZ decimal(18,3),
    DOZVOLJEN_PRENOS char(1),
    VODI_SE_LAGER integer,
    STOPA decimal(18,4),
    SIFRA_POREZA integer,
    ULAZ_CENA decimal(18,4),
    UCESCE decimal(18,2),
    SIFRA_MAGACINA integer)
as
declare variable DOKUMENT_FISKAL integer;
declare variable SIFRA_KATEGORIJE integer;
declare variable ZA_PROIZ decimal(18,3);
declare variable UKUPNO_PRODATO decimal(18,4);
declare variable STARA_SIFRA integer;
declare variable VEC_PROIZVEDENO decimal(18,4);
declare variable FISK_PUSTEN integer;
declare variable PROMET_KASE decimal(18,4);
declare variable PROMET_PROGRAM decimal(18,4);
declare variable KONTROLA integer;
declare variable GODINA integer;
declare variable FORSIRAJ integer;
begin
  za_proiz = 0;
  proizvodnja = 0;
  lager = 0;
  prodaja = 0;
  proizvedi = 0;
  dozvoljen_prenos = 'N';
  dodaj_proiz = 0;
  proizvodnja = 0;
  stara_sifra = -1;
  fisk_pusten = 0;

  if(d2 is null) then
    d2 = :d1;
  godina = extract (year from :d1);

  select m.PREBACI_PRODAJU from tblmagacin m where m.sifra_magacina = :sm into :forsiraj;

   if (forsiraj = 0) then
   begin
    for
    select a.sifra_robe
    from azuriranje_lagera_hp(:sm, :godina) a
    into :SIFRA_ROBE
    do
    begin

    end
   end
  SIFRA_ROBE = null;

  select coalesce(sum(d.promett), 0)
  from fiskalna_dnevin_izvestaj d join fiskalna_kasa k on d.idkase = k.id_broj_isecka and d.datum = :d1 and k.sifra_magacina = :sm
  into :promet_kase;

  select coalesce(sum(z.kes) + sum(z.kartica) + sum(z.cek) + sum(z.virman), 0)
  from mp_fisk_z z
  where z.datumdpo between :d1 and :d2 and
        z.sifra_magacina = :sm  and
        coalesce((z.kes) + (z.kartica) + (z.cek) + (z.virman), 0) > 0
  into promet_program;

  if (abs(promet_kase - promet_program) < 1) then fisk_pusten = -3;

  select first 1 s.kontrolisi_promet_kasa from system s into :kontrola;
  if (:kontrola = 0) then fisk_pusten = 0;
  else if (:kontrola = -1) then fisk_pusten = -3;


  for select o.sifra_robe,
             a.kod,
             o.cena,
             a.artikal,
             o.procenatpdva,
             a.sifra_kategorije,
             a.vodi_se_lager,
             o.procenatpdva,
             o.sifra_poreza,
             a.plan_cena,
             o.sifra_magacina,
             sum(o.kolicina) as kolicina,
             sum(o.iznos) as vrednost,  --sum(o.cena * o.kolicina) as vrednost,
             sum(o.ucesce) as ucesce
            -- ,d.fiskalni

      from hp_obracun o    join tblartikli a on o.sifra_robe = a.sifra_robe
                           join mp_fisk_z z on o.idzg = z.idz
                           join tbldokumenti d on z.sifra_dokumenta = d.sifra_dokumenta
      where z.placeno = 'Y' and
           -- z.poslatouknjigovodstvo is distinct from 'D' and
           z.poslatouknjigovodstvo = 'P' and
            z.datumdpo between :d1 and :d2 and
            o.sifra_magacina = :sm and
            (z.fiskal_pusten > :fisk_pusten or d.fiskalni = 0)
           -- and o.sifra_robe = 140001
      group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, o.sifra_magacina--,d.fiskalni
      into :sifra_robe, :kod, :cena, :artikal, :procenatpdva, :sifra_kategorije, :vodi_se_lager, :stopa, :sifra_poreza,
           :ulaz_cena, :sifra_magacina, :prodaja, :vrednost, :ucesce--, :DOKUMENT_FISKAL
  do
  begin
    sm = :sifra_magacina;
    -- koliko ih ima na stanju u magacinu
    select (l.kolicina - l.rezervisano), l.hp_kol
    from tlokacija l join tblmagacin m on ((m.sifra_magacina = l.sifra_magacina) or (m.vezani_mg = l.sifra_magacina))
    where l.sifra_robe = :sifra_robe and
          l.sifra_magacina = :sm and
          l.kolicina >= 0 and
          l.godina = extract(year from :d1)
    into :lager, ukupno_prodato;

    --koliko moze da se proizvede
    select min(k.kol)
    from artikli_proveri_materijal(:sm, :sifra_robe, extract(year from :d1)) k
    into :proizvodnja;
/*
    -- koliko je ukupno prodato tog artikla
    select sum(o.kolicina)
    from hp_obracun o
    inner join mp_fisk_z z on o.idzg = z.idz
    where   z.datumdpo between :d1 and :d2 and
            z.placeno = 'Y' and
            z.poslatouknjigovodstvo is distinct from 'D' and
            o.sifra_magacina = :sm and
            (z.fiskal_pusten > :fisk_pusten or :DOKUMENT_FISKAL = 0  ) and
            o.sifra_robe = :sifra_robe

    into :ukupno_prodato;
*/
--proizvodnja = moguce napraviti AKO JE PROIZVODNJA=NULL ZNACI DA NEMA NORMATIVA
--proizvedi = potrebno napraviti
--za_proiz = toliko treba da se napravi
    begin
      if (lager is null) then
        lager = 0;
      if (za_proiz is null) then
        za_proiz = 0;
--      if (proizvodnja is null) then
--        proizvodnja = 0;

      --ako je prodaja veca od lagera i forsiraj=1 onda proizvedi koliko treba
      if ((prodaja - lager) > 0 or (forsiraj = 1) ) then
         za_proiz = (prodaja - lager);
      else
         za_proiz = 0;

      --ako treba da se napravi vise nego sto moze da se napravi i forsiraj = 1 onda napravi sve
      if ((za_proiz - proizvodnja) > 0 and forsiraj = 0) then
        proizvedi = proizvodnja;
      else
        proizvedi = za_proiz;

      if (proizvedi = 0 and
          (lager < prodaja)) then
        dodaj_proiz = (prodaja - lager - proizvodnja);
      if (proizvodnja is null) then
      begin
        dodaj_proiz = proizvedi;
        proizvedi = 0;
      end
      if (prodaja > lager and
          (proizvodnja + lager < prodaja)) then
        dozvoljen_prenos = 'N';
      else
        dozvoljen_prenos = 'D';
--      if (stara_sifra <> sifra_robe) then
      begin
        stara_sifra = sifra_robe;
        vec_proizvedeno = proizvedi;
      end
      if (prodaja <= vec_proizvedeno) then
      begin
        proizvedi = prodaja;
        vec_proizvedeno = vec_proizvedeno - prodaja;
      end
      else
      begin
        proizvedi = vec_proizvedeno;
        vec_proizvedeno = 0;
      end
      suspend;
      za_proiz = 0;
      lager = 0;
      prodaja = 0;
      proizvedi = 0;
      prodaja = 0;
      proizvodnja = 0;
      dodaj_proiz = 0;
      proizvodnja = 0;
      ukupno_prodato = 0;
    end
  end
end^

SET TERM ; ^



SET TERM ^ ;

create or alter procedure HP_RACUNIN (
    D1 date,
    D2 date,
    SM integer)
returns (
    BENEFIT decimal(18,2),
    KONTO_KUPCA integer,
    KUPAC_KONTO_K integer,
    DATUMDPO date,
    BROJ_RACUNA integer,
    DATUM date,
    SIFRA_KOMITENTA integer,
    SIFRA_MAGACINA integer,
    MAGACIN varchar(50),
    KOMITENT varchar(255),
    IZNOS decimal(18,2),
    SIFRA_DOKUMENTA integer,
    DOKUMENT varchar(50),
    SKRACENICA varchar(10),
    ADRESA_MG varchar(50),
    MESTO_MG varchar(50),
    PLACANJE varchar(255),
    VODI_SE_LAGER integer,
    KES decimal(18,2),
    KARTICA decimal(18,2),
    CEK decimal(18,2),
    VIRMAN decimal(18,2),
    SIFRA_KOMITENTA2 integer,
    NAPOMENA varchar(255),
    BID integer,
    UCESCE decimal(18,2),
    ID_MESTO_ISP integer,
    D_ROBNO integer,
    BROJ_RATA integer,
    DATUM_VALUTE date,
    IDNOVCANO integer,
    UKUPNO decimal(18,2),
    IDZ integer,
    INVOICENUMBER varchar(50),
    DATEADDED timestamp)
as
declare variable SORTIRANJE integer;
declare variable VREDNOST decimal(18,2);
declare variable PROMET_KASE decimal(18,2);
declare variable PROMET_PROGRAM decimal(18,2);
declare variable FISK_PUSTEN integer;
declare variable KONTROLA integer;
declare variable SIFRA_DEFAULT_KUPCA integer;
begin
  FISK_PUSTEN = 0;
  select coalesce(sum(D.PROMETT), 0)
  from FISKALNA_DNEVIN_IZVESTAJ D
  inner join FISKALNA_KASA K on D.IDKASE = K.ID_BROJ_ISECKA and D.DATUM between :D1 and :D2 and K.SIFRA_MAGACINA = :SM
  into :PROMET_KASE;
  select coalesce(sum(Z.KES) + sum(Z.KARTICA) + sum(Z.CEK) + sum(Z.VIRMAN), 0)
  from MP_FISK_Z Z
  where Z.DATUMDPO between :D1 and :D2 and
        Z.FISKAL_PUSTEN > 0 and
        Z.SIFRA_MAGACINA = :SM and
        coalesce((Z.KES) + (Z.KARTICA) + (Z.CEK) + (Z.VIRMAN) + (Z.BENEFIT), 0) > 0
  into :PROMET_PROGRAM;
  if (abs(PROMET_KASE - PROMET_PROGRAM) > 1) then
    FISK_PUSTEN = -3;
  select first 1 S.KONTROLISI_PROMET_KASA
  from SYSTEM S
  into :KONTROLA;
  if (:KONTROLA = 0) then
    FISK_PUSTEN = 0;
  else
  if (:KONTROLA = -1) then
    FISK_PUSTEN = -3;
  select M.MAGACIN,
         M.SIFRA_MAGACINA,
         M.SKRACENICA,
         M.ADRESA,
         M.MESTO
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :SM
  into :MAGACIN, :SIFRA_MAGACINA, SKRACENICA, ADRESA_MG, MESTO_MG;
  select first 1 F.SIFRA_DEFAULT_KUPCA
  from HP_FISKAL F
  into :SIFRA_DEFAULT_KUPCA;
  for select
             case
               when Z.SIFRA_KOMITENTA <> :SIFRA_DEFAULT_KUPCA then Z.IDZ
               else 0
             end as IDZ,
             Z.SIFRA_KOMITENTA,
             Z.SIFRA_MAGACINA,
             Z.SIFRA_DOKUMENTA,
             Z.DATUMDPO,
             sum(Z.KES) as KES,
             sum(Z.KARTICA) as KARTICA,
             sum(Z.CEK) as CEK,
             sum(Z.VIRMAN) as VIRMAN,
             sum(Z.BENEFIT) as BENEFIT
      from MP_FISK_Z Z
      where Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.DATUMDPO between :D1 and :D2 and
            Z.SIFRA_MAGACINA = :SM and
            Z.PLACENO = 'Y'
      group by 1, 2, 3, 4, 5
      into :IDZ, :SIFRA_KOMITENTA, :SIFRA_MAGACINA, :SIFRA_DOKUMENTA, :DATUM, :KES, :KARTICA, :CEK, :VIRMAN, :BENEFIT
  do
  begin
    if (:IDZ > 0) then
    begin
      select Z.BROJ_FISKALNOG,
             Z.SIFRA_KOMITENTA2,
             D.DOKUMENT,
             Z.BID,
             Z.NAPOMENA,
             Z.ID_MESTO_ISP,
             Z.BROJ_RATA,
             Z.DATUMVALUTE,
             M.KONTO_KUPCA,
             S.KUPAC,
             Z.ROBNO,
             Z.INVOICENUMBER,
             Z.DATUMPRAVLJENJA,
             K.KOMITENT
      from MP_FISK_Z Z
      inner join TBLKOMITENTI K on (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA) --AND K.SIFRA_KOMITENTA NOT IN (555, 501, 2000)
      inner join TBLDOKUMENTI D on (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
      inner join TBLMAGACIN M on M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
      inner join TBLSTATUS S on S.SIFRA_STATUSA = K.SIFRA_STATUSA
      where Z.IDZ = :IDZ
      into :BROJ_RACUNA, :SIFRA_KOMITENTA2, :DOKUMENT, :BID, :NAPOMENA, :ID_MESTO_ISP, :BROJ_RATA, :DATUM_VALUTE,
           :KONTO_KUPCA, :KUPAC_KONTO_K, :D_ROBNO, :INVOICENUMBER, :DATEADDED, :KOMITENT;
      select sum(cast((O.CENA + coalesce(O.UCESCE_CENA, 0)) * (
             case
               when (O.SIFRA_ROBE_RECEPT > 0 and O.KOLICINA_FISKAL is not null) then O.KOLICINA_FISKAL
               else O.KOLICINA
             end) as decimal(18,2))),
             coalesce(sum(O.UCESCE), 0)
      from HP_OBRACUN O
      inner join MP_FISK_Z Z on O.IDZG = Z.IDZ
      where Z.IDZ = :IDZ
      into :VREDNOST, :UCESCE;
    end
    else
    begin
      select first 1 Z.DATUMDPO,
                     Z.SIFRA_KOMITENTA,
                     K.KOMITENT,
                     Z.SIFRA_DOKUMENTA,
                     D.DOKUMENT,
                     Z.SIFRA_MAGACINA,
                     Z.DATUMDPO,
                     Z.DATUMVALUTE,
                     M.KONTO_KUPCA,
                     S.KUPAC,
                     Z.ROBNO
      from MP_FISK_Z Z
      inner join TBLKOMITENTI K on (Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA)
      inner join TBLDOKUMENTI D on (Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA)
      inner join TBLMAGACIN M on M.SIFRA_MAGACINA = Z.SIFRA_MAGACINA
      inner join TBLSTATUS S on S.SIFRA_STATUSA = K.SIFRA_STATUSA
      where Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.PLACENO = 'Y' and
            Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA and
            Z.SIFRA_MAGACINA = :SIFRA_MAGACINA and
            Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA and
            Z.DATUMDPO = :DATUM
      into :DATUM, :SIFRA_KOMITENTA, :KOMITENT, :SIFRA_DOKUMENTA, :DOKUMENT, :SIFRA_MAGACINA, :DATUMDPO, :DATUM_VALUTE,
           :KONTO_KUPCA, :KUPAC_KONTO_K, :D_ROBNO;
      select sum(cast((O.CENA + coalesce(O.UCESCE_CENA, 0)) * (
             case
               when (O.SIFRA_ROBE_RECEPT > 0 and O.KOLICINA_FISKAL is not null) then O.KOLICINA_FISKAL
               else O.KOLICINA
             end) as decimal(18,2))),
             coalesce(sum(O.UCESCE), 0)
      from HP_OBRACUN O
      inner join MP_FISK_Z Z on O.IDZG = Z.IDZ
      join TBLDOKUMENTI D on Z.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
      where Z.SIFRA_KOMITENTA = :SIFRA_KOMITENTA and
            Z.PLACENO = 'Y' and
            Z.POSLATOUKNJIGOVODSTVO = 'P' and
            Z.DATUMDPO = :DATUM and
            O.SIFRA_MAGACINA = :SIFRA_MAGACINA and
            Z.SIFRA_DOKUMENTA = :SIFRA_DOKUMENTA
      into :VREDNOST, :UCESCE;
    end
    PLACANJE = '';
    if (KES > 0) then
      PLACANJE = PLACANJE || 'KES:' || KES || ' ';
    if (KARTICA > 0) then
      PLACANJE = PLACANJE || 'KARTICA:' || KARTICA || ' ';
    if (CEK > 0) then
      PLACANJE = PLACANJE || 'CEK:' || CEK || ' ';
    if (VIRMAN > 0) then
      PLACANJE = PLACANJE || 'VIRMAN:' || VIRMAN || ' ';
    if (BENEFIT > 0) then
      PLACANJE = PLACANJE || 'BENEFIT:' || BENEFIT || ' ';
    if (UCESCE > 0) then
      PLACANJE = PLACANJE || 'UCESCCE:' || UCESCE || ' ';
    IZNOS = :KES + :CEK + :KARTICA + :VIRMAN + BENEFIT + :UCESCE;
 --   if (IZNOS <> VREDNOST) then
 --     KES = KES - (IZNOS - VREDNOST);
--    IZNOS = VREDNOST;
    suspend;
    KES = 0;
    KARTICA = 0;
    CEK = 0;
    VIRMAN = 0;
    BENEFIT = 0;
  end
end
^

SET TERM ; ^


update verzija set maloprodaja = 20221006;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221008 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          left join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          left join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          left join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        left join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, (-1)*:IDN, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :MAG, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select min(G.cena)
          from TBL_CENOVNIK G
          where g.id_cenovnika = :prijem   and
          g.sifra_robe = :sifra_robe --and
    --      (:DATUM between g.VAZI_OD and g.VAZI_DO or (:datum >= g.vazi_od and  g.VAZI_DO is null) )
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        left join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and
              A.DATE_CHANGE >= :DATUM) or (M.CENA_MAGACIN = 2 and
              C.DATE_CHANGE >= :DATUM)
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20221008;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221010 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_BENEFIT_KOMITENT_GOGA (
    D1 date,
    D2 date,
    SK integer = -1)
returns (
    KOMITENT varchar(255),
    SIFRA_KOMITENTA integer,
    DUGUJE decimal(18,4),
    IZNOS decimal(18,2),
    BENEFIT_IZNOS decimal(18,4),
    BENEFIT_PROCENAT decimal(18,4),
    IZNOS_ZA_ISPLATU decimal(18,4),
    BENEFIT_ISPLATA decimal(18,4))
as
declare variable TMPDUGUJE decimal(18,2);
declare variable TMP integer;
BEGIN
/*
   ova procedura racuna koliko benefit bonova
   treba da dobije odredjeni komitent
*/
    select first 1 s.benefit_iznos, s.benefit_procenat
    from system s
    into :benefit_iznos, :benefit_procenat;
  FOR
  with komitenti as (
    select
           K.KOMITENT, k.sifra_komitenta,
           coalesce(sum(pr.duguje),0) as duguje
    
    from tblnovcano Z
    join tblpromene pr on z.idnovcano = pr.idnovcano
    join tblartikli a on pr.sifra_robe = a.sifra_robe and a.nije_benefit is distinct from 1
    
    join TBLKOMITENTI K on Z.SIFRA_KOMITENTA = K.SIFRA_KOMITENTA
    
    where Z.DATUMDPO between :D1 and :D2
    and k.benefit_kartica is not null
    and z.sifra_dokumenta <> 1013
    AND (K.sifra_komitenta = :SK )
    group by 1,2

    union

    select k.komitent, b.sifra_komitenta, coalesce(sum(b.duguje),0)
    from tblkomit_benefit b join tblkomitenti k on b.sifra_komitenta = k.sifra_komitenta
    where b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    AND (K.sifra_komitenta = :SK)
    group by 1,2
    )

    select komitent, sifra_komitenta, sum(duguje)
    from komitenti
    group by 1,2

    INTO :KOMITENT,
         :SIFRA_KOMITENTA,
         :DUGUJE
  DO
  BEGIN
    select  0 , coalesce(sum(b.iznos),0)
    from tblkomit_benefit b
    where b.sifra_komitenta = :SIFRA_KOMITENTA
    and b.datum_isplate between :d1 and :d2
    and b.aktivan = 1
    into :tmpduguje, :iznos;
    duguje = :duguje + :tmpduguje ;

    select p.procenat
    from tblbenefit_procenti p
    where ((:duguje - :iznos)) between  p.iznos and p.iznos1 or ((:duguje - :iznos) > p.iznos and p.iznos1 is null)
    into :BENEFIT_PROCENAT;

    iznos_za_isplatu = (:duguje - :iznos)*:BENEFIT_PROCENAT/100.00;
    if (benefit_iznos > 0) then
       tmp = floor((duguje - iznos)/benefit_iznos);
       BENEFIT_ISPLATA = tmp * benefit_iznos;

       select first 1 p.procenat
       from tblbenefit_procenti p
       where :benefit_isplata between p.iznos and p.iznos1 or (:benefit_isplata > p.iznos and p.iznos1 is null)
       into :BENEFIT_PROCENAT;

       iznos_za_isplatu = BENEFIT_ISPLATA * :BENEFIT_PROCENAT/100.00;
    SUSPEND;
  END
END^

SET TERM ; ^



SET TERM ^ ;



CREATE OR ALTER TRIGGER TBLKOMIT_BENEFIT_BI0 FOR TBLKOMIT_BENEFIT
ACTIVE BEFORE INSERT POSITION 0
AS
    declare variable benefit varchar(20);
    declare variable aktivan integer;
begin
    select m.tip_benefita
    from system_mp m
    into :benefit;


    if (benefit = 'GOGA') then
    begin

        select u.active
        from ac_users u
        where u.card_number = new.sifra_komitenta
        into :aktivan;
        if (:aktivan is null) then
        begin
          INSERT INTO AC_USERS (CARD_NUMBER, "ACTIVE", SUPER)
                  VALUES (new.sifra_komitenta, 1, 0);
        end

        INSERT INTO AC_CREDIT_HISTORY ( "VALUE", DATE_INSERT,  CARD_ID, MP_FISK_Z_ID, SIFRA_MAGACINA, GUID_MPFISKZ, POSLATO)
        VALUES ( new.iznos_isplate, current_timestamp,  new.sifra_komitenta, NULL, null, NULL, 0);

    end
end
^


SET TERM ; ^


update verzija set maloprodaja = 20221010;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221012 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date,
    SM integer = -1)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    CEK decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer)
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'CEKOVI') as CEK,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'VIRMANSKI') as VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           and n.sifra_dokumenta <> 1013
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
          and (m.sifra_magacina = :sm or :sm = -1)
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK,
           :virman, 
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK is null) then
      CEK = 0;
    if (:VIRMAN is null) then
      VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;
    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;


    select sum(d.prodaja), sum(d.refundacija), sum(d.broj_prodati), sum(d.broj_refundacija), sum(d.broj_dokumenata)
    from fiskalna_dnevin_izvestaj d
    where d.datum = :datum
    and d.idkase = :SIFRA_MAGACINA
    into :prodaja, :refundacija, :broj_prodati, :broj_refundacija, :broj_dokumenata ;

    if ( abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > ABS(:UKUPNO - :UKUPNO_DI) and abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > 1) then
        RAZLIKA = :UKUPNO - :PRODAJA - :storno;
    ELSE
        RAZLIKA = :UKUPNO - :UKUPNO_DI;

    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    SM integer,
    DATUM1 date,
    DATUM2 date)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    CEK decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    DATUM date)
as
begin
 datum = :datum1;
 while (datum <= :datum2) do
 begin
     for
        select M.BENEFIT,
               M.MAGACIN,
               M.MESTO,
               M.SIFRA_MAGACINA,
               sum(M.GOTOVINA),
               sum(M.CEK),
               sum(M.VIRMAN),
               sum(M.KARTICA),
               sum(M.UKUPNO),
               sum(M.BR_RADNIKA),
               sum(M.PROMET_PO_RADNIKU),
               sum(M.UKUPNO_DI),
               sum(M.RAZLIKA) ,
               sum(M.STORNO),
               sum(M.PROMET),
               sum(M.PRODAJA),
               sum(M.REFUNDACIJA),
               sum(M.BROJ_PRODATI),
               sum(M.BROJ_REFUNDACIJA),
               sum(M.BROJ_DOKUMENATA)
        from PROC_MP_IZVESTAJ_PAZAR(:DATUM, :SM) M
        group by M.BENEFIT, M.MAGACIN, M.MESTO, M.SIFRA_MAGACINA
        into :BENEFIT,
               :MAGACIN,
               :MESTO,
               :SIFRA_MAGACINA,
               :GOTOVINA,
               :CEK,
               :VIRMAN,
               :KARTICA,
               :UKUPNO,
               :BR_RADNIKA,
               :PROMET_PO_RADNIKU,
               :UKUPNO_DI,
               :RAZLIKA ,
               :STORNO,
               :PROMET,
               :PRODAJA,
               :REFUNDACIJA,
               :BROJ_PRODATI,
               :BROJ_REFUNDACIJA,
               :BROJ_DOKUMENATA
     do
     begin
        suspend;

     end
   datum = datum + 1; 
 end

end^

SET TERM ; ^


update verzija set maloprodaja = 20221012;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221014 }

alter table tblcekovi_evidencija  alter COLUMN sifra_mesta drop not null;

update verzija set maloprodaja = 20221014;
COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221016 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_PLACANJA (
    IDZ integer)
returns (
    IDPLACANJA integer,
    NAZIV varchar(100),
    SUF_PAYMENT varchar(50),
    IZNOS decimal(18,4))
as
BEGIN
  FOR
    select p.idplacanja, p.naziv, p.suf_payment,
    (
     select  case
        when upper(p.naziv) = 'GOTOVINA' then z.kes
        when upper(p.naziv) = 'VIRMANSKI' then z.virman
        when upper(p.naziv) = 'CEKOVI' then z.cek
        when upper(p.naziv) = 'KARTICA' then z.kartica
        when upper(p.naziv) = 'BENEFIT' then z.benefit
        when upper(p.naziv) = 'VAUCER' then z.vaucer
        end as iznos
     from mp_fisk_z z
     where z.idz = :idz
    
    )
    from tip_placanja p
    where p.aktivan = 1
    and p.ide_na_kasu = 1
    and p.suf_payment is not null
    INTO :IDPLACANJA,
         :NAZIV,
         :SUF_PAYMENT,
         :IZNOS
  DO
  BEGIN
    if (iznos <> 0) then
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20221016;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221018 }


SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_DODAJ_ART_U_CENOVNIK (
    SR integer,
    IDC integer,
    DATUM date,
    CENA decimal(18,2),
    SRADNIK integer)
returns (
    IDCENOVNIK integer,
    LIFLET integer,
    SIFRA_ROBE integer,
    DATUMOD date,
    AUTO_UBACI_U_CENOVNIK integer,
    ID integer)
as
declare variable SLEDECI_DATUM_DO date;
begin
    --da li postoji u cenovniku vazeca cena za ovaj unos
    select first 1 c.id_cenovnika, c.sifra_robe, c.VAZI_od, c.id
    from tbl_cenovnik c
    where c.sifra_robe = :sr
    and c.id_cenovnika = :idc
    and ( (c.VAZI_od <= :datum and ( c.VAZI_do >= :datum or c.VAZI_do is null) )  )
    into :idcenovnik, :sifra_robe, :datumod , :id;

    --koji je sledeci datum od kog vazi neka druga cena a veci je od datuma unosa artikla u cenovnik
    select min(c.vazi_od)
    from tbl_cenovnik c
    where c.sifra_robe = :sr
    and c.id_cenovnika = :idc
    and c.vazi_od > :datum
    into :SLEDECI_DATUM_DO;

    -- da li postoji jos neki cenovnik u kome se nalazi taj artikal koji se unosi
    select c.id_cenovnika, c.sifra_robe
    from tbl_cenovnik c
    join tip_cenovnika a on C.ID_CENOVNIKA = A.ID
            where C.SIFRA_ROBE = :SR and
            A.ID_CENOVNIKA_OLD = -1 and
            (:DATUM between C.VAZI_OD and C.VAZI_DO or C.VAZI_DO is null)
            and a.aktivan = 1
    into :liflet, :sifra_robe;


    select first 1 m.auto_ubaci_art_cenovni
    from system_mp m into :auto_ubaci_u_cenovnik;
    --nema tog artikla u cenovniku, ubaci ga
    if (:idcenovnik is null and :auto_ubaci_u_cenovnik is not distinct from 1) then
    begin
       insert into tbl_cenovnik (ID, ID_CENOVNIKA, SIFRA_ROBE, CENA, VAZI_OD, VAZI_DO, SIFRA_RADNIKA, AKTIVAN)
       VALUES (gen_id(gen_tbl_cenovnik_id, 1), :idc, :sr, :cena, :datum, :SLEDECI_DATUM_DO-1, :sradnik, 1);
    end
    else
    if (:liflet is null) then
    begin
        update tbl_cenovnik c
        set c.stara_cena = c.cena, c.cena = :cena, c.date_change = 'now' , c.radnik_change = :sradnik
        where --c.id_cenovnika = :idc
        c.id = :id
        and c.sifra_robe = :sr
        and c.cena <> :cena
      --  and c.VAZI_od = :datumod
        and :cena > 0;
    end

  suspend;
end^

SET TERM ; ^


update verzija set maloprodaja = 20221018;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221118 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure AVANS_PROVERA_MP (
    KOMITENT integer,
    DOC integer)
returns (
    UPLACENO decimal(15,2),
    OBRACUNATO decimal(15,2),
    RAZLIKA decimal(15,2))
as
BEGIN
  FOR
    select CAST(SUM(p.vrednost * (-1)) as DECIMAL(15,2))
     FROM tblNovcano n, tblUslugePromene p, invoice i
     WHERE n.idnovcano=p.idnovcano
     AND n.sifra_komitenta=:komitent
     AND n.sifra_dokumenta=:doc
  --   and p.kolicina < 0
     and n.zavrseno = 0
     and n.idnovcano = i.idnovcano
    INTO :uplaceno
  DO
  BEGIN
  /*
     select SUM(a.ukupno) FROM tbl_obracun_avansa a, tblnovcano n
     WHERE  a.idnovcano=n.idnovcano
     AND n.sifra_komitenta=:komitent
     AND a.sifra_dokumenta=:doc
     INTO :obracunato;
  */
     if(obracunato is null) then obracunato=0;

     if((uplaceno-obracunato) <> 0) then
       begin
        razlika = uplaceno-obracunato;
        SUSPEND;
       end
  END
END^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_PROVERA_AVANS_PLACANJA
returns (
    IDNOVCANO integer,
    DUGUJE_NOVPLACANJE decimal(18,2),
    DUGUJE decimal(18,2),
    DUGUJE_USLGPROMENE decimal(18,4))
as
declare variable IDN integer;
declare variable VEZA integer;
BEGIN
--sredjuje avansna placanja u tblnov_placanja ako nedostaju
  FOR
    select n.idnovcano, (select sum(p.iznos) from tblnov_placanje p where p.idnovcano = n.idnovcano)    , n.duguje
       , (select sum(p.vrednost) from tbluslugepromene p where p.idnovcano = n.idnovcano)
    from tblnovcano n
    where n.sifra_dokumenta = 1000
    and n.duguje <> (select sum(p.iznos) from tblnov_placanje p where p.idnovcano = n.idnovcano)
    or (select sum(p.iznos) from tblnov_placanje p where p.idnovcano = n.idnovcano) is null
    INTO :IDNOVCANO,
         :duguje_novplacanje,
         :DUGUJE,
         :duguje_uslgpromene
  DO
  BEGIN
    if ( duguje_uslgpromene <> DUGUJE) then
    begin
        update tblnovcano n set n.duguje = :duguje_uslgpromene where n.idnovcano = :idnovcano;
    end 

    if (duguje_novplacanje = 0 or duguje_novplacanje is null ) then
    
            INSERT INTO TBLNOV_PLACANJE (IDNOVCANO,  IDNACIN_PLACANJA, IZNOS) VALUES (:IDNOVCANO,  2, :duguje_uslgpromene);
    SUSPEND;
  END

  for
  select  n.idnovcano, n.veza
  from tblnovcano n
  where n.sifra_dokumenta = 1000
  and n.veza is not null
  and n.source_dok is null
--  and n.idnovcano in (12,14,179,180)
  into :idnovcano, :idn
  do
  begin
    while (:idn > 0)
    do
    begin
      select a.veza
      from tblnovcano a
      where a.idnovcano = :idn
      into :veza;
      if (veza is null) then
      begin
        update tblnovcano n set n.source_dok = :idn where n.idnovcano = :idnovcano;
        idn = -1;
      end
      else
      begin
         idn = :veza;
      end
    end
  end
END^

SET TERM ; ^


update verzija set maloprodaja = 20221118;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221120 }

select  a.idnovcano
from PROC_MP_PROVERA_AVANS_PLACANJA a;
COMMIT WORK;

update verzija set maloprodaja = 20221120;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221122 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure ARTIKLI_DOC (
    MAG integer,
    DATUM date,
    DOC integer,
    IDN integer,
    PRIJEM integer)
returns (
    DATUM_PROMENE_CENE timestamp,
    SKLADISNI_PROSTOR varchar(20),
    KATEGORIJA_GRUPE varchar(50),
    PROIZVODJAC varchar(100),
    ULAZ_CENA decimal(15,4),
    IZLAZ_CENA decimal(15,4),
    KOLICINA decimal(15,4),
    IDNOVCANO integer,
    SIFRA_ROBE integer,
    BARKOD varchar(50),
    KOD varchar(20),
    CENA decimal(15,4),
    CENAVP decimal(15,4),
    CENAMP decimal(15,4),
    ARTIKAL varchar(255),
    CENAMPKURS decimal(15,4),
    BRDOK varchar(20),
    DATUMOUT date,
    CENAVP_POREZ_KURS decimal(18,2),
    STARA_CENA decimal(18,2),
    DATUM_AKCIJE_OD date,
    DATUM_AKCIJE_DO date,
    OPIS varchar(10000),
    CENA_SA_POPUSTOM decimal(18,2),
    AKCIJA_OZNAKA varchar(1),
    ROK_TRAJANJA date,
    COUNTER integer,
    ZEMLJA_POREKLA varchar(30),
    STATUS_CENE varchar(1),
    ZEMLJA_UVOZA varchar(30))
as
declare variable KURS numeric(15,2);
declare variable CENA_MAGACIN integer;
declare variable ID_CENOVNIK integer;
declare variable TIP_CENA integer;
begin
  select KURS
  from TBLKURS
  where VALUTA = 'EURO'
  into :KURS;
  if (:DATUM is null) then
    DATUM = current_date;
  select M.CENA_MAGACIN,
         M.ID_CENOVNIK,
         M.TIP_CENA
  from TBLMAGACIN M
  where M.SIFRA_MAGACINA = :MAG
  into :CENA_MAGACIN, :ID_CENOVNIK, :TIP_CENA;
  -- UZIMAS CENE IZ POSEBNOG DOKUMENTA ZA IZABRANI MAGACIN I IZABRANI DATUM
  if (:IDN > 0) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               P.CENA_MG,
               A.KOD,
               A.SIFRA_ROBE,
               N.IDNOVCANO,
               (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
               P.IZLAZ_CENA,
               P.ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               N.DATUMDPO,
               P.ROK_TRAJANJA,
               case
                 when N.BUD is null then cast(N.BID as varchar(20))
                 when N.BID is null then cast(N.BUD as varchar(20))
                 else cast(N.BID as varchar(20))
               end as BRDOK,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               P.STATUS_CENE
        from TBLNOVCANO N
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        where N.IDNOVCANO = P.IDNOVCANO and
              P.SIFRA_ROBE = A.SIFRA_ROBE and
              N.DATUMDPO = :DATUM and
              N.SIFRA_MAGACINA = :MAG and
              L.SIFRA_ROBE = A.SIFRA_ROBE and
              L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
              K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
              V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
              A.SIFRA_POREZA = S.SIFRA_POREZA and
              N.IDNOVCANO = :IDN and
              L.GODINA = extract(year from :DATUM)
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
             :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
             :STATUS_CENE
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      suspend;
    end
  end
  else
  if (:DOC > 0) then
  begin
    if (:PRIJEM = 1) then
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 P.IDNOVCANO,
                 PS.KOLICINA as KOLICINA,
                 PS.IZLAZ_CENA,
                 0 as ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 P.DATUM,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA
          from TBLARTIKLI A
          left join TBLPREDRACUNSASTAV PS on PS.SIFRA_ROBE = A.SIFRA_ROBE
          left join TBLPREDRACUN P on P.IDPRED = PS.IDPRED
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = P.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
          left join TLOKACIJA L on L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = P.SIFRA_MAGACINA and L.GODINA = extract(year from :DATUM)
          left join TBLNOVCANO N on N.IDNOVCANO = P.IDNOVCANO
          left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
          left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where P.ID_DOKUMENTA = :DOC and
                P.DATUM = :DATUM and
                P.SIFRA_MAGACINA = :MAG
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :BRDOK, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM,
               :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        suspend;
      end
    end
    else
    begin
      for select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 N.IDNOVCANO,
                 (P.IZLAZ_KOL + P.ULAZ_KOL) as KOLICINA,
                 P.IZLAZ_CENA,
                 P.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 N.DATUMDPO,
                 P.ROK_TRAJANJA,
                 case
                   when N.BUD is null then cast(N.BID as varchar(20))
                   when N.BID is null then cast(N.BUD as varchar(20))
                   else cast(N.BID as varchar(20))
                 end as BRDOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 P.STATUS_CENE
          from TBLNOVCANO N
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = N.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLPROMENE P, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where N.IDNOVCANO = P.IDNOVCANO and
                P.SIFRA_ROBE = A.SIFRA_ROBE and
                N.SIFRA_DOKUMENTA = :DOC and
                N.DATUMDPO = :DATUM and
                N.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = N.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 NA.IDNOVCANO,
                 NS.KOLICINA as KOLICINA,
                 NS.CENA,
                 NS.ULAZ_CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 NA.DATUM,
                 null,
                 NA.BROJ_DOK,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLNABAVKA NA
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = NA.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLNABAVKASTAVKE NS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where NA.ID = NS.IDNABAVKE and
                NS.SIFRA_ROBE = A.SIFRA_ROBE and
                NA.ID_DOKUMENTA = :DOC and
                NA.DATUM = :DATUM and
                NA.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = NA.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          union
          select A.ARTIKAL,
                 A.CENAMP,
                 cast(A.CENAMP * :KURS as integer),
                 A.CENAVP,
                 L.CENA,
                 A.KOD,
                 A.SIFRA_ROBE,
                 RE.IDNOVCANO,
                 RS.KOLICINA as KOLICINA,
                 RS.CENA,
                 RS.CENA,
                 K.PROIZVODJAC,
                 V.KATEGORIJA_GRUPE,
                 RE.DATUM1,
                 null,
                 RE.BROJ_REZERVACIJE,
                 A.CENAVP as CENAVP_POREZ_KURS,
                 A.CENAMP_SA_POPUSTOM,
                 cast(A.TEKST_ODOBRENJA as varchar(10000)),
                 A.CENOVNIK,
                 L.SKLADISNI_PROSTOR,
                 Z.ZEMLJA,
                 Z2.ZEMLJA,
                 '' as STATUS_CENE
          from TBLREZERVACIJA RE
          left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = RE.SIFRA_KOMITENTA
          left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
          left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE, TBLREZERVACIJASASTAV RS, TLOKACIJA L, TBLPROIZVODJAC K, TBLPOREZ S, TBLVRSTAROBE V, TBLARTIKLI A
          left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
          where RE.IDREZERVACIJE = RS.IDREZERVACIJE and
                RS.SIFRA_ROBE = A.SIFRA_ROBE and
                RE.SIFRA_DOKUMENTA = :DOC and
                RE.DATUM1 = :DATUM and
                RS.SIFRA_MAGACINA = :MAG and
                L.SIFRA_ROBE = A.SIFRA_ROBE and
                L.SIFRA_MAGACINA = RS.SIFRA_MAGACINA and
                K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA and
                V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE and
                A.SIFRA_POREZA = S.SIFRA_POREZA and
                L.GODINA = extract(year from :DATUM)
          into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
               :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :DATUMOUT, :ROK_TRAJANJA, :BRDOK, :CENAVP_POREZ_KURS,
               :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA, :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA,
               :STATUS_CENE
      do
      begin
        select B.BARKOD
        from PROC_MP_BARKOD(:SIFRA_ROBE) B
        into :BARKOD;
        COUNTER = COUNTER + 1;
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        suspend;
      end
    end
  end

  -- UZIMAS CENE IZ LAGER LISTE
  else
  if (:DOC = -1) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               L.CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               A.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.CENAMP_STARA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        inner join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      if (:TIP_CENA = 1) then -- PROSECNA CENA
      begin
        if (:KOLICINA > 0) then
        begin
          CENA = :CENA / :KOLICINA;
        end
      end
      else
      if (:TIP_CENA = 0) then --VELEPRODAJNA---------------------------
      begin
        if (:CENA_MAGACIN = 0) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 1) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAVP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      else
      if (:TIP_CENA = 3) then --MALOPRODAJNA--------------------------
      begin
        if (:CENA_MAGACIN = 1) then -- CENA IZ TLOKACIJE
        begin
          -- CENA = CENA
        end
        else
        if (:CENA_MAGACIN = 0) then -- CENA IZ ARTIKALA
        begin
          CENA = :CENAMP;
        end
        else
        if (:CENA_MAGACIN = 2 and
            (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO,
                 C.CENAMP_SA_POPUSTOM
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
        end
        else
        begin
          select C.CENA,
                 C.STARA_CENA,
                 C.VAZI_OD,
                 C.VAZI_DO
          from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
          into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
        end
      end
      COUNTER = COUNTER + 1;
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -2 and
      :PRIJEM = 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        left join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, (-1)*:IDN, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA i iz starog cenovnika
  else
  if (:DOC = -2 and
      :PRIJEM > 0) then
  begin
    for select distinct A.ARTIKAL,
                        A.CENAMP,
                        A.CENAVP,
                        A.KOD,
                        A.SIFRA_ROBE,
                        1 as IDNOVCANO,
                        0 as KOLICINA,
                        K.PROIZVODJAC as PROIZVODJAC,
                        V.KATEGORIJA_GRUPE,
                        A.CENAVP as CENAVP_POREZ_KURS,
                        cast(A.TEKST_ODOBRENJA as varchar(10000)),
                        Z.ZEMLJA,
                        Z2.ZEMLJA
        from TBL_CENOVNIK C
        join TBL_CENOVNIK C2 on C.SIFRA_ROBE = C2.SIFRA_ROBE and C2.id_cenovnika = :PRIJEM
        join TBLARTIKLI A on A.SIFRA_ROBE = C.SIFRA_ROBE and C.ID_CENOVNIKA = :MAG
        inner join TBLPOREZ S on (A.SIFRA_POREZA = S.SIFRA_POREZA)
        --   INNER JOIN TBLMAGACIN M ON M.SIFRA_MAGACINA = :MAG
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        where C.CENA > 0
        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAVP, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :PROIZVODJAC, :KATEGORIJA_GRUPE,
             :CENAVP_POREZ_KURS, :OPIS, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM,
               G.DATUM_CHANGE,
               G.CENOVNIK
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :MAG, :DATUM) C
        join TBL_CENOVNIK G on C.ID = G.ID
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM, :DATUM_PROMENE_CENE,
             :AKCIJA_OZNAKA;
        if (:PRIJEM > 0) then
        begin
          select min(G.cena)
          from TBL_CENOVNIK G
          where g.id_cenovnika = :prijem   and
          g.sifra_robe = :sifra_robe --and
    --      (:DATUM between g.VAZI_OD and g.VAZI_DO or (:datum >= g.vazi_od and  g.VAZI_DO is null) )
          into :STARA_CENA;
        end
      end
      suspend;
    end
  end

  -- UZIMAS CENE IZ CENOVNIKA
  else
  if (:DOC = -3) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               cast(A.CENAMP * :KURS as integer),
               A.CENAVP,
               case
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA = 3 then A.CENAMP
                 when M.CENA_MAGACIN = 0 and M.TIP_CENA <> 3 then A.CENAVP
                 when M.CENA_MAGACIN = 1 then L.CENA
                 when M.CENA_MAGACIN = 2 then C.CENA
               end as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               1 as IDNOVCANO,
               L.KOLICINA as KOLICINA,
               L.CENA as IZLAZ_CENA,
               L.CENA as ULAZ_CENA,
               K.PROIZVODJAC as PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               A.CENAVP as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)),
               C.CENOVNIK,
               L.SKLADISNI_PROSTOR,
               C.STARA_CENA,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               C.DATE_CHANGE,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBL_CENOVNIK C
        left join TBLARTIKLI A on C.SIFRA_ROBE = A.SIFRA_ROBE
        inner join TBLMAGACIN M on M.SIFRA_MAGACINA = :MAG and C.ID_CENOVNIKA = M.ID_CENOVNIK
        left join TBLPROIZVODJAC K on (K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA)
        left join TBLVRSTAROBE V on (V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE)
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO MS on MS.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on MS.ID_ZEMLJE = Z2.ID_ZEMLJE
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.KOLICINA > 0 and L.SIFRA_MAGACINA = :MAG and L.GODINA = extract(year from :DATUM))
        where (M.CENA_MAGACIN <> 2 and A.DATE_CHANGE >= :DATUM) or
               (M.CENA_MAGACIN = 2 and ((C.DATE_CHANGE = :DATUM and  (:DATUM between c.vazi_od and c.vazi_do or c.vazi_do is null ) ) or ( :datum = c.vazi_od) )  )

        order by A.SIFRA_KATEGORIJE, A.ARTIKAL
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :AKCIJA_OZNAKA,
             :SKLADISNI_PROSTOR, :STARA_CENA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_PROMENE_CENE, :DATUM_AKCIJE_OD,
             :DATUM_AKCIJE_DO
    do
    begin
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      if (:IDN > 0) then
      begin
        select C.STARA_CENA
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :IDN, :DATUM) C
        into :STARA_CENA;
      end
      suspend;
    end
  end

  -- STAMPA ARTIKLE
  else
  if (:DOC = -4) then
  begin
    for select A.ARTIKAL,
               A.CENAMP,
               A.CENAMP as CENAMPKURS,
               A.CENAVP,
               0.0 as CENA,
               A.KOD,
               A.SIFRA_ROBE,
               0 as IDNOVCANO,
               1.0 as KOLICINA,
               0.0 as IZLAZ_CENA,
               0.0 as ULAZ_CENA,
               K.PROIZVODJAC,
               V.KATEGORIJA_GRUPE,
               ((A.CENAVP)) as CENAVP_POREZ_KURS,
               A.CENAMP_SA_POPUSTOM,
               cast(A.TEKST_ODOBRENJA as varchar(10000)) as OPIS,
               A.CENAMP_STARA,
               A.CENOVNIK,
               Z.ZEMLJA,
               Z2.ZEMLJA,
               A.AKCIJA_OD,
               A.AKCIJA_DO
        from TBLARTIKLI A
        left join TBLZEMLJA Z on A.ID_ZEMLJE_POREKLO = Z.ID_ZEMLJE
        left join TBLVRSTAROBE V on V.SIFRA_KATEGORIJE = A.SIFRA_KATEGORIJE
        left join TBLPROIZVODJAC K on K.SIFRA_PROIZVODJACA = A.SIFRA_PROIZVODJACA
        left join TBLKOMITENTI KM on KM.SIFRA_KOMITENTA = A.SIFRA_DOBAVLJACA
        left join TBLMESTO M on M.SIFRA_MESTA = KM.SIFRA_MESTA
        left join TBLZEMLJA Z2 on M.ID_ZEMLJE = Z2.ID_ZEMLJE
        into :ARTIKAL, :CENAMP, :CENAMPKURS, :CENAVP, :CENA, :KOD, :SIFRA_ROBE, :IDNOVCANO, :KOLICINA, :IZLAZ_CENA,
             :ULAZ_CENA, :PROIZVODJAC, :KATEGORIJA_GRUPE, :CENAVP_POREZ_KURS, :CENA_SA_POPUSTOM, :OPIS, :STARA_CENA,
             :AKCIJA_OZNAKA, :ZEMLJA_POREKLA, :ZEMLJA_UVOZA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO
    do
    begin
      if (:CENA_MAGACIN = 2 and
          (:CENA_SA_POPUSTOM is null or :CENA_SA_POPUSTOM = 0)) then -- CENA IZ CENOVNIKA
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO,
               C.CENAMP_SA_POPUSTOM
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO, :CENA_SA_POPUSTOM;
      end
      else
      begin
        select C.CENA,
               C.STARA_CENA,
               C.VAZI_OD,
               C.VAZI_DO
        from CENA_ARTIKLA_IZ_CENOVNIKA(:SIFRA_ROBE, :ID_CENOVNIK, :DATUM) C
        into :CENA, :STARA_CENA, :DATUM_AKCIJE_OD, :DATUM_AKCIJE_DO;
      end
      select B.BARKOD
      from PROC_MP_BARKOD(:SIFRA_ROBE) B
      into :BARKOD;
      COUNTER = COUNTER + 1;
      suspend;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20221122;
COMMIT WORK;
{$ENDIF}

SET TERM ^ ;

create or alter procedure PROC_MP_VAGA1 (
    ID integer,
    DATUM date,
    GODINA integer)
returns (
    PLU varchar(20),
    COM varchar(255),
    UP decimal(18,4),
    IDVAGE integer,
    KOD_VAGE varchar(5),
    S1U integer,
    BCF integer,
    FLAG integer,
    ING char(4))
as
declare variable SM integer;
declare variable BR_KARAKTERA integer;
BEGIN
-- digi tip=1
    select first 1 v.sifra_magacina , v.broj_karaktera, v.kod_vage, v.id
    from vaga v
    where v.id = :id
    into :sm, :br_karaktera, :kod_vage, :idvage ;
  FOR
    select
    lpad(substr(a.kod_info, 3,8),:br_karaktera, '0') as  plu,
     replace( a.artikal, ',', ' ')as com,

       (select C.CENA
        from ARTIKLI_CENA(:SM, -1, A.SIFRA_ROBE, :SM, :DATUM, :GODINA) C) as up,
     case when m.vaga_komad = 1 then 1 else 0 end as s1u,5 as bcf,
     case when m.vaga_komad =1 then '23'||lpad(substr(a.kod_info, 3,8),:br_karaktera, '0') else
     '27'||lpad(substr(a.kod_info, 3,8),:br_karaktera, '0') end as flag,
     'NEMA' as ing
    from tblartikli a
    left join tbljm m on a.idpjm = m.id
    where a.vaga = 1
    INTO :PLU,
         :COM,
         :UP,
         :S1U,
         :BCF,
         :FLAG,
         :ING
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^



--sablon
--{$IFEXISTS SELECT maloprodaja
--             FROM verzija
--             WHERE maloprodaja < yyyymmdd }

--SET TRPARAMS 'isc_tpb_wait';
--
--update verzija set maloprodaja = yyyymmdd;
--COMMIT WORK;
--{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221213 }
             
SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKAL_PRONADJI_ABP (
    TMP_SIFRA integer,
    KODIN varchar(20),
    NAZIV_ARTIKLA varchar(255))
returns (
    SIFRA integer)
as
declare variable ABP integer;
begin
      select ACCEPTS_BARCODE_PART from system_mp
      into :abp;

      if (TMP_SIFRA is not null) then
      begin
            select AB.SIFRA_ROBE
            from TBLARTIKLI AB
            where
            AB.SIFRA_ROBE = :TMP_SIFRA
            into sifra;
            suspend;
      end 
      else if (:abp = 0 or :abp is null ) then
      begin
        for
            select AB.SIFRA_ROBE
            from TBLARTIKLI AB
            where
            upper(AB.KOD) like upper( :KODIN )
            or upper(AB.ARTIKAL) like upper('%' || :NAZIV_ARTIKLA || '%')
            or (ab.jkl = :kodin)
            into :sifra
            do
            begin
               suspend;
            end
      end 
      else if (:abp = 1) then
      begin     
        for
            select AB.SIFRA_ROBE
            from TBLARTIKLI AB
            where
            upper(AB.KOD) like upper('%' || :KODIN || '%')
            or upper(AB.ARTIKAL) like upper('%' || :NAZIV_ARTIKLA || '%')
            into :sifra
            do
            begin
               suspend;
            end
      end
      else if (:abp = 2) then
      begin
        for
            select AB.SIFRA_ROBE
            from TBLARTIKLI AB
            where

             (:ABP is not distinct from 2 and upper(AB.KOD) like upper(:KODIN || '%'))
            or upper(AB.ARTIKAL) like upper('%' || :NAZIV_ARTIKLA || '%')
            into :sifra
            do
            begin
               suspend;
            end
      end


end^

SET TERM ; ^



SET TERM ^ ;

create or alter procedure ARTIKLI_OFLINE (
    MG integer,
    KAT integer,
    KOLIN decimal(18,4),
    KODIN varchar(20),
    BK varchar(50),
    SR integer,
    NAZIV_ARTIKLA varchar(250),
    MG1 integer,
    DATUM_F date,
    IDCK integer,
    GODINA integer = null)
returns (
    SKLADISNI_PROSTOR varchar(20),
    AKTIVAN integer,
    AKCIJA varchar(1),
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOL decimal(18,4),
    REZER_KOL decimal(18,4),
    PROSECNA_CENA decimal(18,4),
    SIFRA_POREZA integer,
    KATEGORIJA varchar(50),
    PROIZVODJAC varchar(100),
    POREZ decimal(18,2),
    GARANCIJA integer,
    CENA decimal(18,2),
    CENA1 decimal(18,4),
    PL_CENA decimal(18,2),
    MARZA decimal(18,2),
    MARZA_MP decimal(18,2),
    PROSEK decimal(18,2),
    EXTRA_CENA varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA decimal(18,2),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    BARKOD varchar(50),
    FISKAL smallint,
    BOJA integer,
    KOL_SARZA decimal(18,4),
    ROK_TRAJANJA date,
    BROJ_SERIJE varchar(30),
    LAGER_KOL decimal(18,4),
    KOD_PR varchar(20),
    ID_CENOVNIK integer,
    CENA_CENOVNIK decimal(18,4),
    VODI_SE_LAGER integer,
    NAB_VREDNOST decimal(18,4),
    ODNOSPJM double precision,
    POVRATNA_AMBALAZA integer,
    VAGA_KOMAD integer,
    PRODAJA_CEO_BROJ integer,
    RABATC decimal(18,4),
    LABEL varchar(10))
as
declare variable CUSTOM_WHERE varchar(500);
declare variable ABP smallint;
declare variable GODINA_RADA integer;
declare variable CENOVNIK integer;
declare variable TIP_CENA integer;
declare variable KOL_PROIZVEDI decimal(18,4);
declare variable PROIZVODNJA integer;
declare variable HP_TABELE integer;
declare variable KOL_FAKTURISANO decimal(18,4);
declare variable CENOVNIK1 integer;
declare variable ID_CENOVNIK1 integer;
declare variable TIP_CENA1 integer;
declare variable KOL_ decimal(18,4);
declare variable TMP_SIFRA integer;
declare variable SIFRA integer;
declare variable ASORTIMAN integer;
declare variable ASORT_BROJ integer;
begin
  --ZPHARM
  select GODINA
  from SYSTEM
  into :GODINA_RADA;
  select p.asortiman from system_mp p into :asortiman;
  if (:GODINA is null) then
    GODINA = GODINA_RADA;
  if (KODIN = '-1') then
    TMP_SIFRA = SR;
  else
  if (BK = '-1') then
  begin
    select A.TMP_SIFRA
    from ARTIKAL_PRONADJI(:KODIN) A
    into :TMP_SIFRA;
  end
  for select SIFRA
      from ARTIKAL_PRONADJI_ABP(:TMP_SIFRA, :KODIN, :NAZIV_ARTIKLA)
      into :SIFRA
  do
  begin
    select A.KOD,
           A.SIFRA_ROBE,
           A.SIFRA_KATEGORIJE,
           A.SIFRA_PROIZVODJACA,
           A.ARTIKAL,
           A.JED_MERE,
           A.CENAVP,
           A.CENAMP,
           A.KOL,
           A.REZER_KOL,
           A.PROSECNA_CENA,
           A.SIFRA_POREZA,
           A.KATEGORIJA,
           A.PROIZVODJAC,
           A.POREZ,
           A.GARANCIJA,
           A.CENA,
           A.CENA1,
           A.PL_CENA,
           A.MARZA,
           A.MARZA_MP,
           A.PROSEK,
           A.EXTRA_CENA,
           A.TARIFNI_BROJ,
           A.TARIFNA_STOPA,
           A.PODVRSTA,
           A.GRUPA,
           A.BARKOD,
           A.FISKAL,
           A.BOJA,
           A.KOL_SARZA,
           A.ROK_TRAJANJA,
           A.BROJ_SERIJE,
           A.LAGER_KOL,
           A.KOD_PR,
           A.ID_CENOVNIK,
           A.CENA_CENOVNIK,
           A.VODI_SE_LAGER,
           A.NAB_VREDNOST,
           A.AKCIJA_OZNAKA,
           A.AKTIVAN,
           A.SKLADISNI_PROSTOR,
           A.ODNOSPJM,
           A.POVRATNA_AMBALAZA,
           A.VAGA_KOMAD,
           A.PRODAJA_CEO_BROJ,
           A.RABATC,
           A.LABEL
    from ARTIKLI_CENA(:MG, :KOLIN, :SIFRA, :MG1, :DATUM_F, :GODINA, :idck) A
    into :KOD, :SIFRA_ROBE, :SIFRA_KATEGORIJE, :SIFRA_PROIZVODJACA, :ARTIKAL, :JED_MERE, :CENAVP, :CENAMP, :KOL,
         :REZER_KOL, :PROSECNA_CENA, :SIFRA_POREZA, :KATEGORIJA, :PROIZVODJAC, :POREZ, :GARANCIJA, :CENA, :CENA1,
         :PL_CENA, :MARZA, :MARZA_MP, :PROSEK, :EXTRA_CENA, :TARIFNI_BROJ, :TARIFNA_STOPA, :PODVRSTA, :GRUPA, :BARKOD,
         :FISKAL, :BOJA, :KOL_SARZA, :ROK_TRAJANJA, :BROJ_SERIJE, :LAGER_KOL, :KOD_PR, :ID_CENOVNIK, :CENA_CENOVNIK,
         :VODI_SE_LAGER, :NAB_VREDNOST, :AKCIJA, :AKTIVAN, :SKLADISNI_PROSTOR, :ODNOSPJM, :POVRATNA_AMBALAZA,
         :VAGA_KOMAD, :PRODAJA_CEO_BROJ, :RABATC, :LABEL;
    if (:SIFRA_ROBE is not null and
        :AKTIVAN = 1) then
    begin
      select first 1 R.SIFRA_POREZ_IZLAZ,
                     R.STOPA_POREZ_IZLAZ,
                     R.LABEL_IZLAZ
      from ARTIKLI_POREZ_IZLAZ(:SIFRA_ROBE) R
      into :SIFRA_POREZA, :POREZ, :LABEL;
      if (asortiman is null or asortiman =0 ) then
      begin
      suspend;
      end
      else
      begin
       select count(*) from tblartikli_asortiman a where a.sifra_magacina=:mg and a.sifra_robe=:sifra_robe and a.aktivan=1 into :asort_broj;
       if (:asort_broj >0) then
       begin
          suspend;
       end
      end
      SIFRA_ROBE = null;
    end
  end
end^

SET TERM ; ^




SET TERM ^ ;

create or alter procedure ARTIKLI_OFLINE_RESTORAN (
    SM integer,
    KAT integer,
    GODINA integer)
returns (
    KOD varchar(20),
    ARTIKAL varchar(255),
    CENAMP decimal(18,4),
    SIFRA_ROBE integer,
    POREZ decimal(18,2),
    FISKAL smallint,
    KOL decimal(18,4),
    PROIZVEDENO integer,
    SMAGACIN integer,
    VODI_SE_LAGER integer)
as
declare variable ASORTIMAN_BROJ integer;
declare variable ASORTIMAN integer;
declare variable UVEK_VIDLJIV_ARTIKAL integer;
BEGIN
    select s.nema_na_stanju from system s into :uvek_vidljiv_artikal;
    select p.asortiman from system_mp p into:asortiman;

  FOR
    SELECT A.KOD, A.ARTIKAL, A.CENAMP, A.SIFRA_ROBE, P.STOPA1 AS POREZ, P.FISKAL,A.KOL,1 as proizvedeno,
    cast( :SM as integer) as smagacin, a.vodi_se_lager
    FROM ARTIKLI(:SM, :KAT, :GODINA) A, TBLPOREZ P
    WHERE  A.SIFRA_POREZA=P.SIFRA_POREZA
    AND A.aktivan = 1
    AND (A.KOL>0 or a.vodi_se_lager = 0 or  :uvek_vidljiv_artikal = 1)
    INTO :KOD,
         :ARTIKAL,
         :CENAMP,
         :SIFRA_ROBE,
         :POREZ,
         :FISKAL,
         :KOL,
         :PROIZVEDENO,
         :SMAGACIN,
         :vodi_se_lager
  DO
  BEGIN
   if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:sm and a.sifra_robe=:sifra_robe and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
  END
      

  FOR
    SELECT A.KOD, A.ARTIKAL, A.CENAMP, A.SIFRA_ROBE, P.STOPA1 AS POREZ, P.FISKAL,A.KOL,A.PROIZVEDENO,
    cast( :SM as integer) as smagacin
    FROM ARTIKLI_RESTORAN(:SM , :KAT, :godina) A, TBLPOREZ P
    WHERE  A.SIFRA_POREZA=P.SIFRA_POREZA
    and a.aktivan = 1
    AND A.KOL>0
    INTO :KOD,
         :ARTIKAL,
         :CENAMP,
         :SIFRA_ROBE,
         :POREZ,
         :FISKAL,
         :KOL,
         :PROIZVEDENO,
         :SMAGACIN
  DO
  BEGIN
    vodi_se_lager = 1;
       if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:sm and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
  END
    
FOR
    SELECT  A.KOD, A.ARTIKAL, A.CENAMP, A.SIFRA_ROBE, P.STOPA1 AS POREZ, P.FISKAL,A.KOL,0 as proizvedeno,
            (SELECT M.VEZANI_MG FROM TBLMAGACIN M WHERE M.SIFRA_MAGACINA=:SM) as smagacin
    FROM ARTIKLI_RESTORAN((SELECT M.VEZANI_MG FROM TBLMAGACIN M WHERE M.SIFRA_MAGACINA=:SM) , :KAT, :godina) A, TBLPOREZ P
    WHERE  A.SIFRA_POREZA=P.SIFRA_POREZA
    AND a.aktivan = 1
    AND A.KOL>0
    INTO :KOD,
         :ARTIKAL,
         :CENAMP,
         :SIFRA_ROBE,
         :POREZ,
         :FISKAL,
         :KOL,
         :PROIZVEDENO,
         :SMAGACIN
  DO
  BEGIN
    vodi_se_lager = 1;
       if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:sm and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
  END
END^

SET TERM ; ^



SET TERM ^ ;

create or alter procedure MP_POSEBNI_ARTIKLI (
    MG integer)
returns (
    ARTIKAL varchar(255),
    SMAGACIN integer,
    PROIZVEDENO integer,
    SIFRA_ROBE integer,
    BOJA integer,
    SORTIRANJE integer)
as
declare variable ASORTIMAN integer;
declare variable ASORTIMAN_BROJ integer;
BEGIN
 select p.asortiman from system_mp p into:asortiman;
  FOR
    select A.ARTIKAL,
           0 as SMAGACIN,
           0 as PROIZVEDENO,
           A.SIFRA_ROBE,
           A.BOJA,
           A.SORTIRANJE
    from TBLARTIKLI A
    where A.POSEBAN_SPISAK = 1
    order by A.SORTIRANJE
    INTO :ARTIKAL,
         :SMAGACIN,
         :PROIZVEDENO,
         :SIFRA_ROBE,
         :BOJA,
         :SORTIRANJE
  DO
  BEGIN

           if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:MG and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
  END
END^

SET TERM ; ^



SET TERM ^ ;

create or alter procedure PRET_ARTIKLI_MP (
    MG integer,
    KOL decimal(18,4),
    CODE varchar(255),
    NAZIV_ARTIKLA varchar(255),
    KATEG varchar(255),
    PROIZV varchar(255),
    IDCENOVNIKA integer,
    DATUM_F date,
    TIP_CENA integer,
    KOM integer = null)
returns (
    ZAPREMINA decimal(18,4),
    BROJ_REZERVACIJE integer,
    ID_REZERVACIJE integer,
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_POREZA integer,
    STOPA1 decimal(18,2),
    SIFRA_KATEGORIJE integer,
    KATEGORIJA_GRUPE varchar(50),
    SIFRA_PROIZVODJACA integer,
    PROIZVODJAC varchar(100),
    ARTIKAL varchar(255),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    CENA decimal(18,4),
    UKUPNA_KOL decimal(18,4),
    KOLICINA decimal(18,4),
    REZERVISANO decimal(18,2),
    NAB_VREDNOST decimal(18,4),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    GARANCIJA integer,
    PLAN_CENA numeric(18,2),
    MARZA numeric(18,2),
    MARZA_MP decimal(18,2),
    NAB_CENA decimal(18,4),
    CENOVNIK varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA double precision,
    JED_MERE varchar(20),
    PROSECNA_CENA decimal(18,4),
    BARKOD varchar(50),
    KLASA integer,
    KOD_ROBE_KUPCA varchar(20),
    RABAT decimal(15,2),
    CENA_CENOVNIKA decimal(18,4),
    VALUTA decimal(15,4),
    NAB_CENA_DEV decimal(18,4),
    NAB_CENA_DEV_MG decimal(18,4),
    AKCIJSKI_RABAT decimal(18,4),
    AKCIJA_OD date,
    AKCIJA_DO date,
    TAKSA decimal(18,4),
    PROSECNA_CENA_DEV decimal(18,4),
    NAB_VREDNOST_DEV decimal(18,4),
    TIP_PRACENJA varchar(2),
    KOL_SARZE decimal(18,4),
    BROJ_SERIJE varchar(30),
    ROK_TRAJANJA date,
    KOL_LAGER decimal(18,4),
    KOD_PR varchar(20),
    CENA_MAGACINA integer,
    ID_CENOVNIK integer,
    LAGER smallint,
    RASPOLOZIVO decimal(18,4),
    ODNOSPJM double precision,
    AKCIJA_OZNAKA varchar(1))
as
declare variable U_CENOVNIKU integer;
declare variable HP_TABELE integer;
declare variable RS_KORISNIK integer;
declare variable KOL_NEPOSLATO decimal(18,4);
declare variable KOD_BK varchar(20);
declare variable GODINA integer;
declare variable ASORTIMAN integer;
declare variable ASORTIMAN_BROJ integer;
begin
 select p.asortiman from system_mp p into:asortiman;
--zpharm
  -- AKO JE CENA_MAGACINA=0 VUCE CENU IZ ARTIKALA
  -- AKO JE CENA_MAGACINA=1 VUCE CENU IZ TLOKACIJE
  -- AKO JE CENA_MAGACINA=2 VUCE CENU IZ TBL_CENOVNIK
  -- AKO JE KOMITENT VECI OD 0 GLEDA SAMO ARTIKLE REZERVISANE ZA TOG KOMITENTA
  -- PROSECNU CENU VUCE IZ TLOKACIJE A AKO JE TA CENA 0 ONDA VUCE POSLEDNJU NABAVNU CENU IZ CENA_ARTIKLA_MP
--    datum_f = null;
  if (DATUM_F is not null) then godina = extract(year from datum_f);
  else
    godina = (select first 1 godina from system);
    select first 1 H.RS_KORISNIK,
                   H.HP_TABELE
    from TBLHOST H
    into :RS_KORISNIK, :HP_TABELE;
    select M.CENA_MAGACIN,
           M.ID_CENOVNIK,
           M.TIP_CENA
    from TBLMAGACIN M
    where M.SIFRA_MAGACINA = :MG
    into :CENA_MAGACINA, :ID_CENOVNIK, :TIP_CENA;
    if (:CENA_MAGACINA = 2) then
      IDCENOVNIKA = :ID_CENOVNIK;


  if (:KOM < 0 or :KOM is null) then
  begin
 /*
    select A.KOD
    from ARTIKAL_PRONADJI(:NAZIV_ARTIKLA) A
    into :KOD_BK;
    if (:KOD_BK is not null) then
      CODE = :KOD_BK;
 */
if (CODE is not null) then
      begin
          select a.tmp_sifra
          from artikal_pronadji(:CODE)  a
          into :SIFRA_ROBE;
      end

        for select sifra from ARTIKAL_PRONADJI_ABP(:SIFRA_ROBE, :code,  :NAZIV_ARTIKLA)
            into :SIFRA_ROBE
        do
        begin
     for
     select TBLARTIKLI.KOD,
       TBLARTIKLI.SIFRA_ROBE,
       TBLARTIKLI.SIFRA_POREZA,
       TBLPOREZ.STOPA1,
       TBLARTIKLI.SIFRA_KATEGORIJE,
       TBLVRSTAROBE.KATEGORIJA_GRUPE,
       TBLARTIKLI.SIFRA_PROIZVODJACA,
       TBLPROIZVODJAC.PROIZVODJAC,
       TBLARTIKLI.ARTIKAL,
       TBLARTIKLI.CENAVP,
       TBLARTIKLI.CENAMP,
       TBLARTIKLI.GARANCIJA,
       TBLARTIKLI.PLAN_CENA,
       TBLARTIKLI.MARZA,
       TBLARTIKLI.MARZA_MP,
       TBLARTIKLI.NAB_CENA,
       TBLARTIKLI.CENOVNIK,
       TBLARTIKLI.TARIFNI_BROJ,
       TBLARTIKLI.TARIFNA_STOPA,
       TBLARTIKLI.NAB_CENA_DEV,
       TBLARTIKLI.ODNOSPJM,
       TBLJM.NAZIV,
       TBLARTIKLI.TIP_PRACENJA,
       coalesce(L.KOLICINA,0),
       coalesce(L.REZERVISANO,0),
       L.CENA,
       L.NAB_VREDNOST,
       L.NAB_VREDNOST_DEV,
       L.PROS_CENA,
       L.NAB_CENA_DEV,
       coalesce(S.KOL,0),
       S.BROJ_SERIJE,
       S.ROK_VAZENJA as DATUM,
       coalesce(L.KOLICINA,0),
       coalesce(l.hp_kol,0),
       TBLARTIKLI.KOD_PR,
       TBLARTIKLI.VODI_SE_LAGER,
       TBLARTIKLI.ZAPREMINA,
       TBLARTIKLI.CENOVNIK
from TBLARTIKLI
inner join TBLPROIZVODJAC on TBLARTIKLI.SIFRA_PROIZVODJACA = TBLPROIZVODJAC.SIFRA_PROIZVODJACA
inner join TBLVRSTAROBE on TBLARTIKLI.SIFRA_KATEGORIJE = TBLVRSTAROBE.SIFRA_KATEGORIJE
inner join TBLPOREZ on TBLARTIKLI.SIFRA_POREZA = TBLPOREZ.SIFRA_POREZA
inner join TBLJM on TBLARTIKLI.IDPJM = TBLJM.ID
left join TLOKACIJA L on (L.SIFRA_ROBE = TBLARTIKLI.SIFRA_ROBE and L.SIFRA_MAGACINA = :MG and L.GODINA = :godina)
left join TLOKACIJA_SARZA S on L.SIFRA_ROBE = S.SIFRA_ROBE and L.SIFRA_MAGACINA = S.SIFRA_MAGACINA
where TBLARTIKLI.sifra_robe = :SIFRA_ROBE

        order by TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC
        into :KOD, :SIFRA_ROBE, :SIFRA_POREZA, :STOPA1, :SIFRA_KATEGORIJE, :KATEGORIJA_GRUPE, :SIFRA_PROIZVODJACA,
             :PROIZVODJAC, :ARTIKAL, :CENAVP, :CENAMP, :GARANCIJA, :PLAN_CENA, :MARZA, :MARZA_MP, :NAB_CENA, :CENOVNIK,
             :TARIFNI_BROJ, :TARIFNA_STOPA, :NAB_CENA_DEV, :ODNOSPJM, :JED_MERE, :TIP_PRACENJA, :KOLICINA, :REZERVISANO,
             :CENA, :NAB_VREDNOST, :NAB_VREDNOST_DEV, :PROSECNA_CENA, :NAB_CENA_DEV_MG, :KOL_SARZE, :BROJ_SERIJE,
             :ROK_TRAJANJA, :KOL_LAGER,:KOL_NEPOSLATO, :KOD_PR, :LAGER, :ZAPREMINA, :AKCIJA_OZNAKA
       do
       begin



      if ((:PROSECNA_CENA = 0 or :PROSECNA_CENA is null)) then
      begin
        select first 1 C.PROS_CENA
        from CENA_ARTIKLA_MP(:SIFRA_ROBE,:MG, :godina, :DATUM_F, null ) C
        into PROSECNA_CENA;
      end

      if (:KOL_SARZE > 0) then
        KOLICINA = :KOL_SARZE;

      select sum(coalesce(KOLICINA,0)),
             sum(coalesce(KOLICINA,0) - coalesce(REZERVISANO,0) - coalesce(HP_KOL,0))
      from TLOKACIJA
      where SIFRA_ROBE = :SIFRA_ROBE and
            SIFRA_MAGACINA = :MG and
            GODINA = :godina
      into :UKUPNA_KOL, :RASPOLOZIVO;

      if (ukupna_kol is null ) then ukupna_kol = 0;
      if (RASPOLOZIVO is null ) then RASPOLOZIVO = 0;

      KOLICINA = KOLICINA - coalesce(:KOL_NEPOSLATO, 0);
      RABAT = 0;

      --**************************************  C E N E
      if (IDCENOVNIKA = 0) then
      begin
        CENA_CENOVNIKA = CENAMP;
      end
      else
      if (IDCENOVNIKA = 1) then
      begin
        CENA_CENOVNIKA = CENAVP;
      end
      else
      if (IDCENOVNIKA > 1) then
      begin
        CENA_CENOVNIKA = 0;
        select
               c.CENA,
               c.RABAT,
               c.AKCIJSKI_RABAT,
               c.vazi_OD,
               c.vazi_DO,
               C.cenovnik
        from cena_artikla_iz_cenovnika(:sifra_robe, :idcenovnika, :datum_f, null) c
        into  :CENA_CENOVNIKA, :RABAT, :AKCIJSKI_RABAT, :AKCIJA_OD, :AKCIJA_DO, :AKCIJA_OZNAKA;

        if (DATUM_F < AKCIJA_OD or AKCIJA_DO < DATUM_F) then
        begin
          AKCIJSKI_RABAT = 0;
          AKCIJA_OD = null;
          AKCIJA_DO = null;
        end

        if ((CENA is null or CENA = 0) and
            CENA_CENOVNIKA > 0) then
        begin
          CENA = CENA_CENOVNIKA;
        end
      end
      if (:CENA is null) then
      begin
        select A.CENAMP
        from TBLARTIKLI A
        where A.SIFRA_ROBE = :SIFRA_ROBE
        into :CENA;
      end
      if (CENA_CENOVNIKA is null or CENA_CENOVNIKA = 1) then
        CENA_CENOVNIKA = :CENA;
      select first 1 B.BARKOD
      from TBLBARKOD B
      where B.SIFRA_ROBE = :SIFRA_ROBE
      into :BARKOD;

      if (TIP_CENA = 1 and
          KOLICINA <> 0) then
        CENA = CENA / KOLICINA;
      if (KOL > -1) then
      begin
        if (:CENA is null and
            :CENAMP > 0) then
        begin
          CENA = :CENAMP;
        end
        if((select first 1 pib from tblhost) = '100871849') then
            cenamp = :cena;
    if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:MG and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
      end

      else
                  if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:MG and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
    end
  end
  end

  --VRACANJE IZ REZERVACIJE
  else
  if (:KOM > 0) then
  begin

    for select A.KOD,
               A.SIFRA_ROBE,
               A.SIFRA_POREZA,
               TBLPOREZ.STOPA1,
               A.SIFRA_KATEGORIJE,
               TBLVRSTAROBE.KATEGORIJA_GRUPE,
               A.SIFRA_PROIZVODJACA,
               TBLPROIZVODJAC.PROIZVODJAC,
               A.ARTIKAL,
               A.CENAVP,
               A.CENAMP,
               A.GARANCIJA,
               A.PLAN_CENA,
               A.MARZA,
               A.MARZA_MP,
               A.NAB_CENA,
               A.CENOVNIK,
               A.TARIFNI_BROJ,
               A.TARIFNA_STOPA,
               A.NAB_CENA_DEV,
               A.ODNOSPJM,
               TBLJM.NAZIV,
               A.TIP_PRACENJA,
               RS.KOLICINA - coalesce(RS.OTPREMLJENO, 0),
               cast(0 as integer),
               L.CENA,
               L.NAB_VREDNOST,
               L.NAB_VREDNOST_DEV,
               L.PROS_CENA,
               L.NAB_CENA_DEV,
               S.KOL,
               S.BROJ_SERIJE,
               S.DATUM,
               RS.KOLICINA,
               A.KOD_PR,
               A.VODI_SE_LAGER,
               R.IDREZERVACIJE,
               R.BROJ_REZERVACIJE,
               A.ZAPREMINA
        from TBLREZERVACIJA R
        inner join TBLREZERVACIJASASTAV RS on RS.IDREZERVACIJE = R.IDREZERVACIJE
        inner join TBLARTIKLI A on A.SIFRA_ROBE = RS.SIFRA_ROBE and A.AKTIVAN = 1
        inner join TBLPROIZVODJAC on A.SIFRA_PROIZVODJACA = TBLPROIZVODJAC.SIFRA_PROIZVODJACA
        inner join TBLVRSTAROBE on A.SIFRA_KATEGORIJE = TBLVRSTAROBE.SIFRA_KATEGORIJE
        inner join TBLPOREZ on A.SIFRA_POREZA = TBLPOREZ.SIFRA_POREZA
        inner join TBLJM on A.IDPJM = TBLJM.ID
        left join TLOKACIJA L on (L.SIFRA_ROBE = A.SIFRA_ROBE and L.SIFRA_MAGACINA = :MG and L.GODINA = :godina)
        left join TLOKACIJA_SARZA S on L.IDLOKACIJA = S.IDLOKACIJA
        where R.SIFRA_KOMITENTA = :KOM and
              (R.ID_STATUSA in (200, 201, 202) or R.ID_STATUSA is null) and
              (RS.KOLICINA - coalesce(RS.OTPREMLJENO, 0) > 0) and
              (A.KOD containing :CODE or (upper(cast(A.ARTIKAL as varchar(255) character set WIN1250)) containing upper(cast(:NAZIV_ARTIKLA as varchar(255) character set WIN1250)) ) )
        order by TBLVRSTAROBE.KATEGORIJA_GRUPE, TBLPROIZVODJAC.PROIZVODJAC
        into :KOD, :SIFRA_ROBE, :SIFRA_POREZA, :STOPA1, :SIFRA_KATEGORIJE, :KATEGORIJA_GRUPE, :SIFRA_PROIZVODJACA,
             :PROIZVODJAC, :ARTIKAL, :CENAVP, :CENAMP, :GARANCIJA, :PLAN_CENA, :MARZA, :MARZA_MP, :NAB_CENA, :CENOVNIK,
             :TARIFNI_BROJ, :TARIFNA_STOPA, :NAB_CENA_DEV, :ODNOSPJM, :JED_MERE, :TIP_PRACENJA, :KOLICINA, :REZERVISANO,
             :CENA, :NAB_VREDNOST, :NAB_VREDNOST_DEV, :PROSECNA_CENA, :NAB_CENA_DEV_MG, :KOL_SARZE, :BROJ_SERIJE,
             :ROK_TRAJANJA, :KOL_LAGER, :KOD_PR, :LAGER, :ID_REZERVACIJE, :BROJ_REZERVACIJE, :ZAPREMINA
    do
    begin

      if (:KOL_SARZE > 0) then
        KOLICINA = :KOL_SARZE;

      select sum(coalesce(KOLICINA,0)) --, SUM(KOLICINA - REZERVISANO)
      from TLOKACIJA
      where SIFRA_ROBE = :SIFRA_ROBE and
            SIFRA_MAGACINA = :MG and
            GODINA = :godina
      into :UKUPNA_KOL;--, :REZERVISANO;

      RABAT = 0;
      -- AKO JE :CENOVNIK=0 VUCE CENU IZ ARTIKALA
      -- AKO JE :CENOVNIK=1 VUCE CENU IZ TLOKACIJE
      -- AKO JE :CENOVNIK=2 VUCE CENU IZ TBL_CENOVNIK
      if (:IDCENOVNIKA = 0) then
      begin
        CENA = :CENAMP;
        CENA_CENOVNIKA = :CENAMP;
      end
      if (:IDCENOVNIKA = 2) then
      begin
        select c.cena, c.cenovnik
        from cena_artikla_iz_cenovnika(:sifra_robe, :id_cenovnik, :datum_f, null) c
        into :CENA_CENOVNIKA, :CENOVNIK;
      end
      if (:IDCENOVNIKA = 2 and
          :CENA_CENOVNIKA is not null) then
        CENA = :CENA_CENOVNIKA;
      if (:IDCENOVNIKA = 2 and
          :CENAMP is not null and
          :CENA_CENOVNIKA is null and
          :CENAMP > 0) then
        CENA = :CENAMP;
      if (:IDCENOVNIKA = 1 and
          (:CENA is null or :CENA = 0)) then
      begin
        if (:CENAMP is not null or :CENAMP > 0) then
          CENA = :CENAMP;
        else
        if (:CENA_CENOVNIKA is not null or :CENA_CENOVNIKA > 0) then
          CENA = :CENA_CENOVNIKA;
      end
      else
      if (:IDCENOVNIKA = 1) then
        CENA_CENOVNIKA = :CENA;
      select first 1 B.BARKOD
      from TBLBARKOD B
      where B.SIFRA_ROBE = :SIFRA_ROBE
      into :BARKOD;
      if (KOL > -1) then
      begin
        --      IF ((KOLICINA > :KOL AND
        --          KOL_SARZE IS NULL) OR (KOL_SARZE > 0 AND
        --          KOL_LAGER > 0)) THEN
            if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:MG and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
      end
      else
            if (asortiman is null or asortiman=0 ) then
    begin
    SUSPEND;
    end
    else
    begin
    select count(*) from tblartikli_asortiman a where a.sifra_magacina=:MG and a.sifra_robe=:sifra_robe  and a.aktivan=1 into :ASORTIMAN_BROJ;
       if (:ASORTIMAN_BROJ >0) then
       begin
          suspend;
       end
    end
    end
  end
end^

SET TERM ; ^

COMMENT ON PARAMETER PRET_ARTIKLI_MP.KATEG IS
'ne koristi se';

COMMENT ON PARAMETER PRET_ARTIKLI_MP.PROIZV IS
'ne koristi se';

COMMENT ON PARAMETER PRET_ARTIKLI_MP.IDCENOVNIKA IS
'ne koristi se';

COMMENT ON PARAMETER PRET_ARTIKLI_MP.DATUM_F IS
'DATUM FAKTURE AKO SE PRAVE AKCIJE PRILIKOM PRODAJE ROBE';

COMMENT ON PARAMETER PRET_ARTIKLI_MP.TIP_CENA IS
'ne koristi se';

update verzija set maloprodaja = 20221213;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20221220 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR (
    DATUM date,
    SM integer = -1)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    CEK decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    CEK_VIRMAN decimal(18,2))
as
begin
  for select
          M.MAGACIN,
          M.MESTO,
          M.SIFRA_MAGACINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'GOTOVINA') as GOTOVINA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'CEKOVI') as CEK,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'VIRMANSKI') as VIRMAN,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'KARTICA') as KARTICA,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           where
               upper(T.NAZIV) = 'BENEFIT') as BENEFIT,
          (select
               sum(P.IZNOS)
           from
               TBLNOVCANO N
           inner join TBLNOV_PLACANJE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
           inner join TIP_PLACANJA T on T.IDPLACANJA = P.IDNACIN_PLACANJA
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1) as UKUPNO,
          (select
               count(*)
           from
               TBLRADNICI R
           where
               R.ID_DEF_MG_MP = M.SIFRA_MAGACINA) as BR_RADNIKA,
          (select
               sum(D.PROMETT)
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as UKUPNO_DI,
          (select first 1
               D.MALOPRODAJA
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA,
          (select first 1
               D.MP_UPDATE
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as MALOPRODAJA_BAZA,
          (select first 1
               D.VERINFO_MP
           from
               FISKALNA_DNEVIN_IZVESTAJ D
           inner join FISKALNA_KASA F on D.IDKASE = F.ID_BROJ_ISECKA
           where
               F.SIFRA_MAGACINA = M.SIFRA_MAGACINA
               and D.DATUM = :DATUM) as VERINFO_MP,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL < 0
           and n.sifra_dokumenta <> 1013
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as STORNO,
          (select
               sum(P.IZLAZ_KOL * P.IZLAZ_CENA)
           from
               TBLNOVCANO N
           inner join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA and P.IZLAZ_KOL > 0
           join tbldokumenti d on n.sifra_dokumenta = d.sifra_dokumenta and d.fiskalni = 1
           --     inner join TBLNOV_PLACANJE A on N.IDNOVCANO = A.IDNOVCANO and N.DATUMDPO = :DATUM and N.SIFRA_MAGACINA = M.SIFRA_MAGACINA
          ) as PROMET
      from
          TBLMAGACIN M
      where
          M.VIDLJIV_MP = 1
          and (m.sifra_magacina = :sm or :sm = -1)
      order by
          M.MESTO, M.MAGACIN
      into :MAGACIN,
           :MESTO,
           :SIFRA_MAGACINA,
           :GOTOVINA,
           :CEK,
           :virman, 
           :KARTICA,
           :BENEFIT,
           :UKUPNO,
           :BR_RADNIKA,
           :UKUPNO_DI,
           :MALOPRODAJA,
           :MP_UPDATE,
           :VERINFO_MP,
           :STORNO,
           :PROMET
  do
  begin
    if (:GOTOVINA is null) then
      GOTOVINA = 0;
    if (:CEK is null) then
      CEK = 0;
    if (:VIRMAN is null) then
      VIRMAN = 0;
    if (:KARTICA is null) then
      KARTICA = 0;
    if (:BENEFIT is null) then
      BENEFIT = 0;
    if (:UKUPNO is null) then
      UKUPNO = 0;
    if (:UKUPNO_DI is null) then
      UKUPNO_DI = 0;
    if (:STORNO is null) then
      STORNO = 0;
    if (:PROMET is null) then
      PROMET = 0;
    if (:BR_RADNIKA > 0) then
      PROMET_PO_RADNIKU = :UKUPNO / :BR_RADNIKA;
    else
      PROMET_PO_RADNIKU = 0;

    CEK_VIRMAN = cek + virman;

    select sum(d.prodaja), sum(d.refundacija), sum(d.broj_prodati), sum(d.broj_refundacija), sum(d.broj_dokumenata)
    from fiskalna_dnevin_izvestaj d
    where d.datum = :datum
    and d.idkase = :SIFRA_MAGACINA
    into :prodaja, :refundacija, :broj_prodati, :broj_refundacija, :broj_dokumenata ;

    if ( abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > ABS(:UKUPNO - :UKUPNO_DI) and abs(:UKUPNO - :PRODAJA + abs(:refundacija)) > 1) then
        RAZLIKA = :UKUPNO - :PRODAJA - :storno;
    ELSE
        RAZLIKA = :UKUPNO - :UKUPNO_DI;

    suspend;
  end
end^

SET TERM ; ^

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PAZAR_MESEC (
    SM integer,
    DATUM1 date,
    DATUM2 date)
returns (
    BENEFIT decimal(18,2),
    MAGACIN varchar(50),
    MESTO varchar(20),
    SIFRA_MAGACINA integer,
    GOTOVINA decimal(18,2),
    VIRMAN decimal(18,2),
    CEK decimal(18,2),
    KARTICA decimal(18,2),
    UKUPNO decimal(18,2),
    BR_RADNIKA integer,
    PROMET_PO_RADNIKU decimal(18,2),
    UKUPNO_DI decimal(18,2),
    RAZLIKA decimal(18,2),
    MALOPRODAJA varchar(10),
    MP_UPDATE integer,
    STORNO decimal(18,2),
    PROMET decimal(18,2),
    VERINFO_MP varchar(20),
    PRODAJA decimal(18,2),
    REFUNDACIJA decimal(18,2),
    BROJ_PRODATI integer,
    BROJ_REFUNDACIJA integer,
    BROJ_DOKUMENATA integer,
    DATUM date,
    CEK_VIRMAN decimal(18,2))
as
begin
 datum = :datum1;
 while (datum <= :datum2) do
 begin
     for
        select M.BENEFIT,
               M.MAGACIN,
               M.MESTO,
               M.SIFRA_MAGACINA,
               sum(M.GOTOVINA),
               sum(M.CEK),
               sum(M.VIRMAN),
               sum(M.KARTICA),
               sum(M.UKUPNO),
               sum(M.BR_RADNIKA),
               sum(M.PROMET_PO_RADNIKU),
               sum(M.UKUPNO_DI),
               sum(M.RAZLIKA) ,
               sum(M.STORNO),
               sum(M.PROMET),
               sum(M.PRODAJA),
               sum(M.REFUNDACIJA),
               sum(M.BROJ_PRODATI),
               sum(M.BROJ_REFUNDACIJA),
               sum(M.BROJ_DOKUMENATA)
        from PROC_MP_IZVESTAJ_PAZAR(:DATUM, :SM) M
        group by M.BENEFIT, M.MAGACIN, M.MESTO, M.SIFRA_MAGACINA
        into :BENEFIT,
               :MAGACIN,
               :MESTO,
               :SIFRA_MAGACINA,
               :GOTOVINA,
               :CEK,
               :VIRMAN,
               :KARTICA,
               :UKUPNO,
               :BR_RADNIKA,
               :PROMET_PO_RADNIKU,
               :UKUPNO_DI,
               :RAZLIKA ,
               :STORNO,
               :PROMET,
               :PRODAJA,
               :REFUNDACIJA,
               :BROJ_PRODATI,
               :BROJ_REFUNDACIJA,
               :BROJ_DOKUMENATA
     do
     begin
        CEK_VIRMAN = cek + virman;
        suspend;

     end
   datum = datum + 1; 
 end

end^

SET TERM ; ^


update verzija set maloprodaja = 20221220;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230115 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_KOMITENTI (
    SK integer,
    KOM varchar(255))
returns (
    TOLERANCIJA_VV decimal(18,4),
    SIFRA_KOMITENTA integer,
    KOMITENT varchar(255),
    PIB varchar(15),
    JMBG varchar(13),
    JBBK varchar(50),
    TEL1 varchar(25),
    MESTO varchar(50),
    SIFRA_KATEGORIJE integer,
    DOZVOLJENO_ZADUZENJE decimal(18,2),
    ZABRANA_IZD char(1),
    PLACANJE integer,
    KUPAC_KONTO integer,
    RABAT decimal(15,2),
    BENEFIT_KARTICA varchar(30),
    RABATMP decimal(18,4),
    ZABRANA_IZD_VV char(1),
    ID_PRODAVCA integer,
    ID_RADNIKA integer,
    PO_NABAVNOJ smallint)
as
begin
  if (STRLEN(KOM) < 2) then
  begin
    KOM = null;
  end
  for select
          K.SIFRA_KOMITENTA,
          K.KOMITENT,
          K.TEL1,
          M.MESTO,
          K.SIFRA_KATEGORIJE,
          K.DOZVOLJENO_ZADUZENJE,
          K.ZABRANA_IZD,
          K.PLACANJE,
          S.KUPAC as KUPAC_KONTO,
          K.RABAT,
          K.BENEFIT_KARTICA,
          K.ZABRANA_IZD_VV,
          K.ID_PRODAVCA,
          K.ID_RADNIK,
          K.RABATMP,
          K.PO_NABAVNOJ,
          K.TOLERANCIJA_VV,
          K.PIB,
          K.JBBK,
          K.JMBG
      from TBLKOMITENTI K, TBLMESTO M, TBLSTATUS S
      where K.SIFRA_MESTA = M.SIFRA_MESTA and
            S.SIFRA_STATUSA = K.SIFRA_STATUSA and
            K.AKTIVAN = 1 and
            (K.SIFRA_KOMITENTA = :SK or upper(K.KOMITENT) like '%' || upper(:KOM) || '%' or upper(K.BENEFIT_KARTICA) like '%' || upper(:KOM) || '%')

      order by K.KOMITENT
      into :SIFRA_KOMITENTA, :KOMITENT, :TEL1, :MESTO, :SIFRA_KATEGORIJE, :DOZVOLJENO_ZADUZENJE, :ZABRANA_IZD,
           :PLACANJE, :KUPAC_KONTO, :RABAT, :BENEFIT_KARTICA, :ZABRANA_IZD_VV, :ID_PRODAVCA, :ID_RADNIKA, :RABATMP,
           :PO_NABAVNOJ, :TOLERANCIJA_VV, :PIB, :JBBK, :JMBG
  do
  begin
    suspend;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20230115;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230120 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKLI_OFLINE (
    MG integer,
    KAT integer,
    KOLIN decimal(18,4),
    KODIN varchar(20),
    BK varchar(50),
    SR integer,
    NAZIV_ARTIKLA varchar(250),
    MG1 integer,
    DATUM_F date,
    IDCK integer,
    GODINA integer = null)
returns (
    SKLADISNI_PROSTOR varchar(20),
    AKTIVAN integer,
    AKCIJA varchar(1),
    KOD varchar(20),
    SIFRA_ROBE integer,
    SIFRA_KATEGORIJE integer,
    SIFRA_PROIZVODJACA integer,
    ARTIKAL varchar(255),
    JED_MERE varchar(20),
    CENAVP decimal(18,4),
    CENAMP decimal(18,4),
    KOL decimal(18,4),
    REZER_KOL decimal(18,4),
    PROSECNA_CENA decimal(18,4),
    SIFRA_POREZA integer,
    KATEGORIJA varchar(50),
    PROIZVODJAC varchar(100),
    POREZ decimal(18,2),
    GARANCIJA integer,
    CENA decimal(18,2),
    CENA1 decimal(18,4),
    PL_CENA decimal(18,2),
    MARZA decimal(18,2),
    MARZA_MP decimal(18,2),
    PROSEK decimal(18,2),
    EXTRA_CENA varchar(1),
    TARIFNI_BROJ varchar(20),
    TARIFNA_STOPA decimal(18,2),
    PODVRSTA varchar(100),
    GRUPA varchar(100),
    BARKOD varchar(50),
    FISKAL smallint,
    BOJA integer,
    KOL_SARZA decimal(18,4),
    ROK_TRAJANJA date,
    BROJ_SERIJE varchar(30),
    LAGER_KOL decimal(18,4),
    KOD_PR varchar(20),
    ID_CENOVNIK integer,
    CENA_CENOVNIK decimal(18,4),
    VODI_SE_LAGER integer,
    NAB_VREDNOST decimal(18,4),
    ODNOSPJM double precision,
    POVRATNA_AMBALAZA integer,
    VAGA_KOMAD integer,
    PRODAJA_CEO_BROJ integer,
    RABATC decimal(18,4),
    LABEL varchar(10))
as
declare variable CUSTOM_WHERE varchar(500);
declare variable ABP smallint;
declare variable GODINA_RADA integer;
declare variable CENOVNIK integer;
declare variable TIP_CENA integer;
declare variable KOL_PROIZVEDI decimal(18,4);
declare variable PROIZVODNJA integer;
declare variable HP_TABELE integer;
declare variable KOL_FAKTURISANO decimal(18,4);
declare variable CENOVNIK1 integer;
declare variable ID_CENOVNIK1 integer;
declare variable TIP_CENA1 integer;
declare variable KOL_ decimal(18,4);
declare variable TMP_SIFRA integer;
declare variable SIFRA integer;
declare variable ASORTIMAN integer;
declare variable ASORT_BROJ integer;
begin
  --ZPHARM
  select GODINA
  from SYSTEM
  into :GODINA_RADA;
  select p.asortiman from system_mp p into :asortiman;
  if (:GODINA is null) then
    GODINA = GODINA_RADA;
  if (KODIN = '-1') then
    TMP_SIFRA = SR;
  else
--  if (BK = '-1') then
--  begin
    select A.TMP_SIFRA
    from ARTIKAL_PRONADJI(:BK) A
    into :TMP_SIFRA;
--  end
  for select SIFRA
      from ARTIKAL_PRONADJI_ABP(:TMP_SIFRA, :KODIN, :NAZIV_ARTIKLA)
      into :SIFRA
  do
  begin
    select A.KOD,
           A.SIFRA_ROBE,
           A.SIFRA_KATEGORIJE,
           A.SIFRA_PROIZVODJACA,
           A.ARTIKAL,
           A.JED_MERE,
           A.CENAVP,
           A.CENAMP,
           A.KOL,
           A.REZER_KOL,
           A.PROSECNA_CENA,
           A.SIFRA_POREZA,
           A.KATEGORIJA,
           A.PROIZVODJAC,
           A.POREZ,
           A.GARANCIJA,
           A.CENA,
           A.CENA1,
           A.PL_CENA,
           A.MARZA,
           A.MARZA_MP,
           A.PROSEK,
           A.EXTRA_CENA,
           A.TARIFNI_BROJ,
           A.TARIFNA_STOPA,
           A.PODVRSTA,
           A.GRUPA,
           A.BARKOD,
           A.FISKAL,
           A.BOJA,
           A.KOL_SARZA,
           A.ROK_TRAJANJA,
           A.BROJ_SERIJE,
           A.LAGER_KOL,
           A.KOD_PR,
           A.ID_CENOVNIK,
           A.CENA_CENOVNIK,
           A.VODI_SE_LAGER,
           A.NAB_VREDNOST,
           A.AKCIJA_OZNAKA,
           A.AKTIVAN,
           A.SKLADISNI_PROSTOR,
           A.ODNOSPJM,
           A.POVRATNA_AMBALAZA,
           A.VAGA_KOMAD,
           A.PRODAJA_CEO_BROJ,
           A.RABATC,
           A.LABEL
    from ARTIKLI_CENA(:MG, :KOLIN, :SIFRA, :MG1, :DATUM_F, :GODINA, :idck) A
    into :KOD, :SIFRA_ROBE, :SIFRA_KATEGORIJE, :SIFRA_PROIZVODJACA, :ARTIKAL, :JED_MERE, :CENAVP, :CENAMP, :KOL,
         :REZER_KOL, :PROSECNA_CENA, :SIFRA_POREZA, :KATEGORIJA, :PROIZVODJAC, :POREZ, :GARANCIJA, :CENA, :CENA1,
         :PL_CENA, :MARZA, :MARZA_MP, :PROSEK, :EXTRA_CENA, :TARIFNI_BROJ, :TARIFNA_STOPA, :PODVRSTA, :GRUPA, :BARKOD,
         :FISKAL, :BOJA, :KOL_SARZA, :ROK_TRAJANJA, :BROJ_SERIJE, :LAGER_KOL, :KOD_PR, :ID_CENOVNIK, :CENA_CENOVNIK,
         :VODI_SE_LAGER, :NAB_VREDNOST, :AKCIJA, :AKTIVAN, :SKLADISNI_PROSTOR, :ODNOSPJM, :POVRATNA_AMBALAZA,
         :VAGA_KOMAD, :PRODAJA_CEO_BROJ, :RABATC, :LABEL;
    if (:SIFRA_ROBE is not null and
        :AKTIVAN = 1) then
    begin
      select first 1 R.SIFRA_POREZ_IZLAZ,
                     R.STOPA_POREZ_IZLAZ,
                     R.LABEL_IZLAZ
      from ARTIKLI_POREZ_IZLAZ(:SIFRA_ROBE) R
      into :SIFRA_POREZA, :POREZ, :LABEL;
      if (asortiman is null or asortiman =0 ) then
      begin
      suspend;
      end
      else
      begin
       select count(*) from tblartikli_asortiman a where a.sifra_magacina=:mg and a.sifra_robe=:sifra_robe and a.aktivan=1 into :asort_broj;
       if (:asort_broj >0) then
       begin
          suspend;
       end
      end
      SIFRA_ROBE = null;
    end
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20230120;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230121 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_SET_NE_SALJI (
    DATUM date,
    SM integer)
returns (
    OTKAZANO integer)
as
begin
    otkazano = 0;
  update hp_obracun o
  set o.poslatouknjigovodstvo = 'D'
  where o.sifra_dokumenta in ( select d.sifra_dokumenta from tbldokumenti d where (D.FISKALNI = 0 and D.ROBNI_KARTICA = 0) )
  and o.poslatouknjigovodstvo = 'N'
  and o.datum = :datum and o.sifra_magacina = :sm;

  update mp_fisk_z o
  set o.poslatouknjigovodstvo = 'D'
  where o.sifra_dokumenta in ( select d.sifra_dokumenta from tbldokumenti d where (D.FISKALNI = 0 and D.ROBNI_KARTICA = 0) )
  and o.poslatouknjigovodstvo = 'N'
  and o.datumdpo = :datum and o.sifra_magacina = :sm;

  otkazano = 1;
  suspend;
end^

SET TERM ; ^

update verzija set maloprodaja = 20230121;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230122 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure MP_MINUS_LAGER_ZA_POPIS (
    MG integer,
    DATUM_OD date,
    DATUM_DO date)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    STANJE decimal(18,4),
    CENA decimal(18,2),
    NABAVNA_CENA decimal(18,4))
as
BEGIN
  FOR
    select  D.sifra_robe,
            D.KOD,
            D.stanje,
            (select C.CENA from PROC_MP_CENA_ARTIKLA(D.sifra_robe, :MG, -1, 'now') C) as CENA,
            (select C.NAB_CENA from ARTIKAL_POSLEDNJA_NAB_CENA(D.sifra_robe, -1, -1) C) as NABAVNA_CENA
    from PROMET_MAGACINA(:MG, :datum_od, :datum_do ) D
    WHERE D.stanje < 0
    INTO :SIFRA_ROBE,
         :KOD,
         :STANJE,
         :CENA,
         :NABAVNA_CENA
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20230122;

COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230123 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_KOMITENTI (
    SK integer,
    KOM varchar(255))
returns (
    TOLERANCIJA_VV decimal(18,4),
    SIFRA_KOMITENTA integer,
    KOMITENT varchar(255),
    PIB varchar(15),
    JMBG varchar(13),
    JBBK varchar(50),
    TEL1 varchar(25),
    MESTO varchar(50),
    SIFRA_KATEGORIJE integer,
    DOZVOLJENO_ZADUZENJE decimal(18,2),
    ZABRANA_IZD char(1),
    PLACANJE integer,
    KUPAC_KONTO integer,
    RABAT decimal(15,2),
    BENEFIT_KARTICA varchar(30),
    RABATMP decimal(18,4),
    ZABRANA_IZD_VV char(1),
    ID_PRODAVCA integer,
    ID_RADNIKA integer,
    PO_NABAVNOJ smallint,
    BROJ_LK varchar(10))
as
begin
  if (STRLEN(KOM) < 2) then
  begin
    KOM = null;
  end
  for select
          K.SIFRA_KOMITENTA,
          K.KOMITENT,
          K.TEL1,
          M.MESTO,
          K.SIFRA_KATEGORIJE,
          K.DOZVOLJENO_ZADUZENJE,
          K.ZABRANA_IZD,
          K.PLACANJE,
          S.KUPAC as KUPAC_KONTO,
          K.RABAT,
          K.BENEFIT_KARTICA,
          K.ZABRANA_IZD_VV,
          K.ID_PRODAVCA,
          K.ID_RADNIK,
          K.RABATMP,
          K.PO_NABAVNOJ,
          K.TOLERANCIJA_VV,
          K.PIB,
          K.JBBK,
          K.JMBG,
          K.BROJ_LK
      from TBLKOMITENTI K, TBLMESTO M, TBLSTATUS S
      where K.SIFRA_MESTA = M.SIFRA_MESTA and
            S.SIFRA_STATUSA = K.SIFRA_STATUSA and
            K.AKTIVAN = 1 and
            (K.SIFRA_KOMITENTA = :SK or upper(K.KOMITENT) like '%' || upper(:KOM) || '%' or upper(K.BENEFIT_KARTICA) like '%' || upper(:KOM) || '%')

      order by K.KOMITENT
      into :SIFRA_KOMITENTA, :KOMITENT, :TEL1, :MESTO, :SIFRA_KATEGORIJE, :DOZVOLJENO_ZADUZENJE, :ZABRANA_IZD,
           :PLACANJE, :KUPAC_KONTO, :RABAT, :BENEFIT_KARTICA, :ZABRANA_IZD_VV, :ID_PRODAVCA, :ID_RADNIKA, :RABATMP,
           :PO_NABAVNOJ, :TOLERANCIJA_VV, :PIB, :JBBK, :JMBG, :BROJ_LK
  do
  begin
    suspend;
  end
end^

SET TERM ; ^

update verzija set maloprodaja = 20230123;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230124 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure MP_MINUS_LAGER_ZA_POPIS (
    MG integer,
    DATUM_OD date,
    DATUM_DO date)
returns (
    SIFRA_ROBE integer,
    KOD varchar(20),
    STANJE decimal(18,4),
    CENA decimal(18,2),
    NABAVNA_CENA decimal(18,4))
as
BEGIN
  FOR
    select  D.sifra_robe,
            D.KOD,
            D.stanje,
            (select C.CENA from PROC_MP_CENA_ARTIKLA(D.sifra_robe, :MG, -1, 'now') C) as CENA,
            (select C.NAB_CENA from ARTIKAL_POSLEDNJA_NAB_CENA(D.sifra_robe, -1, -1) C) as NABAVNA_CENA
    from PROMET_MAGACINA(:MG, :datum_od, :datum_do ) D
    WHERE D.stanje < 0
    INTO :SIFRA_ROBE,
         :KOD,
         :STANJE,
         :CENA,
         :NABAVNA_CENA
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20230124;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230126 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_IZVESTAJ_PLACANJE (
    D1 date,
    D2 date,
    SM integer,
    FISKAL_PUSTEN integer,
    SK integer = -1)
returns (
    IDZ integer,
    DUGUJE decimal(18,4),
    KES decimal(18,4),
    CEK decimal(18,4),
    KARTICA decimal(18,4),
    VIRMAN decimal(18,4),
    BENEFIT decimal(18,4),
    OPIS varchar(255),
    DATUMDPO date,
    BROJ_FISKALNOG integer,
    INVOICENUMBER varchar(50),
    TOTALAMOUNT decimal(18,2),
    NARUKVICA decimal(18,2),
    SIFRA_MAGACINA integer,
    INVOICETYPE varchar(40),
    TRANSACTIONTYPE varchar(40),
    STORNO decimal(18,4),
    AVANS decimal(18,2))
as
BEGIN
  FOR
    select Z.IDZ,
           Z.DUGUJE,
            z.kes ,
            z.CEK ,
           Z.KARTICA,
           Z.VIRMAN,
           Z.BENEFIT,
           Z.OPIS,
           Z.DATUMDPO,
           Z.BROJ_FISKALNOG,
           z.sifra_magacina,
           IV.INVOICETYPE,
           IV.TRANSACTIONTYPE,
           case
           when z.kes < 0 or z.cek < 0 or z.kartica <0 or z.virman < 0 then z.kes + z.cek + z.kartica + z.virman
           else 0
           end as storno
    from MP_FISK_Z Z
    left join INVOICE IV on IV.IDZ = Z.IDZ
    where Z.DATUMDPO between :D1 and :D2 and
          (Z.SIFRA_MAGACINA = :SM or :sm = -1) and
          Z.PLACENO = 'Y' and upper(iv.invoicetype) = 'NORMAL'
    INTO :IDZ,
         :DUGUJE,
         :KES,
         :CEK,
         :KARTICA,
         :VIRMAN,
         :BENEFIT,
         :OPIS,
         :DATUMDPO,
         :BROJ_FISKALNOG,
         :sifra_magacina,
         :INVOICETYPE,
         :TRANSACTIONTYPE,
         :storno
  DO
  BEGIN
    avans = 0;
    select sum(p.iznos) as avans
    from tblnovcano n
    join tblnov_placanje p on n.idnovcano = p.idnovcano
    where n.sifra_magacina = (select first 1 m.sifra_magacina_avans from system_mp m )
    and n.sifra_dokumenta = (select first 1 d.sifra_dok_avans from system_mp d )
    and n.datumdpo = :DATUMDPO
    into :avans;

    select  first 1 i.invoicenumber,
    case
        when upper(i.transactiontype) = 'SALE' then i.totalamount
        when UPPER(i.transactiontype) = 'REFUND' then (-1)*i.totalamount
    end
    from invoice i
    where i.idz = :idz
    and UPPER(i.invoicetype) in ( 'NORMAL', 'ADVANCE' )
    into :INVOICENUMBER, :TOTALAMOUNT;

    select sum(h."VALUE") as narukvica
    from ac_credit_history h
    where h.mp_fisk_z_id = :idz
    into :narukvica;

    if (FISKAL_PUSTEN = -1 or :invoicenumber is not null ) then
    SUSPEND;
    TOTALAMOUNT = 0;
    INVOICENUMBER = 0;
    narukvica = 0;

  END
  kes=0; cek = 0; kartica = 0; virman = 0;
  for
    select Z.idnovcano,
           Z.DUGUJE,
            (select coalesce(sum(p.iznos),0)  from tblnov_placanje p join tip_placanja a on p.idnacin_placanja = a.idplacanja where p.idnovcano = z.idnovcano and UPPER(a.naziv) = 'GOTOVINA' ) AS KES,
            (select coalesce(sum(p.iznos),0)  from tblnov_placanje p join tip_placanja a on p.idnacin_placanja = a.idplacanja where p.idnovcano = z.idnovcano and UPPER(a.naziv) = 'CEKOVI' ) AS CEK,
            (select coalesce(sum(p.iznos),0)  from tblnov_placanje p join tip_placanja a on p.idnacin_placanja = a.idplacanja where p.idnovcano = z.idnovcano and UPPER(a.naziv) = 'KARTICA' ) AS KARTICA,
            (select coalesce(sum(p.iznos),0)  from tblnov_placanje p join tip_placanja a on p.idnacin_placanja = a.idplacanja where p.idnovcano = z.idnovcano and UPPER(a.naziv) = 'VIRMANSKI' ) AS VIRMAN,
           0,
           Z.OPIS,
           Z.DATUMDPO,
           Z.BROJ_FISKALNOG,
           IV.INVOICETYPE,
           IV.TRANSACTIONTYPE

    from tblnovcano Z
    left join INVOICE IV on IV.idnovcano = Z.idnovcano
    where Z.DATUMDPO between :D1 and :D2 and
          (Z.sifra_kase = :SK or :SK = -1) and
           upper(iv.invoicetype) = 'ADVANCE'
    INTO :IDZ,
         :DUGUJE,
         :KES,
         :CEK,
         :KARTICA,
         :VIRMAN,
         :BENEFIT,
         :OPIS,
         :DATUMDPO,
         :BROJ_FISKALNOG,
         :INVOICETYPE,
         :TRANSACTIONTYPE
     DO
  BEGIN
    select  first 1 i.invoicenumber,
    case
        when upper(i.transactiontype) = 'SALE' then i.totalamount
        when UPPER(i.transactiontype) = 'REFUND' then (-1)*i.totalamount
    end
    from invoice i
    where i.idnovcano = :idz
    and UPPER(i.invoicetype) in ( 'NORMAL', 'ADVANCE' )
    into :INVOICENUMBER, :TOTALAMOUNT;

    if (:kes + :cek + :kartica + :virman <0) then storno = :kes + :cek + :kartica + :virman;
    if (FISKAL_PUSTEN = -1 or :invoicenumber is not null ) then
    SUSPEND;
  end
END^

SET TERM ; ^


SET TERM ^ ;

create or alter procedure PROC_MP_AKCIJA1 (
    IDZ integer)
returns (
    IZNOS decimal(18,2),
    ID integer,
    TIP_AKCIJE varchar(100),
    REZULTAT decimal(18,4))
as
BEGIN
  FOR
    select sum(O.IZNOS) as IZNOS,
           B.ID,
           B.TIP_AKCIJE,
           B.REZULTAT
    from HP_OBRACUN O
    join TBLARTIKLI_AKCIJA A on O.SIFRA_ROBE = A.SIFRA_ROBE and O.SIFRA_MAGACINA = A.SIFRA_MAGACINA
    join TBLAKCIJE B on A.ID_AKCIJE = B.ID
    where O.IDZG = :IDZ and
          B.AKTIVNA = 1
    group by B.ID, B.TIP_AKCIJE, B.REZULTAT
    having sum(O.IZNOS) > B.REZULTAT
    INTO :IZNOS,
         :ID,
         :TIP_AKCIJE,
         :REZULTAT
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^


update verzija set maloprodaja = 20230126;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230128 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_MESTOTROSKA_PS (
    DATUM_OD date,
    DATUM_DO date)
returns (
    ID integer,
    NAZIV varchar(250),
    AKTIVAN smallint,
    VREDNOST decimal(18,2),
    IDNOVCANO integer,
    DATUMPS date)
as
declare variable VREDNOST1 decimal(18,2);
declare variable VREDNOST2 decimal(18,2);
declare variable VREDNOST3 decimal(18,2);
begin

   IDNOVCANO = gen_id(NOVI_IDNOVCANO,1);
   datumps = cast( '01/01/'||(extract(year from :DATUM_OD)+1) as date);
   insert into tblnovcano (idnovcano, SIFRA_KOMITENTA, SIFRA_MAGACINA_U, SIFRA_MAGACINA, SIFRA_DOKUMENTA,OPIS, DATUMDPO, DATUMVALUTE, DATUM_IZD, KURS, SIFRA_RADNIKA, PROMENA, DATUM_PRIJEMA )
   values( :idnovcano, 0 ,0 ,1070 ,3031, 'Pocetno stanje mesta troska za ' || (extract(year from :datumps) ), :datumps, :datumps, :datumps, 1, 10, CURRENT_TIMESTAMP, :datumps );

  for select M.ID, M.NAZIV, M.AKTIVAN
      from TBLMESTOTROSKA M
      order by M.NAZIV

      into :ID, :NAZIV, :AKTIVAN
  do
  begin
    vrednost = 0; vrednost1 = 0; vrednost2  = 0; vrednost3 = 0;
    select coalesce(sum(P.DUG_MG + P.POT_MG),0)
    from TBLNOVCANO N
    join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
    where N.ID_TROSKA = :ID and
          (N.DATUMDPO between :DATUM_OD and :DATUM_DO)
     into vrednost1;

    select coalesce(sum((b.pot_din+b.drugi_iznosi)),0)
    from tblnovcano n
                      join tblblagajna b on b.idnovcano=n.idnovcano and b.id_troska=:ID
    where (n.datumdpo between :datum_od and :datum_do)
    into vrednost2;

    select coalesce(sum(i.duguje+i.potrazuje),0 )
    from tblnovcano n
                      join tblizvodi i on i.idnovcano=n.idnovcano and i.id_troska=:ID
    where (n.datumdpo between :datum_od and :datum_do)
    into :vrednost3;
          vrednost = vrednost1 + vrednost2 + vrednost3;
          suspend;

   INSERT INTO TBLIZVODI (ID, IDNOVCANO, DATUM, POTRAZUJE, ID_KONTA, OPIS, KONTO, ID_VRSTA, ID_TROSKA, PROMENA, SUBJEKAT, DATUMVALUTE, SIFRA_KOMITENTA, idverzije_kp, IDSEKTORA, ID_POPDV, idh, SUBANALITIKA, ID_ODELJENJA, PL_IZNOS  )
   values (GEN_ID(GEN_TBLIZVODI_ID, 1), :IDNOVCANO, :DATUMPS, :VREDNOST , -1 , 'PRENOS PS-DUG ZAPOSLENI 1','2215', 'KONTO_GK', :ID, CURRENT_TIMESTAMP , :NAZIV,  :DATUMPS, 0,1, 0, 0, 1,0,0,0  ) ;

  end
end^

SET TERM ; ^


update verzija set maloprodaja = 20230128;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230130 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_DALJINSKI_LAGER (
    GOD integer,
    SM integer,
    SR integer = -1,
    SDOBAVLJAC integer = -1,
    SKATEGORIJA integer = -1)
returns (
    KOLICINA decimal(18,4),
    SIFRA_ROBE integer,
    SIFRA_MAGACINA integer,
    GODINA integer)
as
declare variable SQL varchar(512);
declare variable SM_LOKAL integer;
declare variable SM2 integer;
declare variable BAZA varchar(512);
begin
    select def_mp_mg from hp_fiskal into sm_lokal;
    if (:SDOBAVLJAC is null) then SDOBAVLJAC = -1;
    if (:SKATEGORIJA is null) then SKATEGORIJA = -1;
    godina = :god;

    select   m.ip_adresa||':'||m.naziv_baze , coalesce(m.vezani_mg , m.sifra_magacina)
    from tblmagacin m
    where m.sifra_magacina = :sm
    and m.ip_adresa is not null
    into :baza, :sm2 ;

    if (sm_lokal <> sm and :baza is not null)
    then
        begin
            sql = 'select coalesce(L.KOLICINA, 0) - coalesce(L.REZERVISANO, 0), l.sifra_robe
                    from  tblartikli a left join tlokacija l on l.sifra_robe = a.sifra_robe
                    and l.sifra_magacina = '||:sm2||' and l.godina = '||:GOD  ||' and (l.sifra_robe = '||:sr ||' or '||:sr||' = -1)'
                    ||' where (a.sifra_dobavljaca = '||:sdobavljac ||' or '||:sdobavljac||' = -1)'
                    ||' and (a.sifra_kategorije = '||:SKATEGORIJA ||' or '||:SKATEGORIJA||' = -1)';
          for
          EXECUTE STATEMENT SQL ON EXTERNAL DATA SOURCE :BAZA AS USER 'SYSDBA' PASSWORD 'masterkey'
          INTO :KOLICINA, :SIFRA_ROBE
          do
          begin
            sifra_magacina = :sm2;

              suspend;
          end

        end
    else
        begin
            for
            select coalesce(L.KOLICINA, 0) - coalesce(L.REZERVISANO, 0), a.SIFRA_ROBE, l.sifra_magacina
            from   tblartikli a left join tlokacija l on l.sifra_robe = a.sifra_robe
            and l.sifra_magacina = :sm and (l.sifra_robe = :sr or :sr = -1)  and l.godina = :GOD
            where (a.sifra_dobavljaca = :sdobavljac or :sdobavljac = -1)
            and (a.sifra_kategorije = :skategorija or :skategorija = -1 )
            into :kolicina, :SIFRA_ROBE, :sifra_magacina
            do
            begin
                sifra_magacina = :sm;
                suspend;
            end
        end

end^

SET TERM ; ^




SET TERM ^ ;

create or alter procedure PROC_MP_TREBOVANJE_DOB_ART (
    MG integer,
    OD_DATUMA date,
    DO_DATUMA date,
    SIFRA_DOBAVLJACA integer,
    BROJ_DANA integer,
    MG1 integer = null,
    SIFRA_KATEGORIJE integer = -1)
returns (
    SIFRA_ROBE integer,
    PRODATA_KOLICINA decimal(18,4),
    SIFRA_MAGACINA integer,
    LAGER_KOL integer,
    KOD varchar(20),
    ARTIKAL varchar(255),
    ODNOSPJM double precision,
    JED_MERE varchar(20),
    PJED_MERE varchar(20),
    REZERVISANO decimal(18,4),
    KOLICINA decimal(18,4),
    BROJ_DANA_LAGER integer,
    KOEF_DINAMIKE decimal(18,4),
    CENA decimal(18,2),
    PROS_CENA decimal(18,2),
    KOLICINA1 decimal(18,4),
    ULAZ_KOL decimal(18,4),
    ULAZ_CENA decimal(18,4),
    DATUM_NAB date)
as
declare variable PRODATA_KOL_HP decimal(15,2);
declare variable HP integer;
declare variable GODINA integer;
declare variable KAPILARNO integer;
begin
  select first 1 S.HP_TABELE
  from TBLHOST S
  into :HP;
  godina = extract(year from DO_DATUMA);
  if (:mg1 is null) then mg1 = :mg;

    if (:MG = :MG1) then  KAPILARNO = 1;
    ELSE KAPILARNO = 0;

  if (:SIFRA_KATEGORIJE is null) then SIFRA_KATEGORIJE = -1;
  if (:SIFRA_DOBAVLJACA is null) then SIFRA_DOBAVLJACA = -1;
  --IZBOR ARTIKALA
  /*
  for select distinct A.SIFRA_ROBE
      from TBLARTIKLI A
      left join tlokacija l on a.sifra_robe = l.sifra_robe and l.godina = :godina
      where (A.SIFRA_DOBAVLJACA = :SIFRA_DOBAVLJACA or  :SIFRA_DOBAVLJACA = -1)
      and (a.sifra_kategorije = :sifra_kategorije or :sifra_kategorije = -1)
      and ( (l.sifra_magacina = :mg1 and l.kolicina > 0) or :mg1 = :mg)

    select  distinct a.sifra_robe
    from tblartikli a
    where (a.sifra_dobavljaca = :SIFRA_DOBAVLJACA)
    */
    /*
    for
    SELECT A.SIFRA_ROBE
    FROM PROC_MP_TREBOVANJE_SPISAK_ART( :SIFRA_DOBAVLJACA, :kapilarno,  :MG, :SIFRA_KATEGORIJE) A
    into :sifra_robe
     */
    for
    select kolicina, sifra_robe
    from proc_mp_daljinski_lager(:godina, :mg1, -1, :SIFRA_DOBAVLJACA, :SIFRA_KATEGORIJE  )
    where kolicina > 0
    into :kolicina1, :sifra_robe
  do
  begin
    KOD = null;
    ARTIKAL = null;
    BROJ_DANA_LAGER = 0;
    PRODATA_KOLICINA = 0;
    PRODATA_KOL_HP = 0;
    --TRAJANJE LAGERA
    select Z.BROJ_DANA
    from ZEGIN_BR_DANA_LAGERA_MP(:MG, :OD_DATUMA, :DO_DATUMA, :SIFRA_ROBE) Z
    into :BROJ_DANA_LAGER;
    --PRODAJA
    if (HP = 0) then
    begin
      select coalesce(sum(P.IZLAZ_KOL), 0),
             N.SIFRA_MAGACINA
      from TBLNOVCANO N
      join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
      join TBLDOKUMENTI D on N.SIFRA_DOKUMENTA = D.SIFRA_DOKUMENTA
      where N.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            D.TIP = 10 and
            P.SIFRA_ROBE = :SIFRA_ROBE and
            N.SIFRA_MAGACINA = :MG
      group by 2
      into :PRODATA_KOLICINA, :SIFRA_MAGACINA;
    end
    else
    begin
      select coalesce(sum(O.KOLICINA), 0),
             Z.SIFRA_MAGACINA
      from HP_OBRACUN O
      join MP_FISK_Z Z on O.IDZG = Z.IDZ
      where Z.DATUMDPO between :OD_DATUMA and :DO_DATUMA and
            O.SIFRA_ROBE = :SIFRA_ROBE and
            Z.SIFRA_MAGACINA = :MG and
            Z.PLACENO = 'Y'
      group by 2
      into :PRODATA_KOL_HP, :SIFRA_MAGACINA;
    end
    PRODATA_KOLICINA = coalesce(PRODATA_KOLICINA, 0) + coalesce(PRODATA_KOL_HP, 0);
    if (:BROJ_DANA_LAGER > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / BROJ_DANA_LAGER;
    end
    else
    if (:DO_DATUMA - :OD_DATUMA > 0) then
    begin
      KOEF_DINAMIKE = PRODATA_KOLICINA / (:DO_DATUMA - :OD_DATUMA);
    end
    else
    begin
      KOEF_DINAMIKE = 0;
    end
    -- NABAVKA
    ulaz_kol=0; ulaz_cena=0; datum_nab=null;

    select first 1 ulaz_kol, ulaz_cena,  datumdpo
    from tblnovcano n1 join tblpromene p1 on n1.idnovcano=p1.idnovcano
                                         and p1.sifra_robe=:sifra_robe
                                         and n1.sifra_magacina=:mg
                                         AND N1.datumdpo >= :od_datuma
    where ulaz_kol>0
    order by n1.datumdpo desc
    into :ulaz_kol, :ulaz_cena, :datum_nab;
    --LAGER
    select first 1 coalesce(L.KOLICINA, 0),
                   coalesce(L.REZERVISANO, 0),
                   L.CENA,
                   L.PROS_CENA,
                   A.KOD,
                   A.ODNOSPJM,
                   A.ARTIKAL,
                   J2.NAZIV as JED_MERE,
                   J.NAZIV as PJED_MERE
    from TBLARTIKLI A
    left join TLOKACIJA L on (A.SIFRA_ROBE = L.SIFRA_ROBE) and L.SIFRA_MAGACINA = :MG and L.GODINA = extract(year from current_date)
    inner join TBLJM J on (J.ID = A.IDJM)
    inner join TBLJM J2 on J2.ID = A.IDPJM
    where A.SIFRA_ROBE = :SIFRA_ROBE
    into :KOLICINA, :REZERVISANO, :CENA, :PROS_CENA, :KOD, :ODNOSPJM, :ARTIKAL, :JED_MERE, :PJED_MERE;
    --      REZERVISANO = :REZERVISANO + :PRODATA_KOL_HP;
    LAGER_KOL = :KOLICINA;-- :PRODATA_KOL_HP;

    suspend;
    KOLICINA1 = 0;
    KOLICINA = 0;
    PRODATA_KOL_HP = 0;
  end
end^

SET TERM ; ^



update verzija set maloprodaja = 20230130;

COMMIT WORK;
{$ENDIF}


{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230202 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_VAGA_UNI (
    ID integer,
    DATUM date,
    GODINA integer)
returns (
    PLU varchar(20),
    COM varchar(512),
    UP decimal(18,4),
    IDVAGE integer,
    KOD_VAGE varchar(5),
    S1U integer,
    BCF integer,
    FLAG integer,
    ING char(4))
as
declare variable SM integer;
declare variable BR_KARAKTERA integer;
declare variable MERENO_POJEDINACNO integer;
declare variable CENA varchar(10);
declare variable TMPCENA integer;
declare variable PREFIX varchar(10);
declare variable IDC integer;
BEGIN
-- digi tip=1
    select first 1 v.sifra_magacina , v.broj_karaktera, v.kod_vage, v.id, v.prefix_vage , m.id_cenovnik
    from vaga v
    join tblmagacin m on v.sifra_magacina = m.sifra_magacina
    where v.id = :id
    into :sm, :br_karaktera, :kod_vage, :idvage, :prefix , :idc;
  FOR
    select
      lpad(v.id_vage,2,'0') || lpad(v.kod,3,'0') ,
     replace( a.artikal, ',', ' ')as com,

       (select C.CENA
        from cena_artikla_iz_cenovnika( A.SIFRA_ROBE, :idc, :DATUM ) C) as up,
     case when m.vaga_komad = 1 then 1 else 0 end as s1u,5 as bcf
    from tblartikli a
    join tblartikli_vaga v on a.sifra_robe = v.sifra_robe and v.id_vage = :id
    left join tbljm m on a.idpjm = m.id
    where a.vaga = 1
    INTO :PLU,
         :COM,
         :UP,
         :S1U,
         :BCF
  DO
  BEGIN
    tmpcena = :up * 100;
    cena = lpad(replace(cast(tmpcena as varchar(6)),'.',''),6,'0');
    com = :kod_vage || :PLU || '0'||:s1u || '00' || :cena || '000' || '1'||:prefix||'00000000000' || :com ;
--    28 03523 00 00 039999 000 1 2700000000000 BELI LUK
    SUSPEND;
  END
END
/*
1.WGNU,  2, N, 0, 1................2 cifre za grupu-odeljenje
2.PNUM,  5, N, 0, 1................5 cifara za sifru artikla (PLU)
3.KLAR,  2, N, 0, 1................2 cifre za tip proizvoda (00-mereno,01-rucni(tj. komadni),03-brojanjem
4.STPA,  2, N, 0, 1................2 cifre za broj komada u paketu ukoliko se koristi 03-brojanjem kod KLAR
5.GPR1,  6, N, 0, 1................6 cifara za cenu
6.HBA1,  3, N, 0, 1................3 cifre za rok trajanja
7.ECO1, 13, C, 0, 1...............13 cifara za barkod, {1 cifra (0 za interni, a 1 proizvodjacki kod) pa 12 cifara za barkod}
8.PLTE,250, C, 0, 1..............250 karaktera za naziv artikla
cr,    1, S, 0, 1, 13..............carrage return
eol,   1, S, 0, 1, 10.............. EndOfLine
*/^

SET TERM ; ^

update verzija set maloprodaja = 20230202;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230204 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure ARTIKAL_POSLEDNJA_NAB_CENA (
    SR integer,
    SM integer = -1,
    SK integer = -1)
returns (
    NAB_CENA decimal(18,4),
    IDNOVCANO integer,
    BUD varchar(20),
    DATUMDPO date)
as
begin
  select first 1 P.ULAZ_CENA,
                 N.BUD,
                 N.DATUMDPO,
                 N.IDNOVCANO
  from TBLNOVCANO N
  join TBLPROMENE P on N.IDNOVCANO = P.IDNOVCANO
  join TBLDOKUMENTI D on D.SIFRA_DOKUMENTA = N.SIFRA_DOKUMENTA and ((D.TIP in (0, 70)) or (D.SIFRA_DOKUMENTA = 3000))
  where P.SIFRA_ROBE = :SR and
        (N.SIFRA_MAGACINA = :SM or :SM = -1) and
        (N.SIFRA_KOMITENTA = :SK or :SK = -1) and
        (P.ULAZ_KOL > 0 or P.IZLAZ_KOL < 0) and
        P.ULAZ_CENA > 0
  order by N.DATUMDPO desc
  into :NAB_CENA,
       :BUD,
       :DATUMDPO,
       :IDNOVCANO;
  suspend;
end^

SET TERM ; ^

update verzija set maloprodaja = 20230204;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230206 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_INVOICE_AGAIN (
    INVNUM varchar(50),
    IDZ integer,
    DATEADDED timestamp)
as
declare variable ID integer;
declare variable INVTYPE varchar(50);
declare variable POSLATO integer;
BEGIN

    FOR

        SELECT I.ID, I.INVOICETYPE, I.POSLATO
        FROM INVOICE I
        WHERE I.IDZ = :IDZ
        INTO :ID, :INVTYPE, :POSLATO

        DO
        BEGIN
           IF (:INVTYPE = 'TRAINING') THEN
           BEGIN
               UPDATE INVOICE I SET I.IDZ = (-1) * I.IDZ, I.POSLATO = 0
               WHERE I.ID = :ID;
           END
       --    INVTYPE = '';
        END

   IF (UPPER(:INVTYPE) <> 'COPY') THEN

   BEGIN
    UPDATE MP_FISK_Z Z
    SET Z.FISKAL_PUSTEN = 1,
        Z.INVOICENUMBER = :INVNUM,
        Z.DATUMPRAVLJENJA = :DATEADDED ,
        z.opis = :INVTYPE
    WHERE Z.IDZ = :IDZ;
    end

END^

SET TERM ; ^

update verzija set maloprodaja = 20230206;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230208 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure GENERATE_BENEFIT_VOUCHER (
    AMOUNT decimal(18,4),
    USER_CREATED integer,
    I integer,
    DATE_TO date,
    SK integer)
as
declare variable NEW_UID_CHECK integer;
declare variable TEMP_ID integer;
declare variable TEMP_IDZ integer;
begin
    temp_idz = gen_id( GEN_BENEFIT_VOUCHER_IDZ, 1);
  while ( :I <> 0 ) do
  begin
    while(temp_id is null) do
        begin
            temp_id = cast(trunc((rand()*9999999)+1) as integer);
            select new_uid from benefit_voucher where new_uid = :temp_id into :NEW_UID_CHECK;
            if(:NEW_UID_CHECK is not null) then
                temp_id = null;
        end
    INSERT INTO BENEFIT_VOUCHER (AMOUNT, USER_CREATED, new_uid,DATE_TO, idz, sifra_komitenta)
                     VALUES (:AMOUNT, :USER_CREATED, :temp_id,:DATE_TO, :temp_idz, :sk);
    I =:I -1;
    temp_id = null;
  end 

end^

SET TERM ; ^

update verzija set maloprodaja = 20230208;

COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230210 }

SET TRPARAMS 'isc_tpb_wait';

SET TERM ^ ;

create or alter procedure PROC_MP_PLACANJA (
    IDZ integer)
returns (
    IDPLACANJA integer,
    NAZIV varchar(100),
    SUF_PAYMENT varchar(50),
    IZNOS decimal(18,4))
as
BEGIN
  FOR
    select p.idplacanja, p.naziv, p.suf_payment,
    (
     select  case
        when upper(p.naziv) = 'GOTOVINA' then z.kes
        when upper(p.naziv) = 'VIRMANSKI' then z.virman
        when upper(p.naziv) = 'CEKOVI' then z.cek
        when upper(p.naziv) = 'KARTICA' then z.kartica
        when upper(p.naziv) = 'BENEFIT' then z.benefit
        when upper(p.naziv) = 'VAUCER' then z.vaucer
        end as iznos
     from mp_fisk_z z
     where z.idz = :idz
    
    )
    from tip_placanja p
    where p.aktivan = 1
    and p.ide_na_kasu = 1
    and p.suf_payment is not null
    INTO :IDPLACANJA,
         :NAZIV,
         :SUF_PAYMENT,
         :IZNOS
  DO
  BEGIN
    if (iznos <> 0) then
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20230210;
COMMIT WORK;
{$ENDIF}

{$IFEXISTS SELECT maloprodaja
             FROM verzija
             WHERE maloprodaja < 20230215 }

SET TRPARAMS 'isc_tpb_wait';


SET TERM ^ ;

create or alter procedure PROC_MP_KOD_ZA_VAGU
returns (
    SIFRA_ZA_VAGU varchar(10))
as
BEGIN
  FOR
    select
    max(cast(A.kod_info as integer)) as sifra_za_vagu
    from tblartikli A
    WHERE A.kod_info SIMILAR TO '[[:DIGIT:]]*'
    INTO :SIFRA_ZA_VAGU
  DO
  BEGIN
    SUSPEND;
  END
END^

SET TERM ; ^

update verzija set maloprodaja = 20230215;
COMMIT WORK;
{$ENDIF}